﻿--------------------------------------------------------
-------------[W_Messages_Search]------------------
--------------------------------------------------------

IF  EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[W_Messages_Search]') AND OBJECTPROPERTY(id,N'IsProcedure') = 1)
DROP PROCEDURE [dbo].[W_Messages_Search]
GO

CREATE Procedure [dbo].[W_Messages_Search]
	@idusera	uniqueidentifier,
	@iduserb	uniqueidentifier,
	@text	nvarchar(100),
	@startdate	datetime,
	@count int = null
as
begin
	Create table #temp  ( 
		Inc	int identity (1,1),
		Id	uniqueidentifier,
		IdUserA uniqueidentifier,
		IdUserB	uniqueidentifier,
		SentDate DateTime,
		Message text collate database_default,
		Viewed bit--,ViewedDate DateTime 
		)

		Insert into #temp
		Select top 100 Id, IdUserA, IdUserB, SentDate, Message, Viewed 
		FROM A_UserMessages 
		Where (( IdUserA = @idusera And IdUserB = @iduserb ) or ( IdUserA = @iduserb And IdUserB = @idusera ))
			and ([Message] like @text + '%' or [Message] like '%[ "#@№(-:;.,«'']' + @text + '%')
		and SentDate < @startdate
		--Order By SentDate Desc
		
		select * 
		from #temp
		where Inc <= @count
		Order by SentDate desc
		drop table #temp
end
GO

--------------------------------------------------------
-----------[W_Messages_GetUsersWithNumbers]-------
--------------------------------------------------------
IF  EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[W_Messages_GetUsersWithNumbers]') AND OBJECTPROPERTY(id,N'IsProcedure') = 1)
DROP PROCEDURE [dbo].[W_Messages_GetUsersWithNumbers]
GO

Create Procedure [dbo].[W_Messages_GetUsersWithNumbers]
as
begin
	select np.id [npid],np.prefix, u.id [userid], u.name 
	into #temp	
	from A_RuleRecords rr
	inner join
	A_NumberPlanAction as npa
	on rr.ruleid = npa.extraid and npa.numtype=0
	inner join
	A_NumberPlan as np
	on np.id=npa.numid
	right join
	A_Users as u
	on rr.reactid = u.id
	--order by np.prefix--name
	
	delete from #temp
	where prefix in (	select prefix
	from #temp
	group by prefix
	having count (*) > 1)
	
	select * from #temp
	
	drop table #temp
end
GO

--------------------------------------------------------
----------------[W_Messages_GetNewCount]----------------
--------------------------------------------------------
IF  EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[W_Messages_GetNewCount]') AND OBJECTPROPERTY(id,N'IsProcedure') = 1)
DROP PROCEDURE [dbo].[W_Messages_GetNewCount]
GO

CREATE Procedure [dbo].[W_Messages_GetNewCount]
	@iduser uniqueidentifier

as
begin
	Select count (*) [count]
	From A_UserMessages msg
	Where IdUserB = @iduser 
		and Viewed = 0
end
GO

-------------------------------------------------------------------------------------
----------[W_Messages_GetLastNByDate]--------------------------------
--------------------------------------------------------
IF  EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[W_Messages_GetLastNByDate]') AND OBJECTPROPERTY(id,N'IsProcedure') = 1)
DROP PROCEDURE [dbo].[W_Messages_GetLastNByDate]
GO

CREATE Procedure [dbo].[W_Messages_GetLastNByDate]
	@idusera	uniqueidentifier,
	@iduserb	uniqueidentifier,
	@startdate	datetime,
	@count		int
as
begin
	Create table #temp  ( 
		Inc	int identity (1,1),
		Id	uniqueidentifier,
		IdUserA uniqueidentifier,
		IdUserB	uniqueidentifier,
		SentDate DateTime,
		Message text collate database_default,
		Viewed bit--,ViewedDate DateTime 
		)

		Insert into #temp
		Select top 100 Id, IdUserA, IdUserB, SentDate, Message, Viewed --Top 100
		FROM A_UserMessages 
		Where (( IdUserA = @idusera And IdUserB = @iduserb )	or ( IdUserA = @iduserb And IdUserB = @idusera ))
			and SentDate < @startdate
		--Order By SentDate Desc

		select * 
		from #temp
		where Inc <= @count
		Order by SentDate desc
		drop table #temp
end
GO

--------------------------------------------------------
------------[W_Messages_Dialogs]------------------------
--------------------------------------------------------

IF  EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[W_Messages_Dialogs]') AND OBJECTPROPERTY(id, N'IsUserTable') = 1)
DROP TABLE [dbo].[W_Messages_Dialogs]
GO

CREATE TABLE [dbo].[W_Messages_Dialogs](
	[iduserA] [uniqueidentifier] NULL,
	[iduserB] [uniqueidentifier] NULL,
	[sentdate] [datetime] NULL,
	[lastmessage] [text] collate database_default NULL,
	[messagecount] [int] NULL,
	[hasnew] [bit] null
) ON [PRIMARY] TEXTIMAGE_ON [PRIMARY]

GO

	select	[idUserA],[idUserB], 
			[sentdate], 
			[message],
			0 [isnew] --case viewed when 1 then 0 else 0 end 
	into #temp
	from  A_UserMessages
	--where idUserA = @iduser
	union all
	select	[idUserB],[idUserA], 
			[sentdate], 
			[message],
			case viewed when 1 then 0 else 1 end
	from  A_UserMessages
	--where [idUserB]= @iduser
	order by [idUserB], [sentdate]
		
	insert into [dbo].[W_Messages_Dialogs] 
	select t1.[idUserA],t1.[idUserB], t1.[lastmesagedate], um.[message], [count], hasnew
	from (
		select [idUserA],[idUserB], 
			max ([sentdate]) [lastmesagedate],
			count (*) [count],
			max ([isnew]) [hasnew]
			--,um.[message]
			from  #temp 
		group by [idUserA],[idUserB]
	) t1
	left join A_UserMessages um
	on t1.[lastmesagedate] = um.[sentdate]
	and ((t1.idusera = um.idusera and t1.iduserb = um.iduserb) or (t1.idusera = um.iduserb and t1.iduserb = um.idusera))
	
	drop table #temp
	
--------------------------------------------------------
-----------------[W_Messages_GetDialogs]----------------
--------------------------------------------------------

IF  EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[W_Messages_GetDialogs]') AND OBJECTPROPERTY(id,N'IsProcedure') = 1)
DROP PROCEDURE [dbo].[W_Messages_GetDialogs]
GO

CREATE procedure [dbo].[W_Messages_GetDialogs]
	@iduser uniqueidentifier
	,@first int = null, @count int = null
as
begin

--declare @iduser uniqueidentifier, @first int, @count int
--select @iduser = '1654740F-0600-493B-B8FD-B09AC9A5A99C',
--@first = 1, @count  = 20
	
	select [id] = identity (int,1,1) 
			,[idUserB]
			,sentdate
			,lastmessage
			,messagecount
			,hasnew
	into #temp
	from W_Messages_Dialogs 
	where iduserA = @iduser
	order by sentdate desc

	if (@first is null or @count is null)
			select * 
			from #temp
			--order by sentdate desc
	else
	select * 
	from #temp
	where id between @first and @first + @count - 1
	--order by sentdate desc

	drop table #temp
	
end
GO

--------------------------------------------------------
------------[A_UserMessages_SetViewed]------------------
--------------------------------------------------------
IF  EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[A_UserMessages_SetViewed]') AND OBJECTPROPERTY(id,N'IsProcedure') = 1)
DROP PROCEDURE [dbo].[A_UserMessages_SetViewed]
GO

CREATE procedure [dbo].[A_UserMessages_SetViewed]
	@idmessage uniqueidentifier
as
begin
	declare @ida uniqueidentifier
	declare @idb uniqueidentifier
	declare @dt datetime

	Select @ida = IdUserA, @idb = IdUserB, @dt = SentDate
	From A_UserMessages 
	Where Id = @idmessage

	if ( @@rowcount = 0 )
		return


	declare @rowcount int
	
	Update A_UserMessages
	Set Viewed = 1, ViewedDate = GetDate ( )
	Where IdUserA = @ida and IdUserB = @idb and SentDate <= @dt and Viewed != 1

	select @rowcount = @@rowcount
	
	Update W_Messages_Dialogs 
	set hasnew = 0 where IdUserB = @ida and IdUserA = @idb and hasnew != 0
	
	Select 120318, @rowcount as updatedcount
end

GO

-------------------------------------------------
-------------Индексы-----------------------------
-------------------------------------------------

--удаляем индекс если есть
IF  EXISTS (SELECT * FROM dbo.sysindexes WHERE id = OBJECT_ID(N'[dbo].[A_UserMessages]') AND name = N'idxUserMessages_SentDate')
DROP INDEX [dbo].[A_UserMessages].[idxUserMessages_SentDate]
GO

--удаляем старый кластерный ключ, если есть
IF  EXISTS (SELECT * FROM dbo.sysindexes WHERE id = OBJECT_ID(N'[dbo].[A_UserMessages]') AND name like N'PK__A_UserMessages_%')
begin
declare @comm nvarchar (1000)
set @comm = 'ALTER TABLE [dbo].[A_UserMessages] DROP CONSTRAINT [' +
			(SELECT NAME FROM dbo.sysindexes 
			WHERE id = OBJECT_ID(N'[dbo].[A_UserMessages]') 
			AND name like N'PK__A_UserMessages_%') + ']';
exec sp_executesql @comm
end
GO

-- Peter's update
if exists ( select * from sysobjects where id=object_id ( 'dbo.A_UserMessages' )) begin
	exec A_DB_ClearConstraintsAll 'A_UserMessages'
	exec A_DB_ClearIndexes 'A_UserMessages'
end
GO

--кластерный ключ на дату
IF NOT EXISTS (SELECT * FROM dbo.sysindexes WHERE id = OBJECT_ID(N'[dbo].[A_UserMessages]') AND name = N'idx_UserMessages_SentDate_clstd')
begin

--столбец [SentDate] теперь not null
UPDATE [A_UserMessages] SET [SentDate] = '2012-01-01' WHERE [SentDate] IS NULL
ALTER TABLE [A_UserMessages] ALTER COLUMN [SentDate] datetime NOT NULL

CREATE CLUSTERED INDEX [idx_UserMessages_SentDate_clstd] ON [A_UserMessages]
(
	[SentDate] deSC
)WITH FILLFACTOR = 90 ON [PRIMARY]
end
GO

--------------------------------------------------------
----------------[W_UpdateDialogTrigger] ----------------
--------------------------------------------------------
IF  EXISTS (SELECT * FROM dbo.sysobjects WHERE id = OBJECT_ID(N'[dbo].[W_UpdateDialogTrigger]') AND OBJECTPROPERTY(id, N'IsTrigger') = 1)
DROP TRIGGER [dbo].[W_UpdateDialogTrigger]
GO

CREATE TRIGGER [dbo].[W_UpdateDialogTrigger] 
   ON [A_UserMessages]
   AFTER INSERT
AS 
BEGIN
	-- SET NOCOUNT ON added to prevent extra result sets from
	-- interfering with SELECT statements.
	SET NOCOUNT ON;
	
	declare 
	--@iduserA uniqueidentifier,
	--@iduserB uniqueidentifier,
	--@sentdate datetime, 
	@message nvarchar(4000)
	,@count int
	
	--select 	@iduserA = iduserA,
	--@iduserB = iduserB,
	--@sentdate = sentdate
	--from inserted
	
	select @message = substring (um.message, 0, 255)
	from A_UserMessages um, inserted i
	where um.iduserA = i.iduserA and
	um.iduserB = i.iduserB and
	um.sentdate = i.sentdate
	
	update W_Messages_Dialogs 
	set sentdate = i.sentdate, 
	lastmessage = @message,
	messagecount = md.messagecount+1,
	hasnew = 0
	from inserted i, 
	W_Messages_Dialogs md
	where (md.iduserA = i.iduserA and md.iduserB = i.iduserB)
	
	update W_Messages_Dialogs 
	set sentdate = i.sentdate, 
	lastmessage = @message,
	messagecount = md.messagecount+1,
	hasnew = 1
	from inserted i, 
	W_Messages_Dialogs md
	where (md.iduserB = i.iduserA and md.iduserA = i.iduserB)
	
	if (@@rowcount = 0)
	begin
	
		select @count = count (*)
		from A_UserMessages um,  inserted i
		where (um.iduserA = i.iduserA and um.iduserB = i.iduserB) or (um.iduserB = i.iduserA and um.iduserA = i.iduserB)
		
		insert into W_Messages_Dialogs (iduserA, iduserB, sentdate, messagecount, lastmessage,hasnew)--
		select iduserA,
		iduserB,
		sentdate 
		,@count
		,@message
		,0
		from inserted
		
		insert into W_Messages_Dialogs (iduserB, iduserA, sentdate, messagecount, lastmessage,hasnew)--
		select iduserA,
		iduserB,
		sentdate 
		,@count
		,@message
		,1
		from inserted
	end

END

GO
