﻿if exists ( Select * from sysobjects where id = object_id ( 'dbo.A_Timer_MinuteProc' ))
	Drop procedure dbo.A_Timer_MinuteProc
GO

Create Procedure dbo.[A_Timer_MinuteProc]
	@dtnow datetime = null
as
begin
	if ( @dtnow is null )	
		set @dtnow = GetDate()
--------------------------------------------------------------------------------------------
-- Обеспечивается однократность исполнения (при нескольких серверах к одной базе) 
--------------------------------------------------------------------------------------------
   	Begin tran DbProcActive

		Declare @dtactive datetime
		Select @dtactive = valuedatetime from A_Settings where name like 'DB_procactive'
		if ( not @dtactive is null )
 		  if ( DateDiff ( mi, @dtactive, @dtnow ) < 10 ) begin
		    Rollback tran DbProcActive
		    return
		  end

		Update A_Settings Set valuedatetime = @dtnow where name like 'DB_procactive'
		if ( @@rowcount = 0 )
		  Insert into A_Settings (name, valuedatetime) Values ( 'DB_procactive', @dtnow )

   	Commit tran DbProcActive
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------

	--Время по которое производить расчет намеренно назад на 30 секунд отводим
	-- чтобы исключить возможность попадания в интервалы, когда отложенные сохранения в БД идут
	-- и когда одна таблица уже заполнена, а другая еще нет данными до текущего момента.
	-- ну и еще случаи частичного заполнения строки, когда данные вставляются в момент выборки
	Declare @tilldt DateTime
	Set @tilldt = DateAdd ( ss, -30, @dtnow )

	exec A_CallCenter_Temp_UpdateOperatorStates @tilldt

--------------------------------------------------------------------------------------------
-- Обеспечивается однократность исполнения (при нескольких серверах к одной базе) 
--------------------------------------------------------------------------------------------
	Delete From A_Settings where name like 'DB_procactive'
--------------------------------------------------------------------------------------------
--------------------------------------------------------------------------------------------
end
GO
