﻿
if exists (Select * From sysobjects where id=object_id ('dbo.A_UserState_GetInfo'))
	Drop procedure dbo.A_UserState_GetInfo
GO

Create Procedure dbo.A_UserState_GetInfo

	@userid				uniqueidentifier,
	@datestart			datetime,
	@datestop			datetime,
	@state				int
as

begin
	
	if ( @state < 0 )
		Select State, TimeChange, 
			case When ( icode is null or icode < 0  or icode = 1002) then Info 
			     When ( icode = 1003 ) then 'AutoLock' 
			     When ( State = 2 ) then IsNull ( ls.Name, '' )
			     Else IsNull ( it.Name, '' ) end Info, 
			UserSelfInfo 
		From A_UserStateHistory ush
			Left join A_TaskManager_CardLunchStates ls on ush.ICode = ls.Id
			Left join A_UserStateInfoTypes it on ush.icode = it.Id
		Where UserId = @userid 
			And TimeChange > @datestart and TimeChange < @dateStop 
		Order By TimeChange Desc
	else
		Select State, TimeChange, 
			case When ( icode is null or icode < 0  or icode = 1002) then Info 
			     When ( icode = 1003 ) then 'AutoLock'
			     When ( State = 2 ) then IsNull ( ls.Name, '' ) 			     
			     Else IsNull ( it.Name, '' ) end Info, 
			UserSelfInfo 
		From A_UserStateHistory ush
			Left join A_TaskManager_CardLunchStates ls on ush.ICode = ls.Id
			Left join A_UserStateInfoTypes it on ush.icode = it.Id
		Where UserId = @userid 
			And TimeChange > @datestart and TimeChange < @dateStop 		
			And State = @state
		Order By TimeChange Desc
end
GO
