﻿if exists ( select * from sysobjects where id= object_id ( 'dbo.A_Stat_MyCalls_Get' ))
	Drop procedure [dbo].[A_Stat_MyCalls_Get]
GO


Create procedure [dbo].[A_Stat_MyCalls_Get]
	@media 		int, --1 - внешняя, 2 - внутренняя, 3 - смешанная, 0 - все
	@type 		int, --1 - входящий, 2 - исходящий, 3 - пропущенный, 4 - неудачный, 10 - конф, 11 - селектор, 0 - все
	@dstart 	datetime,
	@dstop 		datetime,
	@number 	nvarchar ( 50 ),
	@showivr 	bit,
	@userid 	uniqueidentifier,
	@comment 	nvarchar ( 4000 ) = NULL
as
begin

/*
	declare @media 	int --1 - внешняя, 2 - внутренняя, 3 - смешанная, 0 - все
	declare @type 	int --1 - входящий, 2 - исходящий, 3 - пропущенный, 0 - все
	declare @dstart datetime
	declare @dstop 	datetime
	declare @number nvarchar ( 50 )
	declare @userid uniqueidentifier

	set dateformat dmy
	set @media = 0
	set @type = 0
	set @dstart = '16.12.2006'
	set @dstop = '16.12.2006'
	set @number = ''
	select @userid = id from A_users where login like 'Peter'	

*/

     Declare @output table ( Id uniqueidentifier, IdChain uniqueidentifier, Media int, Type int, 
				TimeStart DateTime, TimeAnswer DateTime, TimeStop DateTime, Length DateTime, 
				Number nvarchar ( 50 ) collate database_default, AbonentName nvarchar ( 200 ) collate database_default, 
				IsRecorded int, IdRecDir int, 
				ALineNum nvarchar ( 10 ) collate database_default, BLineNum nvarchar ( 10 )  collate database_default, --ARecFile nvarchar ( 100 ), BRecFile nvarchar ( 100 ), 
				AUserId uniqueidentifier, BUserId uniqueidentifier, 
				ALineId uniqueidentifier, BLineId uniqueidentifier, 
				AOutNumber nvarchar ( 50 ) collate database_default, BOutNumber nvarchar ( 50 ) collate database_default, 
				AStr nvarchar ( 200 ) collate database_default, BStr nvarchar ( 100 ) collate database_default, 
				IsConf int, Director uniqueidentifier, CTS DateTime )
     -- Подготовка параметров
     declare @filtercomment bit
     set @filtercomment = case when ( @comment IS NULL or @comment like '' ) then 0 else 1 end

     Declare @id0 uniqueidentifier
     Set @id0 = '00000000-0000-0000-0000-000000000000'

     Declare @ids table ( id uniqueidentifier )

    -------------------------------------
    -- Коммутации -----------------------
    -------------------------------------

    if ( @type in ( 0, 1, 2 )) begin

	if ( @number = '' )
		Insert into @ids
			Select Id
			From A_Stat_Connections_1x1 sc --with ( TabLock )
			Where TimeStart >= @dstart 
				and TimeStart < @dstop
				and (( AUserId = @userid and (@type = 2 or @type = 0) ) or ( BUserId = @userid and ( @type = 1  or @type = 0 ) ))
				and ( @showivr = 1 or (( AUserId != 'AB000000-0000-0000-0000-000000000000' ) and ( BUserId != 'AB000000-0000-0000-0000-000000000000' )))
	else
		Insert into @ids
			Select Id
			From A_Stat_Connections_1x1 sc --with ( TabLock )
			Where TimeStart >= @dstart 
				and TimeStart < @dstop
				and (( AUserId = @userid and (@type = 2 or @type = 0) and BOutNumber like @number ) or ( BUserId = @userid and ( @type = 1  or @type = 0 ) and AOutNumber like @number ))	
				and ( @showivr = 1 or (( AUserId != 'AB000000-0000-0000-0000-000000000000' ) and ( BUserId != 'AB000000-0000-0000-0000-000000000000' )))
	

	Insert into @output ( Id, IdChain, Media, Type,
				TimeStart, TimeAnswer, TimeStop, Length,
				Number, AbonentName, IsRecorded, IdRecDir, 
				ALineNum, BLineNum,
				AUserId, BUserId, 
				ALineId, BLineId, 
				AOutNumber, BOutNumber, 
				AStr, BStr, 
				IsConf, Director, CTS )

	    Select sc.Id, sc.IdChain, null, 0, 
			sc.TimeStart, sc.TimeAnswer, sc.TimeStop, sc.TimeStop - sc.TimeAnswer as Length, 
			'', '', IsRecorded, IdRecDir, 
			ALineNum, BLineNum, --ARecFile, BRecFile, 
			AUserId, BUserId, 
			ALineId, BLineId, 
			AOutNumber, BOutNumber, 
			AStr, BStr,
			0 as IsConf, @id0 as Director, sc.TimeStart as CTS

	    From A_Stat_Connections_1x1 sc --with ( TabLock )
			inner join @ids ids on sc.Id = ids.id
	    Where sc.TimeStop is not null

	-- фильтр по комментарию (если установлен)
	if ( @filtercomment > 0 )
	  begin
		Delete 
		From @output
		Where id not in ( Select Id From A_Stat_Comments Where Comment like '%' + @comment + '%' )
	  end
    end

    -------------------------------------
    -- Конференции ----------------------
    -------------------------------------
    if ( @type in ( 0, 10, 11 )) begin

	-- фильтр по времени	
	Declare @A_Stat_Conference_Ctmp1 table ( IdConn uniqueidentifier PRIMARY KEY )
	Declare @A_Stat_Conference_tmp1 table ( Id uniqueidentifier PRIMARY KEY, RecordAccess int, Director uniqueidentifier )

	Insert into @A_Stat_Conference_Ctmp1
		Select IdConn
		FROM A_Stat_Conference_Competitors scc
		Where (( TimeStart >= @dstart ) and ( TimeStart < @dstop ))
			And IdUser = @userid

	Insert into @A_Stat_Conference_tmp1
		Select Id, RecordAccess, Director 
		FROM A_Stat_Conference sc
		Where (( TimeStart <= @dstart ) and ( TimeStop > @dstart ))
			or (( TimeStart < @dstop ) and ( TimeStop >= @dstop ))
			or (( TimeStart <= @dstart ) and ( TimeStop > @dstart ))
			or (( TimeStart >= @dstart ) and ( TimeStop <= @dstop ))

	-- фильтр по комментарию (если установлен)
	if ( @filtercomment > 0 )
	  begin
		Delete 
		From @A_Stat_Conference_tmp1
		Where id not in ( Select Id From A_Stat_Comments Where Comment like '%' + @comment + '%' )
	  end

	-- фильтр по правам
	Declare @A_Stat_Conference_tmp2 table ( Id uniqueidentifier PRIMARY KEY )

	Insert into @A_Stat_Conference_tmp2
		Select sc.Id From @A_Stat_Conference_tmp1 sc			
		Where sc.RecordAccess = 1 --Директор слушает 
			And sc.Director = @userid

	Insert into @A_Stat_Conference_tmp2
		Select sc.Id From @A_Stat_Conference_tmp1 sc			
			Inner join A_Stat_Conference_Competitors scc on sc.Id = scc.IdConf
		Where sc.RecordAccess = 2 --Участники слушают
			And scc.IdUser = @userid
		Group By sc.Id

	Insert into @A_Stat_Conference_tmp2
		Select sc.Id From @A_Stat_Conference_tmp1 sc
			Inner join A_Stat_Conference_RecordAccessUsers scr on sc.Id = scr.IdConf
		Where sc.RecordAccess = 3 --Указанные участники слушают
			And scr.IdUser = @userid
		Group By sc.Id

		

	Declare @idconfuser uniqueidentifier
	Set @idconfuser = 'CF000000-0000-0000-0000-000000000000'

	Insert into @output ( Id, IdChain, Media, Type,
				TimeStart, TimeAnswer, TimeStop, Length,
				Number, AbonentName, IsRecorded, IdRecDir, 
				ALineNum, BLineNum,
				AUserId, BUserId, 
				ALineId, BLineId, 
				AOutNumber, BOutNumber, 
				AStr, BStr, 
				IsConf, Director, CTS )

		Select IdConn, IdChain, 
			case when sc.Type = 1 then 11/*селектор*/ else 10/*конф*/ end, 
			case when sc.Type = 1 then 11/*селектор*/ else 10/*конф*/ end,
			scc.TimeStart, scc.TimeStart as TimeAnswer, scc.TimeStop, 
			scc.TimeStop - scc.TimeStart as Length, 
			'', case when Name != '' then Name else '#' + cast ( Room as nvarchar ( 10 ) ) end,
			case when ( sct.Id is NULL ) then 0 else sc.IsRecorded end,  
			sc.IdRecDir, LineNum, sc.Room, 
			scc.IdUser, @idconfuser,
			scc.IdLine, IdConf,
			'', '', StrName, case when Name != '' then Name else '#' + cast ( Room as nvarchar ( 10 ) ) end,
			1 as IsConf, Director, sc.TimeStart as CTS
		FROM A_Stat_Conference_Competitors scc
			Inner join A_Stat_Conference sc on sc.Id = scc.IdConf
			Left join @A_Stat_Conference_tmp2 sct on sc.Id = sct.Id --фильтр по правам на прослушивание
		Where ((( scc.TimeStart <= @dstart ) and ( scc.TimeStop > @dstart ))
			or (( scc.TimeStart < @dstop ) and ( scc.TimeStop >= @dstop ))
			or (( scc.TimeStart <= @dstart ) and ( scc.TimeStop > @dstart ))
			or (( scc.TimeStart >= @dstart ) and ( scc.TimeStop <= @dstop )))
			And (( @number = '' ) or ( Cast ( sc.Room as nvarchar(50) ) like @number ))
			And scc.IdUser = @userid
			And ((( sc.Type = 1 ) and ( @type = 11 )) or (( sc.Type = 0 ) and ( @type = 10 )) or ( @type = 0 ))
    end

    -------------------------------------
    -- Пропущенные ----------------------
    -------------------------------------
    if ( @type in ( 0, 3 )) begin

		if ( @number = '' )	
			Insert into @output 
			( 
				Id, IdChain, Media, Type,
				TimeStart, TimeAnswer, TimeStop, Length,
				Number, AbonentName, IsRecorded, IdRecDir, 
				ALineNum, BLineNum,
				AUserId, BUserId, 
				ALineId, BLineId, 
				AOutNumber, BOutNumber, 
				AStr, BStr, 
				IsConf, Director, CTS 
			)
			Select Idg, IdChain, 3, 3, 
				TimeStart, TimeStop, TimeStop, TimeStop - TimeStart, 
				AOutNumber, AStr, 0, 0, 
				ALineNum, BLineNum, 
				AUserId, BUserId,
				ALineId, BLineId,
				AOutNumber, Number,
				AStr, '',
				0, @id0, TimeStart
			From A_Stat_MissedCalls
			Where ( BUserId = @userid )
				And (( TimeStart >= @dstart ) and ( TimeStart < @dstop ))
 		else
 			Insert into @output 
			( 
				Id, IdChain, Media, Type,
				TimeStart, TimeAnswer, TimeStop, Length,
				Number, AbonentName, IsRecorded, IdRecDir, 
				ALineNum, BLineNum,
				AUserId, BUserId, 
				ALineId, BLineId, 
				AOutNumber, BOutNumber, 
				AStr, BStr, 
				IsConf, Director, CTS 
			)
			Select Idg, IdChain, 3, 3, 
				TimeStart, TimeStop, TimeStop, TimeStop - TimeStart, 
				AOutNumber, AStr, 0, 0, 
				ALineNum, BLineNum, 
				AUserId, BUserId,
				ALineId, BLineId,
				AOutNumber, Number,
				AStr, '',
				0, @id0, TimeStart
			From A_Stat_MissedCalls
			Where ( BUserId = @userid ) and ( AOutNumber like @number )
				And (( TimeStart >= @dstart ) and ( TimeStart < @dstop ))
    end

    -------------------------------------
    -- Неудачные  ----------------------
    -------------------------------------
    if ( @type in ( 0, 4 )) begin

		if ( @number = '' ) begin

			Insert into @output 
			( 
				Id, IdChain, Media, Type,
				TimeStart, TimeAnswer, TimeStop, Length,
				Number, AbonentName, IsRecorded, IdRecDir, 
				ALineNum, BLineNum,
				AUserId, BUserId, 
				ALineId, BLineId, 
				AOutNumber, BOutNumber, 
				AStr, BStr, 
				IsConf, Director, CTS 
			)
			Select Id, IdChain, 3, 4, 
				TimeStart, TimeStop, TimeStop, TimeStop - TimeStart, 
				ANumberDialed, ANumberDialed, 0, 0, 
				ALineNum, BLineNum, 
				AUserId, @id0,
				ALineId, BLineId,
				AOutNumber, ANumberDialed,
				AStr, ANumberDialed,
				0, @id0, TimeStart
			From A_Stat_FailedCalls
			Where ( AUserId = @userid )
				And (( TimeStart >= @dstart ) and ( TimeStart < @dstop ))
 		end else begin
 			Insert into @output 
			( 
				Id, IdChain, Media, Type,
				TimeStart, TimeAnswer, TimeStop, Length,
				Number, AbonentName, IsRecorded, IdRecDir, 
				ALineNum, BLineNum,
				AUserId, BUserId, 
				ALineId, BLineId, 
				AOutNumber, BOutNumber, 
				AStr, BStr, 
				IsConf, Director, CTS 
			)
			Select Id, IdChain, 3, 4, 
				TimeStart, TimeStop, TimeStop, TimeStop - TimeStart, 
				ANumberDialed, ANumberDialed, 0, 0, 
				ALineNum, BLineNum, 
				AUserId, @id0,
				ALineId, BLineId,
				AOutNumber, ANumberDialed,
				AStr, ANumberDialed,
				0, @id0, TimeStart
			From A_Stat_FailedCalls
			Where ( AUserId = @userid ) and ( ANumberDialed like @number )
				And (( TimeStart >= @dstart ) and ( TimeStart < @dstop ))
		end
    end



	-----------------------------------
  	-- Преобразования -----------------
	-----------------------------------

	Update o
	Set o.Type =  1,
		o.Number = AOutNumber
	From @output o
	Where o.BUserId = @userid
		And Type = 0

	Update o
	Set o.Type =  2,
		o.Number = BOutNumber
	From @output o
	Where o.AUserId = @userid
		And Type = 0

	Update o
	Set o.Media = 1
	From @output o, A_ServerExtLines el
	Where o.ALineId = el.Id or o.BLineId = el.Id

	Update o
	Set o.Media = 2
	From @output o
	Where o.Media is null
	
	Update o
	Set o.AbonentName = u.Name
	From @output o, A_Users u
	Where ( o.AUserId = @userid and o.BUserId = u.Id ) or ( o.BUserId = @userid and o.AUserId = u.Id )

	Update o
	Set o.AbonentName = c.Name
	From @output o, A_Clients c, A_ClientContacts cc
	Where ( o.Number = cc.Content ) and ( cc.IdClient = c.Id )
		and ( c.OwnerId = @userid )

	Update o
	Set o.AbonentName = c.Name
	From @output o, A_Clients c, A_ClientContacts cc
	Where ( o.Number = cc.Content ) and ( cc.IdClient = c.Id )
		and ( c.OwnerId = @id0 )
		and (( o.AbonentName is null ) or ( o.AbonentName like '' ))


	if ( @showivr = 1 )
		Update o
		Set o.AbonentName = 'IVR'
		From @output o
		Where o.AUserId = 'AB000000-0000-0000-0000-000000000000' or o.BUserId = 'AB000000-0000-0000-0000-000000000000'

	Update o
	Set o.AbonentName = case When o.Type = 1 Then o.AStr else o.BStr end
	From @output o
	Where o.AbonentName = ''-- and o.Number = ''

	Update o
	Set o.AbonentName = ''
	From @output o
	Where o.AbonentName = o.Number

	-----------------------------------
  	-- Итог ---------------------------
	-----------------------------------
	
	Select Top 1000 sc.Id, IdChain, Media, Type, TimeStart, TimeAnswer, TimeStop, Cast ( Cast ( Length as float ) * 86400 as int ) as Length, ALineId, BLineId, ALineNum, BLineNum, Number, AbonentName, IsRecorded, IdRecDir, 
		IsConf, Director, CTS, 
		case When ( c.Id is null ) then 0 else 1 end as HasComment		
	From @output sc
		Left join A_Stat_Comments c on sc.Id = c.Id
	Where ( Media = @media ) or ( @media = 0 ) or ( Type >= 10 )
	Order By TimeStart Desc
end
GO
