﻿
if exists ( select * From sysobjects where id=object_id ( 'dbo.W_Messages_GetLastNByDate' ))
	Drop procedure dbo.[W_Messages_GetLastNByDate]
GO

Create Procedure [dbo].[W_Messages_GetLastNByDate]
	@authorizeduserid	uniqueidentifier,
	@iduserb	uniqueidentifier,
	@startdate	datetime,
	@count		int
as
begin
	Create table #temp  ( 
		Inc	int identity (1,1),
		Id	uniqueidentifier,
		IdUserA uniqueidentifier,
		IdUserB	uniqueidentifier,
		SentDate DateTime,
		Message text collate database_default,
		Viewed bit--,ViewedDate DateTime 
		)

		Insert into #temp
		Select top 100 uml.Id, IdUserA, IdUserB, SentDate, Message, Viewed --Top 100
		From A_UserMessageData umd
			Inner join A_UserMessageLink uml on uml.IdMessageData = umd.Id
		Where ( ( isConf = 0 and (( IdUserA = @authorizeduserid And IdUserB = @iduserb ) or ( IdUserA = @iduserb And IdUserB = @authorizeduserid )) ) or
			( IsConf = 1 and IdUserB = @iduserb ) )
			and SentDate < @startdate
		--Order By SentDate Desc
		
		select * 
		from #temp
		where Inc <= @count
		Order by SentDate desc
		

		Select umf.id, umf.sentdate, uml.Id as idmessage, umf.filepath, umf.filesize
		From [dbo].[A_UserMessageFile] umf
			Inner join A_UserMessageData umd on umd.Id = umf.IdMessageData
			Inner join A_UserMessageLink uml on uml.IdMessageData = umd.Id
		Where uml.Id in ( Select Id
							From #temp
							Where Inc <= @count )
		
		drop table #temp
end
GO