﻿------------------------------------------------
if exists ( Select * from sysobjects where id= OBJECT_ID ( 'dbo.A_Service_StatRemove' ))
	Drop procedure dbo.A_Service_StatRemove
GO

Create procedure [dbo].[A_Service_StatRemove]
	 @pbxdrop bit,
	 @pbxdropfiles bit,
	 @pbxfromdate DateTime,
	 @ccdrop bit,
	 @ccdropfiles bit,
	 @ccfromdate DateTime,
	 @dropped int OUTPUT
as
begin

--
/*
declare @pbxdrop bit
declare @pbxdropfiles bit
declare @pbxfromdate DateTime
declare @ccdrop bit
declare @ccdropfiles bit
declare @ccfromdate DateTime
declare @dropped int

set @pbxdrop = 0
set @pbxdropfiles = 1
set @pbxfromdate = '2013-10-11'
set @ccdrop = 0
set @ccdropfiles = 1
set @ccfromdate = '2013-10-10'
*/
--
	 set @dropped = 0

	 -- таблица для вывода наружу и удаления файлов
	 if exists ( select * from tempdb..sysobjects where id = object_id ( 'tempdb..#a' ))
		Drop table #a
	 if exists ( select * from tempdb..sysobjects where id = object_id ( 'tempdb..#b' ))
		Drop table #b
		
	 Create table #a ( IdRecDir int, ALineNum nvarchar ( 20 ), BLineNum nvarchar ( 20 ), TimeStart DateTime, FromCC bit )
	 Create table #b ( IdConf uniqueidentifier, IdRecDir int, Room int, TimeStart DateTime, IsRecorded bit )


	 if ( @pbxdropfiles = 1 and @ccdropfiles = 1 ) 
		  Insert into #a
			   Select IdRecDir, ALineNum, BLineNum, TimeStart, FromCC
			   From A_Stat_Connections_1x1 
			   Where (( TimeStart < @pbxfromdate and FromCC = 0 )
					Or ( TimeStart < @ccfromdate and FromCC = 1 )) 
					And IsRecorded = 1
			   Order By TimeStart

	 else if ( @pbxdropfiles = 1 )
		  Insert into #a
			   Select IdRecDir, ALineNum, BLineNum, TimeStart, FromCC
			   From A_Stat_Connections_1x1 
			   Where ( TimeStart < @pbxfromdate and FromCC = 0 )
					And IsRecorded = 1
			   Order By TimeStart

	 else if ( @ccdropfiles = 1 )
		  Insert into #a
			   Select IdRecDir, ALineNum, BLineNum, TimeStart, FromCC
			   From A_Stat_Connections_1x1 
			   Where ( TimeStart < @ccfromdate and FromCC = 1 )
					And IsRecorded = 1
			   Order By TimeStart

	 
	 -- Конференции тоже будем удалять. Они относятся к PBX
	 if ( @pbxdropfiles = 1 )
		  Insert into #b
			   Select Id, IdRecDir, Room, TimeStart, IsRecorded
			   From A_Stat_Conference 
			   Where ( TimeStart < @pbxfromdate )
					And ( IsRecorded = 1 )

	 
	 -- удаление из таблицы
	 if ( @pbxdrop = 1 and @ccdrop = 1 ) begin
		  -- И АТС и КЦ удаляем
		  Delete
		  From A_Stat_Connections_1x1 
		  Where (( TimeStart < @pbxfromdate ) and ( FromCC = 0 ))
				Or (( TimeStart < @ccfromdate ) and ( FromCC = 1 ))

		  Set @dropped = @@rowcount
		  
	 end else if ( @pbxdrop = 1 ) begin
		  -- АТС удаляем
		  Delete
		  From A_Stat_Connections_1x1 
		  Where (( TimeStart < @pbxfromdate ) and ( FromCC = 0 ))
		  
		  Set @dropped = @@rowcount
		  
		  -- КЦ не удаляем, но устанавливаем, что не нужно больше на них смотреть
		  Update A_Stat_Connections_1x1
		  Set IsRecorded = 0
		  Where (( TimeStart < @ccfromdate ) and ( FromCC = 1 ) and ( IsRecorded = 1 ))
	 
	 end else if ( @ccdrop = 1 ) begin
		  -- КЦ удаляем
		  Delete
		  From A_Stat_Connections_1x1 
		  Where (( TimeStart < @ccfromdate ) and ( FromCC = 1 ))

		  Set @dropped = @@rowcount
		  
		  -- АТС не удаляем, но устанавливаем, что не нужно больше на них смотреть
		  Update A_Stat_Connections_1x1
		  Set IsRecorded = 0
		  Where (( TimeStart < @pbxfromdate ) and ( FromCC = 0 ) and ( IsRecorded = 1 ))
		  
	 end else begin
			
		  -- АТС не удаляем, но устанавливаем, что не нужно больше на них смотреть
		  Update A_Stat_Connections_1x1
		  Set IsRecorded = 0
		  Where (( TimeStart < @pbxfromdate ) and ( FromCC = 0 ) and ( IsRecorded = 1 ))
		  
		  -- КЦ не удаляем, но устанавливаем, что не нужно больше на них смотреть
		  Update A_Stat_Connections_1x1
		  Set IsRecorded = 0
		  Where (( TimeStart < @ccfromdate ) and ( FromCC = 1 ) and ( IsRecorded = 1 ))
	 end


	 -- Конференции, неудачные и пропущенные тоже удаляем. По PBX флагу
	 if ( @pbxdrop = 1 ) begin
		  -- Конфы удаляем
		  Delete 
		  From A_Stat_Conference
		  Where ( TimeStart < @pbxfromdate )

		  Set @dropped = @dropped + @@rowcount

		  Delete
		  From A_Stat_Conference_Competitors 
		  Where not exists ( Select Id from A_Stat_Conference where A_Stat_Conference.Id = IdConf )
		  
		   -- Пропущенные удаляем
		  Delete 
		  From A_Stat_MissedCalls
		  Where ( TimeStart < @pbxfromdate )
		  
		  -- Неудачные удаляем
		  Delete 
		  From A_Stat_FailedCalls
		  Where ( TimeStart < @pbxfromdate )	  
		  
	 end else begin
		  -- Конфы не удаляем, но устанавливаем, что не нужно больше на них смотреть
		  Update A_Stat_Conference
		  Set IsRecorded = 0
		  Where ( TimeStart < @pbxfromdate ) and ( IsRecorded = 1 )
		  
	 end
	
	 
	 -- вывод наружу
	 Select IdRecDir, ALineNum, BLineNum, TimeStart, FromCC
	 From #a

	 Union

	 Select IdRecDir, cast ( Room as nvarchar(20) ), '', TimeStart, 0 
	 From #b 
 
end
GO