﻿

-------------------------------------------------------------------------
if exists ( select * from oktell_settings..sysobjects where id = object_id ( 'oktell_settings.dbo.A_Policy_ObjectTypes' ))
	Drop table oktell_settings.dbo.A_Policy_ObjectTypes
GO

Create table oktell_settings.dbo.A_Policy_ObjectTypes
( 
	[id] int primary key,
	[name] nvarchar(500),
	[isBasicType] bit Default 1
)
GO

--------------------------------

Insert into oktell_settings.dbo.A_Policy_ObjectTypes ( id, name )
Values ( 101, 'project' )

Insert into oktell_settings.dbo.A_Policy_ObjectTypes ( id, name )
Values ( 102, 'task' )

Insert into oktell_settings.dbo.A_Policy_ObjectTypes ( id, name )
Values ( 103, 'report' )

Insert into oktell_settings.dbo.A_Policy_ObjectTypes ( id, name )
Values ( 104, 'indicator' )

Insert into oktell_settings.dbo.A_Policy_ObjectTypes ( id, name )
Values ( 105, 'dashboard' )

Insert into oktell_settings.dbo.A_Policy_ObjectTypes ( id, name )
Values ( 106, 'script' )

Insert into oktell_settings.dbo.A_Policy_ObjectTypes ( id, name )
Values ( 107, 'calllist' )

GO

-------------------------------------------------------------------------
if exists ( select * from oktell_settings..sysobjects where id = object_id ( 'oktell_settings.dbo.A_Policy_Objects' ))
	Drop table oktell_settings.dbo.A_Policy_Objects
GO

Create table oktell_settings.dbo.A_Policy_Objects
( 
	[id] uniqueidentifier Primary Key,
	[type] int,
	[name] nvarchar(500), -- ?
	[idParentProject] uniqueidentifier
)
GO

-------------------------------------------------------------------------
if exists ( select * from oktell_settings..sysobjects where id = object_id ( 'oktell_settings.dbo.A_Policy_Privileges' ))
	Drop table oktell_settings.dbo.A_Policy_Privileges
GO

Create table oktell_settings.dbo.A_Policy_Privileges
(
	[id] uniqueidentifier Primary Key,
	[objType] int,
	[knot] nvarchar(50),
	[name] nvarchar(1000),	
	[code] nvarchar(200),
	[levelNesting] int Default 0,
	[isBasicType] bit Default 1,
	[isPolicyModify] bit Default 0
)
GO

--------------------------------
use oktell_settings
if exists (select * from dbo.sysindexes where name = N'idx_PolicyPrivileges_ObjType' and id = object_id(N'[dbo].[A_Policy_Privileges]'))
	Drop index [A_Policy_Privileges].[idx_PolicyPrivileges_ObjType]
GO

use oktell_settings
Create Nonclustered Index [idx_PolicyPrivileges_ObjType] 
On [dbo].[A_Policy_Privileges] ( [ObjType] ) 
With FillFactor = 80 ON [PRIMARY]
GO

--------------------------------
use oktell_settings

Truncate table A_Policy_Privileges

Select * FROM A_Policy_Privileges order by knot

Insert into A_Policy_Privileges (id, objtype, knot, name, code, levelNesting, isBasicType, isPolicyModify)
Values ('F876E650-7972-475A-AE96-BCCF831AF818',	101,	'101.1',	'Просмотр',		'ProjectView',		1,	1,	0)

Insert into A_Policy_Privileges (id, objtype, knot, name, code, levelNesting, isBasicType, isPolicyModify)
Values ('C892CC9E-4660-4ABC-8AD1-BAECDBFEAAC3',	101,	'101.2',	'Изменение',	'ProjectEdit',		2,	1,	1)

Insert into A_Policy_Privileges (id, objtype, knot, name, code, levelNesting, isBasicType, isPolicyModify)
Values ('8E2C5D49-08E0-48CE-9628-661BB6007889',	102,	'102.1',	'Просмотр',		'TaskView',			1,	1,	0)

Insert into A_Policy_Privileges (id, objtype, knot, name, code, levelNesting, isBasicType, isPolicyModify)
Values ('003FD36D-85F7-4A1C-8BC1-2E35732EDA63',	102,	'102.2',	'Старт/стоп',	'TaskActivate',		2,	1,	0)

Insert into A_Policy_Privileges (id, objtype, knot, name, code, levelNesting, isBasicType, isPolicyModify)
Values ('46D69D19-46DC-4B82-ADD2-9B9209AA769F',	102,	'102.3',	'Перезапуск',	'TaskClearStat',	3,	1,	0)

Insert into A_Policy_Privileges (id, objtype, knot, name, code, levelNesting, isBasicType, isPolicyModify)
Values ('49C5337B-3660-467B-9C58-2B793CBAF2C2',	102,	'102.4',	'Изменение',	'TaskEdit',			4,	1,	1)

Insert into A_Policy_Privileges (id, objtype, knot, name, code, levelNesting, isBasicType, isPolicyModify)
Values ('67139CAC-5C95-45DF-88A1-FBE8CC8F7BA4',	103,	'103.1',	'Просмотр',		'ReportView',		1,	1,	0)

Insert into A_Policy_Privileges (id, objtype, knot, name, code, levelNesting, isBasicType, isPolicyModify)
Values ('A7ECEDEA-76A3-4BBF-98DA-D05CD1B84F9D',	103,	'103.2',	'Изменение',	'ReportEdit',		2,	1,	1)

Insert into A_Policy_Privileges (id, objtype, knot, name, code, levelNesting, isBasicType, isPolicyModify)
Values ('495DEB4D-D5FF-4C52-A219-541C3AEC6CAC',	104,	'104.1',	'Просмотр',		'IndicatorView',	1,	1,	0)

Insert into A_Policy_Privileges (id, objtype, knot, name, code, levelNesting, isBasicType, isPolicyModify)
Values ('A2E397DF-40DB-4C80-BB2D-8CD49A29E09D',	104,	'104.2',	'Изменение',	'IndicatorEdit',	2,	1,	1)

Insert into A_Policy_Privileges (id, objtype, knot, name, code, levelNesting, isBasicType, isPolicyModify)
Values ('95176304-7E76-46FE-A473-0DF01F29B863',	105,	'105.1',	'Просмотр',		'DashboardView',	1,	1,	0)

Insert into A_Policy_Privileges (id, objtype, knot, name, code, levelNesting, isBasicType, isPolicyModify)
Values ('C04D309A-159F-4F13-9C50-01B74945CAD5',	105,	'105.2',	'Изменение',	'DashboardEdit',	2,	1,	1)

Insert into A_Policy_Privileges (id, objtype, knot, name, code, levelNesting, isBasicType, isPolicyModify)
Values ('8BBFAB7B-460C-4D5B-B4E4-1695F86AF6D1',	106,	'106.1',	'Просмотр',		'ScriptView',		1,	1,	0)

Insert into A_Policy_Privileges (id, objtype, knot, name, code, levelNesting, isBasicType, isPolicyModify)
Values ('B8CDCA65-866D-4636-92B9-8C8F58FF76D3',	106,	'106.2',	'Изменение',	'ScriptEdit',		2,	1,	1)

Insert into A_Policy_Privileges (id, objtype, knot, name, code, levelNesting, isBasicType, isPolicyModify)
Values ('A3800C07-462C-4E33-B985-8D8FA921E0C2',	107,	'107.1',	'Просмотр',		'CalllistView',		1,	1,	0)

Insert into A_Policy_Privileges (id, objtype, knot, name, code, levelNesting, isBasicType, isPolicyModify)
Values ('3D8CB103-C18B-4F35-BC96-E2F7E9E09A8E',	107,	'107.2',	'Изменение',	'CalllistEdit',		2,	1,	1)
GO

use oktell
GO

-------------------------------------------------------------------------
if exists ( select * from oktell_settings..sysobjects where id = object_id ( 'oktell_settings.dbo.A_Policy_PrivilegeDefaults' ))
	Drop table oktell_settings.dbo.A_Policy_PrivilegeDefaults
GO

Create table oktell_settings.dbo.A_Policy_PrivilegeDefaults
(
	[idPrivilege] uniqueidentifier, 
	[idSubject] uniqueidentifier,
	[subjType] int,
	[subjExtraId] uniqueidentifier, 
	[value] int
)
GO

--------------------------------
use oktell_settings
if exists (select * from dbo.sysindexes where name = N'idx_PolicyPrivilegeDef_idPriv' and id = object_id(N'[dbo].[A_Policy_PrivilegeDefaults]'))
	Drop index [A_Policy_PrivilegeDefaults].[idx_PolicyPrivilegeDef_idPriv]
GO

use oktell_settings
Create Nonclustered Index [idx_PolicyPrivilegeDef_idPriv] 
On [dbo].[A_Policy_PrivilegeDefaults] ( [idPrivilege] ) 
With FillFactor = 80 ON [PRIMARY]
GO

use oktell
GO

-------------------------------------------------------------------------
if exists ( select * from oktell_settings..sysobjects where id = object_id ( 'oktell_settings.dbo.A_Policy_SubjectTypes' ))
	Drop table oktell_settings.dbo.A_Policy_SubjectTypes
GO

Create table oktell_settings.dbo.A_Policy_SubjectTypes
(
	-- Код типа
	[id] int,
	-- Название типа
	[name] nvarchar(500),
	-- Вспомогательный идентификатор
	[groupId] uniqueidentifier,
	-- Режим сравнения (соотсветствия по полям 1-только по типу, 2-по типу и основному идентификатору, 3-по типу и двум идентификаторам, 4-по типу и доп идентификатору)
	[equalMode] int,
	-- Тип представляет собой замыкание на привилегии других объектов 
	[isNested] bit Default 0
)
GO

--------------------------------
use oktell_settings
if exists (select * from dbo.sysindexes where name = N'idx_PolicySubjectTypes_id_groupid' and id = object_id(N'[dbo].[A_Policy_SubjectTypes]'))
	Drop index [A_Policy_SubjectTypes].[idx_PolicySubjectTypes_id_groupid]
GO

use oktell_settings
Create Nonclustered Index [idx_PolicySubjectTypes_id_groupid] 
On [dbo].[A_Policy_SubjectTypes] ( [id], [groupId] ) 
With FillFactor = 80 ON [PRIMARY]
GO

use oktell
GO

--------------------------------

Insert into oktell_settings.dbo.A_Policy_SubjectTypes ( id, name, equalmode )
Values ( 1, 'user', 2 )

Insert into oktell_settings.dbo.A_Policy_SubjectTypes ( id, name, equalmode )
Values ( 2, 'department', 2 )

Insert into oktell_settings.dbo.A_Policy_SubjectTypes ( id, name, equalmode )
Values ( 3, 'user role', 2 )

Insert into oktell_settings.dbo.A_Policy_SubjectTypes ( id, name, equalmode, [groupId] )
Values ( 4, 'all operators', 1, '4BEC0D77-2AE1-49DD-AB99-CD306454A809' )

Insert into oktell_settings.dbo.A_Policy_SubjectTypes ( id, name, equalmode )
Values ( 5, 'operators of task', 2 )

Insert into oktell_settings.dbo.A_Policy_SubjectTypes ( id, name, equalmode, [groupId] )
Values ( 6, 'operators of project', 2, 'D99E54D2-0EF5-4CC1-A751-BD1642A7A02D' )

Insert into oktell_settings.dbo.A_Policy_SubjectTypes ( id, name, equalmode, [groupId] )
Values ( 7, 'all supervisors', 1, '74C5D339-4E68-4CA6-AB44-3188B6CAAA06' )

Insert into oktell_settings.dbo.A_Policy_SubjectTypes ( id, name, equalmode )
Values ( 8, 'supervisors of task', 2 )

Insert into oktell_settings.dbo.A_Policy_SubjectTypes ( id, name, equalmode, [groupId] )
Values ( 9, 'supervisors of project', 2, 'E96FD541-5985-4FCD-95FE-59EE4CD11BF0' )

Insert into oktell_settings.dbo.A_Policy_SubjectTypes ( id, name, equalmode, [groupId] )
Values ( 12, 'current project operators', 3, 'D99E54D2-0EF5-4CC1-A751-BD1642A7A02D' )

Insert into oktell_settings.dbo.A_Policy_SubjectTypes ( id, name, equalmode, [groupId] )
Values ( 13, 'current project supervisors', 3, 'F3A13B50-6801-4D1A-8640-C3A7693EC5F6' )

Insert into oktell_settings.dbo.A_Policy_SubjectTypes ( id, name, equalmode, [groupId] )
Values ( 14, 'all users', 1, 'E96FD541-5985-4FCD-95FE-59EE4CD11BF0' )

Insert into oktell_settings.dbo.A_Policy_SubjectTypes ( id, name, equalmode, isNested )
Values ( 101, 'object privilege', 3, 1 )

Insert into oktell_settings.dbo.A_Policy_SubjectTypes ( id, name, equalmode, [groupId], isNested )
Values ( 101, 'current project viewers', 4, 'F876E650-7972-475A-AE96-BCCF831AF818', 1 )

Insert into oktell_settings.dbo.A_Policy_SubjectTypes ( id, name, equalmode, [groupId], isNested )
Values ( 101, 'current project editors', 4, 'C892CC9E-4660-4ABC-8AD1-BAECDBFEAAC3', 1 )

GO

-------------------------------------------------------------------------
if exists ( select * from oktell_settings..sysobjects where id = object_id ( 'oktell_settings.dbo.A_Policy_SubjectTypePriority' ))
	Drop table oktell_settings.dbo.A_Policy_SubjectTypePriority
GO

Create table oktell_settings.dbo.A_Policy_SubjectTypePriority
(
	[idType] int primary key,
	[priority] int
)
GO

--------------------------------
use oktell_settings
if exists (select * from dbo.sysindexes where name = N'idx_PolicySubjPriority_Prioriy' and id = object_id(N'[dbo].[A_Policy_SubjectTypePriority]'))
	Drop index [dbo].[A_Policy_SubjectTypePriority].[idx_PolicySubjPriority_Prioriy]
GO

use oktell_settings
Create Nonclustered Index [idx_PolicySubjPriority_Prioriy] 
On [dbo].[A_Policy_SubjectTypePriority]([priority]) 
With FillFactor = 80 ON [PRIMARY]
GO

use oktell
GO

-------------------------------------------------------------------------
if exists ( select * from oktell_settings..sysobjects where id = object_id ( 'oktell_settings.dbo.A_Policy_SubjectPrivileges' ))
	Drop table oktell_settings.dbo.A_Policy_SubjectPrivileges
GO

Create table oktell_settings.dbo.A_Policy_SubjectPrivileges
( 
	-- Ид субъекта (юзера, отдела, задачи, проекта, роли, другого объекта чьи привилегии участвуют в образовании прав здесь)
	[idSubject] uniqueidentifier, 
	-- Тип субъекта (таблица A_Policy_SubjectTypes)
	[subjType] int, 
	-- Дополнительный идентификатор (ид привилегии при оформлении на основе привилегий другого объекта, например все читатели проекта X)
	[subjExtraId] uniqueidentifier,
	-- Ид объекта
	[idObject] uniqueidentifier,
	-- Ид привилегии
	[idPrivilege] uniqueidentifier,	
	-- Разрешено/запрещено
	[value] int,
	-- Дефолтная или измененная
	[isDefault] bit Default 0,
	-- Кто создал
	[idCreator] uniqueidentifier
)
GO

--------------------------------
use oktell_settings
if exists (select * from dbo.sysindexes where name = N'idx_PolicySubjPrivileges_Subject' and id = object_id(N'[dbo].[A_Policy_SubjectPrivileges]'))
	Drop index [dbo].[A_Policy_SubjectPrivileges].[idx_PolicySubjPrivileges_Subject]
GO

use oktell_settings
Create Nonclustered Index [idx_PolicySubjPrivileges_Subject] 
On [dbo].[A_Policy_SubjectPrivileges]([idSubject], [subjType], [subjExtraId]) 
With FillFactor = 80 ON [PRIMARY]
GO

--------------------------------
use oktell_settings
if exists (select * from dbo.sysindexes where name = N'idx_PolicySubjPrivileges_Object' and id = object_id(N'[dbo].[A_Policy_SubjectPrivileges]'))
	Drop index [dbo].[A_Policy_SubjectPrivileges].[idx_PolicySubjPrivileges_Object]
GO

use oktell_settings
Create Nonclustered Index [idx_PolicySubjPrivileges_Object] 
On [dbo].[A_Policy_SubjectPrivileges]([idObject], [idPrivilege], [value]) 
With FillFactor = 80 ON [PRIMARY]
GO

use oktell
GO

-------------------------------------------------------------------------
if exists ( select * from oktell_settings..sysobjects where id = object_id ( 'oktell_settings.dbo.A_Policy_SubjectGroupCache' ))
	Drop table oktell_settings.dbo.A_Policy_SubjectGroupCache
GO

Create table oktell_settings.dbo.A_Policy_SubjectGroupCache
( 
	idUser uniqueidentifier,
	idSubject uniqueidentifier,
	subjType int,
	subjExtraId uniqueidentifier,
	levelNesting int,
	isUpdating bit Default 0
)
GO

--------------------------------
use oktell_settings
if exists (select * from dbo.sysindexes where name = N'idx_PolicySubjGroupCache_Object' and id = object_id(N'[dbo].[A_Policy_SubjectGroupCache]'))
	Drop index [dbo].[A_Policy_SubjectGroupCache].[idx_PolicySubjGroupCache_Object]
GO

use oktell_settings
Create Nonclustered Index [idx_PolicySubjGroupCache_Object] 
On [dbo].[A_Policy_SubjectGroupCache]([idUser]) 
With FillFactor = 80 ON [PRIMARY]
GO

use oktell
GO

--------------------------------
Delete 
From A_Settings
Where (name like 'PolicyCacheUpdate')
	or (name like 'PolicyFilter')
GO

-------------------------------------------------------------------------
-------------------------------------------------------------------------
-------------------------------------------------------------------------

if exists ( select * from sysobjects where id = object_id ( 'dbo.A_Policy_ObjectTypes' ))
	Drop view dbo.A_Policy_ObjectTypes
GO

Create view dbo.A_Policy_ObjectTypes
as 
	Select * 
	From oktell_settings.dbo.A_Policy_ObjectTypes
GO

-------------------------------------------------------------------------
if exists ( select * from sysobjects where id = object_id ( 'dbo.A_Policy_Objects' ))
	Drop view dbo.A_Policy_Objects
GO

Create view dbo.A_Policy_Objects
as 
	Select * 
	From oktell_settings.dbo.A_Policy_Objects
GO

-------------------------------------------------------------------------
if exists ( select * from sysobjects where id = object_id ( 'dbo.A_Policy_Privileges' ))
	Drop view dbo.A_Policy_Privileges
GO

Create view dbo.A_Policy_Privileges
as 
	Select * 
	From oktell_settings.dbo.A_Policy_Privileges
GO

-------------------------------------------------------------------------
if exists ( select * from sysobjects where id = object_id ( 'dbo.A_Policy_PrivilegeDefaults' ))
	Drop view dbo.A_Policy_PrivilegeDefaults
GO

Create view dbo.A_Policy_PrivilegeDefaults
as 
	Select * 
	From oktell_settings.dbo.A_Policy_PrivilegeDefaults
GO

-------------------------------------------------------------------------
if exists ( select * from sysobjects where id = object_id ( 'dbo.A_Policy_SubjectTypes' ))
	Drop view dbo.A_Policy_SubjectTypes
GO

Create view dbo.A_Policy_SubjectTypes
as 
	Select * 
	From oktell_settings.dbo.A_Policy_SubjectTypes
GO

-------------------------------------------------------------------------
if exists ( select * from sysobjects where id = object_id ( 'dbo.A_Policy_SubjectTypePriority' ))
	Drop view dbo.A_Policy_SubjectTypePriority
GO

Create view dbo.A_Policy_SubjectTypePriority
as 
	Select * 
	From oktell_settings.dbo.A_Policy_SubjectTypePriority
GO

-------------------------------------------------------------------------
if exists ( select * from sysobjects where id = object_id ( 'dbo.A_Policy_SubjectPrivileges' ))
	Drop view dbo.A_Policy_SubjectPrivileges
GO

Create view dbo.A_Policy_SubjectPrivileges
as 
	Select * 
	From oktell_settings.dbo.A_Policy_SubjectPrivileges
GO

-------------------------------------------------------------------------
if exists ( select * from sysobjects where id = object_id ( 'dbo.A_Policy_SubjectGroupCache' ))
	Drop view dbo.A_Policy_SubjectGroupCache
GO

Create view dbo.A_Policy_SubjectGroupCache
as 
	Select * 
	From oktell_settings.dbo.A_Policy_SubjectGroupCache
GO


--------------------------------------------------------------------------
--------------------------------------------------------------------------
--------------------------------------------------------------------------

if exists ( select * from sysobjects where id = object_id ( 'dbo.A_Policy_SubjectGroups_GetByUser' ))
	Drop procedure dbo.A_Policy_SubjectGroups_GetByUser
GO

Create procedure dbo.A_Policy_SubjectGroups_GetByUser
	@myuser uniqueidentifier,
	@buildnesting bit = 1,
	@nestinglevels int = 100
as
begin
		
	-- Возвращает список идентификаторов и типов ролей, в которых участвует пользователь,
	--  чтобы затем пересекать итог с таблицами на определение наличия привилегий.
	
	if exists ( Select * From tempdb..sysobjects where id=object_id('tempdb..#myroles'))
		Drop table #myroles
		
	Create table #myroles 
	( 
		[idSubject] uniqueidentifier, 
		[subjType] int, 
		[subjExtraId] uniqueidentifier, 
		[levelNesting] int 
	)

	
	-- Сам пользователь
	Insert into #myroles ( [idSubject], [subjType] )
		Select @myuser, 1

	
	-- Отдел
	Insert into #myroles ( [idSubject], [subjType] )
		Select Distinct g.ID, 2
		From A_Groups g
			inner join A_Users u on u.parentgroupid = g.id	
		Where u.id = @myuser

			
	-- Роли
	Insert into #myroles ( [idSubject], [subjType] )
		Select Distinct r.Id, 3
		From A_UserRoles_Roles r
			Inner join A_UserRoles_RolesOfUsers u on u.IdRole = r.Id
		Where u.IdUser = @myuser		
		
		
	-- Все операторы
	Insert into #myroles ( [idSubject], [subjType] )
		Select Top 1 st.[groupId], 4
		From A_UserParams up
			Inner join A_Policy_SubjectTypes st on (st.[id] = 4)
		Where ( up.IsOperator = 1 )
			and ( up.IdUser = @myuser )
		
		
	-- Операторы задачи
	Insert into #myroles ( [idSubject], [subjType] )
		Select Distinct t.Id, 5
		From A_TaskManager_Tasks t
			Inner join A_TaskManager_Operators o on o.TaskId = t.Id
			Inner join A_UserParams up on up.IdUser = o.OperatorId
			--Inner join A_Users u on u.Id = o.OperatorId
		Where ( up.IsOperator = 1 )-- and ( u.Login like 'peter' )
			and ( up.IdUser = @myuser )
			
		
	-- Операторы проекта
	Insert into #myroles ( [idSubject], [subjType] )
		Select Distinct p.Id, 6
		From A_TaskManager_Projects p
			Inner join A_TaskManager_Tasks t on t.IdProject = p.Id
			Inner join A_TaskManager_Operators o on o.TaskId = t.Id
			Inner join A_UserParams up on up.IdUser = o.OperatorId		
		Where ( up.IsOperator = 1 )
			and ( up.IdUser = @myuser )
		
		
	-- Все супервизоры (должны иметь также доступ к проектам соответствующим)
	Insert into #myroles ( [idSubject], [subjType] )
		Select Top 1 st.[groupId], 7
		From A_TaskManager_TaskSupervisors s
			Inner join A_Policy_SubjectTypes st on (st.[id] = 7)
			--Inner join A_TaskManager_Tasks t on t.Id = s.TaskId
			--Inner join A_TaskManager_Projects p on p.Id = t.ProjectId
		Where s.SupervisorId = @myuser
			
		
	-- Супервизоры задачи (должны иметь также доступ к проекту и задаче соответствующим)
	Insert into #myroles ( [idSubject], [subjType] )
		Select Distinct t.Id, 8
		From A_TaskManager_Tasks t
			Inner join A_TaskManager_TaskSupervisors s on s.TaskId = t.Id
		Where s.SupervisorId = @myuser
			
			
	-- Супервизоры проекта (должны иметь также доступ к проекту и задачам соответствующим)
	Insert into #myroles ( [idSubject], [subjType] )
		Select Distinct p.Id, 9
		From A_TaskManager_Projects p
			Inner join A_TaskManager_Tasks t on t.IdProject = p.Id
			Inner join A_TaskManager_TaskSupervisors s on s.TaskId = t.Id
		Where s.SupervisorId = @myuser
		
			
	-- Операторы текущего проекта (копия с другим индексом)
	Insert into #myroles ( [idSubject], [subjType] )
		Select [idSubject], 12
		From #myroles
		Where [subjType] = 6
		
		
	-- Супервизоры текущего проекта (копия с другим индексом)
	Insert into #myroles ( [idSubject], [subjType] )
		Select [idSubject], 13
		From #myroles
		Where [subjType] = 9
				
					
	-- Все пользователи	
	Insert into #myroles ( [idSubject], [subjType] )
		Select st.[groupId], 14
		From A_Policy_SubjectTypes st
		Where st.[id] = 14
		
	
	-- Копия привилегии другого объекта (101)
	-- Строится отдельно по запросу
		
	-- Вложенные привилегии
	if ((@buildnesting = 1) and (@nestinglevels > 0)) begin
		
		-- Те объекты, чьи привилегии участвуют в замыкании ролевой политики
		--  Мы можем существенно сократить объем итоговой таблицы, поскольку
		--  применение привилегий через привилегии - еще под вопросом.
		if exists ( select * from tempdb..sysobjects where id = object_id ( 'tempdb..#closureobjects' ))
			Drop table #closureobjects
		
		Create table #closureobjects ( idobject uniqueidentifier, idprivilege uniqueidentifier )
		
		Insert into #closureobjects ( idobject, idprivilege )
			Select Distinct idSubject, subjExtraId
			From dbo.A_Policy_SubjectPrivileges
			Where subjType = 101
			
		if ( @@rowcount > 0 ) begin
			
			-- Вспомогательная таблица для промежуточного итога группировки при построении списка субъектов из привилегий других объектов	
			if exists ( select * from tempdb..sysobjects where id= object_id('tempdb..#A'))
				Drop table #A
				
			Create table #A ( [idObject] uniqueidentifier, [idPrivilege] uniqueidentifier, [subjType] int, [value] int )
		
			-- Нулевой уровень вложенных ссылок на привилегии объектов (например все читатели проекта X)
			--  С учетом запретов и приоритетов разных субъектных групповых объединений
			-- Среди односортных типов ищем разрешения (запреты менее приоритетны)
			Insert into #A ( [idObject], [idPrivilege], [subjType], [value] )
				Select sp.[idObject], sp.[idPrivilege], mr.[subjType], Max ( sp.[value] ) as [value]
				From A_Policy_SubjectPrivileges sp
					Inner join #myroles mr on (mr.[idSubject] = sp.[idSubject]) and (mr.[subjType] = sp.[subjType])
					Inner join #closureobjects cl on (cl.[idObject] = sp.[idObject]) and (cl.[idPrivilege] = sp.[idPrivilege])
				Group by sp.[idObject], sp.[idPrivilege], mr.[subjType]
				
			-- Среди всех групп выбираем первую по сортировочному приоритету и именно ее значение value берем
			--  На выход нас интересуют разрешенные - те у кого value получился 1
			Insert into #myroles ( [idSubject], [subjType], [subjExtraId], [levelNesting] )
				Select a.[idObject], 101, a.[idPrivilege], 0
				From ( Select a.[idObject], a.[idPrivilege], Min(b.[priority]) as priority
						From #A a
							inner join dbo.A_Policy_SubjectTypePriority b on b.[idType] = a.[subjType]
						Group by a.[idObject], a.[idPrivilege]
					)x
					Inner join dbo.A_Policy_SubjectTypePriority b on b.[priority] = x.[priority]
					Inner join #A a on (b.[idType] = a.[subjType]) and (x.[idObject] = a.[idObject]) and (x.[idPrivilege] = a.[idPrivilege])
				Where a.[value] = 1
				
					
			-- Остальные уровни вложенных ссылок на привилегии объектов
			Declare @i int
			Set @i = 0
			
			While ( @@rowcount > 0 ) begin
							
				Set @i = @i + 1
				
				if ( @i >= @nestinglevels )
					break
							
				-- Только один следующий уровень участвует
				-- Среди односортных типов ищем разрешения (запреты менее приоритетны)
				Truncate table #A
				
				Insert into #A ( [idObject], [idPrivilege], [subjType], [value] )
					Select sp.[idObject], sp.[idPrivilege], mr.[subjType], Max ( sp.[value] )
					From A_Policy_SubjectPrivileges sp
						Inner join ( Select * 
									 From #myroles mr
									 Where (mr.[subjType] = 101) and (mr.[levelNesting] = @i-1)
									) mr on (mr.[idSubject] = sp.[idSubject]) and (mr.[subjType] = sp.[subjType]) and (mr.[subjExtraId] = sp.[subjExtraId])
						Inner join #closureobjects cl on (cl.[idObject] = sp.[idObject]) and (cl.[idPrivilege] = sp.[idPrivilege])
					Group by sp.[idObject], sp.[idPrivilege], mr.[subjType]
				
				-- Среди всех групп выбираем первую по сортировочному приоритету и именно ее значение value берем
				--  На выход нас интересуют разрешенные - те у кого value получился 1
				Insert into #myroles ( [idSubject], [subjType], [subjExtraId], [levelNesting] )
					Select a.[idObject], 101, a.[idPrivilege], @i
					From ( Select a.[idObject], a.[idPrivilege], Min(b.[priority]) as priority
							From #A a
								inner join dbo.A_Policy_SubjectTypePriority b on b.[idType] = a.[subjType]
							Group by a.[idObject], a.[idPrivilege]
						)x
						Inner join dbo.A_Policy_SubjectTypePriority b on b.[priority] = x.[priority]
						Inner join #A a on (b.[idType] = a.[subjType]) and (x.[idObject] = a.[idObject]) and (x.[idPrivilege] = a.[idPrivilege])
					Where (a.[value] = 1)
						and not exists ( Select mr.[idSubject]
										 From #myroles mr 
										 Where (mr.[idSubject] = a.[idObject]) 
											and (mr.[subjExtraId] = a.[idPrivilege]))
			end
			
			Drop table #A
			
		end
		
		Drop table #closureobjects
	end


	Select * 
	From #myroles mr
	Order by mr.[subjType], mr.[levelNesting]
		
end
GO

--------------------------------------------------------------------------
if exists ( select * from sysobjects where id = object_id ( 'dbo.A_Policy_SubjectGroups_GetByAllUsers' ))
	Drop procedure dbo.A_Policy_SubjectGroups_GetByAllUsers
GO

Create procedure dbo.A_Policy_SubjectGroups_GetByAllUsers
	@myuser uniqueidentifier = NULL,
	@buildnesting bit = 1,
	@nestinglevels int = 100,
	@fillcache bit = 0
as
begin
		
	-- Возвращает список идентификаторов и типов ролей, в которых участвует пользователь,
	--  чтобы затем пересекать итог с таблицами на определение наличия привилегий.
		
	if exists ( Select * From tempdb..sysobjects where id=object_id('tempdb..#userroles'))
		Drop table #userroles
		
	Create table #userroles 
	( 
		[idUser] uniqueidentifier, 
		[idSubject] uniqueidentifier, 
		[subjType] int, 
		[subjExtraId] uniqueidentifier, 
		[levelNesting] int 
	)

	-- Сам пользователь
	Insert into #userroles ([idUser], [idSubject], [subjType])
		Select [ID], [ID], 1
		From dbo.A_Users u		
		Where (u.[IsDeleted] = 0)
			and ((@myuser is NULL) or (@myuser = u.[ID]))

		
	-- Отдел
	Insert into #userroles ([idUser], [idSubject], [subjType])
		Select Distinct u.[ID], g.[ID], 2
		From A_Groups g
			inner join A_Users u on u.[parentgroupid] = g.[ID]
		Where (u.[IsDeleted] = 0)
			and ((@myuser is NULL) or (@myuser = u.[ID]))


	-- Роли
	Insert into #userroles ([idUser], [idSubject], [subjType])
		Select Distinct u.[Id], r.[Id], 3
		From A_UserRoles_Roles r
			Inner join A_UserRoles_RolesOfUsers ur on ur.[IdRole] = r.[Id]
			Inner join A_Users u on u.[Id] = ur.[IdUser]
		Where (u.[IsDeleted] = 0)
			and ((@myuser is NULL) or (@myuser = u.[Id]))
		
		
	-- Все операторы (должны иметь также доступ к проектам соответствующим)
	Insert into #userroles ([idUser], [idSubject], [subjType])
		Select Distinct u.[ID], st.[groupId], 4
		From A_UserParams up
			Inner join A_Users u on u.[ID] = up.[IdUser]
			Inner join A_Policy_SubjectTypes st on st.[id] = 4
		Where (u.[IsDeleted] = 0)
			and ((@myuser is NULL) or (@myuser = u.[ID]))
			and (up.[IsOperator] = 1)
			
		
	-- Операторы задачи (должны иметь также доступ к проекту соответствующему)
	Insert into #userroles ([idUser], [idSubject], [subjType])
		Select Distinct u.[Id], t.[Id], 5
		From A_TaskManager_Tasks t
			Inner join A_TaskManager_Operators o on o.[TaskId] = t.[Id]
			Inner join A_UserParams up on up.[IdUser] = o.[OperatorId]
			Inner join A_Users u on u.[Id] = o.[OperatorId]
		Where (u.[IsDeleted] = 0)
			and ((@myuser is NULL) or (@myuser = u.[Id]))
			and (up.[IsOperator] = 1)
			
		
	-- Операторы проекта (должны иметь также доступ к проекту соответствующему)
	Insert into #userroles ([idUser], [idSubject], [subjType])
		Select Distinct u.[Id], p.[Id], 6
		From A_TaskManager_Projects p
			Inner join A_TaskManager_Tasks t on t.[IdProject] = p.[Id]
			Inner join A_TaskManager_Operators o on o.[TaskId] = t.[Id]
			Inner join A_UserParams up on up.[IdUser] = o.[OperatorId]
			Inner join A_Users u on u.[Id] = o.[OperatorId]
		Where (u.[IsDeleted] = 0)
			and ((@myuser is NULL) or (@myuser = u.[Id]))
			and (up.[IsOperator] = 1)	
				
			
	-- Все супервизоры (должны иметь также доступ к проектам соответствующим)
	Insert into #userroles ([idUser], [idSubject], [subjType])
		Select Distinct u.[Id], st.[groupId], 7
		From A_TaskManager_TaskSupervisors s
			Inner join dbo.A_Users u on u.[id] = s.[SupervisorId]
			Inner join A_Policy_SubjectTypes st on st.[id] = 7
		Where (u.[IsDeleted] = 0)
			and ((@myuser is NULL) or (@myuser = u.[Id]))
			
	
	-- Супервизоры задачи (должны иметь также доступ к проекту и задаче соответствующим)
	Insert into #userroles ([idUser], [idSubject], [subjType])
		Select Distinct u.[Id], t.[Id], 8
		From A_TaskManager_Tasks t
			Inner join A_TaskManager_TaskSupervisors s on s.[TaskId] = t.[Id]
			Inner join A_Users u on u.[Id] = s.[SupervisorId]
		Where (u.[IsDeleted] = 0)
			and ((@myuser is NULL) or (@myuser = u.[Id]))
			
	
	-- Супервизоры проекта (должны иметь также доступ к проекту и задачам соответствующим)
	Insert into #userroles ([idUser], [idSubject], [subjType])
		Select Distinct u.[Id], p.[Id], 9
		From A_TaskManager_Projects p
			Inner join A_TaskManager_Tasks t on t.[IdProject] = p.[Id]
			Inner join A_TaskManager_TaskSupervisors s on s.[TaskId] = t.[Id]
			Inner join A_Users u on u.[Id] = s.[SupervisorId]
		Where (u.[IsDeleted] = 0)
			and ((@myuser is NULL) or (@myuser = u.[Id]))
		
			
	-- Операторы текущего проекта (копия с другим индексом и размещением ид проекта в subjExtraId)
	Insert into #userroles ( [idUser], [idSubject], [subjType], [subjExtraId] )
		Select [idUser], st.[groupId], 12, [idSubject]
		From #userroles
			Inner join A_Policy_SubjectTypes st on st.[id] = 12
		Where [subjType] = 6
		
		
	-- Супервизоры текущего проекта (копия с другим индексом и размещением ид проекта в subjExtraId)
	Insert into #userroles ( [idUser], [idSubject], [subjType], [subjExtraId] )
		Select [idUser], st.[groupId], 13, [idSubject]
		From #userroles
			Inner join A_Policy_SubjectTypes st on st.[id] = 13
		Where [subjType] = 9
						
						
	-- Все пользователи	
	Insert into #userroles ([idUser], [idSubject], [subjType])
		Select u.[Id], st.[groupId], 14
		From A_Users u
			Inner join A_Policy_SubjectTypes st on st.[id] = 14
		Where (u.[IsDeleted] = 0)
			and ((@myuser is NULL) or (@myuser = u.[Id]))
		
	
	
	-- Копия привилегии другого объекта (101)
	-- Строится отдельно по запросу
	
		
	-- Вложенные привилегии
	if ((@buildnesting = 1) and (@nestinglevels > 0)) begin
		
		-- Те объекты, чьи привилегии участвуют в замыкании ролевой политики
		--  Мы можем существенно сократить объем итоговой таблицы, поскольку
		--  применение привилегий через привилегии - еще под вопросом.
		if exists ( select * from tempdb..sysobjects where id = object_id ( 'tempdb..#closureobjects' ))
			Drop table #closureobjects
		
		Create table #closureobjects ( idobject uniqueidentifier, idprivilege uniqueidentifier )
		
		Insert into #closureobjects ( idobject, idprivilege )
			Select Distinct idSubject, subjExtraId
			From dbo.A_Policy_SubjectPrivileges
			Where subjType = 101
			
		if ( @@rowcount > 0 ) begin
			
			-- Вспомогательная таблица для промежуточного итога группировки при построении списка субъектов из привилегий других объектов	
			if exists ( select * from tempdb..sysobjects where id= object_id('tempdb..#A'))
				Drop table #A
				
			Create table #A ( [idUser] uniqueidentifier, [idObject] uniqueidentifier, [idPrivilege] uniqueidentifier, [subjType] int, [value] int )
		
			-- Нулевой уровень вложенных ссылок на привилегии объектов (например все читатели проекта X)
			--  С учетом запретов и приоритетов разных субъектных групповых объединений
			-- Среди односортных типов ищем разрешения (запреты менее приоритетны)
			Insert into #A ( [idUser], [idObject], [idPrivilege], [subjType], [value] )
				Select ur.[idUser], sp.[idObject], sp.[idPrivilege], ur.[subjType], Max ( sp.[value] ) as [value]
				From A_Policy_SubjectPrivileges sp
					Inner join #userroles ur on (ur.[idSubject] = sp.[idSubject]) and (ur.[subjType] = sp.[subjType])
					Inner join #closureobjects cl on (cl.[idObject] = sp.[idObject]) and (cl.[idPrivilege] = sp.[idPrivilege])
				Group by ur.[idUser], sp.[idObject], sp.[idPrivilege], ur.[subjType]
				
			-- Среди всех групп выбираем первую по сортировочному приоритету и именно ее значение value берем
			--  На выход нас интересуют разрешенные - те у кого value получился 1
			Insert into #userroles ([idUser], [idSubject], [subjType], [subjExtraid], [levelNesting])
				Select a.[idUser], a.[idObject], 101, a.[idPrivilege], 0
				From ( Select a.[idUser], a.[idObject], a.[idPrivilege], Min(b.[priority]) as priority
						From #A a
							inner join dbo.A_Policy_SubjectTypePriority b on b.[idType] = a.[subjType]
						Group by a.[idUser], a.[idObject], a.[idPrivilege]
					)x
					Inner join dbo.A_Policy_SubjectTypePriority b on b.[priority] = x.[priority]
					Inner join #A a on (b.[idType] = a.[subjType]) 
										and (x.[idUser] = a.[idUser]) 
										and (x.[idObject] = a.[idObject]) 
										and (x.[idPrivilege] = a.[idPrivilege])
				Where a.[value] = 1
				
					
			-- Остальные уровни вложенных ссылок на привилегии объектов
			Declare @i int
			Set @i = 0
			
			While ( @@rowcount > 0 ) begin
							
				Set @i = @i + 1
				
				if ( @i >= @nestinglevels )
					break
							
				-- Только один следующий уровень участвует
				-- Среди односортных типов ищем разрешения (запреты менее приоритетны)
				Truncate table #A
				
				Insert into #A ( [idUser], [idObject], [idPrivilege], [subjType], [value] )
					Select ur.[idUser], sp.[idObject], sp.[idPrivilege], ur.[subjType], Max ( sp.[value] )
					From A_Policy_SubjectPrivileges sp
						Inner join ( Select * 
									 From #userroles ur
									 Where (ur.[subjType] = 101) and (ur.[levelNesting] = @i-1)
									) ur on (ur.[idSubject] = sp.[idSubject]) and (ur.[subjType] = sp.[subjType]) and (ur.[subjExtraId] = sp.[subjExtraId])
						Inner join #closureobjects cl on (cl.[idObject] = sp.[idObject]) and (cl.[idPrivilege] = sp.[idPrivilege])
					Group by ur.[idUser], sp.[idObject], sp.[idPrivilege], ur.[subjType]
				
				-- Среди всех групп выбираем первую по сортировочному приоритету и именно ее значение value берем
				--  На выход нас интересуют разрешенные - те у кого value получился 1
				Insert into #userroles ([idUser], [idSubject], [subjType], [subjExtraid], [levelNesting])
					Select a.[idUser], a.[idObject], 101, a.[idPrivilege], @i
					From ( Select a.[idUser], a.[idObject], a.[idPrivilege], Min(b.[priority]) as priority
							From #A a
								inner join dbo.A_Policy_SubjectTypePriority b on b.[idType] = a.[subjType]
							Group by a.[idUser], a.[idObject], a.[idPrivilege]
						)x
						Inner join dbo.A_Policy_SubjectTypePriority b on b.[priority] = x.[priority]
						Inner join #A a on (b.[idType] = a.[subjType]) 
										and (x.[idUser] = a.[idUser]) 
										and (x.[idObject] = a.[idObject]) 
										and (x.[idPrivilege] = a.[idPrivilege])
					Where (a.[value] = 1)
						and not exists ( Select ur.[idSubject]
										 From #userroles ur 
										 Where (ur.[idSubject] = a.[idObject]) 
											and (ur.[subjExtraId] = a.[idPrivilege]))
			end
			
			Drop table #A
			
		end
		
		Drop table #closureobjects
	end

	if ( @fillcache = 1 ) begin
	
		Insert into A_Policy_SubjectGroupCache ( [idUser], [idSubject], [subjType], [subjExtraId], [levelNesting] )		
			Select [idUser], [idSubject], [subjType], [subjExtraId], [levelNesting]
			From #userroles ur
			
	end else begin
	
			Select [idUser], [idSubject], [subjType], [subjExtraId], [levelNesting]
			From #userroles ur
			Order by ur.[subjType], ur.[levelNesting]		
	end	
		
end
GO

-------------------------------------------------------------------------
if exists ( select * from sysobjects where id=object_id ( 'dbo.A_Policy_SubjectGroupCache_Update' ))
	Drop procedure dbo.A_Policy_SubjectGroupCache_Update
GO

Create procedure dbo.A_Policy_SubjectGroupCache_Update
as
begin

	-- Строит по новой кэш вхождений пользователей в группы субъектов
	
	-- Удалять то чего нет - неэффективная операция, поэтому через полную вставку
	
	-- Прежние записи помечаем обновляемыми
	Update A_Policy_SubjectGroupCache
	Set [isUpdating] = 1
	
	-- Полностью вставляем новую копию (но не через INSERT EXEC)
	exec dbo.A_Policy_SubjectGroups_GetByAllUsers @fillcache = 1
		
	-- Удаляем помеченное устаревшее
	Delete 
	From A_Policy_SubjectGroupCache
	Where [isUpdating] = 1
	
	
	
	-- Обновляем версию в A_Settings
	Update A_Settings
	Set [valueDateTime] = GetDate()
	Where [name] like 'PolicyCacheVersion'
	
	if ( @@rowcount = 0 ) 
		Insert into A_Settings ( name, valueDateTime )
		Values ( 'PolicyCacheVersion', GetDate() )
	
end
GO

-------------------------------------------------------------------------
if exists ( select * from sysobjects where id=object_id ( 'dbo.A_Policy_SubjectGroupCache_CheckUpdate' ))
	Drop procedure dbo.A_Policy_SubjectGroupCache_CheckUpdate
GO

Create procedure dbo.A_Policy_SubjectGroupCache_CheckUpdate
as
begin

	Declare @update int
	
	Select @update = [valueInt]
	From A_Settings
	Where name like 'PolicyCacheUpdate'
		
	if (( @update is null ) or ( @update > 0 )) begin
	
		begin tran PolicyCache
		
			-- Еще раз проверка, чтобы дубликаты одновременные не исполняли
			Select @update = [valueInt]
			From A_Settings
			Where name like 'PolicyCacheUpdate'
			
			if (( @update is null ) or ( @update > 0 )) begin

				-- Перестраиваем таблицу привилегий
				exec dbo.A_Policy_SubjectGroupCache_Update
				
				-- Обновляем, что все сделано
				Update A_Settings
				Set [valueInt] = 0
				Where [name] like 'PolicyCacheUpdate'
				
				if ( @@rowcount = 0 ) 
					Insert into A_Settings ( name, valueint )
					Values ( 'PolicyCacheUpdate', 0 )
					
			end
					
		commit tran PolicyCache
		
	end

end
GO

-------------------------------------------------------------------------
if exists ( select * from sysobjects where id=object_id ( 'dbo.A_Policy_SubjectGroupCache_SetUpdate' ))
	Drop procedure dbo.A_Policy_SubjectGroupCache_SetUpdate
GO

Create procedure dbo.A_Policy_SubjectGroupCache_SetUpdate
as
begin

	begin tran PolicyCache
		
		-- Обновляем, что все сделано
		Update A_Settings
		Set [valueInt] = 1
		Where [name] like 'PolicyCacheUpdate'
		
		if ( @@rowcount = 0 ) 
			Insert into A_Settings ( name, valueint )
			Values ( 'PolicyCacheUpdate', 1 )				
				
	commit tran PolicyCache

end
GO

--------------------------------------------------------------------------
if exists ( select * from sysobjects where id = object_id ( 'dbo.A_Policy_SubjectGroups_GetList' ))
	Drop procedure dbo.A_Policy_SubjectGroups_GetList
GO

Create procedure dbo.A_Policy_SubjectGroups_GetList
	@objecttype int = 0
as 
begin

	-- Возвращает список всех именованных субъектов, доступных для назначения прав

	if exists ( Select * From tempdb..sysobjects where id=object_id('tempdb..#subjects'))
		Drop table #subjects
		
	Create table #subjects ( [type] int, [name] nvarchar(500), [id] uniqueidentifier, [extraId] uniqueidentifier, [equalMode] int )


	-- Пользователи
	Insert into #subjects ( [type], [name], [id], [extraId], [equalMode] )
		Select 1, [Name], [Id], null, 2
		From A_Users u
		Where u.IsDeleted = 0
	
	-- Отделы
	Insert into #subjects ( [type], [name], [id], [extraId], [equalMode] )
		Select 2, [Name], [Id], null, 2
		From A_Groups g	
	
	-- Роли
	Insert into #subjects ( [type], [name], [id], [extraId], [equalMode] )
		Select 3, r.[Name], r.[Id], null, 2
		From A_UserRoles_Roles r
		Where not exists ( Select Id from A_Users u Where u.Id = r.Id )
			and Domination = 0
	
	
	-- Все операторы	
	Declare @alloperators nvarchar(200)
	Select @alloperators = langvalue 
	From A_LangTexts
	Where langkey like 'alloperators'
	if ( @alloperators is NULL )
		Set @alloperators = 'Все операторы'
		
	Insert into #subjects ( [type], [name], [id], [extraId], [equalMode] )
		Select 4, @alloperators, st.[groupId], null, 1
		From A_Policy_SubjectTypes st
		Where st.[id] = 4
		
		
	if ( @objecttype in ( 0, 101, 102, 105, 106, 107 )) begin
	
		-- Операторы текущего проекта
		Declare @currentprojectoperators nvarchar(200)
		Select @currentprojectoperators = langvalue 
		From A_LangTexts
		Where langkey like 'currentprojectoperators'
		if ( @currentprojectoperators is NULL )
			Set @currentprojectoperators = 'Операторы текущего проекта'
			
		Insert into #subjects ( [type], [name], [id], [extraId], [equalMode] )
			Select 12, @currentprojectoperators, st.[groupId], null, 1
			From A_Policy_SubjectTypes st
			Where st.[id] = 12
	end
	
	
	---- Операторы задачи
	--Declare @taskoperators nvarchar(200)
	--Select @taskoperators = langvalue 
	--From A_LangTexts
	--Where langkey like 'taskoperators'
	--if ( @taskoperators is NULL )
	--	Set @taskoperators = 'Операторы задачи'
		
	--Insert into #subjects ( [type], [name], [id], [extraId], [equalMode] )
	--	Select 5, @taskoperators + ' «' + t.[Name] + '»', t.[Id], null, 2
	--	From A_TaskManager_Tasks t
		
		
	---- Операторы проекта
	--Declare @projectoperators nvarchar(200)
	--Select @projectoperators = langvalue 
	--From A_LangTexts
	--Where langkey like 'projectoperators'
	--if ( @projectoperators is NULL )
	--	Set @projectoperators = 'Операторы проекта'
		
	--Insert into #subjects ( [type], [name], [id], [extraId], [equalMode] )
	--	Select 5, @projectoperators + ' «' + p.[Name] + '»', p.[Id], null, 2
	--	From A_TaskManager_Projects p
	
	
	-- Все супервизоры
	Declare @allsupervisors nvarchar(200)
	Select @allsupervisors = langvalue 
	From A_LangTexts
	Where langkey like 'allsupervisors'
	if ( @allsupervisors is NULL )
		Set @allsupervisors = 'Все супервизоры'
		
	Insert into #subjects ( [type], [name], [id], [extraId], [equalMode] )		
		Select 7, @allsupervisors, st.[groupId], null, 1
		From A_Policy_SubjectTypes st
		Where st.[id] = 7
	
	
	if ( @objecttype in ( 0, 101, 102, 105, 106, 107 )) begin
	
		-- Супервизоры текущего проекта	
		Declare @currentprojectsupervisors nvarchar(200)
		Select @currentprojectsupervisors = langvalue 
		From A_LangTexts
		Where langkey like 'currentprojectsupervisors'
		if ( @currentprojectsupervisors is NULL )
			Set @currentprojectsupervisors = 'Супервизоры текущего проекта'
			
		Insert into #subjects ( [type], [name], [id], [extraId], [equalMode] )
			Select 13, @currentprojectsupervisors, st.[groupId], null, 1
			From A_Policy_SubjectTypes st
			Where st.[id] = 13	
	end
	
	---- Супервизоры задачи
	--Declare @tasksupervisors nvarchar(200)
	--Select @tasksupervisors = langvalue 
	--From A_LangTexts
	--Where langkey like 'tasksupervisors'
	--if ( @tasksupervisors is NULL )
	--	Set @tasksupervisors = 'Супервизоры задачи'
		
	--Insert into #subjects ( [type], [name], [id], [extraId], [equalMode] )
	--	Select 8, @tasksupervisors + ' «' + t.[Name] + '»', t.[Id], null, 2
	--	From A_TaskManager_Tasks t
		
		
	---- Супервизоры проекта
	--Declare @projectsupervisors nvarchar(200)
	--Select @projectsupervisors = langvalue 
	--From A_LangTexts
	--Where langkey like 'projectsupervisors'
	--if ( @projectsupervisors is NULL )
	--	Set @projectsupervisors = 'Супервизоры проекта'
		
	--Insert into #subjects ( [type], [name], [id], [extraId], [equalMode] )
	--	Select 9, @projectsupervisors + ' «' + p.[Name] + '»', p.[Id], null, 2
	--	From A_TaskManager_Projects p
	

	---- Владельцы проекта
	--Declare @projectowners nvarchar(200)
	--Select @projectowners = langvalue 
	--From A_LangTexts
	--Where langkey like 'projectowners'
	--if ( @projectowners is NULL )
	--	Set @projectowners = 'Владельцы проекта'
		
	--Insert into #subjects ( [type], [name], [id], [extraId], [equalMode] )
	--	Select 10, @projectowners + ' «' + p.[Name] + '»', p.[Id], null, 2
	--	From A_TaskManager_Projects p


	-- По другим привилегиями других объектов - ниже
	
	
	-- Все пользователи
	Declare @allusers nvarchar(200)
	Select @allusers = langvalue 
	From A_LangTexts
	Where langkey like 'allusers'
	if ( @allusers is NULL )
		Set @allusers = 'Все пользователи'
		
	Insert into #subjects ( [type], [name], [id], [extraId], [equalMode] )		
		Select 14, @allusers, st.[groupId], null, 1
		From A_Policy_SubjectTypes st
		Where st.[id] = 14


	-- По привилегиям всех объектов - слишком много попадет в список. Пропустим пока.
	-- Только на проекты сошлемся
	
	if ( @objecttype in ( 0, 102, 105, 106, 107 )) begin
		
		Declare @idempty uniqueidentifier
		Set @idempty = '00000000-0000-0000-0000-000000000000'
		
		
		-- Читатели текущего проекта
		Declare @currentprojectviewers nvarchar(200)
		Select @currentprojectviewers = langvalue 
		From A_LangTexts
		Where langkey like 'currentprojectviewers'
		if ( @currentprojectviewers is NULL )
			Set @currentprojectviewers = 'Пользователи с правом просмотра текущего проекта'
			
		Insert into #subjects ( [type], [name], [id], [extraId], [equalMode] )
			Select 101, @currentprojectviewers, @idempty, 'F876E650-7972-475A-AE96-BCCF831AF818', 4
					
						
		-- Редакторы текущего проекта
		Declare @currentprojectredactors nvarchar(200)
		Select @currentprojectredactors = langvalue 
		From A_LangTexts
		Where langkey like 'currentprojectredactors'
		if ( @currentprojectredactors is NULL )
			Set @currentprojectredactors = 'Пользователи с правом изменения текущего проекта'
			
		Insert into #subjects ( [type], [name], [id], [extraId], [equalMode] )
			Select 101, @currentprojectredactors, @idempty, 'C892CC9E-4660-4ABC-8AD1-BAECDBFEAAC3', 4
						
	end
	
	
	-- Итоговый вывод
	Select s.[type], tp.[priority], s.[name], s.[id], s.[extraId], s.[equalMode]
	From #subjects s
		Inner join dbo.A_Policy_SubjectTypePriority tp on tp.[idType] = s.[type]
	Order By tp.[priority], s.[name]
	
end
GO

--------------------------------------------------------------------------
--------------------------------------------------------------------------
--------------------------------------------------------------------------
if exists ( select * from sysobjects where id = object_id ( 'dbo.A_Policy_SubjectPrivileges_GetForUserByObject' ))
	Drop procedure dbo.A_Policy_SubjectPrivileges_GetForUserByObject
GO

Create procedure dbo.A_Policy_SubjectPrivileges_GetForUserByObject
	@iduser uniqueidentifier,
	@idobject uniqueidentifier = '00000000-0000-0000-0000-000000000000',
	@idprivilege uniqueidentifier = NULL,
	@onlyreturncount bit = 0,
	@resultcount int = 0
as 
begin
	-- Возвращает список всех установленных привилегий (разрешений)
	--  на конкретный объект для указанного пользователя
	--  с учетом вложенности назначенных привилегий по разным объектам

	-- Обновляем кэш при необходимости
	exec A_Policy_SubjectGroupCache_CheckUpdate
	
	
	-- Строим разрешения на объект с учетом приоритета для субъектных групп (например всем разрешено, а юзеру запрещено)		
		
	-- Вспомогательная таблица для промежуточного итога группировки при построении списка субъектов из привилегий других объектов	
	if exists ( select * from tempdb..sysobjects where id= object_id('tempdb..#A'))
		Drop table #A
		
	Create table #A ( [idPrivilege] uniqueidentifier, [subjType] int, [value] int )
		
	-- С учетом запретов и приоритетов разных субъектных групповых объединений
	-- Среди односортных типов ищем разрешения (запреты менее приоритетны)
	Insert into #A ( [idPrivilege], [subjType], [value] )
		Select sp.[idPrivilege], ur.[subjType], Max ( sp.[value] ) as [value]
		From A_Policy_SubjectPrivileges sp
			Inner join dbo.A_Policy_SubjectGroupCache ur on (ur.[idSubject] = sp.[idSubject]) and (ur.[subjType] = sp.[subjType]) and ((ur.[subjExtraId] is null) or (ur.[subjExtraId] = sp.[subjExtraid]))
		Where (sp.[idObject] = @idobject)
			and (ur.idUser = @iduser)
			and ((@idprivilege is NULL) or (sp.[idPrivilege] = @idprivilege))
		Group by sp.[idPrivilege], ur.[subjType]
				
	-- Среди всех групп выбираем первую по сортировочному приоритету и именно ее значение value берем
	--  На выход нас интересуют разрешенные - те у кого value получился 1
	Declare @tempresult table ( [idobject] uniqueidentifier, [idprivilege] uniqueidentifier, [code] nvarchar(200), [type] int )
	
	Insert into @tempresult ( [idobject], [idprivilege], [code], [type] )		
		Select @idobject, a.[idPrivilege], p.[code], o.[type]
		From ( Select a.[idPrivilege], Min(b.[priority]) as priority
				From #A a
					inner join dbo.A_Policy_SubjectTypePriority b on b.[idType] = a.[subjType]
				Group by a.[idPrivilege]
			)x
			Inner join dbo.A_Policy_SubjectTypePriority b on b.[priority] = x.[priority]
			Inner join #A a on (b.[idType] = a.[subjType])
								and (x.[idPrivilege] = a.[idPrivilege])		
			Inner join dbo.A_Policy_Objects o on (o.[id] = @idobject)
			Inner join dbo.A_Policy_Privileges p on p.[id] = a.[idPrivilege]
		Where a.[value] = 1		
	
	-- Разные варианты возврата значения
	if ( @onlyreturncount = 0 ) begin	
		Select *
		From @tempresult	
	end else 	
		Select @resultcount = Count(*)
		From @tempresult
			
end
GO

--------------------------------------------------------------------------
if exists ( select * from sysobjects where id = object_id ( 'dbo.A_Policy_SubjectPrivileges_GetForUserByObjectType' ))
	Drop procedure dbo.A_Policy_SubjectPrivileges_GetForUserByObjectType
GO

Create procedure dbo.A_Policy_SubjectPrivileges_GetForUserByObjectType
	@iduser uniqueidentifier,
	@objecttype int = 0,
	@idparentproject uniqueidentifier = NULL,
	@idprivilege uniqueidentifier = NULL,
	@onlyreturncount bit = 0,
	@resultcount int = 0
as 
begin
	-- Возвращает список всех установленных привилегий (разрешений) 
	--  для всех объектов указанного типа для указанного пользователя
	--  с учетом вложенности назначенных привилегий по разным объектам

	-- Обновляем кэш при необходимости
	exec A_Policy_SubjectGroupCache_CheckUpdate
	
	
	-- Строим разрешения на объект с учетом приоритета для субъектных групп (например всем разрешено, а юзеру запрещено)		
	
	-- Вспомогательная таблица для промежуточного итога группировки при построении списка субъектов из привилегий других объектов	
	if exists ( select * from tempdb..sysobjects where id= object_id('tempdb..#A'))
		Drop table #A
		
	Create table #A ( [idObject] uniqueidentifier, [idPrivilege] uniqueidentifier, [subjType] int, [value] int )
		
	-- С учетом запретов и приоритетов разных субъектных групповых объединений
	-- Среди односортных типов ищем разрешения (запреты менее приоритетны)
	Insert into #A ( [idObject], [idPrivilege], [subjType], [value] )
		Select sp.[idObject], sp.[idPrivilege], ur.[subjType], Max ( sp.[value] ) as [value]
		From A_Policy_SubjectPrivileges sp
			Inner join dbo.A_Policy_SubjectGroupCache ur on (ur.[idSubject] = sp.[idSubject]) and (ur.[subjType] = sp.[subjType]) and ((ur.[subjExtraId] is null) or (ur.[subjExtraId] = sp.[subjExtraid]))
			Inner join dbo.A_Policy_Objects o on o.[id] = sp.[idObject]
		Where (ur.[idUser] = @iduser)
			and ((@objecttype = 0) or (o.[type] = @objecttype))
			and ((@idparentproject is NULL) or (o.[idParentProject] = @idparentproject))
			and ((@idprivilege is NULL) or (sp.[idPrivilege] = @idprivilege))
		Group by sp.[idObject], sp.[idPrivilege], ur.[subjType]
				
	-- Среди всех групп выбираем первую по сортировочному приоритету и именно ее значение value берем
	--  На выход нас интересуют разрешенные - те у кого value получился 1
	Declare @tempresult table ( [idobject] uniqueidentifier, [idprivilege] uniqueidentifier, [code] nvarchar(200) )
	
	Insert into @tempresult ( [idobject], [idprivilege], [code] )		
		Select a.[idObject], a.[idPrivilege], p.[code]
		From ( Select a.[idObject], a.[idPrivilege], Min(b.[priority]) as priority
				From #A a
					inner join dbo.A_Policy_SubjectTypePriority b on b.[idType] = a.[subjType]
				Group by a.[idObject], a.[idPrivilege]
			)x
			Inner join dbo.A_Policy_SubjectTypePriority b on b.[priority] = x.[priority]
			Inner join #A a on (b.[idType] = a.[subjType]) 
								and (x.[idObject] = a.[idObject]) 
								and (x.[idPrivilege] = a.[idPrivilege])
			Inner join dbo.A_Policy_Privileges p on p.[id] = a.[idPrivilege]
		Where a.[value] = 1
		Order by a.[idObject], a.[idPrivilege]
	
	
	-- Разные варианты возврата значения
	if ( @onlyreturncount = 0 ) begin	
		Select *
		From @tempresult	
	end else 	
		Select @resultcount = Count(*)
		From @tempresult
	
end
GO

--------------------------------------------------------------------------
if exists ( select * from sysobjects where id = object_id ( 'dbo.A_Policy_SubjectPrivileges_CheckUserHasModifyPrivilege' ))
	Drop procedure dbo.A_Policy_SubjectPrivileges_CheckUserHasModifyPrivilege
GO

Create procedure dbo.A_Policy_SubjectPrivileges_CheckUserHasModifyPrivilege
	@idUser uniqueidentifier,
	@idObject uniqueidentifier,
	@onlyreturnvalue bit = 0,
	@resultvalue int = 0
as
begin
	-- Проверяет наличие у пользователя на объект привилегии, позволяющей модифицировать политику доступа (с учетом назначения разных субъектов)
	-- В выборке возвращает:
	--   0 - у объекта есть привилегия изменения прав, и у пользователя она установлена
	--   100 - объект не найден в таблице правовой политики
	--   102 - у объекта есть привилегия изменения прав, но у пользователя она не установлена
	--   1 - у объекта нет ни одной привилегии изменения прав
	
	-- Обновляем кэш при необходимости
	exec A_Policy_SubjectGroupCache_CheckUpdate
	
	
	-- Есть ли у объекта привилегии с типом isPolicyModify
	-- Если есть - смотрим, доступна ли она указанному пользователю - если не доступна - на выход
	-- Если доступна, или если нет привилегии с типом isPolicyModify, 
	-- то проверяем изменяемую привилегию. Даем изменять те, которые у самого есть.
	
	-- Тип объекта
	Declare @objType int	
	Select @objType = [type]
	From A_Policy_Objects o		
	Where o.[id] = @idObject
	
	-- Объект не найден
	if ( @objType is NULL ) begin
		if ( @onlyreturnvalue = 0 )
			Select 100
		else
			Set @resultvalue = 100
		return
	end
	
	
	-- Привилегии для объекта с типом 'модификация политики привилегий'
	Declare @pmPrivileges table ( [id] uniqueidentifier )
	Insert into @pmPrivileges ( [id] )
		Select p.[id]
		From A_Policy_Privileges p
		Where (p.[objType] = @objType)
			and (p.[isPolicyModify] = 1)
	
	
	-- Проверяем наличие привилегии изменения прав доступа у пользователя. Ищем хотя бы одну, которая разрешает
	if ( @@rowcount > 0 ) begin
		
		Declare @hasmodify int
		
		-- Вспомогательная таблица для промежуточного итога группировки при построении списка субъектов из привилегий других объектов	
		if exists ( select * from tempdb..sysobjects where id= object_id('tempdb..#A'))
			Drop table #A
			
		Create table #A ( [idObject] uniqueidentifier, [idPrivilege] uniqueidentifier, [subjType] int, [value] int )
			
		-- С учетом запретов и приоритетов разных субъектных групповых объединений
		-- Среди односортных типов ищем разрешения (запреты менее приоритетны)
		Insert into #A ( [idObject], [idPrivilege], [subjType], [value] )
			Select sp.[idObject], sp.[idPrivilege], ur.[subjType], Max ( sp.[value] ) as [value]
			From A_Policy_SubjectPrivileges sp
				Inner join dbo.A_Policy_SubjectGroupCache ur on (ur.[idSubject] = sp.[idSubject]) and (ur.[subjType] = sp.[subjType]) and ((ur.[subjExtraId] is null) or (ur.[subjExtraId] = sp.[subjExtraid]))
				Inner join @pmPrivileges pmp on sp.[idPrivilege] = pmp.[id]
			Where (sp.[idObject] = @idObject)
				and (ur.[idUser] = @iduser)
			Group by sp.[idObject], sp.[idPrivilege], ur.[subjType]
					
		-- Среди всех групп выбираем первую по сортировочному приоритету и именно ее значение value берем
		--  На выход нас интересуют разрешенные - те у кого value получился 1
		Select @hasmodify = Count ( * )
		From ( Select a.[idObject], a.[idPrivilege], Min(b.[priority]) as priority
				From #A a
					inner join dbo.A_Policy_SubjectTypePriority b on b.[idType] = a.[subjType]
				Group by a.[idObject], a.[idPrivilege]
			)x
			Inner join dbo.A_Policy_SubjectTypePriority b on b.[priority] = x.[priority]
			Inner join #A a on (b.[idType] = a.[subjType]) 
								and (x.[idObject] = a.[idObject]) 
								and (x.[idPrivilege] = a.[idPrivilege])
		Where a.[value] = 1
		
		
		if (( @hasmodify is NULL ) or ( @hasmodify = 0 )) begin			
			-- Нельзя менять
			if ( @onlyreturnvalue = 0 )
				Select 102
			else
				Set @resultvalue = 102
			return
		end
		
		-- Можно менять
		if ( @onlyreturnvalue = 0 )
			Select 0
		else
			Set @resultvalue = 0
		return
		
	end
	
	if ( @onlyreturnvalue = 0 )
		Select 1
	else
		Set @resultvalue = 1
	
end
GO

--------------------------------------------------------------------------
if exists ( select * from sysobjects where id = object_id ( 'dbo.A_Policy_SubjectPrivileges_CheckCanModifyPolicy' ))
	Drop procedure dbo.A_Policy_SubjectPrivileges_CheckCanModifyPolicy
GO

Create procedure dbo.A_Policy_SubjectPrivileges_CheckCanModifyPolicy
	@idUser uniqueidentifier,
	@idObject uniqueidentifier,
	@idPrivilege uniqueidentifier,
	@onlyreturnvalue bit = 0,
	@resultvalue int = 0
as 
begin

	-- Возвращает результат проверки возможности для указанного пользователя
	-- измененять указанную привилегию указанного объекта (с учетом разных типов субъектов)	
	-- В выборке возвращает:
	--   0 - у объекта есть привилегия изменения прав, и у пользователя она установлена, 
	--       либо у объекта нет привилегии изменения прав, но у пользователя установлена привилегия, 
	--       которую он хочет изменить (у другого субъекта или у себя)
	--   100 - объект не найден в таблице правовой политики
	--   102 - у объекта есть привилегия изменения прав, но у пользователя она не установлена	
	--   103 - у объекта нет ни одной привилегии изменения прав, и у пользователя не установлена привилегия, 
	--         которую он хочет изменить (у другого субъекта или у себя)
	
	
	-- Первая часть аналогична A_Policy_SubjectPrivileges_CheckUserHasModifyPrivilege.
	--   Нельзя вложенно исполнять INSERT EXEC, поэтому копия


	-- Обновляем кэш при необходимости
	exec A_Policy_SubjectGroupCache_CheckUpdate
	
	
	-- Есть ли у объекта привилегии с типом isPolicyModify
	-- Если есть - смотрим, доступна ли она указанному пользователю - если не доступна - на выход
	-- Если доступна, или если нет привилегии с типом isPolicyModify, 
	-- то проверяем изменяемую привилегию. Даем изменять те, которые у самого есть.
	
	-- Тип объекта
	Declare @objType int	
	Select @objType = [type]
	From A_Policy_Objects o		
	Where o.[id] = @idObject
	
	-- Объект не найден
	if ( @objType is NULL ) begin
		if ( @onlyreturnvalue = 0 )
			Select 100
		else
			Set @resultvalue = 100
		return
	end
	
	
	-- Привилегии для объекта с типом 'модификация политики привилегий'
	Declare @pmPrivileges table ( [id] uniqueidentifier )
	Insert into @pmPrivileges ( [id] )
		Select p.[id]
		From A_Policy_Privileges p
		Where (p.[objType] = @objType)
			and (p.[isPolicyModify] = 1)
	
	
	-- Проверяем наличие привилегии изменения прав доступа у пользователя. Ищем хотя бы одну, которая разрешает
	if ( @@rowcount > 0 ) begin
		
		Declare @hasmodify int
		
		-- Вспомогательная таблица для промежуточного итога группировки при построении списка субъектов из привилегий других объектов	
		if exists ( select * from tempdb..sysobjects where id= object_id('tempdb..#A'))
			Drop table #A
			
		Create table #A ( [idObject] uniqueidentifier, [idPrivilege] uniqueidentifier, [subjType] int, [value] int )
			
		-- С учетом запретов и приоритетов разных субъектных групповых объединений
		-- Среди односортных типов ищем разрешения (запреты менее приоритетны)
		Insert into #A ( [idObject], [idPrivilege], [subjType], [value] )
			Select sp.[idObject], sp.[idPrivilege], ur.[subjType], Max ( sp.[value] ) as [value]
			From A_Policy_SubjectPrivileges sp
				Inner join dbo.A_Policy_SubjectGroupCache ur on (ur.[idSubject] = sp.[idSubject]) and (ur.[subjType] = sp.[subjType]) and ((ur.[subjExtraId] is null) or (ur.[subjExtraId] = sp.[subjExtraid]))
				Inner join @pmPrivileges pmp on sp.[idPrivilege] = pmp.[id]
			Where (sp.[idObject] = @idObject)
				and (ur.[idUser] = @iduser)
			Group by sp.[idObject], sp.[idPrivilege], ur.[subjType]
					
		-- Среди всех групп выбираем первую по сортировочному приоритету и именно ее значение value берем
		--  На выход нас интересуют разрешенные - те у кого value получился 1
		Select @hasmodify = Count ( * )
		From ( Select a.[idObject], a.[idPrivilege], Min(b.[priority]) as priority
				From #A a
					inner join dbo.A_Policy_SubjectTypePriority b on b.[idType] = a.[subjType]
				Group by a.[idObject], a.[idPrivilege]
			)x
			Inner join dbo.A_Policy_SubjectTypePriority b on b.[priority] = x.[priority]
			Inner join #A a on (b.[idType] = a.[subjType]) 
								and (x.[idObject] = a.[idObject]) 
								and (x.[idPrivilege] = a.[idPrivilege])
		Where a.[value] = 1
		
		
		if (( @hasmodify is NULL ) or ( @hasmodify = 0 )) begin			
			-- Нельзя менять
			if ( @onlyreturnvalue = 0 )
				Select 102
			else
				Set @resultvalue = 102
			return
		end
		
		-- Можно менять
		if ( @onlyreturnvalue = 0 )
			Select 0
		else
			Set @resultvalue = 0		
		return
		
	end
	
	Declare @res int 
	Set @res = 1

	
	-- Дальше продолжение уникальное
	if ( @res = 0 ) begin
		
		-- Можно менять
		if ( @onlyreturnvalue = 0 )
			Select 0
		else
			Set @resultvalue = 0
		return
	
	end else if ( @res in (100, 102)) begin
		
		-- Невозможно определить наличие.
		-- Привилегия такая есть у объекта, но пользователю не разрешено.
		-- Значит менять нельзя
		if ( @onlyreturnvalue = 0 )
			Select @res
		else
			Set @resultvalue = @res
		return
		
	end else /* res = 1 */ begin
	
		-- Проверяем, установлена ли у самого юзера привилегия, которую пытается менять
		-- Возможно это условие в дальнейшем пригодится безусловно даже в том случае, если установлена привилегия изменения прав доступа
		
		Declare @hassame int
		
		-- Вспомогательная таблица для промежуточного итога группировки при построении списка субъектов из привилегий других объектов	
		if exists ( select * from tempdb..sysobjects where id= object_id('tempdb..#A'))
			Drop table #B
			
		Create table #B ( [idObject] uniqueidentifier, [idPrivilege] uniqueidentifier, [subjType] int, [value] int )
			
		-- С учетом запретов и приоритетов разных субъектных групповых объединений
		-- Среди односортных типов ищем разрешения (запреты менее приоритетны)
		Insert into #B ( [idObject], [idPrivilege], [subjType], [value] )
			Select sp.[idObject], sp.[idPrivilege], ur.[subjType], Max ( sp.[value] ) as [value]
			From A_Policy_SubjectPrivileges sp
				Inner join dbo.A_Policy_SubjectGroupCache ur on (ur.[idSubject] = sp.[idSubject]) and (ur.[subjType] = sp.[subjType]) and ((ur.[subjExtraId] is null) or (ur.[subjExtraId] = sp.[subjExtraid]))
			Where (sp.[idObject] = @idObject)
				and (sp.[idPrivilege] = @idPrivilege)
				and (ur.[idUser] = @iduser)				
			Group by sp.[idObject], sp.[idPrivilege], ur.[subjType]
					
		-- Среди всех групп выбираем первую по сортировочному приоритету и именно ее значение value берем
		--  На выход нас интересуют разрешенные - те у кого value получился 1
		Select @hassame = Count ( * )
		From ( Select a.[idObject], a.[idPrivilege], Min(b.[priority]) as priority
				From #B a
					inner join dbo.A_Policy_SubjectTypePriority b on b.[idType] = a.[subjType]
				Group by a.[idObject], a.[idPrivilege]
			)x
			Inner join dbo.A_Policy_SubjectTypePriority b on b.[priority] = x.[priority]
			Inner join #B a on (b.[idType] = a.[subjType]) 
								and (x.[idObject] = a.[idObject]) 
								and (x.[idPrivilege] = a.[idPrivilege])
		Where a.[value] = 1
		
		if (( @hassame is NULL ) or ( @hassame = 0 )) begin
			-- Нельзя менять
			if ( @onlyreturnvalue = 0 )
				Select 103
			else
				Set @resultvalue = 103
			return
		end
		
		-- Можно менять
		if ( @onlyreturnvalue = 0 )
			Select 0
		else
			Set @resultvalue = 0
		return
	
	end
	
end
GO

--------------------------------------------------------------------------
if exists ( select * from sysobjects where id = object_id ( 'dbo.A_Policy_SubjectPrivileges_GetByObject' ))
	Drop procedure dbo.A_Policy_SubjectPrivileges_GetByObject
GO

Create procedure dbo.A_Policy_SubjectPrivileges_GetByObject
	@idobject uniqueidentifier,
	@actionUserId uniqueidentifier = NULL	
as 
begin
	-- Возвращает список установленных привилегий (всех - и разрешенных, и запрещенных) для указанного объекта
	--  без учета вложенности привилегий по разным объектам
	
	-- Общие группы, названия из языковой таблицы
	Declare @groupnames table ( [id] int, [extraId] uniqueidentifier, [code] nvarchar(200) Collate Database_Default, [name] nvarchar(500) Collate Database_Default)

	Insert into @groupnames ( [id], [code], [name] ) Values ( 4, 'alloperators', 'Все операторы' )
	Insert into @groupnames ( [id], [code], [name] ) Values ( 7, 'allsupervisors', 'Все супервизоры' )
	Insert into @groupnames ( [id], [code], [name] ) Values ( 12, 'currentprojectoperators', 'Операторы текущего проекта' )
	Insert into @groupnames ( [id], [code], [name] ) Values ( 13, 'currentprojectsupervisors', 'Супервизоры текущего проекта' )
	Insert into @groupnames ( [id], [code], [name] ) Values ( 14, 'allusers', 'Все пользователи' )
	Insert into @groupnames ( [id], [extraId], [code], [name] ) Values ( 101, 'F876E650-7972-475A-AE96-BCCF831AF818', 'currentprojectviewers', 'Пользователи с правом просмотра текущего проекта' )
	Insert into @groupnames ( [id], [extraId], [code], [name] ) Values ( 101, 'C892CC9E-4660-4ABC-8AD1-BAECDBFEAAC3', 'currentprojectredactors', 'Пользователи с правом изменения текущего проекта' )

	Update g
	Set g.[name] = l.[langvalue]
	From @groupnames g, A_LangTexts l
	Where g.[code] = l.[langkey]
		
			
	-- Права пользователя на изменение привилегий
	Declare @resmodifyall int
	Declare @userprivileges table ( [idPrivilege] uniqueidentifier, [isHigherPrivilege] bit )
	
	Set @resmodifyall = 0
	if ( not @actionUserId is null ) begin
	
		-- Привилегия изменения прав для этого объекта есть?
		exec A_Policy_SubjectPrivileges_CheckUserHasModifyPrivilege 
			@idUser = @actionUserId, 
			@idObject = @idobject,
			@onlyreturnvalue = 1,
			@resultvalue = @resmodifyall OUTPUT
			
		-- Если нет, то выгребаем те привелегии, которые юзер сам имеет
		if ( @resmodifyall = 1 ) begin
		
			-- Вспомогательная таблица для промежуточного итога группировки при построении списка субъектов из привилегий других объектов	
			if exists ( select * from tempdb..sysobjects where id= object_id('tempdb..#A'))
				Drop table #A
				
			Create table #A ( [idObject] uniqueidentifier, [idPrivilege] uniqueidentifier, [subjType] int, [value] int )
				
			-- С учетом запретов и приоритетов разных субъектных групповых объединений
			-- Среди односортных типов ищем разрешения (запреты менее приоритетны)
			Insert into #A ( [idObject], [idPrivilege], [subjType], [value] )
				Select sp.[idObject], sp.[idPrivilege], ur.[subjType], Max ( sp.[value] ) as [value]
				From A_Policy_SubjectPrivileges sp
					Inner join dbo.A_Policy_SubjectGroupCache ur on (ur.[idSubject] = sp.[idSubject]) and (ur.[subjType] = sp.[subjType]) and ((ur.[subjExtraId] is null) or (ur.[subjExtraId] = sp.[subjExtraid]))
				Where (sp.[idObject] = @idObject)
					and (ur.[idUser] = @actionUserId)				
				Group by sp.[idObject], sp.[idPrivilege], ur.[subjType]
						
			-- Среди всех групп выбираем первую по сортировочному приоритету и именно ее значение value берем
			--  На выход нас интересуют разрешенные - те у кого value получился 1
			Insert into @userprivileges ( [idPrivilege], [isHigherPrivilege] )
				Select a.[idPrivilege], 0
				From ( Select a.[idObject], a.[idPrivilege], Min(b.[priority]) as priority
						From #A a
							inner join dbo.A_Policy_SubjectTypePriority b on b.[idType] = a.[subjType]
						Group by a.[idObject], a.[idPrivilege]
					)x
					Inner join dbo.A_Policy_SubjectTypePriority b on b.[priority] = x.[priority]
					Inner join #A a on (b.[idType] = a.[subjType]) 
										and (x.[idObject] = a.[idObject]) 
										and (x.[idPrivilege] = a.[idPrivilege])
				Where a.[value] = 1
		end
		
	end
	
	

	-- Выборка итоговая
	Select 
		sp.[subjType],
	
		case when (( sp.[subjType] = 101 ) 
					and ( sp.[subjExtraId] in ('F876E650-7972-475A-AE96-BCCF831AF818', 'C892CC9E-4660-4ABC-8AD1-BAECDBFEAAC3')))
				then NULL
			else sp.[idSubject]
		end as idSubject,
		
		case when ( sp.subjType in ( 12, 13 ))
				then NULL
			else sp.[subjExtraId]
		end as subjPrivilegeId,
		
		sp.[idPrivilege], 
		sp.[value], 
		sp.[isDefault], 
		sp.[idCreator],
		
		cast ( case when ( @resmodifyall = 0 )
					then 0
					when ( @resmodifyall = 1 )
					then IsNull ( up.[isHigherPrivilege], 1 )
					else 1
				end as bit ) as isHigherPrivilege,				
		
		st.[name] as subjTypeName, 
		p.[name] as subjPrivilegeName,		
		
		case when (sp.[subjType] = 1)
				then IsNull ( xusers.Name, '' )
			 when (sp.[subjType] = 2)
				then IsNull ( xdepartments.[Name], '' )
			 when (sp.[subjType] = 3)			 
				then IsNull ( xroles.[Name], '' )
			 when (sp.[subjType] in (5, 8))
				then IsNull ( xtasks.[Name], '' )
			 when (sp.[subjType] in (6, 9, 10))
				then IsNull ( xprojs.[Name], '' )
			 when (sp.[subjType] in (4, 7, 12, 13, 14))
				then IsNull ( xgroupnames.[Name], '' )
			 when ((sp.[subjType] = 101) and (sp.[subjExtraId] = 'F876E650-7972-475A-AE96-BCCF831AF818'))
				then IsNull ( xgroupnames.[Name], '' )
			 when ((sp.[subjType] = 101) and (sp.[subjExtraId] = 'C892CC9E-4660-4ABC-8AD1-BAECDBFEAAC3'))
				then IsNull ( xgroupnames.[Name], '' )
			 when (sp.[subjType] = 101)
				then IsNull ( xobjs.[name], '' )--Здесь из кэша субъектных групп надо взять
			 else NULL
		end as subjGroupName,
		
		case when (sp.[subjType] = 101)
				then IsNull ( xobjtypes.[id], 0 )
			 else NULL
		end as subjObjectType,
		 
		case when (sp.[subjType] = 101)
				then IsNull ( xobjtypes.[name], '' )
			 else NULL
		end as subjObjectTypeName,
		
		case when (sp.[subjType] = 101)
				then IsNull ( xobjs.[name], '' )
			 else NULL
		end as subjObjectName
		 
	From dbo.A_Policy_SubjectPrivileges sp
		Inner join dbo.A_Policy_SubjectTypes as st on st.[id] = sp.[subjType]
		Left join dbo.A_Policy_Privileges as p on p.[id] = sp.[subjExtraId]
		Left join dbo.A_Users as xusers on (sp.[subjType] = 1) and (xusers.[Id] = sp.[idSubject])
		Left join dbo.A_Groups as xdepartments on (sp.[subjType] = 2) and (xdepartments.[Id] = sp.[idSubject])
		Left join dbo.A_UserRoles_Roles as xroles on (sp.[subjType] = 3) and (xroles.[Id] = sp.[idSubject])
		Left join @groupnames as xgroupnames on ((sp.[subjType] in (4, 7, 12, 13, 14)) and (xgroupnames.[id] = sp.[subjType]))
											 or ((sp.[subjType] = 101) and (xgroupnames.[id] = sp.[subjType]) and (xgroupnames.[extraId] = sp.[subjExtraId]))
		Left join dbo.A_TaskManager_Tasks as xtasks on (sp.[subjType] in (5, 8)) and (xtasks.[Id] = sp.[idSubject])
		Left join dbo.A_TaskManager_Projects as xprojs on (sp.[subjType] in (6, 9, 10)) and (xprojs.[Id] = sp.[idSubject])
		--Left join dbo.A_TaskManager_Projects as xprojsx on (sp.[subjType] in (12, 13)) and (xprojs.[Id] = sp.[subjExtraId])
		Left join dbo.A_Policy_Objects xobjs on (sp.[subjType] = 101) and (xobjs.[id] = sp.[idSubject])
		Left join dbo.A_Policy_ObjectTypes xobjtypes on (sp.[subjType] = 101) and (xobjtypes.[id] = xobjs.[type])
		--Left join со всеми таблицами объектов, поддерживающих POLICY, через xobjs.type и xobjs.id
		Left join @userprivileges up on up.[idPrivilege] = sp.[idPrivilege]
	Where (sp.[idObject] = @idobject)

end
GO

--------------------------------------------------------------------------
if exists ( select * from sysobjects where id = object_id ( 'dbo.A_Policy_SubjectPrivileges_Save' ))
	Drop procedure dbo.A_Policy_SubjectPrivileges_Save
GO

Create procedure dbo.A_Policy_SubjectPrivileges_Save
	@idObject uniqueidentifier,
	@idPrivilege uniqueidentifier,
	@subjType int,	
	@idSubject uniqueidentifier = NULL,
	@subjExtraId uniqueidentifier = NULL,	
	@value int = 1,
	@default bit = 0,
	@actionUserId uniqueidentifier = NULL
as 
begin
	-- Добавляет/изменяет привилегию субъекту с проверкой права на операцию	
	-- Изменять может только тот, у кого стоит привилегия isPolicyModify для этого объекта
	-- В выборке возвращает:
	--   0 - сохранено
	--   101 - не указанные пользователи не могут изменять права доступа
	--   100 - объект не найден в таблице правовой политики
	--   102 - у объекта есть привилегия изменения прав, но у пользователя она не установлена	
	--   103 - у объекта нет ни одной привилегии изменения прав, и у пользователя не установлена привилегия, 
	--         которую он хочет изменить (у другого субъекта или у себя)
	--   104 - криво исполнилась процедура проверки права изменения желаемой привилегии
	
	-- Неуказанные юзеры не могут менять
	if ( @actionUserId is NULL ) begin
		Select 101
		return
	end
	
	-- Проверяем наличие привилегии изменения политики, а также проверяем
	Declare @res int
	exec dbo.A_Policy_SubjectPrivileges_CheckCanModifyPolicy 
		@idUser = @actionUserId, 
		@idObject = @idObject, 
		@idPrivilege = @idPrivilege,
		@onlyreturnvalue = 1,
		@resultvalue = @res OUTPUT
		
		
	if ( @res is NULL ) begin
		Select 104
		return
	end
	
	if ( @res > 0 ) begin
		Select @res
		return
	end
	
	
	-- Модификации обновляемых полей перед сохранением
	if ( @subjType in ( 12, 13 )) begin
	
		-- Ид проекта для объекта надо достать и сохранить в ExtraId
		Select @subjExtraId = IsNull ( idParentProject, @subjExtraId )
		From A_Policy_Objects o
		Where o.[id] = @idObject
	
	end	else if (( @subjType = 101 ) and ( @subjExtraId in ('F876E650-7972-475A-AE96-BCCF831AF818', 'C892CC9E-4660-4ABC-8AD1-BAECDBFEAAC3'))) begin
	
		-- Ид проекта для объекта надо достать и сохранить в idSubject
		Select @idSubject = IsNull ( idParentProject, @idSubject )
		From A_Policy_Objects o
		Where o.[id] = @idObject
		
	end
	
	if ( @idSubject is NULL )
		Set @idSubject = '00000000-0000-0000-0000-000000000000'
	
	
	-- Изменение
	Update A_Policy_SubjectPrivileges
	Set [value] = @value,
		--[isDefault] = @default,--Изменения признака дефолтной привилегии не происходит. ее удалить нельзя
		[idCreator] = @actionUserId
	Where ([idObject] = @idobject)
		and ([idPrivilege] = @idPrivilege)
		and ([idSubject] = @idSubject)
		and ([subjType] = @subjType)
		and ((@subjExtraId is NULL) or ([subjExtraId] = @subjExtraId))
			
	if ( @@rowcount = 0 ) begin
		Insert into A_Policy_SubjectPrivileges ( [idSubject], [subjType], [subjExtraId], [idObject], [idPrivilege], [value], [isDefault], [idCreator] )
		Values ( @idSubject, @subjType, @subjExtraId, @idObject, @idPrivilege, @value, @default, @actionUserId )
	end
	
	Select 0
	
end
GO

--------------------------------------------------------------------------
if exists ( select * from sysobjects where id = object_id ( 'dbo.A_Policy_SubjectPrivileges_Remove' ))
	Drop procedure dbo.A_Policy_SubjectPrivileges_Remove
GO

Create procedure dbo.A_Policy_SubjectPrivileges_Remove
	@idObject uniqueidentifier,
	@idPrivilege uniqueidentifier,
	@subjType int,
	@idSubject uniqueidentifier = NULL,
	@subjExtraId uniqueidentifier = NULL,	
	@actionUserId uniqueidentifier = NULL
as 
begin
	-- Удаляет привилегию у субъекта с проверкой права на операцию
	-- Изменять может только тот, у кого стоит привилегия isPolicyModify для этого объекта
	-- В выборке возвращает:
	--   0 - удалено
	--   101 - не указанные пользователи не могут изменять права доступа
	--   100 - объект не найден в таблице правовой политики
	--   102 - у объекта есть привилегия изменения прав, но у пользователя она не установлена	
	--   103 - у объекта нет ни одной привилегии изменения прав, и у пользователя не установлена привилегия, 
	--         которую он хочет изменить (у другого субъекта или у себя)
	--   104 - криво исполнилась процедура проверки права изменения желаемой привилегии
	
	-- Неуказанные юзеры не могут менять
	if ( @actionUserId is NULL ) begin
		Select 101
		return
	end
	
	-- Проверяем наличие привилегии изменения политики, а также проверяем
	Declare @res int
	exec dbo.A_Policy_SubjectPrivileges_CheckCanModifyPolicy 
		@idUser = @actionUserId, 
		@idObject = @idObject, 
		@idPrivilege = @idPrivilege,
		@onlyreturnvalue = 1,
		@resultvalue = @res OUTPUT
	
	
	if ( @res is NULL ) begin
		Select 104
		return
	end
	
	if ( @res > 0 ) begin
		Select @res
		return
	end
	
	-- Удаление
	Delete
	From A_Policy_SubjectPrivileges
	Where ([idObject] = @idobject)
		and ([idPrivilege] = @idPrivilege)
		and ([subjType] = @subjType)
		and ((@idSubject is NULL) or ([idSubject] = @idSubject))		
		and ((@subjExtraId is NULL) or ([subjExtraId] = @subjExtraId))
		
	Select 0
		
end
GO

--------------------------------------------------------------------------
if exists ( select * from sysobjects where id = object_id ( 'dbo.A_Policy_SubjectTypes_Clear' ))
	Drop procedure dbo.A_Policy_SubjectTypes_Clear
GO

Create procedure dbo.A_Policy_SubjectTypes_Clear	
as 
begin
	-- Чистит таблицу типов субъектов
	
	-- Типы
	Truncate table oktell_settings.dbo.A_Policy_SubjectTypes
	
	-- Приоритеты
	Truncate table oktell_settings.dbo.A_Policy_SubjectTypePriority
	
end
GO

--------------------------------------------------------------------------
if exists ( select * from sysobjects where id = object_id ( 'dbo.A_Policy_SubjectTypes_Save' ))
	Drop procedure dbo.A_Policy_SubjectTypes_Save
GO

Create procedure dbo.A_Policy_SubjectTypes_Save	
	@id int,
	@name nvarchar(500),
	@groupId uniqueidentifier = NULL,
	@priority int,
	@equalMode int,
	@isNested bit = 0
as 
begin
	-- Добавляет новый тип субъекта
	
	-- Типы
	Insert into dbo.A_Policy_SubjectTypes ( [id], [name], [groupId], [equalMode], [isNested] )
	Values ( @id, @name, @groupid, @equalMode, @isNested )
	
	-- Приоритеты
	if not exists ( select * from A_Policy_SubjectTypePriority where idType = @id )
		Insert into dbo.A_Policy_SubjectTypePriority ( [idType], [priority] )
		Values ( @id, @priority )
	
end
GO

--------------------------------------------------------------------------
if exists ( select * from sysobjects where id = object_id ( 'dbo.A_Policy_ObjectTypes_Save' ))
	Drop procedure dbo.A_Policy_ObjectTypes_Save
GO

Create procedure dbo.A_Policy_ObjectTypes_Save
	@id int,
	@name nvarchar(500),
	@isBasicType bit = 1
as 
begin
	-- Сохраняет тип объекта
	
	Update dbo.A_Policy_ObjectTypes
	Set [name] = @name,
		[isBasicType] = @isBasicType
	Where [id] = @id
	
	if ( @@rowcount = 0 ) begin
		Insert into dbo.A_Policy_ObjectTypes ( [id], [name], [isBasicType] )
		Values ( @id, @name, @isBasicType )
	end
	
end
GO

--------------------------------------------------------------------------
if exists ( select * from sysobjects where id = object_id ( 'dbo.A_Policy_ObjectTypes_ClearBasic' ))
	Drop procedure dbo.A_Policy_ObjectTypes_ClearBasic
GO

Create procedure dbo.A_Policy_ObjectTypes_ClearBasic
as 
begin
	-- Производит очистку базовых типов (перед обновлением)
	
	Delete 
	From dbo.A_Policy_ObjectTypes
	Where [isBasicType] = 1
	
end
GO

--------------------------------------------------------------------------
if exists ( select * from sysobjects where id = object_id ( 'dbo.A_Policy_ObjectPrivileges_GetAll' ))
	Drop procedure dbo.A_Policy_ObjectPrivileges_GetAll
GO

Create procedure dbo.A_Policy_ObjectPrivileges_GetAll
	@objecttype int
as 
begin
	-- Возвращает системный список привилегий для указанного типа объекта
	--  Если параметр = 0, то для всех типов объектов
	
	-- Привилегии
	Select [id], [objType], [knot], [name], [code], [levelNesting], [isPolicyModify]
	From A_Policy_Privileges
	Where ([objType] = @objecttype)
		Or (@objecttype <= 0)
	Order by [objType]
		
	-- Дефолтные настройки
	Select p.[objType], d.[idPrivilege], d.[idSubject], d.[subjType], d.[subjExtraId], d.[value]
	From A_Policy_PrivilegeDefaults d
		Inner join A_Policy_Privileges p on d.[idPrivilege] = p.[id]
	Where (p.[objType] = @objecttype)
		Or (@objecttype <= 0)
	Order by p.[objType]
		
end
GO

--------------------------------------------------------------------------
if exists ( select * from sysobjects where id = object_id ( 'dbo.A_Policy_ObjectPrivileges_Save' ))
	Drop procedure dbo.A_Policy_ObjectPrivileges_Save
GO

Create procedure dbo.A_Policy_ObjectPrivileges_Save
	@id uniqueidentifier,
	@objType int,	
	@knot nvarchar(50),
	@name nvarchar(1000),
	@code nvarchar(200),
	@levelNesting int = 0,
	@isBasicType bit = 1,
	@isPolicyModify bit = 0
as 
begin
	-- Создает новую или изменяет существующий тип привилегии для указанного типа объекта
	
	Update A_Policy_Privileges
	Set [objType] = @objType,
		[knot] = @knot,
		[name] = @name,
		[code] = @code,
		[levelNesting] = @levelNesting,
		[isBasicType] = @isBasicType,
		[isPolicyModify] = @isPolicyModify
	Where ([id] = @id )
	
	
	if ( @@rowcount = 0 ) begin
		
		Insert into A_Policy_Privileges ( [id], [objtype], [knot], [name], [code], [levelNesting], [isBasicType], [isPolicyModify] )
		Values ( @id, @objType, @knot, @name, @code, @levelNesting, @isBasicType, @isPolicyModify )
		
	end
		
end
GO

--------------------------------------------------------------------------
if exists ( select * from sysobjects where id = object_id ( 'dbo.A_Policy_ObjectPrivileges_Remove' ))
	Drop procedure dbo.A_Policy_ObjectPrivileges_Remove
GO

Create procedure dbo.A_Policy_ObjectPrivileges_Remove
	@id uniqueidentifier	
as 
begin
	-- Удаляет существующий тип привилегии для указанного типа объекта
	
	-- Саму привилегию
	Delete
	From dbo.A_Policy_Privileges
	Where [id] = @id
	
	-- Дефолтные настройки
	Delete
	From dbo.A_Policy_PrivilegeDefaults
	Where [idPrivilege] = @id
		
end
GO

--------------------------------------------------------------------------
if exists ( select * from sysobjects where id = object_id ( 'dbo.A_Policy_ObjectPrivileges_Clear' ))
	Drop procedure dbo.A_Policy_ObjectPrivileges_Clear
GO

Create procedure dbo.A_Policy_ObjectPrivileges_Clear
	@objecttype int
as 
begin
	-- Удаляет все типы привилегий для указанного типа объекта
	
	if ( @objecttype = 0 ) begin
	
		-- Сами привилегии
		Delete
		From dbo.A_Policy_Privileges
		Where ([objType] in ( Select [id] From A_Policy_ObjectTypes Where [isBasicType] = 1))
			and ([isBasicType] = 1)
		
	end else begin
		
		-- Сами привилегии по типу
		Delete
		From dbo.A_Policy_Privileges
		Where [objType] = @objecttype
	
	end
	
	-- Дефолтные настройки
	Delete
	From dbo.A_Policy_PrivilegeDefaults
	Where not exists ( Select [id] From A_Policy_Privileges p Where p.[id] = A_Policy_PrivilegeDefaults.[idPrivilege] )
		
end
GO

--------------------------------------------------------------------------
if exists ( select * from sysobjects where id = object_id ( 'dbo.A_Policy_ObjectPrivileges_DefaultSave' ))
	Drop procedure dbo.A_Policy_ObjectPrivileges_DefaultSave
GO

Create procedure dbo.A_Policy_ObjectPrivileges_DefaultSave
	@idPrivilege uniqueidentifier,
	@idSubject uniqueidentifier,	
	@subjType int,
	@subjExtraId uniqueidentifier = NULL,
	@value int = 1
as 
begin
	-- Добавляет/изменяет настройку дефолтной привязки привилегии к субъектной группе для вновь создаваемых объектов
	
	Update A_Policy_PrivilegeDefaults
	Set [value] = @value	
	Where ([idPrivilege] = @idPrivilege)
		and ([idSubject] = @idSubject)
		and ([subjType] = @subjType)
		and (([subjExtraId] = @subjExtraId) or (@subjExtraId is NULL))
	
	if ( @@rowcount = 0 ) begin
		
		Insert into A_Policy_PrivilegeDefaults ( [idPrivilege], [idSubject], [subjType], [subjExtraId], [value] )
		Values ( @idPrivilege, @idSubject, @subjType, @subjExtraId, @value )
		
	end
		
end
GO

--------------------------------------------------------------------------
if exists ( select * from sysobjects where id = object_id ( 'dbo.A_Policy_ObjectPrivileges_DefaultRemove' ))
	Drop procedure dbo.A_Policy_ObjectPrivileges_DefaultRemove
GO

Create procedure dbo.A_Policy_ObjectPrivileges_DefaultRemove
	@idPrivilege uniqueidentifier,
	@idSubject uniqueidentifier,	
	@subjType int,
	@subjExtraId uniqueidentifier = NULL
as 
begin
	-- Удаляет настройку дефолтной привязки привилегии к субъектной группе для вновь создаваемых объектов
	
	Delete
	From dbo.A_Policy_PrivilegeDefaults
	Where ([idPrivilege] = @idPrivilege )
		and ([idSubject] = @idSubject)
		and ([subjType] = @subjType)
		and (([subjExtraId] = @subjExtraId) or (@subjExtraId is NULL))
		
end
GO

--------------------------------------------------------------------------
if exists ( select * from sysobjects where id = object_id ( 'dbo.A_Policy_ObjectPrivileges_DefaultClear' ))
	Drop procedure dbo.A_Policy_ObjectPrivileges_DefaultClear
GO

Create procedure dbo.A_Policy_ObjectPrivileges_DefaultClear
	@idPrivilege uniqueidentifier	
as 
begin
	-- Удаляет настройку дефолтной привязки привилегии к субъектной группе для вновь создаваемых объектов
	
	Delete
	From dbo.A_Policy_PrivilegeDefaults
	Where ([idPrivilege] = @idPrivilege )	
			
end
GO

--------------------------------------------------------------------------
if exists ( select * from sysobjects where id = object_id ( 'dbo.A_Policy_Objects_Save' ))
	Drop procedure dbo.A_Policy_Objects_Save
GO

Create procedure dbo.A_Policy_Objects_Save
	@idObject uniqueidentifier,
	@type int,
	@name nvarchar(1000),
	@idParentProject uniqueidentifier = NULL,
	@actionUserId uniqueidentifier = NULL
as 
begin
	-- Добавляет новый объект в список объектов правовой политики
	
	-- Только имя может изменяться
	Update A_Policy_Objects
	Set [name] = @name
	Where ([id] = @idObject)
		and ([type] = @type)
		
	-- Добавление нового
	if ( @@rowcount = 0 ) begin
	
		-- В объекты
		Insert into A_Policy_Objects ( [id], [type], [name], [idParentProject] )
		Values ( @idObject, @type, @name, @idParentProject )
		
		
		-- Привязка дефолтных привилегий (прямых)
		Insert into A_Policy_SubjectPrivileges ( [idSubject], [subjType], [subjExtraId], [idObject], [idPrivilege], [value], [isDefault], [idCreator] )
			Select pd.[idSubject], pd.[subjType], pd.[subjExtraId], @idObject, pd.[idPrivilege], pd.[value], 1, NULL
			From A_Policy_PrivilegeDefaults pd
				Inner join A_Policy_Privileges p on p.[id] = pd.[idPrivilege]
			Where (p.[objType] = @type)
				and not (pd.[subjType] in (12, 13))
				and not ((pd.[subjType] = 101) and (pd.[subjExtraId] in ('F876E650-7972-475A-AE96-BCCF831AF818', 'C892CC9E-4660-4ABC-8AD1-BAECDBFEAAC3')))
								
		-- Привязка дефолтных привилегий (обновляемых) - замена спец ид субъекта на ид проекта текущего объекта
		if ( not @idParentProject is NULL ) begin
			Insert into A_Policy_SubjectPrivileges ( [idSubject], [subjType], [subjExtraId], [idObject], [idPrivilege], [value], [isDefault], [idCreator] )
				Select pd.[idSubject], pd.[subjType], @idParentProject, @idObject, pd.[idPrivilege], pd.[value], 1, NULL
				From A_Policy_PrivilegeDefaults pd
					Inner join A_Policy_Privileges p on p.[id] = pd.[idPrivilege]
				Where (p.[objType] = @type)
					and (pd.[subjType] in (12, 13))
		end
		
		-- Привязка дефолтных привилегий (обновляемых) - замена спец ид субъекта на ид проекта текущего объекта
		if ( not @idParentProject is NULL ) begin
			Insert into A_Policy_SubjectPrivileges ( [idSubject], [subjType], [subjExtraId], [idObject], [idPrivilege], [value], [isDefault], [idCreator] )
				Select @idParentProject, pd.[subjType], pd.[subjExtraId], @idObject, pd.[idPrivilege], pd.[value], 1, NULL
				From A_Policy_PrivilegeDefaults pd
					Inner join A_Policy_Privileges p on p.[id] = pd.[idPrivilege]
				Where (p.[objType] = @type)
					and ((pd.[subjType] = 101) and (pd.[subjExtraId] in ('F876E650-7972-475A-AE96-BCCF831AF818', 'C892CC9E-4660-4ABC-8AD1-BAECDBFEAAC3')))
		end
			
			
		-- Создатель всегда приоритетно владеет объектом по всем привилегиям
		if ( not @actionUserId is NULL ) begin	
			Insert into A_Policy_SubjectPrivileges ( [idSubject], [subjType], [subjExtraId], [idObject], [idPrivilege], [value], [isDefault], [idCreator] )
				Select @actionUserId, 1, NULL, @idObject, [id], 1, 0, @actionUserId
				From A_Policy_Privileges 
				Where [objType] = @type
		end
		
	end
	
end
GO

--------------------------------------------------------------------------
if exists ( select * from sysobjects where id = object_id ( 'dbo.A_Policy_Objects_Remove' ))
	Drop procedure dbo.A_Policy_Objects_Remove
GO

Create procedure dbo.A_Policy_Objects_Remove
	@idObject uniqueidentifier	
as 
begin
	-- Удаляет объект из списка объектов правовой политики
	
	-- Из объектов
	Delete 
	From A_Policy_Objects 
	Where [id] = @idObject
	
	-- Из субъектных привилегий
	Delete 
	From A_Policy_SubjectPrivileges
	Where ([idObject] = @idObject)
		Or (([subjType] = 101) and ([idSubject] = @idObject))
		
end
GO

---------------------------------------------------------------------------
-- Перед обращением к вьюхам надо гарантировать их соответствие по полям --
---------------------------------------------------------------------------
if exists ( select * from sysobjects where id = object_id ( 'dbo.A_CallCenter_Reports' ))
	Drop view dbo.A_CallCenter_Reports
GO

Create view dbo.A_CallCenter_Reports
as 
	Select * 
	From oktell_settings.dbo.A_CallCenter_Reports
GO

--------------------------------------------------------------------------
if exists ( select * from sysobjects where id = object_id ( 'dbo.A_CallCenter_Indicators' ))
	Drop view dbo.A_CallCenter_Indicators
GO

Create view dbo.A_CallCenter_Indicators
as 
	Select * 
	From oktell_settings.dbo.A_CallCenter_Indicators
GO

--------------------------------------------------------------------------
if exists ( select * from sysobjects where id = object_id ( 'dbo.A_TaskManager_Lists' ))
	Drop view dbo.A_TaskManager_Lists
GO

Create view dbo.A_TaskManager_Lists
as 
	Select * 
	From oktell_settings.dbo.A_TaskManager_Lists
GO

--------------------------------------------------------------------------
if exists ( select * from sysobjects where id = object_id ( 'dbo.A_TaskManager_Projects' ))
	Drop view dbo.A_TaskManager_Projects
GO

Create view dbo.A_TaskManager_Projects
as 
	Select * 
	From oktell_settings.dbo.A_TaskManager_Projects
GO

--------------------------------------------------------------------------
if exists ( select * from sysobjects where id = object_id ( 'dbo.A_SmsTaskManager_Tasks' ))
	Drop view dbo.A_SmsTaskManager_Tasks
GO

Create view dbo.A_SmsTaskManager_Tasks
as 
	Select * 
	From oktell_settings.dbo.A_SmsTaskManager_Tasks
GO

--------------------------------------------------------------------------
if exists ( select * from sysobjects where id = object_id ( 'dbo.A_TaskManager_Tasks' ))
	Drop view dbo.A_TaskManager_Tasks
GO

Create view dbo.A_TaskManager_Tasks
as 
	Select * 
	From oktell_settings.dbo.A_TaskManager_Tasks
GO

--------------------------------------------------------------------------
--------------------------------------------------------------------------
if exists ( select * from sysobjects where id = object_id ( 'dbo.A_Policy_Filter' ))
	Drop procedure dbo.A_Policy_Filter
GO

Create procedure dbo.A_Policy_Filter
as 
begin
	-- Очищает остатки по удаленным объектам и субъектам из таблиц правовой политики
	
	-- Объекты
	Delete
	From dbo.A_Policy_Objects
	Where (([type] = 101) -- Projects
			and not exists ( Select o.[Id] From A_TaskManager_Projects o Where o.[Id] = A_Policy_Objects.[id] ))
		or (([type] = 102) -- Tasks
			and not exists ( Select o.[Id] From A_TaskManager_Tasks o Where o.[Id] = A_Policy_Objects.[id] )
			and not exists ( Select o.[Id] From A_SmsTaskManager_Tasks o Where o.[Id] = A_Policy_Objects.[id] ))
		or (([type] = 103) -- Reports
			and not exists ( Select o.[Id] From A_CallCenter_Reports o Where o.[Id] = A_Policy_Objects.[id] ))
		or (([type] = 104) -- Indicators
			and not exists ( Select o.[Id] From A_CallCenter_Indicators o Where o.[Id] = A_Policy_Objects.[id] ))
		--or (([type] = 105) -- Dashboards		
		--	and not exists ( Select o.[Id] From WO_Dashboards o Where o.[Id] = A_Policy_Objects.[id] ))
		--or (([type] = 106) -- Scripts
		--	and not exists ( Select o.[Id] From A_Scripts o Where o.[Id] = A_Policy_Objects.[id] ))
		or (([type] = 107) -- CallLists
			and not exists ( Select o.[Id] From A_TaskManager_Lists o Where o.[Id] = A_Policy_Objects.[id] ))
		
		
	-- Привилегии
	Delete
	From dbo.A_Policy_SubjectPrivileges
	Where not exists ( Select o.[Id] From A_Policy_Privileges o Where o.[id] = A_Policy_SubjectPrivileges.[idPrivilege] )
		
		
	-- Субъекты обычные
	Delete
	From dbo.A_Policy_SubjectPrivileges
	Where (([subjType] = 1) -- Users
			and not exists ( Select o.[Id] From A_Users o Where o.[Id] = A_Policy_SubjectPrivileges.[idSubject] ))
		or (([subjType] = 2) -- Groups
			and not exists ( Select o.[Id] From A_Groups o Where o.[Id] = A_Policy_SubjectPrivileges.[idSubject] ))
		or (([subjType] = 3) -- Roles
			and not exists ( Select o.[Id] From A_UserRoles_Roles o Where o.[Id] = A_Policy_SubjectPrivileges.[idSubject] ))					
		or (([subjType] in (5, 8)) -- TaskOperators, TaskSupervisors
			and not exists ( Select o.[Id] From A_TaskManager_Tasks o Where o.[Id] = A_Policy_SubjectPrivileges.[idSubject] ))
		or (([subjType] in (6, 9, 10)) -- ProjectOperators, ProjectSupervisors, ProjectOwners
			and not exists ( Select o.[Id] From A_TaskManager_Tasks o Where o.[Id] = A_Policy_SubjectPrivileges.[idSubject] ))
		or (([subjType] in (12, 13))-- CurrentProject Operators, Supervisors
			and not exists ( Select o.[Id] From A_TaskManager_Projects o Where o.[Id] = A_Policy_SubjectPrivileges.[subjExtraId] ))
			
			
	-- Субъекты в замыкании
	Delete
	From dbo.A_Policy_SubjectPrivileges
	Where ([subjType] = 101)
		and (( not exists ( Select o.[Id] From A_Policy_Objects o Where o.[id] = A_Policy_SubjectPrivileges.[idSubject] ))
			or ( not exists ( Select o.[Id] From A_Policy_Privileges o Where o.[id] = A_Policy_SubjectPrivileges.[subjExtraId] )))
			
	-- Кэш
	Delete
	From dbo.A_Policy_SubjectGroupCache
	Where not exists ( Select o.Id From A_Users o Where o.[Id] = A_Policy_SubjectGroupCache.[idUser] )
		or (([subjType] = 1) -- Users
			and not exists ( Select o.[Id] From A_Users o Where o.[Id] = A_Policy_SubjectGroupCache.[idSubject] ))
		or (([subjType] = 2) 
			and not exists ( Select o.Id From A_Groups o Where o.[Id] = A_Policy_SubjectGroupCache.[idSubject] ))
		or (([subjType] = 3) 
			and not exists ( Select o.Id From A_UserRoles_Roles o Where o.[Id] = A_Policy_SubjectGroupCache.[idSubject] ))
		or (([subjType] in (5, 8)) -- TaskOperators, TaskSupervisors
			and not exists ( Select o.[Id] From A_TaskManager_Tasks o Where o.[Id] = A_Policy_SubjectGroupCache.[idSubject] ))
		or (([subjType] in (6, 9, 10)) -- ProjectOperators, ProjectSupervisors, ProjectOwners
			and not exists ( Select o.[Id] From A_TaskManager_Tasks o Where o.[Id] = A_Policy_SubjectGroupCache.[idSubject] ))
		or (([subjType] in (12, 13))-- CurrentProject Operators, Supervisors
			and not exists ( Select o.[Id] From A_TaskManager_Projects o Where o.[Id] = A_Policy_SubjectGroupCache.[subjExtraId] ))
					
					
	-- Сопоставление с объектами в таблице типов
	Delete 
	From A_Policy_SubjectPrivileges
	WHere not exists ( Select Id From A_Policy_Objects o where o.Id = A_Policy_SubjectPrivileges.idObject )	
	
end
GO

-------------------------------------------------------------------------
if exists ( select * from sysobjects where id=object_id ( 'dbo.A_Policy_CheckFilter' ))
	Drop procedure dbo.A_Policy_CheckFilter
GO

Create procedure dbo.A_Policy_CheckFilter
as
begin

	Declare @make int
	
	Select @make = [valueInt]
	From A_Settings
	Where name like 'PolicyFilter'
		
	if (( @make is null ) or ( @make > 0 )) begin
	
		begin tran PolicyFilter

			-- Еще раз проверка в транзакции, чтобы дубликаты параллельные не исполняли
			Select @make = [valueInt]
			From A_Settings
			Where name like 'PolicyFilter'
			
			if (( @make is null ) or ( @make > 0 )) begin
	
				-- Перестраиваем таблицу привилегий
				exec dbo.A_Policy_Filter
				
				-- Обновляем, что все сделано
				Update A_Settings
				Set [valueInt] = 0
				Where [name] like 'PolicyFilter'
				
				if ( @@rowcount = 0 ) 
					Insert into A_Settings ( name, valueint )
					Values ( 'PolicyFilter', 0 )		
				
			end		
					
		commit tran PolicyFilter
		
	end

end
GO

-------------------------------------------------------------------------
if exists ( select * from sysobjects where id=object_id ( 'dbo.A_Policy_SetFilter' ))
	Drop procedure dbo.A_Policy_SetFilter
GO

Create procedure dbo.A_Policy_SetFilter
as
begin

	begin tran PolicyFilter

		-- Обновляем, что все сделано
		Update A_Settings
		Set [valueInt] = 1
		Where [name] like 'PolicyFilter'
		
		if ( @@rowcount = 0 ) 
			Insert into A_Settings ( name, valueint )
			Values ( 'PolicyFilter', 1 )				
				
	commit tran PolicyFilter

end
GO

-----------------------------------------------------------------------
-----------------------------------------------------------------------
-----------------------------------------------------------------------

if exists ( select * from sysobjects where id = object_id('dbo.A_Timer_MinuteProc' ))
	Drop procedure dbo.A_Timer_MinuteProc
GO

Create Procedure [dbo].[A_Timer_MinuteProc]
	@dtnow datetime = null
as
begin
	if ( @dtnow is null )	
		set @dtnow = GetDate()
	--------------------------------------------------------------------------------------------
	-- Обеспечивается однократность исполнения (при нескольких серверах к одной базе) 
	--------------------------------------------------------------------------------------------
   	Begin tran DbProcActive

		Declare @dtactive datetime
		Select @dtactive = valuedatetime from A_Settings where name like 'DB_procactive'
		if ( not @dtactive is null )
 		  if ( DateDiff ( mi, @dtactive, @dtnow ) < 10 ) begin
		    Rollback tran DbProcActive
		    return
		  end

		Update A_Settings Set valuedatetime = @dtnow where name like 'DB_procactive'
		if ( @@rowcount = 0 )
		  Insert into A_Settings (name, valuedatetime) Values ( 'DB_procactive', @dtnow )

   	Commit tran DbProcActive
	--------------------------------------------------------------------------------------------
	--------------------------------------------------------------------------------------------

	-- Очистка неактуальных регистрационных сессий
	exec dbo.A_Registrar_FilterSessions

	--Время по которое производить расчет намеренно назад на 30 секунд отводим
	-- чтобы исключить возможность попадания в интервалы, когда отложенные сохранения в БД идут
	-- и когда одна таблица уже заполнена, а другая еще нет данными до текущего момента.
	-- ну и еще случаи частичного заполнения строки, когда данные вставляются в момент выборки
	Declare @tilldt DateTime
	Set @tilldt = DateAdd ( ss, -30, @dtnow )

	exec A_CallCenter_Temp_UpdateOperatorStates @tilldt
	
	-- Очистка неактуальных пользовательских сессий
	exec dbo.A_SessionStorage_FilterSessions @dtnow
	
	
	-- Обновление кэша политики прав доступа к объектам
	exec dbo.A_Policy_SubjectGroupCache_CheckUpdate
	
	-- Очистка пустых ссылок в таблицах политики прав доступа к объектам
	exec dbo.A_Policy_CheckFilter
	
	
	-- Пользовательская процедура, которой можно пользоваться и изменять
	exec dbo.A_Timer_UserDefinedProc
	
	--------------------------------------------------------------------------------------------
	-- Обеспечивается однократность исполнения (при нескольких серверах к одной базе) 
	--------------------------------------------------------------------------------------------
	Delete From A_Settings where name like 'DB_procactive'
	--------------------------------------------------------------------------------------------
	--------------------------------------------------------------------------------------------
end
GO

-----------------------------------------------------------------------
if exists ( select * from sysobjects where id = object_id('dbo.A_DB_RemoveTails' ))
	Drop procedure dbo.[A_DB_RemoveTails]
GO

Create Procedure [dbo].[A_DB_RemoveTails] 
as
begin

-- Отрубание глюков после изменений в БД. Лишние ссылки, пустые элементы и т.д.

		-----------------------------------------------------
		-- преобразования на стыке версий -------------------
		-----------------------------------------------------

		Update dbo.A_ServerExtLines
		Set SystemNumStr = Cast ( SystemNum as nvarchar(10 ))
		Where SystemNumStr is NULL

		Update dbo.A_ServerGSMLines
		Set SystemNumStr = Cast ( SystemNum as nvarchar(10 ))
		Where SystemNumStr is NULL

		Update dbo.A_ServerIntLines
		Set SystemNumStr = Cast ( SystemNum as nvarchar(10 ))
		Where SystemNumStr is NULL

		Update dbo.A_ServerSipLines
		Set SystemNumStr = Cast ( SystemNum as nvarchar(10 ))
		Where SystemNumStr is NULL

		Update dbo.A_ServerUSBLines
		Set SystemNumStr = Cast ( SystemNum as nvarchar(10 ))
		Where SystemNumStr is NULL

		Update dbo.A_ServerVirtualLines
		Set SystemNumStr = Cast ( SystemNum as nvarchar(10 ))
		Where SystemNumStr is NULL

		-----------------------------------------------------
		-- общие возможные глюки ----------------------------
		-----------------------------------------------------
		Delete From A_WorkPlaces where (type in (2,3,4,6)) and not (parentId in (Select [ID] From A_WorkPlaces))
		Delete From A_WorkPlaces where (type in (2,3,4,6)) and not ( LineId in ( Select [ID] From A_View_ServerIntLinesAll ))
		Delete From A_ServerExtLines where not [ServerID] in (Select [id] From A_WORKPLACES)
		Delete From A_ServerIntLines where not [ServerID] in (Select [id] From A_WORKPLACES)
		Delete From A_ServerGSMLines where not [ServerID] in (Select [id] From A_WORKPLACES)
		Delete From A_ServerUSBLines where not [ServerID] in (Select [id] From A_WORKPLACES)
		Delete From A_ServerSipLines where not [ServerID] in (Select [id] From A_WORKPLACES)
		Delete From A_ServerUSBLines where not [id] in (Select LineID From A_WORKPLACES)
		Delete From A_ServerVirtualLines where not [ServerID] in (Select [id] From A_WORKPLACES)
		
		Delete From A_LinesReactors where not [WPID] in ( Select [id] From A_WORKPLACES )
		Delete From A_LinesReactors where not LineID in ( Select [ID] From A_View_ServerLinesAll )
		Delete From A_ServerNumbers where not [id] in ( Select [ID] From A_WorkPlaces Where type=5 )
		Delete From A_ServerNumbers where [id] in ( Select [ID] From A_WorkPlaces where hasdatabase>0 )

		Delete From A_CallRoutes_Lines where not [idroute] in ( Select [ID] From A_CallRoutes )

		Declare @t table(id_ uniqueidentifier)
		insert into @t
			Select [id] From A_WORKPLACES Union 
			Select [id] From A_Users union
			Select [id] From A_ExtNumbers union
			Select [id] From A_View_ServerLinesAll			

		
		Delete From A_RuleRecords where not RuleID in (Select ID From A_Rules)

		--записи правил, где пользователь или линия несуществующие
		Delete From A_RuleRecords where (InnerAddressType in (0,1)) and ( not ReactID in (Select id_ From @t ))
		--записи правил, где поток несуществующий
		Delete From A_RuleRecords where (InnerAddressType in (3)) and ( not ReactID in (Select [Id] From A_ServerStreams ))

		Delete From A_NumberPlanAction where numtype=0 and extraid not in (Select ID From A_Rules)
		Delete From A_NumberPlan where id not in (Select numid From A_NumberPlanAction)
		Delete From A_RuleRecords where InnerAddressType=2 and not ReactID in (Select ID From A_NumberPlan)
		Delete From A_Rules	Where not id in ( Select ruleid From A_RuleRecords )		

		Delete From A_TaskManager_TaskExtLines where not ExtLineId in ( Select id From A_ServerExtLines )
		Delete From A_TaskManager_Operators where not OperatorId in ( Select id From A_Users u inner join A_UserParams up on u.Id = up.IdUser Where up.IsOperator = 1 Union Select Id From C_Groups )
		Delete From A_TaskManager_TaskProperties where not IdTask in ( Select id From A_TaskManager_Tasks )

		-----------------------------------------------------
		-- сетевые адреса рабочих мест = адресу сервера - заменяем брехней 
		-----------------------------------------------------
		Declare @svraddr nvarchar ( 100 )
		Select @svraddr = Address 
		From A_WorkPlaces
		Where HasFastEngine = 1
		Update A_WorkPlaces Set Address = 'Ошибка в адресе' 
		Where Address like @svraddr and HasFastEngine = 0

		-----------------------------------------------------
		-- Null в 0 в ID юзеров по умолчанию ----------------
		-----------------------------------------------------
		Update A_ServerIntLines
		Set DefaultUserId = '00000000-0000-0000-0000-000000000000'
		Where DefaultUserId is null

		Update A_ServerSipLines 
		Set DefaultUserId = '00000000-0000-0000-0000-000000000000'
		Where DefaultUserId is null

		Update A_ServerVirtualLines 
		Set DefaultUserId = '00000000-0000-0000-0000-000000000000'
		Where DefaultUserId is null

		-----------------------------------------------------
		-- в 0 несуществующих юзеров по умолчанию -----------
		-----------------------------------------------------
		Update A_ServerIntLines 
		Set DefaultUserId = '00000000-0000-0000-0000-000000000000'
		Where not DefaultUserId in (Select id From A_Users)

		Update A_ServerSipLines 
		Set DefaultUserId = '00000000-0000-0000-0000-000000000000'
		Where not DefaultUserId in (Select id From A_Users)

		Update A_ServerVirtualLines 
		Set DefaultUserId = '00000000-0000-0000-0000-000000000000'
		Where not DefaultUserId in (Select id From A_Users)

		-----------------------------------------------------
		-- двоение юзеров по умолчанию в ссылках по линиям --
		-----------------------------------------------------
		Declare @useddefusers table (id uniqueidentifier)
		Declare @idtozero table (id uniqueidentifier)
		Declare @lid uniqueidentifier
		Declare @uid uniqueidentifier
		Declare @tmp bit 		

		Declare defusercur Cursor For
			Select Id, DefaultUserId 
			From A_View_ServerIntLinesDefaultUsers
			Where DefaultUserId != '00000000-0000-0000-0000-000000000000'

		Open defusercur
		Fetch Next From defusercur Into @lid, @uid
		While @@FETCH_STATUS = 0
		Begin		
			Select @tmp = 1 From @useddefusers where id = @uid
			if ( @tmp > 0 )
				Insert Into @idtozero (id) values (@lid)
			else
				Insert Into @useddefusers (id) values (@uid)
			Fetch Next From defusercur  Into @lid, @uid
		End
		Close defusercur
		Deallocate defusercur
		
		Update A_ServerIntLines 
		Set DefaultUserId = '00000000-0000-0000-0000-000000000000'
		From A_ServerIntLines si, @idtozero iz
		Where si.Id = iz.Id

		Update A_ServerSipLines 
		Set DefaultUserId = '00000000-0000-0000-0000-000000000000'
		From A_ServerSipLines si, @idtozero iz
		Where si.Id = iz.Id

		Update A_ServerVirtualLines 
		Set DefaultUserId = '00000000-0000-0000-0000-000000000000'
		From A_ServerVirtualLines si, @idtozero iz
		Where si.Id = iz.Id
		
		-----------------------------------------------------
		-- удаляем несуществующие значения ------------------
		-----------------------------------------------------
		Begin Tran UIT

		Delete From A_TaskManager_UserInTask with ( TabLock, HoldLock )
		Where not exists ( Select Id From A_Users Where A_Users.Id = UserId )

		Delete From A_TaskManager_UserInTask --with ( TabLock )
		Where not exists ( Select Id From A_TaskManager_Tasks Where A_TaskManager_Tasks.Id = TaskId )
		
		Commit tran UIT


		Delete From A_TaskManager_Operators
		Where not exists ( Select Id From A_TaskManager_Tasks where A_TaskManager_Tasks.Id = TaskId )

		Delete From A_TaskManager_TaskExtLines
		Where not exists ( Select Id From A_TaskManager_Tasks where A_TaskManager_Tasks.Id = TaskId )

		Delete From A_TaskManager_Operators
		Where IsGroup = 1 and not exists ( Select Id From C_Groups where C_Groups.Id = OperatorId )

		Delete From A_TaskManager_Operators
		Where IsGroup = 1 and not Exists ( Select * From A_Users where A_Users.Id = OperatorId )
		

		Declare @uidt table ( id uniqueidentifier )
		Insert into @uidt
			Select Id From A_Users
		Delete From A_UserControls
		Where not UserA in (Select id From @uidt)
			or not UserB in (Select id From @uidt)
		Delete From A_UserRoles_Roles
		Where (Domination = 1)
			and ( not Id in (Select id From @uidt))

		-----------------------------------------------------
		-- Редиректы на удаленных юзеров --------------------
		-----------------------------------------------------
		Delete 
		From A_Redirect
		Where IdUser not in ( Select Id From A_Users )

		-----------------------------------------------------
		-- Пустые группы, номера, несвязанные правила -------
		-----------------------------------------------------
		exec A_Admin_UserGroup_Group_SiftEmpty		

		exec A_Admin_Number_SiftByActions
		
		exec A_Admin_Rule_SiftByNumbers
		
		-----------------------------------------------------
		-- неиспользуемые плагин-модули ---------------------
		-----------------------------------------------------
		Delete From A_PluginMenu_User
		Where not exists ( Select Id From A_Users u Where u.Id = A_PluginMenu_User.IdUser )

		-----------------------------------------------------
		-- канонические адреса ------------------------------
		-----------------------------------------------------	
		Delete from A_WorkPlace_Address
		
		-----------------------------------------------------	
		-- Очистка пустых ссылок в таблицах политики прав доступа к объектам
		-----------------------------------------------------	
		exec dbo.A_Policy_CheckFilter
end
GO

-----------------------------------------------------------------------
if exists ( select * from sysobjects where id = object_id('dbo.A_DB_RemoveTailsOnStart' ))
	Drop procedure dbo.A_DB_RemoveTailsOnStart
GO

Create Procedure [dbo].[A_DB_RemoveTailsOnStart]
as
begin
		
		-- динамические объекты карты сети 
		exec A_DynamicConfig_Clear

		-- Регистрации 
		exec A_StreamRegistration_Clear
		
		-- Обновление кэша политики прав доступа к объектам
		exec dbo.A_Policy_SubjectGroupCache_CheckUpdate
		
		
		-- Прочие хвосты
		exec A_DB_RemoveTails
end
GO
----------------------------------------------------------------------------------------------------------------------------------------------
-- Простановка прав при обновлении в соответствии с имевшимися ранее настройками
----------------------------------------------------------------------------------------------------------------------------------------------


-----------------------------------------------------------------------
----- Projects --------------------------------------------------------
-----------------------------------------------------------------------
		
	-- Проекты
	Insert into A_Policy_Objects ( [id], [type], [name], [idParentProject] )
		Select [Id], 101, [Name], [Id]
		From A_TaskManager_Projects
	
	-- Проекты, у которых общий доступ закрыт, и разрешено некоторым	

	Insert into A_Policy_SubjectPrivileges([idSubject],[subjType],[subjExtraId],[idObject],[idPrivilege],[value])	
		Select st.[groupId], 14, NULL, p.[Id], 'F876E650-7972-475A-AE96-BCCF831AF818', 0
		From A_TaskManager_Projects p
			Inner join A_Policy_SubjectTypes st on st.[id] = 14			
		Where p.[Shared] = 0
		
	Insert into A_Policy_SubjectPrivileges([idSubject],[subjType],[subjExtraId],[idObject],[idPrivilege],[value])	
		Select st.[groupId], 14, NULL, p.[Id], 'C892CC9E-4660-4ABC-8AD1-BAECDBFEAAC3', 0
		From A_TaskManager_Projects p
			Inner join A_Policy_SubjectTypes st on st.[id] = 14			
		Where p.[Shared] = 0
		
	Insert into A_Policy_SubjectPrivileges([idSubject],[subjType],[subjExtraId],[idObject],[idPrivilege],[value])	
		Select u.[Id], 1, NULL, p.[Id], 'F876E650-7972-475A-AE96-BCCF831AF818', 1
		From A_TaskManager_Projects p
			Inner join A_TaskManager_ProjectUsers pu on pu.[IdProject] = p.[Id]
			Inner join A_Users u on u.[Id] = pu.[IdUser]
		Where p.[Shared] = 0
		
	Insert into A_Policy_SubjectPrivileges([idSubject],[subjType],[subjExtraId],[idObject],[idPrivilege],[value])	
		Select u.[Id], 1, NULL, p.[Id], 'C892CC9E-4660-4ABC-8AD1-BAECDBFEAAC3', 1
		From A_TaskManager_Projects p
			Inner join A_TaskManager_ProjectUsers pu on pu.[IdProject] = p.[Id]
			Inner join A_Users u on u.[Id] = pu.[IdUser]
		Where p.[Shared] = 0
		
	-- Проекты, у которых общий доступ открыт, и запрещено некоторым
		
	Insert into A_Policy_SubjectPrivileges([idSubject],[subjType],[subjExtraId],[idObject],[idPrivilege],[value])	
		Select st.[groupId], 14, NULL, p.[Id], 'F876E650-7972-475A-AE96-BCCF831AF818', 1
		From A_TaskManager_Projects p
			Inner join A_Policy_SubjectTypes st on st.[id] = 14			
		Where p.[Shared] = 1
		
	Insert into A_Policy_SubjectPrivileges([idSubject],[subjType],[subjExtraId],[idObject],[idPrivilege],[value])	
		Select st.[groupId], 14, NULL, p.[Id], 'C892CC9E-4660-4ABC-8AD1-BAECDBFEAAC3', 1
		From A_TaskManager_Projects p
			Inner join A_Policy_SubjectTypes st on st.[id] = 14			
		Where p.[Shared] = 1
GO
				
-----------------------------------------------------------------------
if exists ( select * from sysobjects where id = object_id('dbo.A_TaskManager_Project_Save' ))
	Drop procedure dbo.A_TaskManager_Project_Save
GO

Create procedure [dbo].[A_TaskManager_Project_Save]
	@id uniqueidentifier,
	@name nvarchar ( 100 ),
	@description nvarchar ( 255 ) = '',
	@datecreation DateTime,
	@idcreator uniqueidentifier,
	@mainscript nvarchar ( 500 ) = null,
	@shared bit = 1,
	@urestype int = 0
as
begin

	if ( exists ( Select [id] from dbo.A_TaskManager_Projects where [id] = @id )) begin
		
		-- Проверка прав на изменение
		Declare @checkcount int
		
		exec A_Policy_SubjectPrivileges_GetForUserByObject
			@iduser = @idcreator,
			@idobject = @id,
			@idprivilege = 'C892CC9E-4660-4ABC-8AD1-BAECDBFEAAC3',
			@onlyreturncount = 1,
			@resultcount = @checkcount OUTPUT
	
		if ( @checkcount = 0 ) begin
			-- Прав недостаточно
			Select 1
			return
		end
		
		-- Обновляем существующий проект
		Update A_TaskManager_Projects
		Set	[Name] = @name,
			[Description] = @description,
			[UserResType] = @urestype
		Where Id = @id
	
	end else begin
	
		-- Новый проект
		Insert into A_TaskManager_Projects ( [Id], [Name], [Description], [DateCreation], [IdCreator], [MainScript], [UserResType] )
		Values ( @id, @name, @description, @datecreation, @idcreator, @mainscript, @urestype )
	
	end


	/* В таблицах политики прав доступа изменяем имя и проставляем дефолтные привилегии */
	exec A_Policy_Objects_Save
		@idObject = @id,
		@type = 101,
		@name = @name,
		@idParentProject = @id,
		@actionUserId = @idcreator
	
	
	-- В базе кубов поправляем имя проекта
	If Exists ( Select * FROM Master..sysdatabases where name like 'oktell_cc_temp' )
	If Exists ( Select * FROM oktell_cc_temp..sysobjects where id = Object_Id ( 'oktell_cc_temp.dbo.A_Cube_CC_Cat_Project' ) )
		Update oktell_cc_temp.dbo.A_Cube_CC_Cat_Project
		Set Name = @name
		Where Id = @id
	
end
GO

-----------------------------------------------------------------------
if exists ( select * from sysobjects where id = object_id('dbo.A_TaskManager_Project_Delete' ))
	Drop procedure dbo.A_TaskManager_Project_Delete
GO

Create procedure [dbo].[A_TaskManager_Project_Delete]
	@id uniqueidentifier,
	@iduser uniqueidentifier = NULL
as
begin

	if ( exists ( Select [id] from dbo.A_TaskManager_Projects where [id] = @id )) begin
	
		-- Проверка прав пользователя на удаление
		Declare @checkcount int
		
		exec A_Policy_SubjectPrivileges_GetForUserByObject
			@iduser = @iduser,
			@idobject = @id,
			@idprivilege = 'C892CC9E-4660-4ABC-8AD1-BAECDBFEAAC3',
			@onlyreturncount = 1,
			@resultcount = @checkcount OUTPUT			
		
		if ( @checkcount = 0 ) begin
			-- Прав недостаточно
			Select 1
			return
		end


		-- Удаляем проект
		Delete from A_TaskManager_Projects
		Where Id = @id


		-- Удаляем списки
		Declare tcursor Cursor For
			Select id 
			From A_TaskManager_Lists
			Where ProjectId = @id 

		Declare @idlist uniqueidentifier

		Open tcursor
		Fetch Next From tcursor Into @idlist

		while ( @@FETCH_STATUS = 0 ) begin
			exec A_TaskManager_List_Delete @idlist

			Fetch Next From tcursor Into @idlist
		end

		Close tcursor
		Deallocate tcursor


		-- Удаляем задачи, которые к спискам не относятся
		Delete From A_TaskManager_Tasks 
		Where IdProject = @id


		-- очищаем список пользовательских состояний уникальных для проекта
		--   не надо, чтобы кубы можно было пересекать. когда нибудь потом...
		--exec A_TaskManager_UserResultsProject_Clear @id
		
		
		-- Из таблиц политики прав доступа к объектам
		exec A_Policy_Objects_Remove @id		
		-- Заказ на очистку таблиц политики доступа
		exec A_Policy_SetFilter
		
	end
	
	-- Все удачно
	Select 0

end
GO

-----------------------------------------------------------------------
if exists ( select * from sysobjects where id = object_id('dbo.A_TaskManager_Project_GetAll' ))
	Drop procedure dbo.A_TaskManager_Project_GetAll
GO

Create procedure [dbo].[A_TaskManager_Project_GetAll]
as
begin

	Select Id, Name, Description, DateCreation, IdCreator, MainScript, cast(1 as bit), UserResType
	From A_TaskManager_Projects
	
end
GO

-----------------------------------------------------------------------
if exists ( select * from sysobjects where id = object_id('dbo.A_TaskManager_Project_GetAllViewed' ))
	Drop procedure dbo.A_TaskManager_Project_GetAllViewed
GO

Create procedure [dbo].[A_TaskManager_Project_GetAllViewed]
	@iduser uniqueidentifier
as
begin
	
	-- Привилегии доступные пользователю по проектам
	if exists ( Select * from tempdb..sysobjects where id = object_id ( 'tempdb..#privileges' ))
		Drop table #privileges
	Create table #privileges ( [idObject] uniqueidentifier, [idPrivilege] uniqueidentifier, [code] nvarchar(200))	
	Insert into #privileges ( [idObject], [idPrivilege], [code] )
		exec A_Policy_SubjectPrivileges_GetForUserByObjectType
			@iduser = @iduser,
			@objecttype = 101
			--@idparentproject = NULL,
			--@idprivilege = 'F876E650-7972-475A-AE96-BCCF831AF818'
		
	-- Непосредственно проекты, доступные хотя бы по одной привилегии
	Select t.[Id], t.[Name], t.[Description], t.[DateCreation], t.[IdCreator], t.[MainScript], cast(1 as bit), t.[UserResType]
	From (
			Select Distinct [Id]
			From A_TaskManager_Projects t
				Inner join #privileges p on p.[idObject] = t.[Id]
		) a
		Inner join A_TaskManager_Projects t on t.[Id] = a.[Id]
	
	-- Набор привилегий для каждого из доступных проектов
	Select [idObject], [idPrivilege], [code]
	From #privileges
	Order by [idObject]
	
end
GO


-----------------------------------------------------------------------
----- Reports --------------------------------------------------------
-----------------------------------------------------------------------

if exists ( Select * from oktell_settings..sysobjects where id = object_id ( 'oktell_settings.dbo.A_CallCenter_Reports_old' ))
	Drop table oktell_settings.dbo.A_CallCenter_Reports_old
GO


use oktell_settings

if exists ( select * from sysobjects where id = object_id ( 'dbo.A_CallCenter_Reports' ))
	exec sp_rename 'dbo.A_CallCenter_Reports', 'A_CallCenter_Reports_old'
	
use oktell
GO


if not exists ( Select * from oktell_settings..sysobjects where id = object_id ( 'oktell_settings.dbo.A_CallCenter_Reports' ))
CREATE TABLE oktell_settings.[dbo].A_CallCenter_Reports
(
	[Id] uniqueidentifier Primary Key Not NULL,
	[Name] nvarchar(2000),
	[Stream] image NULL
) 
ON [PRIMARY]
GO


if exists ( select * from sysobjects where id = object_id ( 'dbo.A_CallCenter_Reports' ))
	Drop view dbo.A_CallCenter_Reports
GO

Create view dbo.A_CallCenter_Reports
as 
	Select * 
	From oktell_settings.dbo.A_CallCenter_Reports
GO


if exists ( Select * from oktell_settings..sysobjects where id = object_id ( 'oktell_settings.dbo.A_CallCenter_Reports_old' ))
	Insert into oktell_settings.dbo.A_CallCenter_Reports ( [Id], [Name], [Stream] )
		Select [Id], '', [Stream]
		From oktell_settings.dbo.A_CallCenter_Reports_old
GO


if exists ( Select * from oktell_settings..sysobjects where id = object_id ( 'oktell_settings.dbo.A_CallCenter_Reports_old' ))
	Drop table oktell_settings.dbo.A_CallCenter_Reports_old
GO

-----------------------------------------------------------------------

	-- Отчеты
	Insert into A_Policy_Objects ( [id], [type], [name], [idParentProject] )
		Select [Id], 103, [Name], NULL
		From A_CallCenter_Reports
	
	-- Всем отчетам по умолчанию доступ открыт
	Insert into A_Policy_SubjectPrivileges([idSubject],[subjType],[subjExtraId],[idObject],[idPrivilege],[value])	
		Select st.[groupId], 14, NULL, t.[Id], '67139CAC-5C95-45DF-88A1-FBE8CC8F7BA4', 1
		From A_CallCenter_Reports t
			Inner join A_Policy_SubjectTypes st on st.[id] = 14			
		
	Insert into A_Policy_SubjectPrivileges([idSubject],[subjType],[subjExtraId],[idObject],[idPrivilege],[value])	
		Select st.[groupId], 14, NULL, t.[Id], 'A7ECEDEA-76A3-4BBF-98DA-D05CD1B84F9D', 1
		From A_CallCenter_Reports t
			Inner join A_Policy_SubjectTypes st on st.[id] = 14			

GO			
			
-----------------------------------------------------------------------
if exists ( select * from sysobjects where id = object_id('dbo.A_CallCenter_Report_Save' ))
	Drop procedure dbo.A_CallCenter_Report_Save
GO

Create Procedure [dbo].[A_CallCenter_Report_Save]
	@id uniqueidentifier,
	@stream image,
	@name nvarchar(2000) = NULL,
	@iduser uniqueidentifier = NULL
as
begin
	-- Сохраняет (создает или изменяет) отчет
	
	if ( exists ( Select [id] from dbo.A_CallCenter_Reports where [id] = @id )) begin
		
		-- Пользователь NULL - это 
		--    либо обновление отчета при старте системы из файла обновления
		--    либо старая версия к новой базе подцепилась
		--  и в том и в другом случае даем сохранить
		if ( not @iduser is NULL ) begin
				
			-- Проверка прав на изменение
			Declare @checkcount int
			
			exec A_Policy_SubjectPrivileges_GetForUserByObject
					@iduser = @iduser,
					@idobject = @id,
					@idprivilege = 'A7ECEDEA-76A3-4BBF-98DA-D05CD1B84F9D',
					@onlyreturncount = 1,
					@resultcount = @checkcount OUTPUT				
			
			if ( @checkcount = 0 ) begin
				-- Прав недостаточно
				Select 1
				return
			end
		end
		
		-- Обновление существующего отчета
		Update A_CallCenter_Reports
		Set [Name] = @name,
			[Stream] = @stream
		Where [Id] = @id
		
	end else begin
		
		-- Это новый отчет
		Insert into A_CallCenter_Reports ( [Id], [Name], [Stream] )
		Values ( @id, @name, @stream )
		
	end
	
	
	/* В таблицах политики прав доступа изменяем имя и проставляем дефолтные привилегии */
	exec A_Policy_Objects_Save
		@idObject = @id,
		@type = 103,
		@name = @name,
		@idParentProject = NULL,
		@actionUserId = @iduser
	
	
	-- Все удачно
	Select 0
	
end
GO

-----------------------------------------------------------------------
if exists ( select * from sysobjects where id = object_id('dbo.A_CallCenter_Report_Delete' ))
	Drop procedure dbo.A_CallCenter_Report_Delete
GO

Create Procedure [dbo].[A_CallCenter_Report_Delete]
	@id uniqueidentifier,
	@iduser uniqueidentifier = NULL
as
begin
	-- Удаляет отчет
	
	if ( exists ( Select [id] from dbo.A_CallCenter_Reports where [id] = @id )) begin
	
		-- Проверка прав пользователя на удаление
		Declare @checkcount int
		
		exec A_Policy_SubjectPrivileges_GetForUserByObject
			@iduser = @iduser,
			@idobject = @id,
			@idprivilege = 'A7ECEDEA-76A3-4BBF-98DA-D05CD1B84F9D',
			@onlyreturncount = 1,				
			@resultcount = @checkcount OUTPUT
		
		if ( @checkcount = 0 ) begin
			-- Прав недостаточно
			Select 1
			return
		end


		-- Из отчетов
		Delete 
		From A_CallCenter_Reports
		Where [Id] = @id
		
		-- Из таблиц политики прав доступа к объектам
		exec A_Policy_Objects_Remove @id
		
	end
	
	-- Все удачно
	Select 0
	
end
GO

-----------------------------------------------------------------------
if exists ( select * from sysobjects where id = object_id('dbo.A_CallCenter_Report_GetAll' ))
	Drop procedure dbo.A_CallCenter_Report_GetAll
GO

Create Procedure [dbo].[A_CallCenter_Report_GetAll]
as
begin
	-- Возвращает все отчеты

	Select Id, DataLength(Stream) as Length, Stream 
	From A_CallCenter_Reports
	
end
GO

-----------------------------------------------------------------------
if exists ( select * from sysobjects where id = object_id('dbo.A_CallCenter_Report_GetAllViewed' ))
	Drop procedure dbo.A_CallCenter_Report_GetAllViewed
GO

Create Procedure dbo.A_CallCenter_Report_GetAllViewed
	@iduser uniqueidentifier
as
begin
	-- Возвращает все отчеты, доступные для просмотра указанному пользователю

	-- Привилегии доступные пользователю по отчетам
	if exists ( Select * from tempdb..sysobjects where id = object_id ( 'tempdb..#privileges' ))
		Drop table #privileges
	Create table #privileges ( [idObject] uniqueidentifier, [idPrivilege] uniqueidentifier, [code] nvarchar(200))
	Insert into #privileges ( [idObject], [idPrivilege], [code] )
		exec A_Policy_SubjectPrivileges_GetForUserByObjectType
			@iduser = @iduser,
			@objecttype = 103
			--@idparentproject = NULL,
			--@idprivilege = '67139CAC-5C95-45DF-88A1-FBE8CC8F7BA4'
		
	-- Непосредственно отчеты, доступные хотя бы по одной привилегии
	Select t.[Id], DataLength(t.[Stream]) as Length, t.[Stream] 
	From (
			Select Distinct [Id]
			From A_CallCenter_Reports t
				Inner join #privileges p on p.[idObject] = t.[Id]
		) a
		Inner join A_CallCenter_Reports t on t.[Id] = a.[Id]
	
	-- Набор привилегий для каждого из доступных отчетов
	Select [idObject], [idPrivilege], [code]
	From #privileges
	Order by [idObject]
	
end
GO

-----------------------------------------------------------------------
----- Indicators --------------------------------------------------------
-----------------------------------------------------------------------

if exists ( Select * from oktell_settings..sysobjects where id = object_id ( 'oktell_settings.dbo.A_CallCenter_Indicators_old' ))
	Drop table oktell_settings.dbo.A_CallCenter_Indicators_old
GO


use oktell_settings

if exists ( select * from sysobjects where id = object_id ( 'dbo.A_CallCenter_Indicators' ))
	exec sp_rename 'dbo.A_CallCenter_Indicators', 'A_CallCenter_Indicators_old'
	
use oktell
GO


if not exists ( Select * from oktell_settings..sysobjects where id = object_id ( 'oktell_settings.dbo.A_CallCenter_Indicators' ))
CREATE TABLE oktell_settings.[dbo].A_CallCenter_Indicators
(
	[Id] uniqueidentifier Primary Key Not NULL,
	[Name] nvarchar(2000),
	[Stream] image NULL
) 
ON [PRIMARY]
GO


if exists ( select * from sysobjects where id = object_id ( 'dbo.A_CallCenter_Indicators' ))
	Drop view dbo.A_CallCenter_Indicators
GO

Create view dbo.A_CallCenter_Indicators
as 
	Select * 
	From oktell_settings.dbo.A_CallCenter_Indicators
GO


if exists ( Select * from oktell_settings..sysobjects where id = object_id ( 'oktell_settings.dbo.A_CallCenter_Indicators_old' ))
	Insert into oktell_settings.dbo.A_CallCenter_Indicators ( [Id], [Name], [Stream] )
		Select [Id], '', [Stream]
		From oktell_settings.dbo.A_CallCenter_Indicators_old
GO


if exists ( Select * from oktell_settings..sysobjects where id = object_id ( 'oktell_settings.dbo.A_CallCenter_Indicators_old' ))
	Drop table oktell_settings.dbo.A_CallCenter_Indicators_old
GO

-----------------------------------------------------------------------
	
	-- Индикаторы
	Insert into A_Policy_Objects ( [id], [type], [name], [idParentProject] )
		Select [Id], 104, [Name], NULL
		From A_CallCenter_Indicators
	
	-- Всем индикаторам по умолчанию доступ открыт
	Insert into A_Policy_SubjectPrivileges([idSubject],[subjType],[subjExtraId],[idObject],[idPrivilege],[value])	
		Select st.[groupId], 14, NULL, t.[Id], '495DEB4D-D5FF-4C52-A219-541C3AEC6CAC', 1
		From A_CallCenter_Indicators t
			Inner join A_Policy_SubjectTypes st on st.[id] = 14			
		
	Insert into A_Policy_SubjectPrivileges([idSubject],[subjType],[subjExtraId],[idObject],[idPrivilege],[value])	
		Select st.[groupId], 14, NULL, t.[Id], 'A2E397DF-40DB-4C80-BB2D-8CD49A29E09D', 1
		From A_CallCenter_Indicators t
			Inner join A_Policy_SubjectTypes st on st.[id] = 14			
GO
			
-----------------------------------------------------------------------
if exists ( select * from sysobjects where id = object_id('dbo.A_CallCenter_Indicator_Save' ))
	Drop procedure dbo.A_CallCenter_Indicator_Save
GO

Create Procedure [dbo].[A_CallCenter_Indicator_Save]
	@id uniqueidentifier,
	@stream image,
	@name nvarchar(2000) = NULL,
	@iduser uniqueidentifier = NULL
as
begin
	-- Сохраняет (создает или изменяет) индикатор
	
	if ( exists ( Select [id] from dbo.A_CallCenter_Indicators where [id] = @id )) begin
		
		-- Пользователь NULL - это 
		--    либо обновление отчета при старте системы из файла обновления
		--    либо старая версия к новой базе подцепилась
		--  и в том и в другом случае даем сохранить
		if ( not @iduser is NULL ) begin
		
			-- Проверка прав на изменение
			Declare @checkcount int
			
			exec A_Policy_SubjectPrivileges_GetForUserByObject
				@iduser = @iduser,
				@idobject = @id,
				@idprivilege = 'A2E397DF-40DB-4C80-BB2D-8CD49A29E09D',
				@onlyreturncount = 1,
				@resultcount = @checkcount OUTPUT
		
			if ( @checkcount = 0 ) begin
				-- Прав недостаточно
				Select 1
				return
			end
		end
		
		-- Обновление существующего индикатора
		Update A_CallCenter_Indicators
		Set [Name] = @name,
			[Stream] = @stream
		Where [Id] = @id
		
	end else begin
		
		-- Это новый индикатор
		Insert into A_CallCenter_Indicators ( [Id], [Name], [Stream] )
		Values ( @id, @name, @stream )
		
	end
	
	
	/* В таблицах политики прав доступа изменяем имя и проставляем дефолтные привилегии */
	exec A_Policy_Objects_Save
		@idObject = @id,
		@type = 104,
		@name = @name,
		@idParentProject = NULL,
		@actionUserId = @iduser
	
	
	-- Все удачно
	Select 0	
	
end
GO

-----------------------------------------------------------------------
if exists ( select * from sysobjects where id = object_id('dbo.A_CallCenter_Indicator_Delete' ))
	Drop procedure dbo.A_CallCenter_Indicator_Delete
GO

Create Procedure [dbo].[A_CallCenter_Indicator_Delete]
	@id uniqueidentifier,
	@iduser uniqueidentifier = NULL
as
begin
	-- Удаляет индикатор

	if ( exists ( Select [id] from dbo.A_CallCenter_Indicators where [id] = @id )) begin
	
		-- Проверка прав пользователя на удаление
		Declare @checkcount int
		
		exec A_Policy_SubjectPrivileges_GetForUserByObject
			@iduser = @iduser,
			@idobject = @id,
			@idprivilege = 'A2E397DF-40DB-4C80-BB2D-8CD49A29E09D',
			@onlyreturncount = 1,				
			@resultcount = @checkcount OUTPUT
		
		if ( @checkcount = 0 ) begin
			-- Прав недостаточно
			Select 1
			return
		end


		-- Из индикаторов
		Delete 
		From A_CallCenter_Indicators
		Where [Id] = @id
		
		-- Из таблиц политики прав доступа к объектам
		exec A_Policy_Objects_Remove @id
		
	end
	
	-- Все удачно
	Select 0
	
end
GO

-----------------------------------------------------------------------
if exists ( select * from sysobjects where id = object_id('dbo.A_CallCenter_Indicator_GetAll' ))
	Drop procedure dbo.A_CallCenter_Indicator_GetAll
GO

Create Procedure [dbo].[A_CallCenter_Indicator_GetAll]
as
begin
	-- Возвращает все индикаторы

	Select Id, DataLength(Stream) as Length, Stream 
	From A_CallCenter_Indicators
	
end
GO

-----------------------------------------------------------------------
if exists ( select * from sysobjects where id = object_id('dbo.A_CallCenter_Indicator_GetAllViewed' ))
	Drop procedure dbo.A_CallCenter_Indicator_GetAllViewed
GO

Create Procedure dbo.A_CallCenter_Indicator_GetAllViewed
	@iduser uniqueidentifier
as
begin
	-- Возвращает все инликаторы, доступные для просмотра указанному пользователю
	
	-- Привилегии доступные пользователю по индикаторам
	if exists ( Select * from tempdb..sysobjects where id = object_id ( 'tempdb..#privileges' ))
		Drop table #privileges
	Create table #privileges ( [idObject] uniqueidentifier, [idPrivilege] uniqueidentifier, [code] nvarchar(200))
	Insert into #privileges ( [idObject], [idPrivilege], [code] )
		exec A_Policy_SubjectPrivileges_GetForUserByObjectType
			@iduser = @iduser,
			@objecttype = 104
			--@idparentproject = NULL,
			--@idprivilege = '495DEB4D-D5FF-4C52-A219-541C3AEC6CAC'
		
	-- Непосредственно индикаторы, доступные хотя бы по одной привилегии
	Select t.[Id], DataLength(t.[Stream]) as Length, t.[Stream] 
	From (
			Select Distinct [Id]
			From A_CallCenter_Indicators t
				Inner join #privileges p on p.[idObject] = t.[Id]
		) a
		Inner join A_CallCenter_Indicators t on t.[Id] = a.[Id]
	
	-- Набор привилегий для каждого из доступных индикаторов
	Select [idObject], [idPrivilege], [code]
	From #privileges
	Order by [idObject]
	
end
GO


-----------------------------------------------------------------------
----- CallLists --------------------------------------------------------
-----------------------------------------------------------------------

	-- Таблицы абонентов (кроме колллистов для автозадач IVR, признак - отсутствие привязки к проекту)
	Insert into A_Policy_Objects ( [id], [type], [name], [idParentProject] )
		Select [Id], 107, [Name], [ProjectId]
		From A_TaskManager_Lists t
		Where t.ProjectId != '00000000-0000-0000-0000-000000000000'
	
	-- Всем таблицам по умолчанию доступ открыт (кроме автозадач)
	Insert into A_Policy_SubjectPrivileges([idSubject],[subjType],[subjExtraId],[idObject],[idPrivilege],[value])	
		Select st.[groupId], 14, NULL, t.[Id], 'A3800C07-462C-4E33-B985-8D8FA921E0C2', 1
		From A_TaskManager_Lists t
			Inner join A_Policy_SubjectTypes st on st.[id] = 14			
		Where t.ProjectId != '00000000-0000-0000-0000-000000000000'
		
	Insert into A_Policy_SubjectPrivileges([idSubject],[subjType],[subjExtraId],[idObject],[idPrivilege],[value])	
		Select st.[groupId], 14, NULL, t.[Id], '3D8CB103-C18B-4F35-BC96-E2F7E9E09A8E', 1
		From A_TaskManager_Lists t
			Inner join A_Policy_SubjectTypes st on st.[id] = 14		
		Where t.ProjectId != '00000000-0000-0000-0000-000000000000'
GO
			
-----------------------------------------------------------------------
if exists ( select * from sysobjects where id = object_id('dbo.A_TaskManager_List_Save' ))
	Drop procedure dbo.A_TaskManager_List_Save
GO
			
Create procedure [dbo].[A_TaskManager_List_Save]
	@id uniqueidentifier,	
	@name nvarchar ( 100 ),
	@description nvarchar ( 255 ),
	@idproject uniqueidentifier,
	@type int,
	@query nvarchar ( 1000 ),
	@joinedtable nvarchar ( 100 ),
	@getviewedfromtable bit = 1,
	@columnid nvarchar ( 100 ),
	@columnsphone nvarchar ( 1000 ),
	@columnname nvarchar ( 100 ),
	@columnsviewed nvarchar ( 1000 ),
	@columnsvieweddescription nvarchar ( 4000 ),
	@columnssqltype nvarchar ( 4000 ),
	@columnssqltypesize nvarchar ( 4000 ),
	@dbconnid int = 0,
	@dbconnstring nvarchar(1000) = '',
	@dbconnmode int = 0,
	@dbprovidername nvarchar(100) = '',
	@iduser uniqueidentifier = NULL
as
begin
	Declare @tp int
	Declare @jt nvarchar ( 100 )

	Select @tp = Type, @jt = JoinedTable
	From A_TaskManager_Lists 
	Where Id = @id

	declare @sql nvarchar ( 100 )
	set @sql = 'drop table ' + @jt

	-- если это локальная таблица, и изменено ее имя
	if ( @tp in ( 1, 5, 6 )) and ( @jt != @joinedtable )
		if ( exists ( Select * From sysobjects where id = object_id ( @jt ) ) )
			exec sp_executesql @sql

	Update A_Taskmanager_Lists
	Set		
		[Name]					= @name,
		[Description]			= @description,
		[ProjectId]				= @idproject,
		[Type]					= @type,
		[Query]					= @query,
		[JoinedTable]			= @joinedtable,
		[GetViewedFromTable]	= @getviewedfromtable,
		[ColumnId] 				= @columnid,
		[ColumnsPhone] 			= @columnsphone,
		[ColumnName] 			= @columnname,
		[ColumnsViewed] 		= @columnsviewed,
		[ColumnsViewedDescription] = @columnsvieweddescription,
		[ColumnsSqlType] 		= @columnssqltype,
		[ColumnsSqlTypeSize] 	= @columnssqltypesize,
		[DbConnId]				= @dbconnid,
		[DbConnString]			= @dbconnstring,
		[DbConnMode]			= @dbconnmode,
		[DbProviderName]		= @dbprovidername
	Where Id = @id

	if ( @@rowcount = 0 ) begin

		-- Добавляется новый		
		Insert into A_TaskManager_Lists ( Id, Name, Description, ProjectId, Type, Query, JoinedTable, GetViewedFromTable, ColumnId, ColumnsPhone, ColumnName, ColumnsViewed, ColumnsViewedDescription, ColumnsSqlType, ColumnsSqlTypeSize, DbConnId, DbConnString, DbConnMode, DbProviderName )
		Values ( @id, @name, @description, @idproject, @type, @query, @joinedtable, @getviewedfromtable, @columnid, @columnsphone, @columnname, @columnsviewed, @columnsvieweddescription, @columnssqltype, @columnssqltypesize, @dbconnid, @dbconnstring, @dbconnmode, @dbprovidername )
		
	end
		
	/* В таблицах политики прав доступа изменяем имя и проставляем дефолтные привилегии */
	/*   только если это не авто список для задач из IVR (признак - отсутствие привязки к проекту) */
	if ( @idproject != '00000000-0000-0000-0000-000000000000' )
		exec A_Policy_Objects_Save
			@idObject = @id,
			@type = 107,
			@name = @name,
			@idParentProject = @idproject,
			@actionUserId = @iduser
end
GO

-----------------------------------------------------------------------
if exists ( select * from sysobjects where id = object_id('dbo.A_TaskManager_List_Delete' ))
	Drop procedure dbo.[A_TaskManager_List_Delete]
GO
			
Create procedure [dbo].[A_TaskManager_List_Delete]
	@id uniqueidentifier,
	@droptable bit = 1,
	@iduser uniqueidentifier = NULL
as
begin

	-- Задачи обновляем
	Update A_TaskManager_Tasks
	Set ListId = '00000000-0000-0000-0000-000000000000'
	Where ListId = @id

	-- Запоминаем тип и закрепленную таблицу
	Declare @type int, @jt nvarchar ( 100 ), @idproject uniqueidentifier
	
	Select @type = t.[Type], 
		   @jt = t.[JoinedTable],
		   @idproject = t.[ProjectId]
	From A_TaskManager_Lists t
	Where t.[id] = @id
	
	-- Из таблиц
	Delete 
	From A_TaskManager_Lists
	Where Id = @id

	-- Локальную таблицу
	declare @sql nvarchar ( 100 )
	set @sql = 'drop table ' + @jt
	if ( @type in ( 1, 5, 6 ) ) and ( @droptable = 1 ) begin
		if ( exists ( Select * From sysobjects where id = object_id ( @jt ) ) )
			exec sp_executesql @sql
	end		
	
	
	-- Из таблиц политики прав доступа к объектам
	if ( @idproject != '00000000-0000-0000-0000-000000000000' )
		exec A_Policy_Objects_Remove @id
	
end
GO

-----------------------------------------------------------------------
if exists ( select * from sysobjects where id = object_id('dbo.A_TaskManager_List_GetViewedByProject' ))
	Drop procedure dbo.A_TaskManager_List_GetViewedByProject
GO

Create procedure [dbo].A_TaskManager_List_GetViewedByProject
	@idproject uniqueidentifier,
	@iduser uniqueidentifier = NULL
as
begin

	-- Возвращает информацию о всех таблицах абонентов, входящих в указанный проект
	
	-- Привилегии доступные пользователю по таблицам абонентов
	if exists ( select * from tempdb..sysobjects where id = object_id ( 'tempdb..#privileges' ))
		Drop table #privileges
	Create table #privileges ( [idObject] uniqueidentifier, [idPrivilege] uniqueidentifier, [code] nvarchar(200))
	Insert into #privileges ( [idObject], [idPrivilege], [code] )
		exec A_Policy_SubjectPrivileges_GetForUserByObjectType
			@iduser = @iduser,
			@objecttype = 107
			--@idparentproject = NULL,
			--@idprivilege = '495DEB4D-D5FF-4C52-A219-541C3AEC6CAC'


	-- Таблицы абонентов
	Select t.[Id], t.[Name], t.[Description], t.[ProjectId], t.[Type], 
		t.[Query], t.[JoinedTable], t.[ColumnId], t.[ColumnsPhone], 
		t.[ColumnName], t.[ColumnsViewed], t.[ColumnsViewedDescription],
		t.[ColumnsSqlType], t.[ColumnsSqlTypeSize],
		t.[GetViewedFromTable],
		t.[DbConnId], t.[DbConnString], t.[DbConnMode], t.[DbProviderName]
	From (
			Select Distinct [Id]
			From A_TaskManager_Lists t
				Inner join #privileges p on p.[idObject] = t.[Id]
			Where t.[ProjectId] = @idproject
		) a
		Inner join A_TaskManager_Lists t on t.[Id] = a.[Id]
	Order By t.[Name]
	
	
	-- Набор привилегий для каждого из доступных индикаторов
	Select [idObject], [idPrivilege], [code]
	From #privileges
	Order by [idObject]
	
end
GO

-----------------------------------------------------------------------
if exists ( select * from sysobjects where id = object_id('dbo.A_TaskManager_List_GetInfo' ))
	Drop procedure dbo.A_TaskManager_List_GetInfo
GO

Create procedure [dbo].[A_TaskManager_List_GetInfo]
	@idlist uniqueidentifier,
	@iduser uniqueidentifier = NULL
as
begin

	-- Возвращает информацию о таблице абонентов по идентификатору
	
	Select t.[Id], t.[Name], t.[Description], t.[ProjectId], t.[Type], 
		t.[Query], t.[JoinedTable], t.[ColumnId], t.[ColumnsPhone], 
		t.[ColumnName], t.[ColumnsViewed], t.[ColumnsViewedDescription],
		t.[ColumnsSqlType], t.[ColumnsSqlTypeSize],
		t.[GetViewedFromTable],
		t.[DbConnId], t.[DbConnString], t.[DbConnMode], t.[DbProviderName]
	From A_TaskManager_Lists t
	Where t.[Id] = @idlist
	Order by t.[Name]
	
end
GO

-----------------------------------------------------------------------
----- Tasks -----------------------------------------------------------
-----------------------------------------------------------------------

	-- Голосовые задачи (кроме автозадач)
	Insert into A_Policy_Objects ( [id], [type], [name], [idParentProject] )
		Select [Id], 102, [Name], [IdProject]
		From A_TaskManager_Tasks t
		Where t.CreationType != 4
			
	-- Всем голосовым задачам по умолчанию доступ открыт (кроме автозадач)
	Insert into A_Policy_SubjectPrivileges([idSubject],[subjType],[subjExtraId],[idObject],[idPrivilege],[value])	
		Select st.[groupId], 14, NULL, t.[Id], '8E2C5D49-08E0-48CE-9628-661BB6007889', 1
		From A_TaskManager_Tasks t
			Inner join A_Policy_SubjectTypes st on st.[id] = 14
		Where t.CreationType != 4
		
	Insert into A_Policy_SubjectPrivileges([idSubject],[subjType],[subjExtraId],[idObject],[idPrivilege],[value])	
		Select st.[groupId], 14, NULL, t.[Id], '003FD36D-85F7-4A1C-8BC1-2E35732EDA63', 1
		From A_TaskManager_Tasks t
			Inner join A_Policy_SubjectTypes st on st.[id] = 14	
		Where t.CreationType != 4
			
	Insert into A_Policy_SubjectPrivileges([idSubject],[subjType],[subjExtraId],[idObject],[idPrivilege],[value])	
		Select st.[groupId], 14, NULL, t.[Id], '46D69D19-46DC-4B82-ADD2-9B9209AA769F', 1
		From A_TaskManager_Tasks t
			Inner join A_Policy_SubjectTypes st on st.[id] = 14	
		Where t.CreationType != 4
			
	Insert into A_Policy_SubjectPrivileges([idSubject],[subjType],[subjExtraId],[idObject],[idPrivilege],[value])	
		Select st.[groupId], 14, NULL, t.[Id], '49C5337B-3660-467B-9C58-2B793CBAF2C2', 1
		From A_TaskManager_Tasks t
			Inner join A_Policy_SubjectTypes st on st.[id] = 14	
		Where t.CreationType != 4
			
	-- Текстовые задачи
	Insert into A_Policy_Objects ( [id], [type], [name], [idParentProject] )
		Select [Id], 102, [Name], [IdProject]
		From A_SmsTaskManager_Tasks
			
	-- Всем текстовым задачам по умолчанию доступ открыт
	Insert into A_Policy_SubjectPrivileges([idSubject],[subjType],[subjExtraId],[idObject],[idPrivilege],[value])	
		Select st.[groupId], 14, NULL, t.[Id], '8E2C5D49-08E0-48CE-9628-661BB6007889', 1
		From A_SmsTaskManager_Tasks t
			Inner join A_Policy_SubjectTypes st on st.[id] = 14			
		
	Insert into A_Policy_SubjectPrivileges([idSubject],[subjType],[subjExtraId],[idObject],[idPrivilege],[value])	
		Select st.[groupId], 14, NULL, t.[Id], '003FD36D-85F7-4A1C-8BC1-2E35732EDA63', 1
		From A_SmsTaskManager_Tasks t
			Inner join A_Policy_SubjectTypes st on st.[id] = 14	
			
	Insert into A_Policy_SubjectPrivileges([idSubject],[subjType],[subjExtraId],[idObject],[idPrivilege],[value])	
		Select st.[groupId], 14, NULL, t.[Id], '46D69D19-46DC-4B82-ADD2-9B9209AA769F', 1
		From A_SmsTaskManager_Tasks t
			Inner join A_Policy_SubjectTypes st on st.[id] = 14	
			
	Insert into A_Policy_SubjectPrivileges([idSubject],[subjType],[subjExtraId],[idObject],[idPrivilege],[value])	
		Select st.[groupId], 14, NULL, t.[Id], '49C5337B-3660-467B-9C58-2B793CBAF2C2', 1
		From A_SmsTaskManager_Tasks t
			Inner join A_Policy_SubjectTypes st on st.[id] = 14	
GO			

-----------------------------------------------------------------------
if exists ( select * from sysobjects where id = object_id('dbo.A_TaskManager_Task_Save' ))
	Drop procedure dbo.[A_TaskManager_Task_Save]
GO

Create Procedure [dbo].[A_TaskManager_Task_Save]
	@id uniqueidentifier,
	@idproject uniqueidentifier,
	@name nvarchar(500),
	@active int,
	@done int,
	@type int,
	@ivrname nvarchar(500),
	@stopreason int,
	@talkscript nvarchar(500),
	@pausewhenbusy float,
	@pausewhennotrespond float,
	@maxeffortcountbusy int,
	@maxeffortcountnotrespond int,
	@mintimetocheckdone int,
	@tryconnecttime int,
	@choiceoperator int,
	@deleteaftersuccess int,
	@isextnumber int,
	@isoutputtask int,
	@resulted int,
	@resulttype int,
	@resultinfo nvarchar(500),
	@resultdatetime datetime,
	@creationuserid uniqueidentifier,
	@creationtype int,
	@creationdatetime datetime,
	@startrundatetime datetime,
	@stoprundatetime datetime,
	@canadddynamically int,
	@tagdouble float,
	@listid uniqueidentifier,
	@operatorshowquery bit,
	@operatorshownotify bit,
	@progresscall bit,
	@progresscallmaxcount int,
	@progresscallkeepqueue bit,
	@predictcall bit,
	@predictcalloffsetsec int,
	@queueuse bit,
	@queuemaxcount int,
	@queuemusic nvarchar ( 500 ),
	@queueloyality int,
	@choiceabonents int,
	@choicenumber int,
	@choicetable int,
	@choiceprogress int,
	@dontsetdone bit,
	@pausesynclistwaitingnewabonent int,
	@incomingcallsmaxcount int,
	@servicescript nvarchar ( 200 ),
	@dialcallerid nvarchar ( 20 ),
	@incomingupdateifexists bit,
	@activeonholidays bit,
	@code nvarchar ( 30 ),
	@pausesynclistforcedsec int,
	@queuemaxtimeminutes int,
	@predictcallerrprobability int,
	@queuerandomfrompath nvarchar ( 200 ),
	@savedb	bit,
	@directdbmethod int = 0,
	@directdbmethodproc nvarchar ( 200 ) = '',
	@streamparams image = NULL,
	@iduser uniqueidentifier = NULL
as
begin

	if ( exists ( Select Id From A_TaskManager_Tasks Where Id = @id )) begin
	
		-- Обновляет задачу
		Update A_TaskManager_Tasks
		Set 
			IdProject			= @idproject,
			Name 				= @name, 			
			Active 				= @active, 
			Done 				= @done, 
			Type 				= @type, 
			IvrName 			= @ivrname, 
			StopReason 			= @stopreason, 
			TalkScript 			= @talkscript, 
			PauseWhenBusy 			= @pausewhenbusy, 
			PauseWhenNotRespond 		= @pausewhennotrespond, 
			MaxEffortCountBusy 		= @maxeffortcountbusy, 
			MaxEffortCountNotRespond 	= @maxeffortcountnotrespond, 
			MinTimeToCheckDone 		= @mintimetocheckdone, 
			TryConnectTime 			= @tryconnecttime, 
			ChoiceOperator			= @choiceoperator,
			DeleteAfterSuccess 		= @deleteaftersuccess, 
			IsExtNumber 			= @isextnumber, 
			IsOutputTask			= @isoutputtask,
			Resulted 			= @resulted, 
			ResultType 			= @resulttype, 
			ResultInfo 			= @resultinfo, 
			ResultDateTime 			= @resultdatetime, 
			CreationUserId 			= @creationuserid, 
			CreationType 			= @creationtype, 
			CreationDateTime 		= @creationdatetime,
			StartRunDateTime		= @startrundatetime,
			StopRunDateTime			= @stoprundatetime,
			CanAddDynamically		= @canadddynamically,	
			TagDouble			= @tagdouble,	
			ListId				= @listid,
			OperatorShowQuery		= @operatorshowquery,
			OperatorShowNotify		= @operatorshownotify,
			ProgressCall			= @progresscall,
			ProgressCallMaxCount		= @progresscallmaxcount,
			ProgressCallKeepQueue		= @progresscallkeepqueue,
			PredictCall			= @predictcall,
			PredictCallOffsetSec		= @predictcalloffsetsec,
			QueueUse 			= @queueuse,
			QueueMaxCount			= @queuemaxcount,
			QueueMusic			= @queuemusic,
			QueueLoyality			= @queueloyality,
			ChoiceAbonent			= @choiceabonents,
			ChoiceNumber			= @choicenumber,
			ChoiceTable			= @choicetable,
			ChoiceProgress			= @choiceprogress,
			DontSetDone			= @dontsetdone,
			PauseSyncListWaitingNewAbonent	= @pausesynclistwaitingnewabonent,
			IncomingCallsMaxCount		= @incomingcallsmaxcount,
			ServiceScript			= @servicescript,
			DialCallerId			= @dialcallerid,
			IncomingUpdateIfExists		= @incomingupdateifexists,
			ActiveOnHolidays		= @activeonholidays,
			Code				= @code,
			PauseSyncListForcedSec		= @pausesynclistforcedsec,
			QueueMaxTimeMinutes		= @queuemaxtimeminutes,
			PredictCallErrProbability	= @predictcallerrprobability,
			QueueRandomFromPath		= @queuerandomfrompath,
			SaveDB				= @savedb,
			DirectDbMethod			= @directdbmethod,
			DirectDbMethodProc		= @directdbmethodproc
 		Where
			Id = @id


		-- Обновляет свойства дополнительные
		Update A_TaskManager_TaskProperties
		Set Stream = @streamparams
		Where IdTask = @id
		
		if ( @@rowcount = 0 ) begin
			insert into A_TaskManager_TaskProperties ( IdTask, Stream )
			Values ( @id, @streamparams )
		end
		
	end else begin
	
		-- Добавляет новую задачу
		Insert into A_TaskManager_Tasks
		(
			Id, 
			IdProject,
			Name, 
			Active, 
			Done, 
			Type, 
			IvrName, 
			StopReason, 
			TalkScript, 
			PauseWhenBusy, 
			PauseWhenNotRespond, 
			MaxEffortCountBusy, 
			MaxEffortCountNotRespond, 
			MinTimeToCheckDone, 
			TryConnectTime, 
			ChoiceOperator, 
			DeleteAfterSuccess, 
			IsExtNumber, 
			IsOutputTask, 
			Resulted, 
			ResultType, 
			ResultInfo, 
			ResultDateTime, 
			CreationUserId, 
			CreationType, 
			CreationDateTime, 
			StartRunDateTime, 
			StopRunDateTime, 
			CanAddDynamically, 
			TagDouble, 
			ListId,
			OperatorShowQuery,
			OperatorShowNotify,
			ProgressCall,
			ProgressCallMaxCount,
			ProgressCallKeepQueue,
			PredictCall,
			PredictCallOffsetSec,
			QueueUse,
			QueueMaxCount,
			QueueMusic,
			QueueLoyality,
			ChoiceAbonent,
			ChoiceNumber,
			ChoiceTable,
			ChoiceProgress,
			DontSetDone,			
			PauseSyncListWaitingNewAbonent,
			IncomingCallsMaxCount,
			ServiceScript,
			DialCallerId,
			IncomingUpdateIfExists,
			ActiveOnHolidays,
			Code,
			PauseSyncListForcedSec,
			QueueMaxTimeMinutes,
			PredictCallErrProbability,
			QueueRandomFromPath,
			SaveDB,
			DirectDbMethod,
			DirectDbMethodProc
		) 
		Values  
		(
			@id,
			@idproject,
			@name,
			@active,
			@done,
			@type,
			@ivrname,
			@stopreason,
			@talkscript,
			@pausewhenbusy,
			@pausewhennotrespond,
			@maxeffortcountbusy,
			@maxeffortcountnotrespond,
			@mintimetocheckdone,
			@tryconnecttime,
			@choiceoperator,
			@deleteaftersuccess,
			@isextnumber,
			@isoutputtask,
			@resulted,
			@resulttype,
			@resultinfo,
			@resultdatetime,
			@creationuserid,
			@creationtype,
			@creationdatetime,
			@startrundatetime,
			@stoprundatetime,
			@canadddynamically,
			@tagdouble,
			@listid,
			@operatorshowquery,
			@operatorshownotify,
			@progresscall,
			@progresscallmaxcount,
			@progresscallkeepqueue,
			@predictcall,
			@predictcalloffsetsec,
			@queueuse,
			@queuemaxcount,
			@queuemusic,
			@queueloyality,
			@choiceabonents,
			@choicenumber,
			@choicetable,
			@choiceprogress,
			@dontsetdone,
			@pausesynclistwaitingnewabonent,
			@incomingcallsmaxcount,
			@servicescript,
			@dialcallerid,
			@incomingupdateifexists,
			@activeonholidays,
			@code,
			@pausesynclistforcedsec,
			@queuemaxtimeminutes,
			@predictcallerrprobability,
			@queuerandomfrompath,
			@savedb,
			@directdbmethod,
			@directdbmethodproc
		)		

		-- Добавляет свойства для нее
		Insert into A_TaskManager_TaskProperties ( IdTask, Stream )
		Values ( @id, @streamparams )
	end


	-- Политика прав доступа
	if ( @creationtype != 4 ) begin --AUTO не надо
	
		/* В таблицах политики прав доступа изменяем имя и проставляем дефолтные привилегии */
		exec A_Policy_Objects_Save
			@idObject = @id,
			@type = 102,
			@name = @name,
			@idParentProject = @idproject,
			@actionUserId = @iduser
			
		-- Заказ на обновление кэша групп пользователей (операторы супервизоры новые появились)
		exec A_Policy_SubjectGroupCache_SetUpdate
		
	end


	-- в базе кубов поправляем имя юзера
	If Exists ( Select * FROM Master..sysdatabases where name like 'oktell_cc_temp' )
	If Exists ( Select * FROM oktell_cc_temp..sysobjects where id = Object_Id ( 'oktell_cc_temp.dbo.A_Cube_CC_Cat_Task' ) )
		Update oktell_cc_temp.dbo.A_Cube_CC_Cat_Task
		Set Name = @name
		Where Id = @id
end
GO

-----------------------------------------------------------------------
if exists ( select * from sysobjects where id = object_id('dbo.A_TaskManager_Task_Delete' ))
	Drop procedure dbo.[A_TaskManager_Task_Delete]
GO

Create Procedure [dbo].[A_TaskManager_Task_Delete]
	@id uniqueidentifier,
	@iduser uniqueidentifier = NULL
as
begin	
	-- Удаляет голосовую задачу
	
	-- Проверка прав? 
	-- Менеджер задач авто задачи удаляет тоже. Автозадачи вообще не нужны в правовой политике
	
	Declare @type int, @creationtype int
	Select @type = Type, 
		   @creationtype = CreationType 
	From A_SmsTaskManager_Tasks
	Where Id = @id
	
	
	-- Удаление задачи
	Delete 
	From A_TaskManager_Tasks 
	Where Id = @id

	-- Удаляет дополнительные свойства
	Delete
	From A_TaskManager_TaskProperties
	Where IdTask = @id
	
	-- Удаляет линии
	exec A_TaskManager_Task_ClearExtLines @id
	
	-- Удаляет операторов
	exec A_TaskManager_Task_ClearOperators @id
	
	-- Удаляет супервизоров
	exec A_TaskManager_Task_ClearSupervisors @id
	
	-- Удаляет периоды
	exec A_TaskManager_Task_ClearPeriods @id
	
	-- Удаляет подзадачи
	exec A_TaskManager_Task_ClearSubTasks @id
	
	-- Удаляет статистику
	exec A_TaskManager_Task_ClearStatistics @id, 0
	
	

	-- Очистка кэш-таблиц
	Exec dbo.A_TaskManager_List_DirectDB_CacheDelete @id
	Exec dbo.A_TaskManager_List_DistrDirectDB_CacheDelete @id
	
	-- Политика прав
	if ( @creationtype != 4 ) begin --AUTO не надо
	
		-- Из таблиц политики прав доступа к объектам
		exec A_Policy_Objects_Remove @id
		
		if ( @type != 10 ) begin --IVR не надо
		
			-- Заказ на очистку таблиц политики доступа
			exec A_Policy_SetFilter
			
			-- Заказ на обновление кэша групп субъектов (операторы и супервизоры удалены)
			exec A_Policy_SubjectGroupCache_SetUpdate
			
		end		
	end
	
end
GO			

-----------------------------------------------------------------------
if exists ( select * from sysobjects where id = object_id('dbo.A_TaskManager_Task_DeleteAll' ))
	Drop procedure [dbo].[A_TaskManager_Task_DeleteAll]
GO

-----------------------------------------------------------------------
if exists ( select * from sysobjects where id = object_id('dbo.A_TaskManager_Task_DeleteAllDone' ))
	Drop procedure [dbo].[A_TaskManager_Task_DeleteAllDone]
GO

-----------------------------------------------------------------------
if exists ( select * from sysobjects where id = object_id('dbo.A_TaskManager_Task_DeleteById' ))
	Drop procedure [dbo].[A_TaskManager_Task_DeleteById]
GO

-----------------------------------------------------------------------
if exists ( select * from sysobjects where id = object_id('dbo.A_TaskManager_Task_DeleteByName' ))
	Drop procedure [dbo].[A_TaskManager_Task_DeleteByName]
GO


-----------------------------------------------------------------------
if exists ( select * from sysobjects where id = object_id('dbo.A_SmsTaskManager_Task_Save' ))
	Drop procedure [dbo].[A_SmsTaskManager_Task_Save]
GO

Create Procedure [dbo].[A_SmsTaskManager_Task_Save]
	@id 				uniqueidentifier,
	@idproject			uniqueidentifier,
	@name				nvarchar(500),
	@code				nvarchar(30),
	@active				int,
	@done				int,
	@type				int,
	@svcscript			nvarchar(500),
	@stopreason			int,
	@choiceoperator		int,
	@deleteaftersuccess	int,
	@isoutputtask		int,
	@resulted			int,
	@resulttype			int,
	@resultinfo			nvarchar(500),
	@resultdatetime		datetime,
	@creationuserid		uniqueidentifier,
	@creationtype		int,
	@creationdatetime	datetime,
	@startrundatetime	datetime,
	@stoprundatetime	datetime,
	@tagdouble			float,
	@listid				uniqueidentifier,
	@dontsetdone		bit,
	@activeonholidays	bit,
	@pausesynclistwaitingnewabonent int,
	@pausesynclistforcedsec		int,
	@ismultithread		bit,
	@threadcount		int,
	@incomingupdateifexists		bit,
	@iduser				uniqueidentifier = NULL
	
as
begin

	if ( exists ( Select Id from A_SmsTaskManager_Tasks where Id = @id )) begin
	
		-- Обновляет задачу
		Update A_SmsTaskManager_Tasks
		Set 
			IdProject			= @idproject,
			Name 				= @name,
			Code				= @code,
			Active 				= @active, 
			Done 				= @done, 
			Type 				= @type, 
			SvcScript 			= @svcscript, 
			StopReason 			= @stopreason, 
			ChoiceOperator		= @choiceoperator,
			DeleteAfterSuccess 	= @deleteaftersuccess, 
			IsOutputTask		= @isoutputtask,
			Resulted 			= @resulted, 
			ResultType 			= @resulttype, 
			ResultInfo 			= @resultinfo, 
			ResultDateTime 		= @resultdatetime, 
			CreationUserId 		= @creationuserid, 
			CreationType 		= @creationtype, 
			CreationDateTime 	= @creationdatetime,
			StartRunDateTime	= @startrundatetime,
			StopRunDateTime		= @stoprundatetime,
			TagDouble			= @tagdouble,	
			ListId				= @listid,
			DontSetDone			= @dontsetdone,
			ActiveOnHolidays	= @activeonholidays,
			PauseSyncListWaitingNewAbonent	= @pausesynclistwaitingnewabonent,
			PauseSyncListForcedSec		= @pausesynclistforcedsec,
			IsMultiThread		= @ismultithread,
			ThreadCount			= @threadcount,
			IncomingUpdateIfExists		= @incomingupdateifexists
 		Where
			Id = @id
	
	end	else begin
		
		Insert into A_SmsTaskManager_Tasks
		(
			Id, 
			IdProject,
			Name, 
			Code,
			Active, 
			Done, 
			Type, 
			SvcScript, 
			StopReason, 
			ChoiceOperator, 
			DeleteAfterSuccess, 
			IsOutputTask, 
			Resulted, 
			ResultType, 
			ResultInfo, 
			ResultDateTime, 
			CreationUserId, 
			CreationType, 
			CreationDateTime, 
			StartRunDateTime, 
			StopRunDateTime, 
			TagDouble, 
			ListId,
			DontSetDone,
			ActiveOnHolidays,
			PauseSyncListWaitingNewAbonent,
			PauseSyncListForcedSec,
			IsMultiThread,
			ThreadCount,
			IncomingUpdateIfExists
		) 
		Values  
		(
			@id,
			@idproject,
			@name,
			@code,
			@active,
			@done,
			@type,
			@svcscript,
			@stopreason,
			@choiceoperator,
			@deleteaftersuccess,
			@isoutputtask,
			@resulted,
			@resulttype,
			@resultinfo,
			@resultdatetime,
			@creationuserid,
			@creationtype,
			@creationdatetime,
			@startrundatetime,
			@stoprundatetime,
			@tagdouble,
			@listid,
			@dontsetdone,
			@activeonholidays,
			@pausesynclistwaitingnewabonent,
			@pausesynclistforcedsec,
			@ismultithread,
			@threadcount,
			@incomingupdateifexists
		)		
	end
	
	/* В таблицах политики прав доступа изменяем имя и проставляем дефолтные привилегии */
	exec A_Policy_Objects_Save
		@idObject = @id,
		@type = 102,
		@name = @name,
		@idParentProject = @idproject,
		@actionUserId = @iduser
			
	--if ( @type != 0 ) begin --Auto не нужны	
	--	-- Заказ на обновление кэша групп пользователей (операторы супервизоры новые появились)
	--	exec A_Policy_SubjectGroupCache_SetUpdate		
	--end
		
end
GO

-----------------------------------------------------------------------
if exists ( select * from sysobjects where id = object_id('dbo.A_SmsTaskManager_Task_Delete' ))
	Drop procedure [dbo].[A_SmsTaskManager_Task_Delete]
GO

Create procedure [dbo].[A_SmsTaskManager_Task_Delete]
	@id uniqueidentifier,
	@iduser uniqueidentifier = NULL
as
begin

	-- Проверка прав? 
	-- Менеджер задач авто задачи удаляет тоже. Автозадачи вообще не нужны в правовой политике
	
	Declare @type int, @creationtype int
	Select @type = Type, 
		   @creationtype = CreationType 
	From A_SmsTaskManager_Tasks
	Where Id = @id
	
	
	-- Удаляет задачу
	Delete 
	From A_SmsTaskManager_Tasks 
	Where Id = @id
	
	-- Удаляет операторов
	exec A_SmsTaskManager_Task_ClearOperators @id
	
	-- Удаляет супервизоров
	exec A_SmsTaskManager_Task_ClearSupervisors @id
	
	-- Удаляет периоды
	exec A_SmsTaskManager_Task_ClearPeriods @id
		
	-- Удаляет статистику
	exec A_SmsTaskManager_Task_ClearStatistics @id, 0
	
	
	-- Из таблиц политики прав доступа к объектам
	exec A_Policy_Objects_Remove @id
	
	--if ( @type != 0 ) begin --Auto не нужны
	
	--	-- Заказ на очистку таблиц политики доступа
	--	exec A_Policy_SetFilter
		
	--	-- Заказ на обновление кэша групп субъектов (операторы и супервизоры удалены)
	--	exec A_Policy_SubjectGroupCache_SetUpdate
	--end
	
end
GO
				
-----------------------------------------------------------------------
-----------------------------------------------------------------------
-----------------------------------------------------------------------	

-- При добавлении юзеров, групп, ролей, изменении прав - A_Policy_SubjectGroupCache_SetUpdate
-- При удалении юзеров, групп, ролей, задач, проектов - A_Policy_SetFilter

--------------
--- USER -----
-----------------------------------------------------------------------
if exists ( select * from sysobjects where id = object_id('dbo.A_Admin_UserGroup_User_Save' ))
	Drop procedure dbo.[A_Admin_UserGroup_User_Save]
GO

Create procedure [dbo].[A_Admin_UserGroup_User_Save]
	@id		uniqueidentifier,
	@name		nvarchar ( 200 ),
	@info		nvarchar ( 1000 ),
	@parentgroupid	uniqueidentifier,
	@login		nvarchar ( 50 ),
	@password	nvarchar ( 50 ),	
	@type		int,
	@isoperator	bit,
	@roleid		uniqueidentifier = null,
	@callerid	nvarchar ( 20 ) = '',
	@isdeleted	bit = 0,
	@deletedt	datetime = NULL
as
begin

	Declare @deletedtN DateTime
	Select @deletedtN = case when (( @isdeleted is null ) or ( @isdeleted = 0 )) then NULL else @deletedt end

	Update A_Users
	Set 	
		Name 		= @name,
		Info 		= @info,
		ParentGroupId 	= @parentgroupid,
		Login		= @login,
		Password 	= @password,
		Type		= @type,
		IsDeleted	= @isdeleted,
		DeleteDT	= @deletedtN
	Where 
		Id = @id
	
	if ( @@rowcount = 0 ) begin
		
		-- Добавление нового пользователя
		Insert Into A_Users ( Id, Name, Info, ParentGroupId, Login, Password, Type, Enabled, IsDeleted, DeleteDT )
		Values ( @id, @name, @info, @parentgroupid, @login, @password, @type, 1, @isdeleted, @deletedt )
			
		-- Заказ на пересчет кэша политики доступа
		exec A_Policy_SubjectGroupCache_SetUpdate
		
	end


	Update A_UserParams
	Set	IdRole = @roleid,
		CallerId = @callerid,
		IsOperator = @isoperator
	Where IdUser = @id

	if ( @@rowcount = 0 ) begin
		Insert 
		Into A_UserParams ( IdUser, IdRole, IsOperator, CallerId, IsRedirect, IsCC, IsLunch  )
		Values	( @id, @roleid, @isoperator, @callerid, 0, 0, 0 )
	end



	if ( @isoperator = 0 ) begin
		Delete 
		From C_GroupOperators
		Where IDoperator = @id
	end


	exec A_Admin_UserGroup_Group_SiftEmpty


	-- в базе кубов поправляем имя юзера
	If Exists ( Select * FROM Master..sysdatabases where name like 'oktell_cc_temp' )
	If Exists ( Select * FROM oktell_cc_temp..sysobjects where id = Object_Id ( 'oktell_cc_temp.dbo.A_Cube_CC_Cat_OperatorInfo' ) )
		Update oktell_cc_temp.dbo.A_Cube_CC_Cat_OperatorInfo
		Set Name = @name
		Where Id = @id

end
GO

-----------------------------------------------------------------------
if exists ( select * from sysobjects where id = object_id('dbo.A_Admin_UserGroup_User_Delete' ))
	Drop procedure dbo.[A_Admin_UserGroup_User_Delete]
GO

Create procedure [dbo].[A_Admin_UserGroup_User_Delete]
	@id		uniqueidentifier	
as
begin

	Delete 
	From A_UserControls
	Where UserA = @id or UserB = @id

	Delete 
	From A_UserControlLines
	Where UserA = @id

	Delete
	From A_UserOutcomingLines
	Where IdUser = @id
		
	Delete 
	From A_Users
	Where Id = @id	
	
	
	-- Заказ на очистку таблиц политики доступа
	exec A_Policy_SetFilter
	
	-- Очистка всех хвостов и зависимостей
	exec A_DB_RemoveTails
end
GO

--------------
--- GROUP ----
-----------------------------------------------------------------------
if exists ( select * from sysobjects where id = object_id('dbo.A_Admin_UserGroup_Group_Save' ))
	Drop procedure dbo.[A_Admin_UserGroup_Group_Save]
GO

Create procedure [dbo].[A_Admin_UserGroup_Group_Save]
	@id		uniqueidentifier,
	@name		nvarchar ( 200 ),
	@info		nvarchar ( 1000 ),
	@parentgroupid	uniqueidentifier
	
as
begin

	Update A_Groups
	Set 	
		Name 		= @name,
		Info 		= @info,
		ParentId 	= @parentgroupid	
	Where 
		Id = @id
	
	if ( @@rowcount = 0 ) begin
		
		-- Добавление нового отдела
		Insert Into A_Groups ( Id, Name, Info, ParentId )
		Values ( @id, @name, @info, @parentgroupid )
		
		-- Заказ на пересчет кэша политики доступа
		exec A_Policy_SubjectGroupCache_SetUpdate
		
	end
end
GO

-----------------------------------------------------------------------
if exists ( select * from sysobjects where id = object_id('dbo.A_Admin_UserGroup_Group_Delete' ))
	Drop procedure dbo.[A_Admin_UserGroup_Group_Delete]
GO

Create procedure [dbo].[A_Admin_UserGroup_Group_Delete]
	@id uniqueidentifier	
as
begin

	Delete 
	From A_Groups 
	Where Id = @id

	while ( @@rowcount > 0 )
	begin
		Delete 
		From A_Groups 
		Where ParentId != '00000000-0000-0000-0000-0000000000000000'
			And not ParentId in ( Select Id From A_Groups ) 
	end

	Delete 
	From A_Users
	Where ParentGroupId != '00000000-0000-0000-0000-0000000000000000' 
		And not ParentGroupId in ( Select Id From A_Groups )
	
	
	-- Заказ на очистку таблиц политики доступа
	exec A_Policy_SetFilter
	
	-- Очистка всех хвостов и зависимостей
	exec A_DB_RemoveTails
	
end
GO

--------------
--- ROLE -----
-----------------------------------------------------------------------
if exists ( select * from sysobjects where id = object_id('dbo.A_UserRoles_SaveRole' ))
	Drop procedure dbo.[A_UserRoles_SaveRole]
GO

Create Procedure [dbo].[A_UserRoles_SaveRole]
	@id uniqueidentifier,
	@name nvarchar (200),
	@baserole uniqueidentifier,
	@domination bit
As
begin

	Update dbo.A_UserRoles_Roles
	Set 
		Id = @id,
		Name = @name,
		BaseRole = @baserole,
		Domination = @domination
	Where
		Id = @id

	if ( @@rowcount = 0 ) begin
	
		-- Добавление новой
		Insert into dbo.A_UserRoles_Roles ( Id, Name, BaseRole, Domination ) Values ( @id, @name, @baserole, @domination )
		
		-- Заказ на пересчет кэша политики доступа
		exec A_Policy_SubjectGroupCache_SetUpdate
		
	end
		
end
GO

-----------------------------------------------------------------------
if exists ( select * from sysobjects where id = object_id('dbo.A_UserRoles_RemoveRole' ))
	Drop procedure dbo.[A_UserRoles_RemoveRole]
GO

Create Procedure [dbo].[A_UserRoles_RemoveRole]
	@id uniqueidentifier
As
Begin
	
	Delete from dbo.A_UserRoles_Roles
	Where Id = @id
	
	Delete from dbo.A_UserRoles_RightsOfRoles
	Where IdRole = @id
	
	-- Заказ на очистку таблиц политики доступа
	exec A_Policy_SetFilter
	
End
GO

-----------------------------------------------------------------------
-----------------------------------------------------------------------
-----------------------------------------------------------------------
