﻿if exists ( select * from sysobjects where id = object_id ( 'dbo.[A_Personal_GetNumbersDepartmentInfo]'))
	Drop procedure dbo.A_Personal_GetNumbersDepartmentInfo
GO

Create Procedure [dbo].[A_Personal_GetNumbersDepartmentInfo]
As
Begin
	-- Возвращает таблицу соответствий внутренних номеров отделам

	Declare @otherdeps nvarchar(200)
	Select @otherdeps = langvalue 
	From A_LangTexts
	Where langkey like 'otherdeps'
	if ( @otherdeps is NULL )
		Set @otherdeps = N'Прочие подразделения'


	if exists ( select * from tempdb..sysobjects where id=OBJECT_ID ( 'tempdb..#t' ))
		Drop table #t
	if exists ( select * from tempdb..sysobjects where id=OBJECT_ID ( 'tempdb..#temp' ))
		Drop table #temp
	if exists ( select * from tempdb..sysobjects where id=OBJECT_ID ( 'tempdb..#removed' ))
		Drop table #removed
	Create table #t ( nid uniqueidentifier, reactid uniqueidentifier )
	Create table #temp ( id uniqueidentifier, oldrid uniqueidentifier, newrid uniqueidentifier )
	Create table #removed ( nid uniqueidentifier, reactid uniqueidentifier )
	
	Insert Into #t
		Select np.Id, rr.ReactId
		From A_NumberPlan np
			Inner Join A_NumberPlanAction na on na.NumId = np.Id
			Inner Join A_Rules r on na.ExtraId = r.Id
			Inner Join A_RuleRecords rr on rr.RuleId = r.Id
		Where na.NumType = 0 --только стандартные (расчет отделов по входящим в состав элементам)
			--and np.Prefix not like '10100'

	Declare @groups table ( groupid uniqueidentifier, groupname nvarchar ( 255 ) collate database_default)
	Insert into @groups
		Select Id, Name 
		From A_Groups
	Insert Into @groups ( groupid, groupname )
		Values ( '00000000-0000-0000-0000-000000000000', @otherdeps )


	Declare @cnt int, @rowcount int, @msg int
	Select @cnt = 0, @rowcount = 1
	
	While ( @rowcount > 0 ) and ( @cnt < 10 )
	begin
		Set @cnt = @cnt + 1
	
		--Выгребаем ссылки на номера @cnt - уровня
		Insert Into #temp
			Select t.nid, t.reactid, t1.reactid
			From #t t
				 Inner Join #t t1 on ( t.Reactid = t1.nId ) and ( t1.nId != t.nId ) and ( t1.reactid != t.nId )
			Where t.ReactId != t.Nid
				and not exists ( select nid from #removed r where t.nid = r.nid and t1.reactid = r.reactid )
				and not exists ( select nid from #t r where t.nid = r.nid and t1.reactid = r.reactid )
			Group by t.nid, t.reactid, t1.reactid
		
		-- 	
		Insert into #removed ( nid, reactid )
			Select t.nid, t.reactid
			From #t t
				Inner join #temp tmp on t.nid= tmp.id and t.reactid = tmp.oldrid
			Where not exists ( select nid from #removed r where t.nid = r.nid and t.reactid = r.reactid )
			Group by t.nid, t.reactid
				
							
		--Удаляем то что будем менять
		Delete From #t
			From #temp
		Where nid = id and reactid = oldrid


		--вставляем замены
		Insert Into #t ( nid, reactid )
			Select id, newrid From #temp

		--чистим времянку
		Select @rowcount = COUNT ( * ) 
		From #temp
				
		Truncate table #temp
	end
		
	-- удаляем остатки ссылок на номера
	Delete From #t
		From A_NumberPlan np
	Where reactid = np.Id


	-- Обновляем инфу по группам
	Declare @output table ( nid uniqueidentifier, prefix nvarchar ( 50 ) collate database_default, groupid uniqueidentifier, groupname nvarchar ( 255 ) collate database_default)
	Insert Into @output
		Select nid, Prefix, groupid, groupname From 
		(
			Select t.nId, np.Prefix, t.ReactId, g.GroupId, g.GroupName
			From #t t
				Inner Join A_Users u on t.ReactId = u.Id
				Inner Join @groups g on u.ParentGroupId = g.GroupId
				Inner join A_NumberPlan np on np.ID = t.nid
			Union all

			Select t.nId, np.Prefix, t.ReactId, g.GroupId, g.GroupName
			From #t t
				Inner join A_View_ServerIntLinesAll l on t.ReactId = l.Id
				Inner Join @groups g on g.GroupId = '00000000-0000-0000-0000-000000000000'
				Inner join A_NumberPlan np on np.ID = t.nid
		) a
		Group By Prefix, GroupId, nid, groupname


	-- Прочие подразделения для тех, у кого много разных отделов внутри значится
	Declare @og table ( id uniqueidentifier, cnt int )
	Insert into @og
		Select * From
		(
			Select nid, count ( * ) as cnt
			From @output
			Group By nid
		)a
	
	Update @output 
	Set Groupid = '00000000-0000-0000-0000-000000000000', GroupName = @otherdeps
	From @output o, @og og
	Where o.nid = og.id and og.cnt > 1


	-- Отдельно быстрые номера
	Insert into @output
		Select np.Id, np.Prefix, g.GroupId, g.GroupName
		From A_NumberPlan np
			Inner Join A_NumberPlanAction na on na.NumId = np.Id
			Inner Join @groups g on na.ExtraId = g.GroupId
		Where na.NumType = 2


	-- Итог достаем
	Select nid, prefix, groupid, groupname 
	From @output
	Group By nid, prefix, groupid, groupname

End
GO


if exists ( select * from sysobjects where id = object_id ( 'dbo.A_Personal_NumbersInfo_GetSeparate'))
	Drop procedure dbo.[A_Personal_NumbersInfo_GetSeparate]
GO

Create Procedure [dbo].[A_Personal_NumbersInfo_GetSeparate]
As
Begin


	-- Информация по отделам и составляющим частям номеров
	
	Declare @otherdeps nvarchar(200)
	Select @otherdeps = langvalue 
	From A_LangTexts
	Where langkey like 'otherdeps'
	if ( @otherdeps is NULL )
		Set @otherdeps = N'Прочие подразделения'


	if exists ( select * from tempdb..sysobjects where id=OBJECT_ID ( 'tempdb..#t' ))
		Drop table #t
	if exists ( select * from tempdb..sysobjects where id=OBJECT_ID ( 'tempdb..#temp' ))
		Drop table #temp
	if exists ( select * from tempdb..sysobjects where id=OBJECT_ID ( 'tempdb..#removed' ))
		Drop table #removed
	Create table #t ( nid uniqueidentifier, reactid uniqueidentifier )
	Create table #temp ( id uniqueidentifier, oldrid uniqueidentifier, newrid uniqueidentifier )
	Create table #removed ( nid uniqueidentifier, reactid uniqueidentifier )
	
	Insert Into #t
		Select np.Id, rr.ReactId
		From A_NumberPlan np
			Inner Join A_NumberPlanAction na on na.NumId = np.Id
			Inner Join A_Rules r on na.ExtraId = r.Id
			Inner Join A_RuleRecords rr on rr.RuleId = r.Id
		Where na.NumType = 0 --только стандартные (расчет отделов по входящим в состав элементам)
			--and np.Prefix not like '10100'

	Declare @groups table ( groupid uniqueidentifier, groupname nvarchar ( 255 ) collate database_default)
	Insert into @groups
		Select Id, Name 
		From A_Groups
	Insert Into @groups ( groupid, groupname )
		Values ( '00000000-0000-0000-0000-000000000000', @otherdeps )


	Declare @cnt int, @rowcount int, @msg int
	Select @cnt = 0, @rowcount = 1
	
	While ( @rowcount > 0 ) and ( @cnt < 10 )
	begin
		Set @cnt = @cnt + 1
	
		--Выгребаем ссылки на номера @cnt - уровня
		Insert Into #temp
			Select t.nid, t.reactid, t1.reactid
			From #t t
				 Inner Join #t t1 on ( t.Reactid = t1.nId ) and ( t1.nId != t.nId ) and ( t1.reactid != t.nId )
			Where t.ReactId != t.Nid
				and not exists ( select nid from #removed r where t.nid = r.nid and t1.reactid = r.reactid )
				and not exists ( select nid from #t r where t.nid = r.nid and t1.reactid = r.reactid )
			Group by t.nid, t.reactid, t1.reactid
		
		-- 	
		Insert into #removed ( nid, reactid )
			Select t.nid, t.reactid
			From #t t
				Inner join #temp tmp on t.nid= tmp.id and t.reactid = tmp.oldrid
			Where not exists ( select nid from #removed r where t.nid = r.nid and t.reactid = r.reactid )
			Group by t.nid, t.reactid
				
							
		--Удаляем то что будем менять
		Delete From #t
			From #temp
		Where nid = id and reactid = oldrid


		--вставляем замены
		Insert Into #t ( nid, reactid )
			Select id, newrid From #temp

		--чистим времянку
		Select @rowcount = COUNT ( * ) 
		From #temp
				
		Truncate table #temp
	end
		
	-- удаляем остатки ссылок на номера
	Delete From #t
		From A_NumberPlan np
	Where reactid = np.Id
	
	Declare @eid uniqueidentifier
	Set @eid = '00000000-0000-0000-0000-000000000000'
	
	-- Инфу возвращаем
	Select nId, Prefix, ReactId, GroupId, GroupName, ReactType
	From
	(
		Select t.nId, np.Prefix, t.ReactId, g.GroupId, g.GroupName, 0 as ReactType
		From #t t
			Inner Join A_Users u on t.ReactId = u.Id
			Inner Join @groups g on u.ParentGroupId = g.GroupId
			Inner join A_NumberPlan np on np.ID = t.nid
	
		Union all

		Select t.nId, np.Prefix, t.ReactId, g.GroupId, g.GroupName, 1 as ReactType
		From #t t
			Inner Join A_View_ServerIntLinesAll l on t.ReactId = l.Id
			Inner Join @groups g on l.ParentGroupId = g.GroupId
			Inner join A_NumberPlan np on np.ID = t.nid

		Union all

		-- Отдельно все кроме стандартных
		Select np.Id, np.Prefix, @eid, g.GroupId, g.GroupName, 2
		From A_NumberPlan np
			Inner Join A_NumberPlanAction na on na.NumId = np.Id
			Inner Join @groups g on na.ExtraId = g.GroupId
		Where na.NumType != 0
	)a
	Order By Prefix

End
GO