﻿IF  EXISTS (SELECT * FROM sysobjects WHERE id = object_id ('[dbo].[WO_Dashboards_Dashboard_Create]'))
DROP PROCEDURE [dbo].[WO_Dashboards_Dashboard_Create]
GO

CREATE procedure [dbo].[WO_Dashboards_Dashboard_Create]
	@authorizeduserid	uniqueidentifier,
	@dashboardname	nvarchar(100),
	@projectid	nvarchar(50)
as
begin
	
	declare	@en bit
	exec dbo.A_UserRoles_CheckPrivilege @privilegecode = 'DashboardCreate', @authorizeduserid = @authorizeduserid, @isenabled = @en OUTPUT
	if ((select @en) = 1)
		begin
			
			declare	@dashboardid uniqueidentifier
			set	@dashboardid = newid()
			
			if ( @projectid like '' )
				Set @projectid = NULL
			
			/* Добавление нового дашборда
			*/
			insert into [dbo].[WO_Dashboards_Dashboards] ( Id, IdProject, Name, Creator, CreationDate, IsPublic, [Password] )
				select	@dashboardid,
						@projectid,
						@dashboardname,
						@authorizeduserid,
						getutcdate(),
						0,
						null
			
			select	@dashboardid dashboardid
			
			/* Default privileges (Non IVR Lists) 
			*/
			exec A_Policy_Objects_Save
				@idObject = @dashboardid,
				@type = 105,
				@name = @dashboardname,
				@idParentProject = @projectid,
				@actionUserId = @authorizeduserid
			
		end
	else
		begin
			RAISERROR ('Access error', 16, 1)
		end
end
GO