﻿if exists ( select * from sysobjects where id= object_id ( 'dbo.A_Stat_Connections_1x1_VoiceMap' ))
	Drop table dbo.A_Stat_Connections_1x1_VoiceMap
GO

Create table dbo.A_Stat_Connections_1x1_VoiceMap
( 
	IdConn uniqueidentifier primary key,
	AVoiceMap image,
	BVoiceMap image,
	ALen int,
	BLen int
)
GO


if exists ( select * from sysobjects where id = object_id ( 'dbo.A_Stat_Set1x1VoiceMap' ))
	Drop procedure dbo.A_Stat_Set1x1VoiceMap
GO	

Create procedure dbo.A_Stat_Set1x1VoiceMap
	@dtstart datetime,
	@alinenum nvarchar(10),
	@blinenum nvarchar(10),
	@amap image,
	@bmap image,
	@alen int,
	@blen int
as
begin

	Declare @idconn uniqueidentifier, @anum nvarchar(10), @bnum nvarchar(10)

	Select @idconn = Id, 
		@anum = ALineNum, 
		@bnum = BLineNum
	From dbo.A_Stat_Connections_1x1 sc
	Where TimeStart = @dtstart
		And (( ALineNum = @alinenum And BLineNum = @blinenum ) or 
		     ( ALineNum = @blinenum And BLineNum = @alinenum ))

	if ( @@rowcount = 0 )
	    return
	    
	if ( @anum = @blinenum ) begin
	
		Insert into dbo.A_Stat_Connections_1x1_VoiceMap ( IdConn, AVoiceMap, BVoiceMap, ALen, BLen )
		Values ( @idconn, @bmap, @amap, @blen, @alen )
		
	end	else begin
	    
		Insert into dbo.A_Stat_Connections_1x1_VoiceMap ( IdConn, AVoiceMap, BVoiceMap, ALen, BLen )
		Values ( @idconn, @amap, @bmap, @alen, @blen )
	
	end
	
end
GO


if exists ( select * from sysobjects where id = object_id ( 'dbo.A_Stat_Get1x1VoiceMap' ))
	Drop procedure dbo.A_Stat_Get1x1VoiceMap
GO

Create procedure dbo.A_Stat_Get1x1VoiceMap
	@idconn uniqueidentifier
as
begin
		
	Select DataLength(AVoiceMap) as AStreamLen, AVoiceMap, 
			DataLength(BVoiceMap) as BStreamLen, BVoiceMap, 
			ALen, BLen,
			ALineNum, BLineNum
	From dbo.A_Stat_Connections_1x1_VoiceMap vm
		Inner join dbo.A_Stat_Connections_1x1 sc on sc.Id = vm.IdConn
	Where idconn = @idconn
	
end
GO


if exists ( select * from sysobjects where id = object_id ( 'dbo.A_DB_RemoveTails' ))
	Drop procedure dbo.A_DB_RemoveTails
GO

Create Procedure [dbo].[A_DB_RemoveTails] 
as
begin

-- Отрубание глюков после изменений в БД. Лишние ссылки, пустые элементы и т.д.

		-----------------------------------------------------
		-- преобразования на стыке версий -------------------
		-----------------------------------------------------

		Update dbo.A_ServerExtLines
		Set SystemNumStr = Cast ( SystemNum as nvarchar(10 ))
		Where SystemNumStr is NULL

		Update dbo.A_ServerGSMLines
		Set SystemNumStr = Cast ( SystemNum as nvarchar(10 ))
		Where SystemNumStr is NULL

		Update dbo.A_ServerIntLines
		Set SystemNumStr = Cast ( SystemNum as nvarchar(10 ))
		Where SystemNumStr is NULL

		Update dbo.A_ServerSipLines
		Set SystemNumStr = Cast ( SystemNum as nvarchar(10 ))
		Where SystemNumStr is NULL

		Update dbo.A_ServerUSBLines
		Set SystemNumStr = Cast ( SystemNum as nvarchar(10 ))
		Where SystemNumStr is NULL

		Update dbo.A_ServerVirtualLines
		Set SystemNumStr = Cast ( SystemNum as nvarchar(10 ))
		Where SystemNumStr is NULL

		-----------------------------------------------------
		-- общие возможные глюки ----------------------------
		-----------------------------------------------------
		Delete From A_WorkPlaces where (type in (2,3,4,6)) and not (parentId in (Select [ID] From A_WorkPlaces))
		Delete From A_WorkPlaces where (type in (2,3,4,6)) and not ( LineId in ( Select [ID] From A_View_ServerIntLinesAll ))
		Delete From A_ServerExtLines where not [ServerID] in (Select [id] From A_WORKPLACES)
		Delete From A_ServerIntLines where not [ServerID] in (Select [id] From A_WORKPLACES)
		Delete From A_ServerGSMLines where not [ServerID] in (Select [id] From A_WORKPLACES)
		Delete From A_ServerUSBLines where not [ServerID] in (Select [id] From A_WORKPLACES)
		Delete From A_ServerSipLines where not [ServerID] in (Select [id] From A_WORKPLACES)
		Delete From A_ServerUSBLines where not [id] in (Select LineID From A_WORKPLACES)
		Delete From A_ServerVirtualLines where not [ServerID] in (Select [id] From A_WORKPLACES)
		
		Delete From A_LinesReactors where not [WPID] in ( Select [id] From A_WORKPLACES )
		Delete From A_LinesReactors where not LineID in ( Select [ID] From A_View_ServerLinesAll )
		Delete From A_ServerNumbers where not [id] in ( Select [ID] From A_WorkPlaces Where type=5 )
		Delete From A_ServerNumbers where [id] in ( Select [ID] From A_WorkPlaces where hasdatabase>0 )

		Delete From A_CallRoutes_Lines where not [idroute] in ( Select [ID] From A_CallRoutes )

		Declare @t table(id_ uniqueidentifier)
		insert into @t
			Select [id] From A_WorkPlaces Union 
			Select [id] From A_Users union
			Select [id] From A_View_ServerLinesAll			

		
		Delete From A_RuleRecords where not RuleID in (Select ID From A_Rules)

		--записи правил, где пользователь или линия несуществующие
		Delete From A_RuleRecords where (InnerAddressType in (0,1)) and ( not ReactID in (Select id_ From @t ))
		--записи правил, где поток несуществующий
		Delete From A_RuleRecords where (InnerAddressType in (3)) and ( not ReactID in (Select [Id] From A_ServerStreams ))

		Delete From A_NumberPlanAction where numtype=0 and extraid not in (Select ID From A_Rules)
		Delete From A_NumberPlan where id not in (Select numid From A_NumberPlanAction)
		Delete From A_RuleRecords where InnerAddressType=2 and not ReactID in (Select ID From A_NumberPlan)
		Delete From A_Rules	Where not id in ( Select ruleid From A_RuleRecords )		

		Delete From A_TaskManager_TaskExtLines where not ExtLineId in ( Select id From A_ServerExtLines )
		Delete From A_TaskManager_Operators where not OperatorId in ( Select id From A_Users u inner join A_UserParams up on u.Id = up.IdUser Where up.IsOperator = 1 )
		Delete From A_TaskManager_TaskProperties where not IdTask in ( Select id From A_TaskManager_Tasks )
		Delete From A_TaskManager_Lists Where (ProjectId = '00000000-0000-0000-0000-000000000000') and not exists ( Select Id From A_TaskManager_Tasks t where t.ListId = A_TaskManager_Lists.Id )
		Delete From A_TaskManager_Tasks Where (IdProject = '00000000-0000-0000-0000-000000000000') and not exists ( Select Id From A_TaskManager_Lists t where t.Id = A_TaskManager_Tasks.ListId )

		-----------------------------------------------------
		-- сетевые адреса рабочих мест = адресу сервера - заменяем брехней 
		-----------------------------------------------------
		Declare @svraddr nvarchar ( 100 )
		Select @svraddr = Address 
		From A_WorkPlaces
		Where HasFastEngine = 1
		Update A_WorkPlaces Set Address = 'Ошибка в адресе' 
		Where Address like @svraddr and HasFastEngine = 0

		-----------------------------------------------------
		-- Null в 0 в ID юзеров по умолчанию ----------------
		-----------------------------------------------------
		Update A_ServerIntLines
		Set DefaultUserId = '00000000-0000-0000-0000-000000000000'
		Where DefaultUserId is null

		Update A_ServerSipLines 
		Set DefaultUserId = '00000000-0000-0000-0000-000000000000'
		Where DefaultUserId is null

		Update A_ServerVirtualLines 
		Set DefaultUserId = '00000000-0000-0000-0000-000000000000'
		Where DefaultUserId is null

		-----------------------------------------------------
		-- в 0 несуществующих юзеров по умолчанию -----------
		-----------------------------------------------------
		Update A_ServerIntLines 
		Set DefaultUserId = '00000000-0000-0000-0000-000000000000'
		Where not DefaultUserId in (Select id From A_Users)

		Update A_ServerSipLines 
		Set DefaultUserId = '00000000-0000-0000-0000-000000000000'
		Where not DefaultUserId in (Select id From A_Users)

		Update A_ServerVirtualLines 
		Set DefaultUserId = '00000000-0000-0000-0000-000000000000'
		Where not DefaultUserId in (Select id From A_Users)

		-----------------------------------------------------
		-- двоение юзеров по умолчанию в ссылках по линиям --
		-----------------------------------------------------
		Declare @useddefusers table (id uniqueidentifier)
		Declare @idtozero table (id uniqueidentifier)
		Declare @lid uniqueidentifier
		Declare @uid uniqueidentifier
		Declare @tmp bit 		

		Declare defusercur Cursor For
			Select Id, DefaultUserId 
			From A_View_ServerIntLinesDefaultUsers
			Where DefaultUserId != '00000000-0000-0000-0000-000000000000'

		Open defusercur
		Fetch Next From defusercur Into @lid, @uid
		While @@FETCH_STATUS = 0
		Begin		
			Select @tmp = 1 From @useddefusers where id = @uid
			if ( @tmp > 0 )
				Insert Into @idtozero (id) values (@lid)
			else
				Insert Into @useddefusers (id) values (@uid)
			Fetch Next From defusercur  Into @lid, @uid
		End
		Close defusercur
		Deallocate defusercur
		
		Update A_ServerIntLines 
		Set DefaultUserId = '00000000-0000-0000-0000-000000000000'
		From A_ServerIntLines si, @idtozero iz
		Where si.Id = iz.Id

		Update A_ServerSipLines 
		Set DefaultUserId = '00000000-0000-0000-0000-000000000000'
		From A_ServerSipLines si, @idtozero iz
		Where si.Id = iz.Id

		Update A_ServerVirtualLines 
		Set DefaultUserId = '00000000-0000-0000-0000-000000000000'
		From A_ServerVirtualLines si, @idtozero iz
		Where si.Id = iz.Id
		
		-----------------------------------------------------
		-- удаляем несуществующие значения ------------------
		-----------------------------------------------------
		Begin Tran UIT

		Delete From A_TaskManager_UserInTask with ( TabLock, HoldLock )
		Where not exists ( Select Id From A_Users Where A_Users.Id = UserId )

		Delete From A_TaskManager_UserInTask --with ( TabLock )
		Where not exists ( Select Id From A_TaskManager_Tasks Where A_TaskManager_Tasks.Id = TaskId )
		
		Commit tran UIT


		Delete From A_TaskManager_Operators
		Where not exists ( Select Id From A_TaskManager_Tasks where A_TaskManager_Tasks.Id = TaskId )

		Delete From A_TaskManager_TaskExtLines
		Where not exists ( Select Id From A_TaskManager_Tasks where A_TaskManager_Tasks.Id = TaskId )

		Delete From A_TaskManager_Operators
		Where IsGroup = 0 and not Exists ( Select * From A_Users where A_Users.Id = OperatorId )
		

		Delete 
		From A_UserControls
		Where not exists (Select id From A_Users u Where u.id = A_UserControls.UserA)
			or not exists (Select id From A_Users u Where u.id = A_UserControls.UserB)
			
		Delete 		
		From A_UserControlLines
		Where not exists (Select id From A_Users u Where u.id = A_UserControlLines.UserA)			
			or (not exists (Select id From A_Users l Where l.id = A_UserControlLines.IdLine)
				and not exists (Select id From A_ServerIntLines l Where l.id = A_UserControlLines.IdLine)
				and not exists (Select id From A_ServerSipLines l Where l.id = A_UserControlLines.IdLine)
				and not exists (Select id From A_ServerExtLines l Where l.id = A_UserControlLines.IdLine)
				and not exists (Select id From A_CallRoutes l Where l.id = A_UserControlLines.IdLine)				
				and (A_UserControlLines.IdLine != '11111111-1111-1111-1111-111111111111')
				and (A_UserControlLines.IdLine != '6F5F7372-D82E-4FB6-97CB-85487A85067C')
				and (A_UserControlLines.IdLine != '14B559C8-BDF8-4D17-9968-FEB8F9F54F47'))				
				
		Delete
		From A_UserOutcomingLines
		Where not exists (Select id From A_Users u Where u.id = A_UserOutcomingLines.IdUser)
			and not exists (Select id From A_ServerExtLines l Where l.id = A_UserOutcomingLines.IdLine)
				
		-----------------------------------------------------
		-- Роли на удаленных юзеров -------------------------
		-----------------------------------------------------
		
		Delete From A_UserRoles_Roles
		Where (Domination = 1)
			and ( not Id in (Select id From A_Users))
			
		Delete
		From A_UserRoles_RolesOfUsers
		Where not IdUser in (Select Id From A_Users)
	
		Delete
		From A_UserRoles_RolesOfUsers
		Where not IdRole in (Select Id From A_UserRoles_Roles)
		
		Delete
		From A_UserRoles_RightsOfRoles
		Where not IdRole in (Select Id From A_UserRoles_Roles)

		-----------------------------------------------------
		-- Редиректы на удаленных юзеров --------------------
		-----------------------------------------------------
		Delete 
		From A_Redirect
		Where IdUser not in ( Select Id From A_Users )

		-----------------------------------------------------
		-- Пустые группы, номера, несвязанные правила -------
		-----------------------------------------------------
		exec A_Admin_UserGroup_Group_SiftEmpty		

		exec A_Admin_Number_SiftByActions
		
		exec A_Admin_Rule_SiftByNumbers
		
		-----------------------------------------------------
		-- неиспользуемые плагин-модули ---------------------
		-----------------------------------------------------
		Delete From A_PluginMenu_User
		Where not exists ( Select Id From A_Users u Where u.Id = A_PluginMenu_User.IdUser )

		-----------------------------------------------------
		-- канонические адреса ------------------------------
		-----------------------------------------------------	
		Delete from A_WorkPlace_Address
		
		-----------------------------------------------------	
		-- Очистка пустых ссылок в таблицах политики прав доступа к объектам
		-----------------------------------------------------	
		exec dbo.A_Policy_CheckFilter
end
GO


if exists ( select * from sysobjects where id = object_id ( 'dbo.A_DB_OptimizeRemove' ))
	Drop procedure dbo.[A_DB_OptimizeRemove]
GO

Create procedure [dbo].[A_DB_OptimizeRemove]
	@days int = 2
as
begin
	
	-- считаем время границы актуальности
	declare @dt DateTime
	Set @dt = DateAdd ( d, -@days, GetDate () )
	select @dt = Cast ( FLOOR ( Cast ( @dt as float ) ) as DateTime )

	-- переменные
	Declare @logname nvarchar(500)
	Declare @sz int, @msz int
	Declare @curdb nvarchar ( 500 )
	Set @curdb = DB_name()

	-- увеличиваем максимальный размер лога для базы
	Select @logname = name from dbo.sysfiles WHERE (status & 0x40) <> 0 
	Select @sz = size, @msz = maxsize from dbo.sysfiles WHERE (status & 0x40) <> 0
	-- увеличиваем maxsize если он меньше 1500
	if ( @msz != -1 and @msz < 1500 * 128 )
		exec ( N'alter database ' + @curdb + ' modify file(name='+@logname+', maxsize=1500)')
	exec ( N'alter database ' + @curdb + ' set recovery simple' )

	-- 
	If Exists ( Select * FROM Master..sysdatabases where name like 'oktell_cc_temp' )
	begin
		-- увеличиваем максимальный размер лога для кубовой базы
		Select @logname = name from oktell_cc_temp.dbo.sysfiles WHERE (status & 0x40) <> 0
		Select @sz = size, @msz = maxsize from oktell_cc_temp.dbo.sysfiles WHERE (status & 0x40) <> 0
		if ( @msz != -1 and @msz < 1500 * 128 )
			exec ( N'alter database oktell_cc_temp modify file(name='+@logname+', maxsize=1500)')
		exec ( N'alter database oktell_cc_temp set recovery simple' )

		-- проводим переиндексацию таблиц кубовой базы
		DBCC DBREINDEX ( 'oktell_cc_temp.dbo.A_Cube_CC_EffortConnections' )
		DBCC DBREINDEX ( 'oktell_cc_temp.dbo.A_Cube_CC_OperatorStates' )
		DBCC DBREINDEX ( 'oktell_cc_temp.dbo.A_Cube_CC_CallQueue' )

		-- сжимаем кубовую базу
		DBCC SHRINKDATABASE (oktell_cc_temp)
	
		-- увеличиваем размер лога кубовой базы с выделением места на диске
		Select @logname = name from oktell_cc_temp.dbo.sysfiles WHERE (status & 0x40) <> 0
		Select @sz = size, @msz = maxsize from oktell_cc_temp.dbo.sysfiles WHERE (status & 0x40) <> 0
		if ( @sz < 500 * 128 )
			exec ( N'alter database oktell_cc_temp modify file(name='+@logname+', size=500)')
		exec ( N'alter database oktell_cc_temp set recovery simple' )
	end
			
	-- удаляем засоры из базы
	Delete From dbo.A_CallBackOrders Where CalledDateTime < @dt
	Delete From dbo.A_CallBackRecievers Where not exists ( Select IDconn From dbo.A_CallBackOrders cbo Where cbo.IDconn = dbo.A_CallBackRecievers.IDconn )
	Delete From dbo.A_CallCenter_ControlEventsJournal Where EventDateTime < @dt
	Delete From dbo.A_CallCenter_LastConnected Where CallTime < @dt
	Delete From dbo.A_CallCenter_UserStateHistory Where TimeEnter < @dt		
		
	Delete From dbo.A_Chat_Messages Where DateUTC < @dt
	Delete From dbo.A_Chat_MessageFile Where not exists ( Select IdMessage From dbo.A_Chat_Messages m Where m.IdMessage = dbo.A_Chat_MessageFile.IdMessage )
	Delete From dbo.A_Chat_Dialog Where not exists ( Select Top 1 IdMessage From dbo.A_Chat_Messages m Where m.IdDialog = dbo.A_Chat_Dialog.IdDialog )
	Delete From dbo.A_Chat_Members Where not exists ( Select IdDialog From dbo.A_Chat_Dialog d Where d.IdDialog = dbo.A_Chat_Members.IdDialog )
	Delete From dbo.A_Chat_NewMessages Where not exists ( Select IdMessage From dbo.A_Chat_Messages m Where m.IdMessage = dbo.A_Chat_NewMessages.IdMessage )
	
	Delete From dbo.A_ClientHistory Where CreationDateTime < @dt
	
	Delete From dbo.A_ICQMessages Where date_receive < @dt
	Delete From dbo.A_IM_Messages Where Date_Received < @dt
	
	Delete From dbo.A_Stat_Connections_1x1 Where TimeStart < @dt
	Delete From dbo.A_Stat_Connections_Errors Where TimeStart < @dt
	Delete From dbo.A_Stat_Connections_VoicePerc Where not exists ( Select Id from dbo.A_Stat_Connections_1x1 s Where s.Id = dbo.A_Stat_Connections_VoicePerc.IdConn )	
	Delete From dbo.A_Stat_Conference Where TimeStart < @dt
	Delete From dbo.A_Stat_Conference_Competitors Where not exists ( Select IdConf From A_Stat_Conference c Where c.Id = dbo.A_Stat_Conference_Competitors.IdConf )
	Delete From dbo.A_Stat_Conference_RecordAccessUsers Where not exists ( Select IdConf From A_Stat_Conference c Where c.Id = dbo.A_Stat_Conference_RecordAccessUsers.IdConf )
	Delete From dbo.A_Stat_MissedCalls Where TimeStart < @dt
	Delete From dbo.A_Stat_FailedCalls Where TimeStart < @dt
	Delete From dbo.A_Stat_Comments Where not exists ( Select Id from dbo.A_Stat_Connections_1x1 s Where s.Id = dbo.A_Stat_Comments.Id ) and not exists ( Select Id from dbo.A_Stat_Conference_Competitors c Where c.IdConn = dbo.A_Stat_Comments.Id )
	Delete From dbo.A_Stat_RingTime Where StartDT < @dt	
	Delete From dbo.A_Stat_DTMF Where DT < @dt
	Delete From dbo.A_Stat_Connections_1x1_VoiceMap Where not exists ( Select Id from dbo.A_Stat_Connections_1x1 s Where (s.Id = dbo.A_Stat_Connections_1x1_VoiceMap.IdConn) and (s.IsRecorded = 1))
	
	Delete From dbo.A_Stat_Talk_Algorythms Where not exists ( Select IdChain From dbo.A_Stat_Connections_1x1 c Where c.IdChain = dbo.A_Stat_Talk_Algorythms.IdConnection )
	Delete From dbo.A_Stat_Talk_Card_Check Where not exists ( Select IdAlgVisit From dbo.A_Stat_Talk_Algorythms a Where a.IdAlgVisit = dbo.A_Stat_Talk_Card_Check.IdAlgVisit )
	Delete From dbo.A_Stat_Talk_Card_Radio Where not exists ( Select IdAlgVisit From dbo.A_Stat_Talk_Algorythms a Where a.IdAlgVisit = dbo.A_Stat_Talk_Card_Radio.IdAlgVisit )
	Delete From dbo.A_Stat_Talk_Card_Text Where not exists ( Select IdAlgVisit From dbo.A_Stat_Talk_Algorythms a Where a.IdAlgVisit = dbo.A_Stat_Talk_Card_Text.IdAlgVisit )	
	Delete From dbo.A_Stat_Talk_StopInfo Where TimeStop < @dt
	Delete From dbo.A_TalkForm_Stat_Values Where TimeSave < @dt
	
	Delete From A_StreamRegistration Where OperationDT < @dt
	
	Delete From dbo.A_TaskManager_SubTaskEfforts Where EDateTime < @dt
	Delete From dbo.A_TaskManager_Task_IncomingCalls Where CallTimeStart < @dt
	Delete From dbo.A_TaskManager_UserInTask Where TimeStart < @dt
	
	if exists ( Select * From sysobjects where id = object_id ( 'dbo.A_UserMessageData' )) begin
		Delete From dbo.A_UserMessageData Where SentDate < @dt
		Delete From dbo.A_UserMessageFile Where not exists ( Select Id From dbo.A_UserMessageData d Where d.Id = dbo.A_UserMessageFile.IdMessageData )
		Delete From dbo.A_UserMessageLink Where not exists ( Select Id From dbo.A_UserMessageData d Where d.Id = dbo.A_UserMessageLink.IdMessageData )
	end
	
	Delete From dbo.A_User_NotifyLog Where NotifyDateTime < @dt
	Delete From dbo.A_UserStateHistory Where TimeChange < @dt
	Delete From dbo.A_VoiceMail Where SentTime < @dt
	Delete From dbo.A_VoiceMailReceivers Where not exists ( Select Id From dbo.A_VoiceMail v Where v.Id = dbo.A_VoiceMailReceivers.msgid )
	
	
	
	-- Перестраиваем индексы всех таблиц
	DECLARE tcursor CURSOR FOR 
	Select name FROM sysobjects where xtype = 'U'

	Declare @sql nvarchar(1000)	
	Declare @tab_name varchar(500)

	OPEN tcursor
	FETCH NEXT FROM tcursor INTO @tab_name

	WHILE @@FETCH_STATUS = 0 Begin
		Set @sql='

	Declare @fullname nvarchar(500)

	Select @fullname = ''['' + su.name + ''].['' + s.name + '']''
	From sysobjects s 
		Inner join sysusers su on s.uid = su.uid
	Where s.name like ''' + @tab_name + ''' and OBJECTPROPERTY(id, N''IsTable'') = 1

	DBCC DBREINDEX ( @fullname )'

		Exec sp_executesql @stmt =@sql

		FETCH NEXT FROM tcursor INTO @tab_name
	End

	CLOSE tcursor
	DEALLOCATE tcursor

	/*
	DBCC DBREINDEX ( 'dbo.A_CallCenter_UserStateHistory' )
	DBCC DBREINDEX ( 'dbo.A_CallCenter_ControlEventsJournal' )
	DBCC DBREINDEX ( 'dbo.A_ClientHistory' )
	DBCC DBREINDEX ( 'dbo.A_ICQMessages' )
	DBCC DBREINDEX ( 'dbo.A_SmsTaskManager_SubTasks' )
	DBCC DBREINDEX ( 'dbo.A_SmsTaskManager_SubTaskNumbers' )
	DBCC DBREINDEX ( 'dbo.A_Stat_Conference' )
	DBCC DBREINDEX ( 'dbo.A_Stat_Conference_Competitors' )
	DBCC DBREINDEX ( 'dbo.A_Stat_Conference_RecordAccessUsers' )
	DBCC DBREINDEX ( 'dbo.A_Stat_Connections_1x1' )
	DBCC DBREINDEX ( 'dbo.A_Stat_Connections_Errors' )
	DBCC DBREINDEX ( 'dbo.A_Stat_DTMF' )
	DBCC DBREINDEX ( 'dbo.A_Stat_Talk_Algorythms' )
	DBCC DBREINDEX ( 'dbo.A_Stat_Talk_StopInfo' )
	DBCC DBREINDEX ( 'dbo.A_TaskManager_Task_IncomingCalls' )
	DBCC DBREINDEX ( 'dbo.A_TaskManager_SubTasks' )
	DBCC DBREINDEX ( 'dbo.A_TaskManager_SubTaskNumber' )
	DBCC DBREINDEX ( 'dbo.A_TaskManager_SubTaskEfforts' )
	DBCC DBREINDEX ( 'dbo.A_TaskManager_UserInTask' )
	DBCC DBREINDEX ( 'dbo.A_User_NotifyLog' )
	DBCC DBREINDEX ( 'dbo.A_UserMessages' )
	DBCC DBREINDEX ( 'dbo.A_UserStateHistory' )
	DBCC DBREINDEX ( 'dbo.A_VoiceMail' )
	*/

	-- сжимаем базу
	Set @sql = 'DBCC SHRINKDATABASE ( ' + db_name() + ' )'
	exec sp_executesql @stmt = @sql

	-- увеличиваем размер лога с выделением места на диске
	Select @logname = name from dbo.sysfiles WHERE (status & 0x40) <> 0 
	Select @sz = size, @msz = maxsize from dbo.sysfiles WHERE (status & 0x40) <> 0
	if ( @sz < 500 * 128 )
		exec ( N'alter database ' + @curdb + ' modify file(name='+@logname+', size=500)')
	exec ( N'alter database ' + @curdb + ' set recovery simple' )
end
GO


if exists ( select * from sysobjects where id = object_id ( 'dbo.A_Stat_Office_Records_Remove' ))
	Drop procedure dbo.[A_Stat_Office_Records_Remove]
GO

Create PROCEDURE [dbo].[A_Stat_Office_Records_Remove]
	@id uniqueidentifier
as
begin
	declare @t DateTime
	declare @r bit
	declare @a nvarchar ( 100 )
	declare @b nvarchar ( 100 )
	declare @dir int
	declare @path nvarchar ( 200 )
	declare @isconf bit
	declare @room int
	
	Select @t = TimeStart, @r = IsRecorded, @a = ALineNum, @b = BLineNum, @dir = IdRecDir
	From A_Stat_Connections_1x1 --with ( TabLock )
	Where Id = @id

	if ( @@rowcount > 0 ) begin
	
		Set @isconf = 0

		Update A_Stat_Connections_1x1 --with ( TabLock )
		Set IsRecorded = 0
		Where Id = @id

		Select @path = Path From A_Stat_RecordDirectories Where Id = @dir
		Select @t, @r, @a, @b, @dir, @path, @isconf
		
		Delete 
		From A_Stat_Connections_1x1_VoiceMap 
		Where IdConn = @id
	
	end	else begin
	
		Set @isconf = 1
		Declare @idconf uniqueidentifier

		Select @t = sc.TimeStart, @r = sc.IsRecorded, @dir = sc.IdRecDir, 
			@room = sc.Room, @idconf = sc.Id
		FROM A_Stat_Conference sc
			Inner join A_Stat_Conference_Competitors scc on sc.Id = scc.IdConf
		Where scc.idconn = @id or sc.Id = @id
	
		Update A_Stat_Conference --with ( TabLock )
		Set IsRecorded = 0
		Where Id = @idconf

		Select @path = Path From A_Stat_RecordDirectories Where Id = @dir
		Select @t, @r, '', '', @dir, @path, @isconf, @room
		
	end
	
end
GO

if exists ( select * from sysobjects where id = object_id ( 'dbo.A_Service_StatRemove' ))
	Drop procedure dbo.[A_Service_StatRemove]
GO

Create procedure [dbo].[A_Service_StatRemove]
	 @pbxdrop bit,
	 @pbxdropfiles bit,
	 @pbxfromdate DateTime,
	 @ccdrop bit,
	 @ccdropfiles bit,
	 @ccfromdate DateTime,
	 @dropped int OUTPUT
as
begin

--
/*
declare @pbxdrop bit
declare @pbxdropfiles bit
declare @pbxfromdate DateTime
declare @ccdrop bit
declare @ccdropfiles bit
declare @ccfromdate DateTime
declare @dropped int

set @pbxdrop = 0
set @pbxdropfiles = 1
set @pbxfromdate = '2013-10-11'
set @ccdrop = 0
set @ccdropfiles = 1
set @ccfromdate = '2013-10-10'
*/
--
	 set @dropped = 0

	 -- таблица для вывода наружу и удаления файлов
	 if exists ( select * from tempdb..sysobjects where id = object_id ( 'tempdb..#a' ))
		Drop table #a
	 if exists ( select * from tempdb..sysobjects where id = object_id ( 'tempdb..#b' ))
		Drop table #b
		
	 Create table #a ( IdRecDir int, ALineNum nvarchar ( 20 ), BLineNum nvarchar ( 20 ), TimeStart DateTime, FromCC bit )
	 Create table #b ( IdConf uniqueidentifier, IdRecDir int, Room int, TimeStart DateTime, IsRecorded bit )


	 if ( @pbxdropfiles = 1 and @ccdropfiles = 1 ) 
		  Insert into #a
			   Select IdRecDir, ALineNum, BLineNum, TimeStart, FromCC
			   From A_Stat_Connections_1x1 
			   Where (( TimeStart < @pbxfromdate and FromCC = 0 )
					Or ( TimeStart < @ccfromdate and FromCC = 1 )) 
					And IsRecorded = 1
			   Order By TimeStart

	 else if ( @pbxdropfiles = 1 )
		  Insert into #a
			   Select IdRecDir, ALineNum, BLineNum, TimeStart, FromCC
			   From A_Stat_Connections_1x1 
			   Where ( TimeStart < @pbxfromdate and FromCC = 0 )
					And IsRecorded = 1
			   Order By TimeStart

	 else if ( @ccdropfiles = 1 )
		  Insert into #a
			   Select IdRecDir, ALineNum, BLineNum, TimeStart, FromCC
			   From A_Stat_Connections_1x1 
			   Where ( TimeStart < @ccfromdate and FromCC = 1 )
					And IsRecorded = 1
			   Order By TimeStart

	 
	 -- Конференции тоже будем удалять. Они относятся к PBX
	 if ( @pbxdropfiles = 1 )
		  Insert into #b
			   Select Id, IdRecDir, Room, TimeStart, IsRecorded
			   From A_Stat_Conference 
			   Where ( TimeStart < @pbxfromdate )
					And ( IsRecorded = 1 )

	 
	 -- удаление из таблицы
	 if ( @pbxdrop = 1 and @ccdrop = 1 ) begin
		  -- И АТС и КЦ удаляем
		  Delete
		  From A_Stat_Connections_1x1 
		  Where (( TimeStart < @pbxfromdate ) and ( FromCC = 0 ))
				Or (( TimeStart < @ccfromdate ) and ( FromCC = 1 ))

		  Set @dropped = @@rowcount
		  
	 end else if ( @pbxdrop = 1 ) begin
		  -- АТС удаляем
		  Delete
		  From A_Stat_Connections_1x1 
		  Where (( TimeStart < @pbxfromdate ) and ( FromCC = 0 ))
		  
		  Set @dropped = @@rowcount
		  
		  -- КЦ не удаляем, но устанавливаем, что не нужно больше на них смотреть
		  Update A_Stat_Connections_1x1
		  Set IsRecorded = 0
		  Where (( TimeStart < @ccfromdate ) and ( FromCC = 1 ) and ( IsRecorded = 1 ))
	 
	 end else if ( @ccdrop = 1 ) begin
		  -- КЦ удаляем
		  Delete
		  From A_Stat_Connections_1x1 
		  Where (( TimeStart < @ccfromdate ) and ( FromCC = 1 ))

		  Set @dropped = @@rowcount
		  
		  -- АТС не удаляем, но устанавливаем, что не нужно больше на них смотреть
		  Update A_Stat_Connections_1x1
		  Set IsRecorded = 0
		  Where (( TimeStart < @pbxfromdate ) and ( FromCC = 0 ) and ( IsRecorded = 1 ))
		  
	 end else begin
			
		  -- АТС не удаляем, но устанавливаем, что не нужно больше на них смотреть
		  Update A_Stat_Connections_1x1
		  Set IsRecorded = 0
		  Where (( TimeStart < @pbxfromdate ) and ( FromCC = 0 ) and ( IsRecorded = 1 ))
		  
		  -- КЦ не удаляем, но устанавливаем, что не нужно больше на них смотреть
		  Update A_Stat_Connections_1x1
		  Set IsRecorded = 0
		  Where (( TimeStart < @ccfromdate ) and ( FromCC = 1 ) and ( IsRecorded = 1 ))
	 end


	 -- Конференции, неудачные и пропущенные тоже удаляем. По PBX флагу
	 if ( @pbxdrop = 1 ) begin
		  -- Конфы удаляем
		  Delete 
		  From A_Stat_Conference
		  Where ( TimeStart < @pbxfromdate )

		  Set @dropped = @dropped + @@rowcount

		  Delete
		  From A_Stat_Conference_Competitors 
		  Where not exists ( Select Id from A_Stat_Conference where A_Stat_Conference.Id = IdConf )
		  
		   -- Пропущенные удаляем
		  Delete 
		  From A_Stat_MissedCalls
		  Where ( TimeStart < @pbxfromdate )
		  
		  -- Неудачные удаляем
		  Delete 
		  From A_Stat_FailedCalls
		  Where ( TimeStart < @pbxfromdate )	  
		  
	 end else begin
		  -- Конфы не удаляем, но устанавливаем, что не нужно больше на них смотреть
		  Update A_Stat_Conference
		  Set IsRecorded = 0
		  Where ( TimeStart < @pbxfromdate ) and ( IsRecorded = 1 )
		  
	 end
	
	 /* Детальная карта владения разговором */
	 Delete 
	 From dbo.A_Stat_Connections_1x1_VoiceMap 
	 Where not exists ( Select Id from dbo.A_Stat_Connections_1x1 s Where (s.Id = dbo.A_Stat_Connections_1x1_VoiceMap.IdConn) and (s.IsRecorded = 1))
	 
	 /* Вывод наружу */
	 Select IdRecDir, ALineNum, BLineNum, TimeStart, FromCC
	 From #a

	 Union

	 Select IdRecDir, cast ( Room as nvarchar(20) ), '', TimeStart, 0 
	 From #b 
 
end
GO