﻿/* */
If not Exists ( Select * From oktell_settings.INFORMATION_SCHEMA.Columns Where TABLE_NAME like 'A_Policy_Objects'
                                                              and TABLE_SCHEMA like 'dbo'
                                                              and COLUMN_NAME in ('publicAccess') )
      Alter Table oktell_settings.dbo.A_Policy_Objects
      Add 
		publicAccess bit Default 0,
		publicPass nvarchar(200) Default ''
GO


/* */
Update oktell_settings.dbo.A_Policy_Objects
Set publicAccess = 0,
	publicPass = ''
Where publicAccess is NULL

/* */
if exists ( select * from sysobjects where id = object_id ( 'dbo.A_Policy_Objects' ))
	Drop view dbo.A_Policy_Objects
GO

Create view dbo.A_Policy_Objects
as 
	Select * 
	From oktell_settings.dbo.A_Policy_Objects
GO		

------------------------------
if exists ( select * From sysobjects where id= object_id ( 'dbo.A_Policy_Objects_PublicAccess_Get' ))
	Drop procedure dbo.A_Policy_Objects_PublicAccess_Get
GO

Create procedure dbo.A_Policy_Objects_PublicAccess_Get
	@idobject uniqueidentifier
as
begin
	
	Select id, type, publicAccess, publicPass
	From dbo.A_Policy_Objects
	Where id = @idobject
	
end
GO

------------------------------
if exists ( select * From sysobjects where id= object_id ( 'dbo.A_Policy_Objects_PublicAccess_Set' ))
	Drop procedure dbo.A_Policy_Objects_PublicAccess_Set
GO

Create procedure dbo.A_Policy_Objects_PublicAccess_Set
	@idobject uniqueidentifier,
	@publicaccess bit = 0,
	@publicpass nvarchar(200) = '',
	@authorizedUserId uniqueidentifier
as
begin
	
	Declare @res int
	exec A_Policy_SubjectPrivileges_CheckCanModifyPolicy
		@idUser = @authorizedUserId,
		@idObject = @idobject,
		@idPrivilege = '00000000-0000-0000-0000-000000000000',
		@onlyreturnvalue = 1,
		@resultvalue = @res OUTPUT
		
	Declare @wPublicAccess bit, @wPublicPass nvarchar(200)
	if ( @res = 0 ) begin
	
		Select @wPublicAccess = publicAccess,
				@wPublicPass = publicPass
		From dbo.A_Policy_Objects
		Where id = @idobject
		
		Update dbo.A_Policy_Objects
		Set publicAccess = @publicaccess,
			publicpass = @publicPass
		Where id = @idobject
		
	end
	
	Select @res as result, @wPublicAccess as wPublicAccess, @wPublicPass as wPublicPass
	
end
GO