﻿
if not exists ( Select * From sysobjects where id = object_id ( 'dbo.A_Registrar_BanList' )) begin
	
	Create table dbo.A_Registrar_BanList
	(
		ipaddress nvarchar(200),
		uaname nvarchar(200),
		reason int,
		dtutc datetime,
		dtutccancel datetime
	)
	
end
GO
	

if exists ( Select * From sysobjects where id = object_id ( 'dbo.A_Registrar_UpdateBanList' ))
	Drop procedure dbo.A_Registrar_UpdateBanList
GO

Create procedure dbo.A_Registrar_UpdateBanList
	@ipaddress nvarchar(200) = NULL,
	@uaname nvarchar(200) = NULL,
	@reason int,
	@dtutc datetime,
	@dtutccancel datetime = NULL
as
begin
	
	if ( @reason = 0 ) begin
		
		Delete 
		From dbo.A_Registrar_BanList
		Where ((ipaddress = @ipaddress) and (not @ipaddress is null))
			or ((uaname = @uaname) and (not @uaname is null))
				
	end else begin
	
		Update dbo.A_Registrar_BanList
		Set reason = @reason,
			dtutc = @dtutc,
			dtutccancel = @dtutccancel
		Where ((ipaddress = @ipaddress) and (not @ipaddress is null))
			or ((uaname = @uaname) and (not @uaname is null))
		
		if ( @@rowcount = 0 )
			Insert into dbo.A_Registrar_BanList ( ipaddress, uaname, reason, dtutc, dtutccancel )
			Values ( @ipaddress, @uaname, @reason, @dtutc, @dtutccancel )
	
	end
	
end
GO



if exists ( Select * From sysobjects where id = object_id ( 'dbo.A_DB_InitOnStart' ))
	Drop procedure dbo.A_DB_InitOnStart
GO	

Create procedure [dbo].[A_DB_InitOnStart]
As
begin
		-- On PBXStatusServer start (2)

		-----------------------------------------------------
		-- Проставляем отвалившихся пользователей -----------
		-----------------------------------------------------
		
		Declare @lastpingtime datetime
		Set @lastpingtime = GetDate()
		select @lastpingtime = valueDateTime From A_Settings where [name] like 'PBXStatusServerPingTime'
		
		Declare @t1 table ( uid  uniqueidentifier ,  tm datetime )
		Insert into @t1
			Select UserId, Max ( TimeChange ) as TS FROM A_UserStateHistory Group By UserId
	

		Insert into A_UserStateHistory --with ( UpdLock )

		Select 	newid(), ush.UserId, 0, @lastpingtime, '', 0, 10104 --'Отвалился'
			From A_UserStateHistory ush inner join @t1 t on ush.UserId = t.uid and ush.TimeChange = t.tm
			Where ush.State != 0

		-----------------------------------------------------
		-- User in Task - проставляем в нуллы значения
		-----------------------------------------------------

		Update A_TaskManager_UserInTask with ( TabLock )
		Set	TimeStopPrior = IsNull ( TimeStopPrior, @lastpingtime ),
			TimeStopWaitCall = IsNull ( TimeStopWaitCall, @lastpingtime ),
			TimeStopBackCall = IsNull ( TimeStopBackCall, @lastpingtime ),
			TimeStopDialog = IsNull ( TimeStopDialog, @lastpingtime ),
			TimeStopPost = IsNull ( TimeStopPost, @lastpingtime )
		Where	( TimeStopPost is null ) or
			( TimeStopDialog is null ) or
			( TimeStopPrior is null ) or
			( TimeStopWaitCall is null ) or
			( TimeStopBackCall is null )

		-----------------------------------------------------
		-- избавление от нуллов в таблице статусов операторов коллцентра, если сервак вырубили
		-----------------------------------------------------

		Update A_CallCenter_UserStateHistory with ( TabLock )
		Set TimeLeave = @lastpingtime,
			LengthSec = Cast ( ( @lastpingtime - TimeEnter ) as float ) * 86400
		Where TimeLeave is NULL
		
		-----------------------------------------------------
		-- очищаем монополии
		-----------------------------------------------------
		
		Delete From A_Monopoly
		Delete From A_MonopolyForTaskChanging
		Delete From C_MonopolyForTaskChanging /*obsolete*/

		-----------------------------------------------------
		-- Пустые входящие задачи, необработанные - ексепшны и положенные трубы
		-----------------------------------------------------
		Delete 
		From A_TaskManager_Task_IncomingCalls
		Where ConnectionChainId = '00000000-0000-0000-0000-000000000000'

		-----------------------------------------------------
		-- неиспользуемые таблицы локальных списков
		-----------------------------------------------------

		Declare @llid int
		Declare @llname nvarchar ( 1000 )
		Declare @ltid uniqueidentifier
		Declare @ltids nvarchar ( 50 )
		Declare @sql nvarchar ( 500 )
		
		Declare tcursor Cursor For
			Select name, Id  
			From sysobjects 
			Where ([type] = 'U') 
				and (name like 'A_TaskManager_LocalList%')
		
		Open tcursor
		Fetch Next From tcursor 
					Into @llname, @llid

		While (@@FETCH_STATUS = 0) begin
		
			Set @llname = 'dbo.[' + @llname + ']'

			-- по названиям (id в названии и Id списка совпадают) (недостаточно в связи с переменой имен - может много быть таблиц с одним ид. N-1 надо удалить)	
			--set @ltids = SUBSTRING ( @llname, 30, 36 )
			--set @ltid = cast ( @ltids as uniqueidentifier )
			--If not exists ( Select Id from A_Taskmanager_Lists Where Id = @ltid )
	
			-- по явным ссылкам через поле JoinedTable в списках
			If not exists ( Select Id from A_TaskManager_Lists Where JoinedTable = @llname ) begin
				set @sql = ' DROP TABLE ' + @llname
				exec sp_executesql @stmt = @sql
			end

			Fetch Next From tcursor 
						Into @llname, @llid
		end

		Close tcursor
		Deallocate tcursor

		-----------------------------------------------------
		-----------------------------------------------------

		-- таблицы КЦ создать??
		--надо или нет обнулить счетчики текущих состояний для куба состояний?
		-- и саму таблицу тоже закрыть?
		-- вроде надо бы.. ничего не мешает, а от возможных глюков избавит..
		Exec dbo.A_CallCenter_Temp_OnLoad

		-----------------------------------------------------
		-----------------------------------------------------
		
		Delete 
		From dbo.A_Registrar_BanList
		Where not (dtutccancel is null )
			and (DateDiff ( s, dtutc, GetUtcDate() ) > 180)
		
end
GO
