﻿IF OBJECT_ID('[dbo].A_Stat_MyCalls_Get') IS NOT NULL
    DROP PROCEDURE [dbo].A_Stat_MyCalls_Get
GO

CREATE procedure [dbo].[A_Stat_MyCalls_Get]
	@media 		int = 0, --1 - внешняя, 2 - внутренняя, 3 - смешанная, 0 - все
	@type 		int = 0, --1 - входящий, 2 - исходящий, 3 - пропущенный, 4 - неудачный, 10 - конф, 11 - селектор, 0 - все
	@dstart 	datetime = NULL,
	@dstop 		datetime = NULL,
	@number 	nvarchar ( 50 ) = NULL,
	@showivr 	bit = 0,
	@userid 	uniqueidentifier,
	@comment 	nvarchar ( 4000 ) = NULL,
	------ новые параметры ------
	@first int = NULL,
	@count int = NULL,
	@p_users_id uniqueidentifier = NULL,
    @parentgroupid uniqueidentifier = NULL,
	@leninms    bit = 0, -- если 1, то выводит поле Length в миллисекундах, иначе в секундах
    @idconn     uniqueidentifier = NULL
as
begin

/*
	declare @media 	int --1 - внешняя, 2 - внутренняя, 3 - смешанная, 0 - все
	declare @type 	int --1 - входящий, 2 - исходящий, 3 - пропущенный, 0 - все
	declare @dstart datetime
	declare @dstop 	datetime
	declare @number nvarchar ( 50 )
	declare @userid uniqueidentifier

	set dateformat dmy
	set @media = 0
	set @type = 0
	set @dstart = '16.12.2006'
	set @dstop = '16.12.2006'
	set @number = ''
	select @userid = id from A_users where login like 'Peter'	

*/

     Declare @output table (Id uniqueidentifier, IdChain uniqueidentifier, Media int, Type int, 
				TimeStart DateTime, TimeAnswer DateTime, TimeStop DateTime, Length DateTime, 
				Number nvarchar ( 50 ) collate database_default, AbonentName nvarchar ( 200 ) collate database_default, 
				IsRecorded int, IdRecDir int, 
				ALineNum nvarchar ( 10 ) collate database_default, BLineNum nvarchar ( 10 )  collate database_default, --ARecFile nvarchar ( 100 ), BRecFile nvarchar ( 100 ), 
				AUserId uniqueidentifier, BUserId uniqueidentifier, 
				ALineId uniqueidentifier, BLineId uniqueidentifier, 
				AOutNumber nvarchar ( 50 ) collate database_default, BOutNumber nvarchar ( 50 ) collate database_default, 
				AStr nvarchar ( 200 ) collate database_default, BStr nvarchar ( 100 ) collate database_default, 
				IsConf int, Director uniqueidentifier, CTS DateTime, leninms int )
     -- Подготовка параметров
     declare @filtercomment bit
     set @filtercomment = case when ( @comment IS NULL or @comment like '' ) then 0 else 1 end

     Declare @id0 uniqueidentifier
     Set @id0 = '00000000-0000-0000-0000-000000000000'



    -------------------------------------
    -- Коммутации -----------------------
    -------------------------------------

    if ( @type in ( 0, 1, 2 )) begin

		Insert into @output (Id, IdChain, Media, Type,
				TimeStart, TimeAnswer, TimeStop, Length,
				Number, AbonentName, IsRecorded, IdRecDir, 
				ALineNum, BLineNum,
				AUserId, BUserId, 
				ALineId, BLineId, 
				AOutNumber, BOutNumber, 
				AStr, BStr, 
				IsConf, Director, CTS, leninms)
			Select TOP 1000 sc.Id, sc.IdChain, null, 0, 
			sc.TimeStart, sc.TimeAnswer, sc.TimeStop, sc.TimeStop - sc.TimeAnswer as Length, 
			'', '', IsRecorded, IdRecDir, 
			ALineNum, BLineNum, --ARecFile, BRecFile, 
			AUserId, BUserId, 
			ALineId, BLineId, 
			AOutNumber, BOutNumber, 
			AStr, BStr,
			0 as IsConf, @id0 as Director, sc.TimeStart as CTS, DATEDIFF(ms, sc.TimeAnswer, sc.TimeStop)
			From A_Stat_Connections_1x1 sc --with ( TabLock )
			Where   (@idconn IS NULL OR sc.Id = @idconn) 
                AND TimeStart >= COALESCE(@dstart,CAST('1900-01-01' AS DATETIME))
                and TimeStart < COALESCE(@dstop ,CURRENT_TIMESTAMP)
                and (
                        (AUserId = @userid and (@type = 2 or @type = 0) and (nullif(ltrim(rtrim(@number)),'') IS NULL OR BOutNumber like '%' + @number + '%') ) or 
                        (BUserId = @userid and ( @type = 1  or @type = 0 ) and (nullif(ltrim(rtrim(@number)),'') IS NULL OR AOutNumber like '%' + @number + '%' ))
                    )
                and (@showivr = 1 or (( AUserId != 'AB000000-0000-0000-0000-000000000000' ) and ( BUserId != 'AB000000-0000-0000-0000-000000000000' )))
                and (@parentgroupid IS NULL 
                      OR EXISTS (SELECT 1 
                                    FROM oktell.dbo.A_Users u 
                                    WHERE case 
                                               when (@type = 2 or @type = 0) then AUserId-- Входящие
                                               when (@type = 1 or @type = 0) then BUserId -- Исходящие
                                          end = u.ID
                                      and u.ParentGroupID = @parentgroupid
                                )
                    )
                and sc.TimeStop is not null
                and (@p_users_id IS NULL 
                      OR case 
                            when (@type = 1 or @type = 0) then sc.AUserId -- Входящие
                            when (@type = 2 or @type = 0) then sc.BUserId -- Исходящие
                        end =  @p_users_id)
                and (NULLIF(@comment,'') IS NULL
                     OR EXISTS (SELECT 1 FROM oktell.dbo.A_Stat_Comments c WHERE c.Id = sc.Id AND c.Comment like lower('%'+@comment+'%') ) )
			ORDER BY TimeStart DESC
		
    end

    -------------------------------------
    -- Конференции ----------------------
    -------------------------------------
    if ( @type in ( 0, 10, 11 )) begin
	
	--Declare @idconfuser uniqueidentifier
	--Set @idconfuser = 'CF000000-0000-0000-0000-000000000000'
	
	-- фильтр по времени	

	INSERT INTO @output (Id, IdChain, Media, Type,
				TimeStart, TimeAnswer, TimeStop, Length,
				Number, AbonentName, IsRecorded, IdRecDir, 
				ALineNum, BLineNum,
				AUserId, BUserId, 
				ALineId, BLineId, 
				AOutNumber, BOutNumber, 
				AStr, BStr, 
				IsConf, Director, CTS, leninms)
		SELECT TOP 1000 IdConn, IdChain, 
			case when sc.Type = 1 then 11/*селектор*/ else 10/*конф*/ end, 
			case when sc.Type = 1 then 11/*селектор*/ else 10/*конф*/ end,
			scc.TimeStart, scc.TimeStart as TimeAnswer, scc.TimeStop, 
			scc.TimeStop - scc.TimeStart as Length, 
			'', case when Name != '' then Name else '#' + cast ( Room as nvarchar ( 10 ) ) end,
			case when NOT ( 	-- фильтр по правам на прослушивание
                    				(sc.RecordAccess = 1 And sc.Director = @userid) OR
                    				(sc.RecordAccess = 2 And scc.IdUser  = @userid) OR
                    				(sc.RecordAccess = 3 And EXISTS(SELECT 1 FROM A_Stat_Conference_RecordAccessUsers scr WHERE sc.Id = scr.IdConf AND scr.IdUser = @userid))
                    			)  then 0 else sc.IsRecorded end,  
			sc.IdRecDir, LineNum, sc.Room, 
			scc.IdUser, 'CF000000-0000-0000-0000-000000000000', -- @idconfuser,
			scc.IdLine, IdConf,
			'', '', StrName, case when Name != '' then Name else '#' + cast ( Room as nvarchar ( 10 ) ) end,
			1 as IsConf, Director, sc.TimeStart as CTS,DATEDIFF(ms, scc.TimeStart, scc.TimeStop)
		  FROM A_Stat_Conference_Competitors scc
		   JOIN A_Stat_Conference sc ON sc.id = scc.IdConf
		WHERE (@idconn IS NULL OR scc.IdConn = @idconn)
          AND scc.TimeStart >= COALESCE(@dstart,CAST('1900-01-01' AS DATETIME))
		  AND scc.TimeStart < COALESCE(@dstop ,CURRENT_TIMESTAMP)
          AND scc.IdUser = @userid
		  ---- Фильтр по Пользователям 
		  AND (@p_users_id IS NULL 
			   OR EXISTS (SELECT 1 
							FROM oktell.dbo.A_Stat_Conference_Competitors sub_scc 
						   WHERE sub_scc.IdConf = scc.IdConf 
							 AND sub_scc.IdUser = @p_users_id)
				)
		  ---- Фильтр по Отделу
		  AND (	@parentgroupid IS NULL 
				OR EXISTS (SELECT 1 
							 FROM oktell.dbo.A_Users u 
							WHERE scc.IdUser = u.ID
							  and u.ParentGroupID = @parentgroupid)
				)
		  -- Фильтр по Комментарию
	      AND (	NULLIF(ltrim(rtrim(@comment)),'') IS NULL 
				OR EXISTS(SELECT 1 FROM A_Stat_Comments scom WHERE scom.Id = scc.IdConf AND scom.[comment] LIKE '%' + ltrim(rtrim(@comment)) + '%')
			   )
		  ---- Фильтр по Номеру телефона
		  AND (nullif(ltrim(rtrim(@number)),'') IS NULL or ( Cast ( sc.Room as nvarchar(50) ) like '%' + @number + '%'))
		ORDER BY scc.TimeStart DESC
	
    end

    -------------------------------------
    -- Пропущенные ----------------------
    -------------------------------------
    if ( @type in ( 0, 3 )) begin

 			Insert into @output 
			( 
				Id, IdChain, Media, Type,
				TimeStart, TimeAnswer, TimeStop, Length,
				Number, AbonentName, IsRecorded, IdRecDir, 
				ALineNum, BLineNum,
				AUserId, BUserId, 
				ALineId, BLineId, 
				AOutNumber, BOutNumber, 
				AStr, BStr, 
				IsConf, Director, CTS , leninms
			)
			Select TOP 1000 Idg, IdChain, 3, 3, 
				TimeStart, TimeStop, TimeStop, TimeStop - TimeStart, 
				AOutNumber, AStr, 0, 0, 
				ALineNum, BLineNum, 
				AUserId, BUserId,
				ALineId, BLineId,
				AOutNumber, Number,
				AStr, '',
				0, @id0, TimeStart, DATEDIFF(ms, TimeStart, TimeStop)
			From A_Stat_MissedCalls
			Where BUserId = @userid
              AND (@idconn IS NULL OR Idg = @idconn)
			  AND TimeStart >= COALESCE(@dstart,CAST('1900-01-01' AS DATETIME))
			  AND TimeStart < COALESCE(@dstop,CURRENT_TIMESTAMP)
			  ---- Фильтр по Отделу
			  AND (@parentgroupid IS NULL
				   OR EXISTS (SELECT 1 FROM oktell.dbo.A_Users u WHERE AUserId = u.ID AND u.ParentGroupID = @parentgroupid))
			  ---- Фильтр по Пользователям 
			  AND (@p_users_id IS NULL
				   OR @p_users_id = AUserId)
			  ---- Фильтр по Номеру телефона
			  AND (NULLIF(ltrim(rtrim(@number)),'') IS NULL
				   OR replace(lower(AOutNumber),'+7','8') like '%' + replace(lower(@number),'+7','8') + '%' )
    end

    -------------------------------------
    -- Неудачные  ----------------------
    -------------------------------------
    if ( @type in ( 0, 4 )) begin
        
            IF @parentgroupid IS NOT NULL 
            BEGIN
                DECLARE @num_parentgroupid nVARCHAR(4000)
                SET @num_parentgroupid = ''
                
                 Select @num_parentgroupid = @num_parentgroupid + np.Prefix+ ';'
            	    From oktell.dbo.A_NumberPlan np
                		Inner join oktell.dbo.A_NumberPlanAction npa on np.Id = npa.NumId
                		Inner join oktell.dbo.A_Rules r on npa.ExtraId = r.Id
                		Inner join oktell.dbo.A_RuleRecords rr on rr.RuleId = r.Id
                        Inner join oktell.dbo.A_Users u ON rr.ReactId = u.ID AND u.ParentGroupID = @parentgroupid
            	    Group by np.Prefix
            END
            
            IF @p_users_id IS NOT NULL 
            BEGIN
                DECLARE @num_p_users_id nVARCHAR(4000) 
                SET @num_p_users_id = ''
                
                 Select @num_p_users_id = @num_p_users_id + np.Prefix+ ';'
            	    From oktell.dbo.A_NumberPlan np
                		Inner join oktell.dbo.A_NumberPlanAction npa on np.Id = npa.NumId
                		Inner join oktell.dbo.A_Rules r on npa.ExtraId = r.Id
                		Inner join oktell.dbo.A_RuleRecords rr on rr.RuleId = r.Id
            	    Where rr.ReactId = @p_users_id
            	    Group by np.Prefix
            END
                    
 			Insert into @output 
			( 
				Id, IdChain, Media, Type,
				TimeStart, TimeAnswer, TimeStop, Length,
				Number, AbonentName, IsRecorded, IdRecDir, 
				ALineNum, BLineNum,
				AUserId, BUserId, 
				ALineId, BLineId, 
				AOutNumber, BOutNumber, 
				AStr, BStr, 
				IsConf, Director, CTS , leninms
			)
			Select TOP 1000 Id, IdChain, 3, 4, 
				TimeStart, TimeStop, TimeStop, TimeStop - TimeStart, 
				ANumberDialed, ANumberDialed, 0, 0, 
				ALineNum, BLineNum, 
				AUserId, @id0,
				ALineId, BLineId,
				AOutNumber, ANumberDialed,
				AStr, ANumberDialed,
				0, @id0, TimeStart, DATEDIFF(ms, TimeStart, TimeStop)
			From A_Stat_FailedCalls d
			Where AUserId = @userid 
              AND (@idconn IS NULL OR d.Id = @idconn)
			  AND TimeStart >= COALESCE(@dstart,CAST('1900-01-01' AS DATETIME))
			  AND TimeStart < COALESCE(@dstop,CURRENT_TIMESTAMP)
			 --///////////
              ---- Фильтр по Отделу
			  AND (@parentgroupid IS NULL
				   OR @num_parentgroupid like '%' + ANumberDialed +'%')
			  ---- Фильтр по Пользователям 
			  AND (@p_users_id IS NULL
				  OR @p_users_id like '%' + ANumberDialed +'%')
			  --/////////////
              ---- Фильтр по Номеру телефона
			  AND (NULLIF(ltrim(rtrim(@number)),'') IS NULL
				   OR replace(lower(ANumberDialed),'+7','8') like '%' + replace(lower(@number),'+7','8') + '%' )
		
    end



	-----------------------------------
  	-- Преобразования -----------------
	-----------------------------------

	Update o
	Set o.Type =  1,
		o.Number = AOutNumber
	From @output o
	Where o.BUserId = @userid
		And Type = 0

	Update o
	Set o.Type =  2,
		o.Number = BOutNumber
	From @output o
	Where o.AUserId = @userid
		And Type = 0

	Update o
	Set o.Media = 1
	From @output o, A_ServerExtLines el
	Where o.ALineId = el.Id or o.BLineId = el.Id

	Update o
	Set o.Media = 2
	From @output o
	Where o.Media is null
	
	Update o
	Set o.AbonentName = u.Name
	From @output o, A_Users u
	Where ( o.AUserId = @userid and o.BUserId = u.Id ) or ( o.BUserId = @userid and o.AUserId = u.Id )

	Update o
	Set o.AbonentName = c.Name
	From @output o, A_Clients c, A_ClientContacts cc
	Where ( o.Number = cc.Content ) and ( cc.IdClient = c.Id )
		and ( c.OwnerId = @userid )

	Update o
	Set o.AbonentName = c.Name
	From @output o, A_Clients c, A_ClientContacts cc
	Where ( o.Number = cc.Content ) and ( cc.IdClient = c.Id )
		and ( c.OwnerId = @id0 )
		and (( o.AbonentName is null ) or ( o.AbonentName like '' ))


	if ( @showivr = 1 )
		Update o
		Set o.AbonentName = 'IVR'
		From @output o
		Where o.AUserId = 'AB000000-0000-0000-0000-000000000000' or o.BUserId = 'AB000000-0000-0000-0000-000000000000'

	Update o
	Set o.AbonentName = case When o.Type = 1 Then o.AStr else o.BStr end
	From @output o
	Where o.AbonentName = ''-- and o.Number = ''

	Update o
	Set o.AbonentName = ''
	From @output o
	Where o.AbonentName = o.Number

	-----------------------------------
  	-- Итог ---------------------------
	-----------------------------------
	Declare @ids table (idx int identity (1,1),Id uniqueidentifier, IdChain uniqueidentifier, Media int, Type int, 
				TimeStart DateTime, TimeAnswer DateTime, TimeStop DateTime, Length DateTime, 
				Number nvarchar ( 50 ) collate database_default, AbonentName nvarchar ( 200 ) collate database_default, 
				IsRecorded int, IdRecDir int, 
				ALineNum nvarchar ( 10 ) collate database_default, BLineNum nvarchar ( 10 )  collate database_default, --ARecFile nvarchar ( 100 ), BRecFile nvarchar ( 100 ), 
				AUserId uniqueidentifier, BUserId uniqueidentifier, 
				ALineId uniqueidentifier, BLineId uniqueidentifier, 
				AOutNumber nvarchar ( 50 ) collate database_default, BOutNumber nvarchar ( 50 ) collate database_default, 
				AStr nvarchar ( 200 ) collate database_default, BStr nvarchar ( 100 ) collate database_default, 
				IsConf int, Director uniqueidentifier, CTS DateTime, leninms INT )
	
	INSERT INTO @ids ( 
				Id, IdChain, Media, Type,
				TimeStart, TimeAnswer, TimeStop, Length,
				Number, AbonentName, IsRecorded, IdRecDir, 
				ALineNum, BLineNum,
				AUserId, BUserId, 
				ALineId, BLineId, 
				AOutNumber, BOutNumber, 
				AStr, BStr, 
				IsConf, Director, CTS , leninms
			)
		Select Top 1000 sc.Id, IdChain, Media, Type, 
                    TimeStart, TimeAnswer, TimeStop, [Length], 
                    Number, AbonentName, IsRecorded, IdRecDir, 
                    ALineNum, BLineNum,
                    AUserId, BUserId, 
                    ALineId, BLineId,
                    AOutNumber, BOutNumber, 
    				AStr, BStr, 
    				IsConf, Director, CTS , leninms
		From @output sc
			Left join A_Stat_Comments c on sc.Id = c.Id
		Where ( Media = @media ) or ( @media = 0 ) or ( Type >= 10 )
		Order By TimeStart Desc
	
	SELECT  sc.Id, IdChain, Media, [Type], TimeStart, TimeAnswer, TimeStop,CASE WHEN @leninms = 1 THEN leninms ELSE Cast ( Cast ( Length as float ) * 86400 as int ) END as [Length], 
			ALineId, BLineId, ALineNum, BLineNum,[Number], AbonentName, IsRecorded, IdRecDir, 
			IsConf, Director, CTS, 
			case When ( c.Id is null ) then 0 else 1 end as HasComment,
			case When ( AUserId = @userid ) then 1 else 0 end as IamA 
	  FROM @ids sc
        Left join A_Stat_Comments c on sc.Id = c.Id
	 WHERE ( nullif(@count,0) IS NULL OR idx between COALESCE(@first,1) and COALESCE(@first,1) + COALESCE(@count,1)-1 )	
	
end
GO