﻿IF OBJECT_ID('dbo.A_Tag') IS NULL
   BEGIN
        CREATE TABLE dbo.A_Tag (
            id UNIQUEIDENTIFIER PRIMARY KEY,
            [text] nVARCHAR(255) collate database_default,
            color varchar(20),
            authorizeduserid UNIQUEIDENTIFIER,
            creation_date DATETIME DEFAULT GETDATE()
        )
   END
GO

IF OBJECT_ID('dbo.A_Tag_Save') IS NOT NULL
    DROP PROCEDURE dbo.A_Tag_Save
GO

CREATE PROCEDURE dbo.A_Tag_Save 
    @id           UNIQUEIDENTIFIER,
    @text         nVARCHAR(255),
    @color      VARCHAR(20),
    @authorizeduserid  UNIQUEIDENTIFIER,
    @creation_date DATETIME
AS
BEGIN
    INSERT INTO A_Tag (id,[text],color,authorizeduserid,creation_date) 
        VALUES (@id,@text,@color,@authorizeduserid,@creation_date)
END
GO

IF OBJECT_ID('dbo.A_Tag_Delete') IS NOT NULL
    DROP PROCEDURE dbo.A_Tag_Delete
GO

CREATE PROCEDURE dbo.A_Tag_Delete
    @id  UNIQUEIDENTIFIER
AS
BEGIN
   DELETE FROM dbo.A_Tag 
        WHERE id = @id
END
GO

IF OBJECT_ID('dbo.A_Tag_Get') IS NOT NULL
    DROP PROCEDURE dbo.A_Tag_Get 
GO

CREATE PROCEDURE dbo.A_Tag_Get 
    @date DATETIME = NULL
AS
BEGIN
    SELECT id, [text], color, creation_date 
        FROM dbo.A_Tag 
        WHERE (@date IS NULL OR creation_date > @date)
END
GO

IF OBJECT_ID('dbo.A_Tag_Commutation') IS NULL
BEGIN
    CREATE TABLE dbo.A_Tag_Commutation (
    authorizeduserid UNIQUEIDENTIFIER,
    commutation_id UNIQUEIDENTIFIER,
    tag_id UNIQUEIDENTIFIER
    )
END
GO

IF OBJECT_ID('dbo.A_Tag_Commutation_Save') IS NOT NULL
    DROP PROCEDURE dbo.A_Tag_Commutation_Save
GO

CREATE PROCEDURE dbo.A_Tag_Commutation_Save 
    @authorizeduserid UNIQUEIDENTIFIER,
    @commutation_id UNIQUEIDENTIFIER,
    @tag_id UNIQUEIDENTIFIER
AS
BEGIN
    INSERT INTO dbo.A_Tag_Commutation (authorizeduserid,commutation_id,tag_id)
        VALUES (@authorizeduserid,@commutation_id,@tag_id)
END
GO

IF OBJECT_ID('dbo.A_Tag_Commutation_Delete') IS NOT NULL
    DROP PROCEDURE dbo.A_Tag_Commutation_Delete
GO

CREATE PROCEDURE dbo.A_Tag_Commutation_Delete
    @commutation_id UNIQUEIDENTIFIER,
    @tag_id UNIQUEIDENTIFIER
AS
BEGIN
   DELETE FROM dbo.A_Tag_Commutation 
        WHERE tag_id = @tag_id 
            AND commutation_id = @commutation_id
END
GO

IF OBJECT_ID('dbo.A_Tag_Commutation_AllDelete') IS NOT NULL
    DROP PROCEDURE dbo.A_Tag_Commutation_AllDelete
GO

CREATE PROCEDURE dbo.A_Tag_Commutation_AllDelete
    @tag_id UNIQUEIDENTIFIER
AS
BEGIN
   DELETE FROM dbo.A_Tag_Commutation 
        WHERE tag_id = @tag_id 
END
GO
