﻿if exists ( Select * from sysobjects where id = object_id ( 'dbo.A_UserNotifyLog_GetByFilter' ))
	Drop procedure dbo.A_UserNotifyLog_GetByFilter
GO

Create procedure dbo.A_UserNotifyLog_GetByFilter
	@iduser uniqueidentifier,
	@dstart datetime = NULL,
	@dstop datetime = NULL,
	@tstart datetime = NULL,
	@tstop datetime = NULL,
	@searchtext nvarchar(1000) = NULL,
	@flagtypes int = NULL
as
begin

	Select *
	FROM A_User_NotifyLog 
	where ( IdUser = @iduser )
		and (( @dstart is NULL ) or ( NotifyDateTime >= @dstart ))
		and (( @dstop is NULL ) or ( NotifyDateTime < @dstop ))
		and (( @tstart is NULL ) or ( Cast(NotifyDateTime as float) - Floor(Cast(NotifyDateTime as float)) >= Cast(@tstart as float) - Floor(Cast(@tstart as float)) ))
		and (( @tstop is NULL ) or ( Cast(NotifyDateTime as float) - Floor(Cast(NotifyDateTime as float)) <= Cast(@tstop as float) - Floor(Cast(@tstop as float)) ))
		and (( @searchtext is NULL ) or ( TextInfo like '%' + @searchtext + '%' ))
		and (( @flagtypes is NULL ) or ( LogType & @flagtypes > 0 ))	
end
GO
