﻿if exists ( select * from sysobjects where id = object_id ( 'dbo.A_CallCenter_Temp_CreateTables'))
	Drop procedure dbo.A_CallCenter_Temp_CreateTables
GO

Create Procedure [dbo].[A_CallCenter_Temp_CreateTables]
as
begin

	If not exists ( Select * From oktell_cc_temp..sysobjects where id = object_id ( '[oktell_cc_temp].[dbo].[A_Cube_CC_EffortConnections]' ) )
	begin
	Create table [oktell_cc_temp].[dbo].[A_Cube_CC_EffortConnections] 
	( 
		[IdProject] uniqueidentifier NOT NULL,
		[IdTask] uniqueidentifier NOT NULL,
		[IsOutput] bit NOT NULL,
		[IdEffort] uniqueidentifier NOT NULL,
		[IdOperator] uniqueidentifier,
		[IdInList] int NOT NULL,
		[AbonentNumber] nvarchar ( 20 ) collate database_default NOT NULL,
		[CallResult] int NOT NULL,
		[CallResultInfo] nvarchar ( 100 )  collate database_default Not NULL,
		[DateTimeStart] DateTime NOT NULL, 
		[DateStart] DateTime NOT NULL, 
		[TimeStart] DateTime NOT NULL,
		[DateTimeStop] DateTime Not Null,
		[IdConn] uniqueidentifier,
		[IdChain] uniqueidentifier,	
		[IdAUser] uniqueidentifier,
		[IdBUser] uniqueidentifier,
		[IdExtLine] uniqueidentifier NOT NULL,
		[LenTime] float NOT NULL, 
		[LenQueue] float NOT NULL,
		[IsBetweenOp] bit,
		[OpponentInfo] nvarchar ( 200 ) collate database_default,
		[IsHandled] bit NOT NULL,
		[IsSuccess] bit Not NULL,
		[IsRecorded] bit,
		[IdRecDir] int,
		[ALineNum] nvarchar ( 12 ) collate database_default,
		[BLineNum] nvarchar ( 12 ) collate database_default,
		--[ARecFile] nvarchar ( 100 ) collate database_default,
		--[BRecFile] nvarchar ( 100 ) collate database_default,
		[UserResult] int
	)	
	end


	If not exists ( Select * From oktell_cc_temp..sysobjects where id = object_id ( '[oktell_cc_temp].[dbo].[A_Cube_CC_OperatorStates]' ) )
	begin
	Create table [oktell_cc_temp].[dbo].[A_Cube_CC_OperatorStates] 
	( 		
		[Id] int identity ( 1, 1 ) not null primary key,
		[IdTask] uniqueidentifier,
		[IsOutput] bit,	
		[IdOperator] uniqueidentifier NOT NULL,
		[CallResult] int,
		[State] int Not Null,
		[DateTimeStart] DateTime NOT NULL, 
		[DateStart] DateTime NOT NULL, 
		[TimeStart] DateTime NOT NULL,
		[DateTimeStop] DateTime NOT NULL, 
		[LenTime] float NOT NULL,
		[ICode] int NULL,
		[IdEffort] uniqueidentifier NULL
	)
	end


	If not exists ( Select * From oktell_cc_temp..sysobjects where id = object_id ( '[oktell_cc_temp].[dbo].[A_Cube_CC_CallQueue]' ) )
	begin
	Create table [oktell_cc_temp].[dbo].[A_Cube_CC_CallQueue] 
	( 
		[IdTask] uniqueidentifier NOT NULL,
		[IdProject] uniqueidentifier Not NULL,
		[DateTimeStart] DateTime NOT NULL, 
		[DateStart] DateTime NOT NULL, 
		[TimeStart] DateTime NOT NULL,
		[CountQueue] int Not Null,
		[CountOperator] int Not Null,
		[CountTalking] int Not Null,
		[elt1WaitStart] DateTime NOT NULL,
		[elt1WaitSec] int Not null,
	)
	end



	If not exists ( Select * From oktell_cc_temp..sysobjects where id = object_id ( '[oktell_cc_temp].[dbo].[A_Cube_CC_Cat_OperatorStateTypes]' ) )
	Create table [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_OperatorStateTypes] 
	(
		[Id] int not null primary key,
		[Name] nvarchar ( 500 ) collate database_default not null
	)

	If not exists ( Select * From oktell_cc_temp..sysobjects where id = object_id ( '[oktell_cc_temp].[dbo].[A_Cube_CC_Cat_TaskResultTypes]' ) )
	Create table [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_TaskResultTypes] 
	(
		[Id] int not null primary key,
		[Name] nvarchar ( 500 ) collate database_default not null
	)

	If not exists ( Select * From oktell_cc_temp..sysobjects where id = object_id ( '[oktell_cc_temp].[dbo].[A_Cube_CC_Cat_Task]' ) )
	Create table [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_Task] 
	(
		[Id] uniqueidentifier not null primary key,
		[Name] nvarchar ( 500 ) collate database_default not null,
		[Type] int,
		[Isoutput] bit
		
	)

	If not exists ( Select * From oktell_cc_temp..sysobjects where id = object_id ( '[oktell_cc_temp].[dbo].[A_Cube_CC_Cat_Project]' ) )
	Create table [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_Project] 
	(
		[Id] uniqueidentifier not null primary key,
		[Name] nvarchar ( 500 ) collate database_default not null
	)

	If not exists ( Select * From oktell_cc_temp..sysobjects where id = object_id ( '[oktell_cc_temp].[dbo].[A_Cube_CC_Cat_OperatorInfo]' ) )
	Create table [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_OperatorInfo] 
	(
		[Id] uniqueidentifier not null primary key,
		[Name] nvarchar ( 500 ) collate database_default,
		p0 int,	p1 int, p2 int, p3 int, p4 int, p5 int,
		s0 int,	s1 int, s2 int, s3 int, s4 int, s5 int,
		[LastDT] DateTime
	)

	if not exists ( Select * FROM oktell_cc_temp..sysobjects Where Id = object_id ( '[oktell_cc_temp].[dbo].[A_Sms]' ) )
	Create table oktell_cc_temp.dbo.A_Sms
	(	
		[Id] int identity ( 1, 1 ) not null primary key,	
		[Received] bit not null,
		[DT] DateTime not null,
		[Sender] nvarchar ( 100 ) collate database_default not null,
		[Receiver] nvarchar ( 100 ) collate database_default not null,
		[SmsText] nvarchar ( 2000 ) collate database_default not null,
		[PushId] int null,
		[Delivered] bit null,
		[DeliveredDT] DateTime null
	)
	
	if not exists ( Select * FROM oktell_cc_temp..sysobjects Where Id = object_id ( '[oktell_cc_temp].[dbo].[Tmp_A_Cube_CC_EffortConnections]' ) )
	CREATE TABLE oktell_cc_temp.[dbo].[Tmp_A_Cube_CC_EffortConnections] (
		[IdProject] uniqueidentifier NOT NULL,
		[IdTask] uniqueidentifier NOT NULL,
		[IsOutput] bit NOT NULL,
		[IdEffort] uniqueidentifier NOT NULL,
		[IdOperator] uniqueidentifier NULL,
		[IdInList] int NOT NULL,
		[AbonentNumber] nvarchar(20) NOT NULL,
		[CallResult] int NOT NULL,
		[CallResultInfo] nvarchar(100) NOT NULL,
		[DateTimeStart] datetime NOT NULL,
		[DateStart] datetime NOT NULL,
		[TimeStart] datetime NOT NULL,
		[DateTimeStop] datetime NOT NULL,
		[IdConn] uniqueidentifier NULL,
		[IdChain] uniqueidentifier NULL,
		[IdAUser] uniqueidentifier NULL,
		[IdBUser] uniqueidentifier NULL,
		[IdExtLine] uniqueidentifier NOT NULL,
		[LenTime] float NOT NULL,
		[LenQueue] float NOT NULL,
		[IsBetweenOp] bit NULL,
		[OpponentInfo] nvarchar(100) NULL,
		[IsHandled] bit NOT NULL,
		[IsSuccess] bit NOT NULL,
		[IsRecorded] bit NULL,
		[IdRecDir] int NULL,
		[ALineNum] nvarchar(12) NULL,
		[BLineNum] nvarchar(12) NULL,
		[UserResult] int NULL,
		[id] bigint IDENTITY(1, 1) NOT NULL,
		CONSTRAINT [Tmp_A_Cube_CC_EffortConnections_id_PK]
		PRIMARY KEY CLUSTERED ([id] ASC)
	)
	
	if not exists ( Select * FROM oktell_cc_temp..sysobjects Where Id = object_id ( '[oktell_cc_temp].[dbo].[tmp_cube_track]' ) )
	CREATE TABLE [oktell_cc_temp].[dbo].[tmp_cube_track] 
	(
		[last_id] BIGINT NULL,
		[curr_id] BIGINT NULL,
		last_delete_dt DATETIME
	)
end
GO

----------------------------------------------------------------------------------
if exists ( select * from sysobjects where id = object_id ( 'dbo.A_CallCenter_Temp_FillTables'))
	Drop procedure dbo.A_CallCenter_Temp_FillTables
GO

Create Procedure [dbo].[A_CallCenter_Temp_FillTables]
as
begin
	-------- категория СОСТОЯНИЕ ОПЕРАТОРА В КЦ ---------------------------------------------------
	/*
	PriorHandle		= 1,
	WaitingCall		= 2,
	BackRing		= 3,
	TalkAbonent		= 4,
	TalkInside		= 5,
	WaitingInside		= 6,
	PostHandle		= 7,
	TalkOther		= 8,
	CCLunch			= 9,
	CCReady			= 10
	*/
	declare @cnt int
	Select @cnt = Count ( * ) From [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_OperatorStateTypes] 
	if ( @cnt < 10 )
	   begin
		Delete From [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_OperatorStateTypes]
	
		Insert into [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_OperatorStateTypes] 
		Values ( 1, N'Предварительная обработка' )
	
		Insert into [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_OperatorStateTypes] 
		Values ( 2, N'Ожидание ответа абонента' )

		Insert into [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_OperatorStateTypes] 
		Values ( 3, N'Обратный вызов' )

		Insert into [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_OperatorStateTypes] 
		Values ( 4, N'Разговор с абонентом' )

		Insert into [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_OperatorStateTypes] 
		Values ( 5, N'Разговор между операторами' )

		Insert into [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_OperatorStateTypes] 
		Values ( 6, N'Разговор по задаче' )-- 'Ожидание внутри Call-центра'

		Insert into [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_OperatorStateTypes] 
		Values ( 7, N'Поствызывная обработка' )

		Insert into [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_OperatorStateTypes] 
		Values ( 8, N'Прочие разговоры' )

		Insert into [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_OperatorStateTypes] 
		Values ( 9, N'Перерыв' )

		Insert into [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_OperatorStateTypes] 
		Values ( 10, N'Готов' )
	   end
	

	-------- категория РЕЗУЛЬТАТ ЗАДАЧИ ---------------------------------------------------

	/*
		Success						= 5,	//успех в самом обычном понимании. Полное завершение по задуманному алгоритму согласно задаче
		NoSuccess					= 18,	//Неуспех (после удачной коммутации - выбирает оператор ). Как для исходящей, так и для входящей после коммутации
		//общие продолжение
		Undefined					= 1,	//система сработала некорректно. В расшифровке - тип. (стоп карта не смогла отобразиться, оператор вышел из системы или колл-центра, сценарий разговора завершился неудачей)
		AbonentHangOff				= 13,	//Абонент после снятия трубы не стал находиться в очереди и вывалился оттуда. В расшифровке время нахождения в очереди
		AbortCalling				= 15,	//Обрыв системой абонента из дозвона (еще не снял трубку) (лояльность?)
		AbortQueue					= 19,	//Обрыв системой абонента из очереди, (увеличенная лояльность?)
		//исходящие завершение
		StopCallNumber				= 16,	//Перестать звонить по номеру ( оператор выбирает ). только для исходящей после коммутации
		StopCallAbonent				= 17,	//Перестать звонить абоненту ( оператор выбирает ). только для исходящей после коммутации
		ListChanged					= 12,	//в новой системе не используется
		RemovedByOperator			= 20,	//оператор удалил абонента в запросе на дозвон. только для исходящей до начала набора номера
		//исходящие продолжение
		Busy						= 2,	//занято. Выставляет пул дозвонов, когда получен ответ занято до коммутации (до поднятия трубы на том конце). Только для исходящей
		NotRespond					= 3,	//не отвечает. Выставляет пул дозвонов, когда получен ответ занято до коммутации (до поднятия трубы на том конце). Только для исходящей
		TimeNotSufficient			= 4,	//когда время коммутации недостаточно. В основном для ivr. В частности для исходящей задачи. Также может быть использован для определения успешности звонка в случае работы с аналоговой линией без возможности задать вопрос об успехе оператору. В расшифровке время, которое провел
		NeedLater					= 8,	//отложить звонок ( оператор выбирает ). Только для исходящей после коммутации
		OperatorSkipCall			= 6,	//оператор в запросе на дозвон выбрал "пропустить". только исходящие до набора номера.
		//входящие завершение
		//входящие продолжение
		lrOperatorAbsent			= 7,		
		ChangeNumber				= 29 //смена номера
	*/

	Select @cnt = Count ( * ) From [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_TaskResultTypes] 
	if ( @cnt < 27 )
	   begin
		Delete From [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_TaskResultTypes]
	
		Insert into [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_TaskResultTypes] 
		Values ( 5, N'Успех' )--success
	
		Insert into [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_TaskResultTypes] 
		Values ( 18, N'Неуспех' )--nosuccess

		Insert into [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_TaskResultTypes] 
		Values ( 1, N'Неопределен' )--undefined

		Insert into [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_TaskResultTypes] 
		Values ( 13, N'Абонент прервал ожидание в очереди' )--abonenthangoff

		Insert into [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_TaskResultTypes] 
		Values ( 15, N'Отбой из дозванивающихся' )--abortcalling

		Insert into [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_TaskResultTypes] 
		Values ( 19, N'Отбой из очереди' )--abortqueue

		Insert into [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_TaskResultTypes] 
		Values ( 16, N'Исключение номера из обработки' )--stopcallnumber

		Insert into [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_TaskResultTypes] 
		Values ( 17, N'Исключение абонента из обработки' )--stopcallabonent

		Insert into [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_TaskResultTypes] 
		Values ( 12, N'Исключение номера при синхронизации' )--listchanged

		Insert into [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_TaskResultTypes] 
		Values ( 20, N'Удален оператором' )--removedbyoperator

		Insert into [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_TaskResultTypes] 
		Values ( 31, N'Обнаружен факс' )--faxdetected

		Insert into [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_TaskResultTypes] 
		Values ( 2, N'Занято' )--busy

		Insert into [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_TaskResultTypes] 
		Values ( 3, N'Не отвечает' )--notrespond

		Insert into [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_TaskResultTypes] 
		Values ( 4, N'Недостаточное время обработки' )--timenotsufficient

		Insert into [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_TaskResultTypes] 
		Values ( 8, N'Перезвонить позже' )--needlater

		Insert into [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_TaskResultTypes] 
		Values ( 6, N'Пропуск оператором' )--operatorskipcall

		Insert into [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_TaskResultTypes] 
		Values ( 7, N'Оператор отсутствует' )--operatorabsent

		Insert into [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_TaskResultTypes] 
		Values ( 29, N'Перезвонить на другой номер' )--IncomingOutTaskNotFound



		Insert into [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_TaskResultTypes] 
		Values ( 21, N'Входящий звонок. Превышено число подключений' )--IncomingOutMaxCount

		Insert into [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_TaskResultTypes] 
		Values ( 22, N'Входящий звонок вне периода активности' )--IncomingOutPeriod	

		Insert into [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_TaskResultTypes] 
		Values ( 23, N'Входящий звонок вне расписания' )--IncomingOutTimeTable

		Insert into [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_TaskResultTypes] 
		Values ( 24, N'Входящий звонок в неактивную задачу' )--IncomingOutActivityParams

		Insert into [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_TaskResultTypes] 
		Values ( 25, N'Превышено время ожидания в очереди' )--IncomingOutQueueTimeout

		Insert into [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_TaskResultTypes] 
		Values ( 26, N'Входящий звонок. Операторы отсутствует' )--IncomingOutNoOperators

		Insert into [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_TaskResultTypes] 
		Values ( 27, N'Входящий звонок. Операторы заняты' )--IncomingOutAllBusy

		Insert into [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_TaskResultTypes] 
		Values ( 28, N'Входящий звонок. Сбой или задача не найдена' )--IncomingOutTaskNotFound

		Insert into [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_TaskResultTypes] 
		Values ( 30, N'Абонент не найден в таблице' ) -- IncomingOutAbonentNotFound

	   end
	   
	----------------------------------------------------------------------
	Select @cnt = Count ( * ) From [oktell_cc_temp].[dbo].[tmp_cube_track] 
	if ( @cnt = 0 ) begin
		Insert into [oktell_cc_temp].[dbo].[tmp_cube_track] 
		Values (0,0,getdate())		
	end

	
end
GO

