﻿-------------------------------------------------------
if exists ( Select * FRom sysobjects where id = object_id ( 'dbo.A_TaskManager_Task_SetActivity'))
	Drop procedure dbo.A_TaskManager_Task_SetActivity
GO

Create Procedure [dbo].[A_TaskManager_Task_SetActivity]
	@id uniqueidentifier,
	@activityflag int,
	@authorizeduserid uniqueidentifier = NULL
as
begin
	
	If object_id('dbo.H_Authorizeduserid_SPID_Save') is not NULL
		EXEC dbo.H_Authorizeduserid_SPID_Save @authorizeduserid
		

	Update A_TaskManager_Tasks
	Set Active = @activityflag,
		Done = 0,
		StopReason = 0, 
		Resulted = 0, 
		ResultType = 0, 
		ResultInfo = '', 
		ResultDateTime = GetDate()
	Where (Id = @id)
		and ((Active != @activityflag)
			or (Done != 0)
			or (StopReason != 0)
			or (Resulted != 0)
			or (ResultType != 0)
			or (ResultInfo != ''))	
end
GO

-------------------------------------------------------
if exists ( Select * FRom sysobjects where id = object_id ( 'dbo.A_SmsTaskManager_Task_SetActivity'))
	Drop procedure dbo.A_SmsTaskManager_Task_SetActivity
GO

Create procedure [dbo].[A_SmsTaskManager_Task_SetActivity]
	@id uniqueidentifier,
	@activityflag int,
	@authorizeduserid uniqueidentifier = NULL
as
begin

	If object_id('dbo.H_Authorizeduserid_SPID_Save') is not NULL
		EXEC dbo.H_Authorizeduserid_SPID_Save @authorizeduserid
		

	Update A_SmsTaskManager_Tasks
	Set Active = @activityflag,
		Done = 0		
	Where (Id = @id)
		and ((Active != @activityflag)
			or (Done != 0))
	
end
GO


-------------------------------------------------------
if exists ( Select * FRom sysobjects where id = object_id ( 'dbo.A_SvcTaskManager_Task_SetActivity'))
	Drop procedure dbo.A_SvcTaskManager_Task_SetActivity
GO

Create procedure [dbo].[A_SvcTaskManager_Task_SetActivity]
	@id uniqueidentifier,
	@activityflag int,
	@authorizeduserid uniqueidentifier = NULL
as
begin

	If object_id('dbo.H_Authorizeduserid_SPID_Save') is not NULL
		EXEC dbo.H_Authorizeduserid_SPID_Save @authorizeduserid
		
		
	Update A_SvcTaskManager_Tasks
	Set Active = @activityflag
	Where (Id = @id)
		and (Active != @activityflag)		
					
end
GO

------------------------------------------------------------------
if exists ( Select * From sysobjects where id= object_id( 'dbo.A_TaskManager_TaskOut_UpdateResult_Point' ))
	Drop procedure dbo.A_TaskManager_TaskOut_UpdateResult_Point
GO

Create Procedure [dbo].[A_TaskManager_TaskOut_UpdateResult_Point]
	@idtask uniqueidentifier,	
	@idinlist int,
	@nextefforttime datetime,
	@nresult int,
	@retrynumbers nvarchar(200) = NULL
as
begin	

	if ( @retrynumbers is NULL ) begin

		Update A_TaskManager_SubTasks
		Set	
			NextEffortTime  = @nextefforttime,
			NResult			= @nresult
		Where 
			(TaskId = @idtask)
			and (IdInList = @idinlist)

	end else begin

		Update A_TaskManager_SubTasks
		Set
			NextEffortTime  = @nextefforttime,
			NResult			= @nresult,
			RetryNumbers	= @retrynumbers
		Where 
			TaskId = @idtask
			and IdInList = @idinlist

	end 

	if ( @@rowcount = 0 ) begin		
		Insert Into A_TaskManager_SubTasks
			( IdInList, TaskId, NResult, IsDeleted, NextEffortTime, RetryNumbers )
		Values
			( @idinlist, @idtask, @nresult, 0, @nextefforttime, @retrynumbers )
	end

end
GO

---------------------------------------------------------------
if exists ( Select * From sysobjects where id= object_id( 'dbo.A_TaskManager_TaskOut_UpdateResult_PointSimple' ))
	Drop procedure dbo.A_TaskManager_TaskOut_UpdateResult_PointSimple
GO

Create Procedure [dbo].[A_TaskManager_TaskOut_UpdateResult_PointSimple]
	@idtask uniqueidentifier,	
	@idinlist int,
	@nresult int
as
begin

	Update A_TaskManager_SubTasks
	Set
		NResult	= @nresult
   	Where		
		TaskId = @idtask
		and IdInList = @idinlist
end
GO

---------------------------------------------------------------
if exists ( Select * From sysobjects where id= object_id( 'dbo.A_TaskManager_TaskOut_UpdateResult_Number' ))
	Drop procedure dbo.A_TaskManager_TaskOut_UpdateResult_Number
GO

Create procedure [dbo].[A_TaskManager_TaskOut_UpdateResult_Number]
	@idtask uniqueidentifier,
	@idinlist int,
	@number nvarchar ( 20 ),
	@countbusy int,
	@countnotrespond int,
	@countqhangoff int,
	@qtime int,
	@nextefforttime DateTime,
	@nresult int
as
begin
	
	Update A_TaskManager_SubTaskNumber
	Set
		CountBusy		= @countbusy,
		CountNotRespond	= @countnotrespond,
		CountQHangOff	= @countqhangoff,
		QTime			= @qtime,
		NextEffortTime 	= @nextefforttime,
		NResult			= @nresult
	Where		
		TaskId = @idtask
		and IdInList = @idinlist
		and Number = @number

	if ( @@rowcount = 0 )
		Insert Into A_TaskManager_SubTaskNumber 
			( IdInList, TaskId, Number, CountBusy, CountNotRespond, CountQHangOff, QTime, NResult, NextEffortTime )
		Values
			( @idinlist, @idtask, @number, @countbusy, @countnotrespond, @countqhangoff, @qtime, @nresult, @nextefforttime )	

end
GO

---------------------------------------------------------------
if exists ( Select * From sysobjects where id= object_id( 'dbo.A_TaskManager_TaskOut_UpdateResult_NumberSimple' ))
	Drop procedure dbo.A_TaskManager_TaskOut_UpdateResult_NumberSimple
GO

Create procedure [dbo].[A_TaskManager_TaskOut_UpdateResult_NumberSimple]
	@idtask uniqueidentifier,
	@idinlist int,
	@number nvarchar ( 20 ),
	@nresult int
as
begin

	Update A_TaskManager_SubTaskNumber 
	Set
		NResult	= @nresult
	Where		
		TaskId = @idtask
		and IdInList = @idinlist
		and Number = @number
end
GO

---------------------------------------------------------------
if exists ( Select * From sysobjects where id= object_id( 'dbo.A_TaskManager_TaskOut_UpdateResult_Effort' ))
	Drop procedure dbo.A_TaskManager_TaskOut_UpdateResult_Effort
GO

Create Procedure [dbo].[A_TaskManager_TaskOut_UpdateResult_Effort]
	@id uniqueidentifier,
	@idinlist int,
	@idtask uniqueidentifier,
	@number nvarchar ( 20 ),
	@edatetime datetime,
	@eresult int,
	@einfo nvarchar(500),
	@idchain uniqueidentifier
as
begin	

	--добавление попытки
	Insert Into A_TaskManager_SubTaskEfforts
		( Id, IdInList, TaskId, Number, EDateTime, EResult, EInfo, ConnectionChainId )
	Values	
		( @id, @idinlist, @idtask, @number, @edatetime, @eresult, @einfo, @idchain )

	--обновление базы коммутаций на принадлежность к задаче	
	Update A_Stat_Connections_1x1
	Set FromCC = 1 
	Where IdChain = @idchain
	
end
GO
