﻿
--------------------------------------------------------------------------------
if exists ( select * From sysobjects where id = object_id ( 'dbo.A_RecordRules_ClearAll' ))
	Drop procedure dbo.A_RecordRules_ClearAll
GO

Create procedure [dbo].[A_RecordRules_ClearAll]
as
begin
	
	Truncate table A_RecordRules
	Truncate table A_RecordRules_Items
	
end
GO

if exists ( select * From sysobjects where id = object_id ( 'dbo.A_RecordRules_ClearAll' ))
	Drop procedure dbo.A_RecordRules_ClearAll
GO

--------------------------------------------------------------------------------
if exists ( select * From sysobjects where id = object_id ( 'dbo.A_RecordRules_Add' ))
	Drop procedure dbo.A_RecordRules_Add
GO

--------------------------------------------------------------------------------
if exists ( select * From sysobjects where id = object_id ( 'dbo.A_RecordRules_Item_Add' ))
	Drop procedure dbo.A_RecordRules_Item_Add
GO

-----------------------------------------------------------------------------
if exists ( Select * from sysobjects where id = object_id ( 'dbo.A_RecordRules_Save' ))
	Drop procedure dbo.A_RecordRules_Save
GO

Create procedure dbo.A_RecordRules_Save
	@xml ntext,
	@authorizeduserid uniqueidentifier = NULL
as
begin

	If object_id('dbo.H_Authorizeduserid_SPID_Save') is not NULL
		EXEC dbo.H_Authorizeduserid_SPID_Save @authorizeduserid
		
	
	If object_id('tempdb..#tmp_xml1') is not NULL
		Drop table #tmp_xml1
	Create table #tmp_xml1
	( 
		id uniqueidentifier, 
		priority int,
		direction int,
		torecord bit		
	)
			
	Declare @idoc1 int
	Exec sp_xml_preparedocument @idoc1 OUTPUT, @xml
	
	Insert into #tmp_xml1
		Select id, priority, direction, torecord
		From OpenXml (@idoc1, '/items/a', 2)	
		With ( 
			id varchar(50) '@id',
			priority int '@idx',
			direction int '@dir',
			torecord bit '@torec'			
		)	
		
	If object_id('tempdb..#tmp_xml2') is not NULL
		Drop table #tmp_xml2
	Create table #tmp_xml2
	( 
		idr uniqueidentifier,
		side bit,
		type int,
		itemid uniqueidentifier 
	)
	
	Declare @idoc2 int
	Exec sp_xml_preparedocument @idoc2 OUTPUT, @xml
	
	Insert into #tmp_xml2
		Select idr, side, type, itemid
		From OpenXml (@idoc2, '/items/a/b', 2)	
		With ( 
			idr varchar(50) '../@id',			
			side bit '@side',
			type int '@type',
			itemid varchar(50) '@item'
		)	
	
		
	-- Удаляем тех, что нет в обновлении
	Delete
	From dbo.A_RecordRules
	Where not exists ( Select 1 
						From #tmp_xml1 x 
						Where A_RecordRules.Id = x.id)
	
	-- Обновляем тех, что есть и там и там и у которых хоть что-то изменилось
	Update w
	Set w.Priority = x.priority,
		w.Direction = x.direction,
		w.ToRecord = x.torecord
	From dbo.A_RecordRules w, #tmp_xml1 x
	Where (w.Id = x.id)
		and ((w.Priority != x.priority)
			or (w.Direction != x.direction)
			or (w.ToRecord != x.torecord))
		
	-- Добавляем тех, что есть только в обновлении
	Insert into dbo.A_RecordRules (Id, Priority, Direction, ToRecord)
		Select Distinct id, priority, direction, torecord
		From #tmp_xml1 x
		Where not exists ( Select 1 
							From dbo.A_RecordRules w 
							Where w.Id = x.id )
		
		
	
	-- Подчищаем ссылки кривые в итемах
	Delete 
	From dbo.A_RecordRules_Items
	Where not exists ( Select 1 From A_RecordRules x Where x.Id = A_RecordRules_Items.IdRecordRule)
	
	
	-- Удаляем тех, что нет в обновлении
	Delete
	From dbo.A_RecordRules_Items
	Where not exists ( Select *
						From #tmp_xml2 x 
						Where (A_RecordRules_Items.IdRecordRule = x.idr) 
							and (A_RecordRules_Items.Side = x.side)
							and (A_RecordRules_Items.Type = x.type)
							and (A_RecordRules_Items.IdItem = x.itemid) )
	
	-- Добавляем тех, что есть только в обновлении
	Insert into dbo.A_RecordRules_Items (IdRecordRule, Side, Type, IdItem)
		Select Distinct idr, side, type, itemid
		From #tmp_xml2 x
		Where not exists ( Select 1 
							From dbo.A_RecordRules_Items w 
							Where (w.IdRecordRule = x.idr) 
								and (w.Side = x.side) 
								and (w.Type = x.type) 
								and (w.IdItem = x.itemid) )
	
		
end
GO		

