﻿
Use [oktell_settings]
GO

If Not exists (Select 1 From information_schema.key_column_usage sub_k
                Where objectproperty(object_id(sub_k.constraint_name), 'IsPrimaryKey') = 1 and sub_k.Table_name = 'A_Settings')
    Alter table dbo.A_Settings Alter column [name] nvarchar(200) collate database_default not null
GO


------------------------------------------------------------
-----  A_Settings ------------------------------------------
------------------------------------------------------------
--If Not exists (Select 1 From information_schema.key_column_usage sub_k
--                Where objectproperty(object_id(sub_k.constraint_name), 'IsPrimaryKey') = 1 and sub_k.Table_name = 'A_Settings')
--    Alter table dbo.A_Settings Add Constraint A_Settings_name_pk Primary Key ([name])
--GO

Use oktell_settings
GO 

if (not object_id ( 'dbo.A_Settings_tmp' ) is null)
	Drop table dbo.A_Settings_tmp
GO

CREATE TABLE [dbo].[A_Settings_tmp]
(
	[name] nvarchar(200) primary key,
	[valueStr] nvarchar(4000) collate database_default,
	[valueInt] int,
	[valueDateTime] datetime,
	[valueGuid] uniqueidentifier,
	[valueDouble] float
)
GO

if (not object_id ( 'tempdb..#tmp' ) is null)
	Drop table #tmp
GO

CREATE TABLE #tmp
(
	idx int identity (1,1),
	[name] nvarchar(200),
	[valueStr] nvarchar(4000) collate database_default,
	[valueInt] int,
	[valueDateTime] datetime,
	[valueGuid] uniqueidentifier,
	[valueDouble] float
)

Insert into #tmp (name, valueStr, valueInt, valueDateTime, valueGuid, valueDouble)
	Select name, valueStr, valueInt, valueDateTime, valueGuid, valueDouble
	From A_Settings	
				 
Insert into [dbo].[A_Settings_tmp] (name, valueStr, valueInt, valueDateTime, valueGuid, valueDouble)
	Select x.name, x.valueStr, x.valueInt, x.valueDateTime, x.valueGuid, x.valueDouble
	From #tmp x
		Inner join ( Select name, Min(idx) as idx
					 From #tmp
					 Group by name ) a 
			on (a.name = x.name) and (x.idx = a.idx)
GO

if (not object_id ( 'dbo.A_Settings2' ) is null)
	Drop table dbo.A_Settings2
GO	

if (exists ( Select 1 From A_Settings_tmp )
	or not exists( Select 1 From A_Settings))
begin
	Exec sp_rename A_Settings, A_Settings2
	Exec sp_rename A_Settings_tmp, A_Settings
	Drop table A_Settings2
end
GO

if (not object_id ( 'dbo.H_createTableTrigger' ) is null)
	Exec [dbo].H_createTableTrigger 'A_Settings', 'Where x.[name] like ''''us~%''''' 
GO

use oktell
GO

if (not object_id ( 'dbo.A_Settings' ) is null)
	Drop View dbo.A_Settings
GO

Create View dbo.A_Settings
as 
	Select *
	From oktell_settings.dbo.A_Settings
GO

use oktell_settings
GO

------------------------------------------------------------
------ A_Settings ------------------------------------------
------------------------------------------------------------

If Not exists (Select 1 From information_schema.key_column_usage sub_k
                Where objectproperty(object_id(sub_k.constraint_name), 'IsPrimaryKey') = 1 and sub_k.Table_name = 'A_CallCenter_OperatorTimeTable')
    Alter table dbo.A_CallCenter_OperatorTimeTable Alter column [Id] uniqueidentifier not null
GO
If Not exists (Select 1 From information_schema.key_column_usage sub_k
                Where objectproperty(object_id(sub_k.constraint_name), 'IsPrimaryKey') = 1 and sub_k.Table_name = 'A_CallCenter_OperatorTimeTable')
    Alter table dbo.A_CallCenter_OperatorTimeTable Add Constraint A_CallCenter_OperatorTimeTable_pk Primary Key ([Id])
GO


If Not exists (Select 1 From information_schema.key_column_usage sub_k
                Where objectproperty(object_id(sub_k.constraint_name), 'IsPrimaryKey') = 1 and sub_k.Table_name = 'A_CallRoutes')
    Alter table dbo.A_CallRoutes Alter column [Id] uniqueidentifier not null
GO
If Not exists (Select 1 From information_schema.key_column_usage sub_k
                Where objectproperty(object_id(sub_k.constraint_name), 'IsPrimaryKey') = 1 and sub_k.Table_name = 'A_CallRoutes')
    Alter table dbo.A_CallRoutes Add Constraint A_CallRoutes_pk Primary Key ([Id])
GO

If Not exists (Select 1 From information_schema.key_column_usage sub_k
                Where objectproperty(object_id(sub_k.constraint_name), 'IsPrimaryKey') = 1 and sub_k.Table_name = 'A_CallRoutes_Lines')
Begin 
    Alter table dbo.A_CallRoutes_Lines Alter column [IdRoute] uniqueidentifier not null
    Alter table dbo.A_CallRoutes_Lines Alter column [IdLine] uniqueidentifier not null
End
GO
If Not exists (Select 1 From information_schema.key_column_usage sub_k
                Where objectproperty(object_id(sub_k.constraint_name), 'IsPrimaryKey') = 1 and sub_k.Table_name = 'A_CallRoutes_Lines')
    Alter table dbo.A_CallRoutes_Lines Add Constraint A_CallRoutes_Lines_pk Primary Key (IdRoute, IdLine)
GO


If Not exists (Select 1 From information_schema.key_column_usage sub_k
                Where objectproperty(object_id(sub_k.constraint_name), 'IsPrimaryKey') = 1 and sub_k.Table_name = 'A_EmergencyDirections')
Begin 
    Alter table dbo.A_EmergencyDirections Alter column [ObjectId] uniqueidentifier not null
    Alter table dbo.A_EmergencyDirections Alter column [OrderIdx] int not null
End
GO
If Not exists (Select 1 From information_schema.key_column_usage sub_k
                Where objectproperty(object_id(sub_k.constraint_name), 'IsPrimaryKey') = 1 and sub_k.Table_name = 'A_EmergencyDirections')
    Alter table dbo.A_EmergencyDirections Add Constraint A_EmergencyDirections_pk Primary Key (ObjectId)
GO


------------------------------------------------------------
-----  A_HolidaysDefault -----------------------------------
------------------------------------------------------------

--If Not exists (Select 1 From information_schema.key_column_usage sub_k
--                Where objectproperty(object_id(sub_k.constraint_name), 'IsPrimaryKey') = 1 and sub_k.Table_name = 'A_HolidaysDefault')
--    Alter table dbo.A_HolidaysDefault Add Id int identity(1,1) Not Null Constraint A_HolidaysDefault_pk Primary Key
--GO


Use oktell_settings
GO 

if (not object_id ( 'dbo.A_HolidaysDefault_tmp' ) is null)
	Drop table dbo.A_HolidaysDefault_tmp
GO

CREATE TABLE [dbo].[A_HolidaysDefault_tmp]
(
	[Date] [datetime] Primary key,
	[Type] [bit],
	[AsDayOfWeek] [int],
	[Description] [nvarchar](1000) collate database_default
)
GO

if (not object_id ( 'tempdb..#tmp' ) is null)
	Drop table #tmp
GO

CREATE TABLE #tmp
(
	idx int identity (1,1),
	[Date] [datetime],
	[Type] [bit],
	[AsDayOfWeek] [int],
	[Description] [nvarchar](1000) collate database_default
)

Insert into #tmp (date, type, asdayofweek, description)
	Select date, type, asdayofweek, description
	From A_HolidaysDefault	
				 
Insert into [dbo].[A_HolidaysDefault_tmp] (Date, Type, AsDayOfWeek, Description)
	Select x.date, x.type, x.asdayofweek, x.description
	From #tmp x
		Inner join ( Select date, Min(idx) as idx
					 From #tmp
					 Group by date ) a 
			on (a.date = x.date) and (x.idx = a.idx)
GO

if (exists ( Select 1 From A_HolidaysDefault_tmp )
	or not exists( Select 1 From A_HolidaysDefault))
begin
	Exec sp_rename A_HolidaysDefault, A_HolidaysDefault2
	Exec sp_rename A_HolidaysDefault_tmp, A_HolidaysDefault
	Drop table A_HolidaysDefault2
end
GO

if (not object_id ( 'dbo.H_createTableTrigger' ) is null)
	Exec [dbo].H_createTableTrigger 'A_HolidaysDefault'
GO

use oktell
GO

if (not object_id ( 'dbo.A_HolidaysDefault' ) is null)
	Drop View dbo.A_HolidaysDefault
GO

Create View dbo.A_HolidaysDefault
as 
	Select *
	From oktell_settings.dbo.A_HolidaysDefault
GO

use oktell_settings
GO

------------------------------------------------------------
------ A_HolidaysUser --------------------------------------
------------------------------------------------------------

--If Not exists (Select 1 From information_schema.key_column_usage sub_k
--                Where objectproperty(object_id(sub_k.constraint_name), 'IsPrimaryKey') = 1 and sub_k.Table_name = 'A_HolidaysUser')
--    Alter table dbo.A_HolidaysUser Add Id int identity(1,1) Not Null Constraint A_HolidaysUser_pk Primary Key
--GO


Use oktell_settings
GO 

if (not object_id ( 'dbo.A_HolidaysUser_tmp' ) is null)
	Drop table dbo.A_HolidaysUser_tmp
GO

CREATE TABLE [dbo].[A_HolidaysUser_tmp]
(
	[Date] [datetime] Primary key,
	[Type] [bit],
	[AsDayOfWeek] [int],
	[Description] [nvarchar](1000) collate database_default
)
GO

if (not object_id ( 'tempdb..#tmp' ) is null)
	Drop table #tmp
GO

CREATE TABLE #tmp
(
	idx int identity (1,1),
	[Date] [datetime],
	[Type] [bit],
	[AsDayOfWeek] [int],
	[Description] [nvarchar](1000) collate database_default
)

Insert into #tmp (date, type, asdayofweek, description)
	Select date, type, asdayofweek, description
	From A_HolidaysUser
				 
Insert into [dbo].[A_HolidaysUser_tmp] (Date, Type, AsDayOfWeek, Description)
	Select x.date, x.type, x.asdayofweek, x.description
	From #tmp x
		Inner join ( Select date, Min(idx) as idx
					 From #tmp
					 Group by date ) a 
			on (a.date = x.date) and (x.idx = a.idx)
GO

if (exists ( Select 1 From A_HolidaysUser_tmp )
	or not exists( Select 1 From A_HolidaysUser))
begin
	Exec sp_rename A_HolidaysUser, A_HolidaysUser2
	Exec sp_rename A_HolidaysUser_tmp, A_HolidaysUser
	Drop table A_HolidaysUser2
end
GO

if (not object_id ( 'dbo.H_createTableTrigger' ) is null)
	Exec [dbo].H_createTableTrigger 'A_HolidaysUser'
GO

use oktell
GO

if (not object_id ( 'dbo.A_HolidaysUser' ) is null)
	Drop View dbo.A_HolidaysUser
GO

Create View dbo.A_HolidaysUser
as 
	Select *
	From oktell_settings.dbo.A_HolidaysUser
GO

use oktell_settings
GO

-------------------------------------------------------
-------------------------------------------------------

If Not exists (Select 1 From information_schema.key_column_usage sub_k
                Where objectproperty(object_id(sub_k.constraint_name), 'IsPrimaryKey') = 1 and sub_k.Table_name = 'A_LinesReactors')
Begin 
    Alter table dbo.A_LinesReactors Alter column [LineID] uniqueidentifier not null
    Alter table dbo.A_LinesReactors Alter column [WPID] uniqueidentifier not null
End
GO
If Not exists (Select 1 From information_schema.key_column_usage sub_k
                Where objectproperty(object_id(sub_k.constraint_name), 'IsPrimaryKey') = 1 and sub_k.Table_name = 'A_LinesReactors')
    Alter table dbo.A_LinesReactors Add Constraint A_LinesReactors_pk Primary Key (LineID, WPID)
GO

    
If Not exists (Select 1 From information_schema.key_column_usage sub_k
                Where objectproperty(object_id(sub_k.constraint_name), 'IsPrimaryKey') = 1 and sub_k.Table_name = 'A_PluginMenu')
    Alter table dbo.A_PluginMenu Alter column [Id] uniqueidentifier not null
GO
If Not exists (Select 1 From information_schema.key_column_usage sub_k
                Where objectproperty(object_id(sub_k.constraint_name), 'IsPrimaryKey') = 1 and sub_k.Table_name = 'A_PluginMenu')
    Alter table dbo.A_PluginMenu Add Constraint A_PluginMenu_pk Primary Key ([Id])
GO


If Not exists (Select 1 From information_schema.key_column_usage sub_k
                Where objectproperty(object_id(sub_k.constraint_name), 'IsPrimaryKey') = 1 and sub_k.Table_name = 'A_PluginMenu_User')
Begin 
    Alter table dbo.A_PluginMenu_User Alter column [IdMenuLink] uniqueidentifier not null
    Alter table dbo.A_PluginMenu_User Alter column [IdUser] uniqueidentifier not null
End
GO
If Not exists (Select 1 From information_schema.key_column_usage sub_k
                Where objectproperty(object_id(sub_k.constraint_name), 'IsPrimaryKey') = 1 and sub_k.Table_name = 'A_PluginMenu_User')
Begin 
    Alter table dbo.A_PluginMenu_User Add Constraint A_PluginMenu_User_pk Primary Key (IdMenuLink, IdUser)
End
GO


If Not exists (Select 1 From information_schema.key_column_usage sub_k
                Where objectproperty(object_id(sub_k.constraint_name), 'IsPrimaryKey') = 1 and sub_k.Table_name = 'A_RecordRules_Items')
Begin
    Alter table dbo.A_RecordRules_Items Alter column [IdRecordRule] uniqueidentifier not null
    Alter table dbo.A_RecordRules_Items Alter column [IdItem] uniqueidentifier not null
    Alter table dbo.A_RecordRules_Items Alter column [Side] bit not null
End
GO
If Not exists (Select 1 From information_schema.key_column_usage sub_k
                Where objectproperty(object_id(sub_k.constraint_name), 'IsPrimaryKey') = 1 and sub_k.Table_name = 'A_RecordRules_Items')
    Alter table dbo.A_RecordRules_Items Add Constraint A_RecordRules_Items_pk Primary Key (IdRecordRule, Side, IdItem)
GO


If Not exists (Select 1 From information_schema.key_column_usage sub_k
                Where objectproperty(object_id(sub_k.constraint_name), 'IsPrimaryKey') = 1 and sub_k.Table_name = 'A_Redirect_Abonents')
	Update dbo.A_Redirect_Abonents 
	Set [Number] = ''
	Where [Number] is NULL
GO
If Not exists (Select 1 From information_schema.key_column_usage sub_k
                Where objectproperty(object_id(sub_k.constraint_name), 'IsPrimaryKey') = 1 and sub_k.Table_name = 'A_Redirect_Abonents')
Begin
	Alter table dbo.A_Redirect_Abonents Alter column [IdRedir] uniqueidentifier not null
    Alter table dbo.A_Redirect_Abonents Alter column [IdAbonent] uniqueidentifier not null
    Alter table dbo.A_Redirect_Abonents Alter column [Number] nvarchar(50) collate database_default not null
    Alter table dbo.A_Redirect_Abonents Alter column [Type] int not null
End
GO
If Not exists (Select 1 From information_schema.key_column_usage sub_k
                Where objectproperty(object_id(sub_k.constraint_name), 'IsPrimaryKey') = 1 and sub_k.Table_name = 'A_Redirect_Abonents')
    Alter table dbo.A_Redirect_Abonents Add Constraint A_Redirect_Abonents_pk Primary Key (IdRedir, IdAbonent, Number, [Type])
GO


------------------------------------------------------------
----- A_Redirect_TimeTable ---------------------------------
------------------------------------------------------------

--If Not exists (Select 1 From information_schema.key_column_usage sub_k
--                Where objectproperty(object_id(sub_k.constraint_name), 'IsPrimaryKey') = 1 and sub_k.Table_name = 'A_Redirect_TimeTable')
--    Alter table dbo.A_Redirect_TimeTable Add Id int identity(1,1) Not Null Constraint A_Redirect_TimeTable_pk Primary Key
--GO


Use oktell_settings
GO 

if (not object_id ( 'dbo.A_Redirect_TimeTable_tmp' ) is null)
	Drop table dbo.A_Redirect_TimeTable_tmp
GO

CREATE TABLE [dbo].[A_Redirect_TimeTable_tmp]
(
	[IdRedir] uniqueidentifier not null,
	[DayOfWeek] int not null,
	[StartTime] datetime not null,
	[StopTime] datetime not null
)
GO

if (not object_id ( 'tempdb..#tmp' ) is null)
	Drop table #tmp
GO

CREATE TABLE #tmp
(
	[idx] int identity (1,1),
	[IdRedir] uniqueidentifier not null,
	[DayOfWeek] int not null,
	[StartTime] datetime not null,
	[StopTime] datetime  not null
)

Insert into #tmp ([IdRedir], [DayOfWeek], [StartTime], [StopTime])
	Select [IdRedir], [DayOfWeek], [StartTime], [StopTime]
	From A_Redirect_TimeTable
				 
Insert into [dbo].[A_Redirect_TimeTable_tmp] ([IdRedir], [DayOfWeek], [StartTime], [StopTime])
	Select x.[IdRedir], x.[DayOfWeek], x.[StartTime], x.[StopTime]
	From #tmp x
		Inner join ( Select [IdRedir], [DayOfWeek], [StartTime], [StopTime], Min([idx]) as idx
					 From #tmp
					 Group by [IdRedir], [DayOfWeek], [StartTime], [StopTime] ) a 
			on (a.idx = x.idx)
				and (a.[IdRedir] = x.[IdRedir]) 
				and (a.[DayOfWeek] = x.[DayOfWeek]) 
				and (a.[StartTime] = x.[StartTime]) 
				and (a.[StopTime] = x.[StopTime]) 
GO

if (exists ( Select 1 From A_Redirect_TimeTable_tmp )
	or not exists( Select 1 From A_Redirect_TimeTable))
begin
	Exec sp_rename A_Redirect_TimeTable, A_Redirect_TimeTable2
	Exec sp_rename A_Redirect_TimeTable_tmp, A_Redirect_TimeTable
	Drop table A_Redirect_TimeTable2
end
GO

Alter 
Table dbo.A_Redirect_TimeTable 
Add Constraint A_Redirect_TimeTable_pk Primary Key ([IdRedir], [DayOfWeek], [StartTime], [StopTime])
GO

if (not object_id ( 'dbo.H_createTableTrigger' ) is null)
	Exec [dbo].H_createTableTrigger 'A_Redirect_TimeTable'
GO

use oktell
GO

if (not object_id ( 'dbo.A_Redirect_TimeTable' ) is null)
	Drop View dbo.A_Redirect_TimeTable
GO

Create View dbo.A_Redirect_TimeTable
as 
	Select *
	From oktell_settings.dbo.A_Redirect_TimeTable
GO

use oktell_settings
GO

-------------------------------------------------------
-------------------------------------------------------

If Not exists (Select 1 From information_schema.key_column_usage sub_k
                Where objectproperty(object_id(sub_k.constraint_name), 'IsPrimaryKey') = 1 and sub_k.Table_name = 'A_ServerVirtualLines_Gates')
    Alter table dbo.A_ServerVirtualLines_Gates Add Constraint A_ServerVirtualLines_Gates_pk Primary Key (IdVirtual, IdReal)
GO

If Not exists (Select 1 From information_schema.key_column_usage sub_k
                Where objectproperty(object_id(sub_k.constraint_name), 'IsPrimaryKey') = 1 and sub_k.Table_name = 'A_SmsTaskManager_Operators')
    Alter table dbo.A_SmsTaskManager_Operators Add Constraint A_SmsTaskManager_Operators_pk Primary Key (OperatorId, TaskId)
GO

------------------------------------------------------------
---- A_SmsTaskManager_RunPeriods ---------------------------
------------------------------------------------------------

--If Not exists (Select 1 From information_schema.key_column_usage sub_k
--                Where objectproperty(object_id(sub_k.constraint_name), 'IsPrimaryKey') = 1 and sub_k.Table_name = 'A_SmsTaskManager_RunPeriods')
--    Alter table dbo.A_SmsTaskManager_RunPeriods Add Id int identity(1,1) Not Null Constraint A_SmsTaskManager_RunPeriods_pk Primary Key
--GO

Use oktell_settings
GO 

if (not object_id ( 'dbo.A_SmsTaskManager_RunPeriods_tmp' ) is null)
	Drop table dbo.A_SmsTaskManager_RunPeriods_tmp
GO

CREATE TABLE [dbo].[A_SmsTaskManager_RunPeriods_tmp]
(
	[TaskId] uniqueidentifier not null,
	[DayOfWeek] int not null,
	[StartTime] datetime not null,
	[FinishTime] datetime not null
)
GO

if (not object_id ( 'tempdb..#tmp' ) is null)
	Drop table #tmp
GO

CREATE TABLE #tmp
(
	[idx] int identity (1,1),
	[TaskId] uniqueidentifier not null,
	[DayOfWeek] int not null,
	[StartTime] datetime not null,
	[FinishTime] datetime  not null
)

Insert into #tmp ([TaskId], [DayOfWeek], [StartTime], [FinishTime])
	Select [TaskId], [DayOfWeek], 
		DateAdd ( yyyy, 2000-DatePart(yyyy, [StartTime]), [StartTime]), 
		DateAdd ( yyyy, 2000-DatePart(yyyy, [FinishTime]), [FinishTime])
	From A_SmsTaskManager_RunPeriods
				 
Insert into [dbo].[A_SmsTaskManager_RunPeriods_tmp] ([TaskId], [DayOfWeek], [StartTime], [FinishTime])
	Select x.[TaskId], x.[DayOfWeek], x.[StartTime], x.[FinishTime]
	From #tmp x
		Inner join ( Select [TaskId], [DayOfWeek], [StartTime], [FinishTime], Min([idx]) as idx
					 From #tmp
					 Group by [TaskId], [DayOfWeek], [StartTime], [FinishTime] ) a 
			on (a.idx = x.idx)
				and (a.[TaskId] = x.[TaskId]) 
				and (a.[DayOfWeek] = x.[DayOfWeek]) 
				and (a.[StartTime] = x.[StartTime]) 
				and (a.[FinishTime] = x.[FinishTime]) 
GO

if (exists ( Select 1 From A_SmsTaskManager_RunPeriods_tmp )
	or not exists( Select 1 From A_SmsTaskManager_RunPeriods))
begin
	Exec sp_rename A_SmsTaskManager_RunPeriods, A_SmsTaskManager_RunPeriods2
	Exec sp_rename A_SmsTaskManager_RunPeriods_tmp, A_SmsTaskManager_RunPeriods
	Drop table A_SmsTaskManager_RunPeriods2
end
GO

Alter 
Table dbo.A_SmsTaskManager_RunPeriods
Add Constraint A_SmsTaskManager_RunPeriods_pk Primary Key ([TaskId], [DayOfWeek], [StartTime], [FinishTime])
GO

if (not object_id ( 'dbo.H_createTableTrigger' ) is null)
	Exec [dbo].H_createTableTrigger 'A_SmsTaskManager_RunPeriods'
GO

use oktell
GO

if (not object_id ( 'dbo.A_SmsTaskManager_RunPeriods' ) is null)
	Drop View dbo.A_SmsTaskManager_RunPeriods
GO

Create View dbo.A_SmsTaskManager_RunPeriods
as 
	Select *
	From oktell_settings.dbo.A_SmsTaskManager_RunPeriods
GO

Use oktell_settings
GO

-------------------------------------------------------
-------------------------------------------------------

If Not exists (Select 1 From information_schema.key_column_usage sub_k
                Where objectproperty(object_id(sub_k.constraint_name), 'IsPrimaryKey') = 1 and sub_k.Table_name = 'A_SmsTaskManager_Supervisors')
    Alter table dbo.A_SmsTaskManager_Supervisors Add Constraint A_SmsTaskManager_Supervisors_pk Primary Key (TaskId, SupervisorId)
GO

If Not exists (Select 1 From information_schema.key_column_usage sub_k
                Where objectproperty(object_id(sub_k.constraint_name), 'IsPrimaryKey') = 1 and sub_k.Table_name = 'A_Stat_RecordDirectories')
    Alter table dbo.A_Stat_RecordDirectories Add Constraint A_Stat_RecordDirectories_pk Primary Key (Id)
GO


------------------------------------------------------------
---- A_SvcTaskManager_RunPeriods ---------------------------
------------------------------------------------------------

--If Not exists (Select 1 From information_schema.key_column_usage sub_k
--                Where objectproperty(object_id(sub_k.constraint_name), 'IsPrimaryKey') = 1 and sub_k.Table_name = 'A_SvcTaskManager_RunPeriods')
--    Alter table dbo.A_SvcTaskManager_RunPeriods Add Id int identity(1,1) Not Null Constraint A_SvcTaskManager_RunPeriods_pk Primary Key    
--GO


-----------------------------------------------------
----- A_SvcTaskManager_RunPeriods -------------------
-----------------------------------------------------

Use oktell_settings
GO 

if (not object_id ( 'dbo.A_SvcTaskManager_RunPeriods_tmp' ) is null)
	Drop table dbo.A_SvcTaskManager_RunPeriods_tmp
GO

CREATE TABLE [dbo].[A_SvcTaskManager_RunPeriods_tmp]
(
	[TaskId] uniqueidentifier not null,
	[DayOfWeek] int not null,
	[StartTime] datetime not null,
	[FinishTime] datetime not null
)
GO

if (not object_id ( 'tempdb..#tmp' ) is null)
	Drop table #tmp
GO

CREATE TABLE #tmp
(
	[idx] int identity (1,1),
	[TaskId] uniqueidentifier not null,
	[DayOfWeek] int not null,
	[StartTime] datetime not null,
	[FinishTime] datetime  not null
)

Insert into #tmp ([TaskId], [DayOfWeek], [StartTime], [FinishTime])
	Select [TaskId], [DayOfWeek], 
		DateAdd ( yyyy, 2000-DatePart(yyyy, [StartTime]), [StartTime]), 
		DateAdd ( yyyy, 2000-DatePart(yyyy, [FinishTime]), [FinishTime])
	From A_SvcTaskManager_RunPeriods
				 
Insert into [dbo].[A_SvcTaskManager_RunPeriods_tmp] ([TaskId], [DayOfWeek], [StartTime], [FinishTime])
	Select x.[TaskId], x.[DayOfWeek], x.[StartTime], x.[FinishTime]
	From #tmp x
		Inner join ( Select [TaskId], [DayOfWeek], [StartTime], [FinishTime], Min([idx]) as idx
					 From #tmp
					 Group by [TaskId], [DayOfWeek], [StartTime], [FinishTime] ) a 
			on (a.idx = x.idx)
				and (a.[TaskId] = x.[TaskId]) 
				and (a.[DayOfWeek] = x.[DayOfWeek]) 
				and (a.[StartTime] = x.[StartTime]) 
				and (a.[FinishTime] = x.[FinishTime]) 
GO

if (exists ( Select 1 From A_SvcTaskManager_RunPeriods_tmp )
	or not exists( Select 1 From A_SvcTaskManager_RunPeriods))
begin
	Exec sp_rename A_SvcTaskManager_RunPeriods, A_SvcTaskManager_RunPeriods2
	Exec sp_rename A_SvcTaskManager_RunPeriods_tmp, A_SvcTaskManager_RunPeriods
	Drop table A_SvcTaskManager_RunPeriods2
end
GO

Alter 
Table dbo.A_SvcTaskManager_RunPeriods
Add Constraint A_SvcTaskManager_RunPeriods_pk Primary Key ([TaskId], [DayOfWeek], [StartTime], [FinishTime])
GO

if (not object_id ( 'dbo.H_createTableTrigger' ) is null)
	Exec [dbo].H_createTableTrigger 'A_SvcTaskManager_RunPeriods'
GO

use oktell
GO

if (not object_id ( 'dbo.A_SvcTaskManager_RunPeriods' ) is null)
	Drop View dbo.A_SvcTaskManager_RunPeriods
GO

Create View dbo.A_SvcTaskManager_RunPeriods
as 
	Select *
	From oktell_settings.dbo.A_SvcTaskManager_RunPeriods
GO

Use oktell_settings
GO

------------------------------------------------------------
------------------------------------------------------------

If Not exists (Select 1 From information_schema.key_column_usage sub_k
                Where objectproperty(object_id(sub_k.constraint_name), 'IsPrimaryKey') = 1 and sub_k.Table_name = 'A_TaskManager_CardUserResultsProject') begin
			
	-- Delete doublicates
	--   first searching for doublicates
	Declare @x table ( id int, projectid uniqueidentifier, maxid int, minidx int )
	Insert into @x (id, projectid, maxid)
		Select t1.Id, t1.ProjectId, a.maxid
		From A_TaskManager_CardUserResultsProject t1
			Inner join ( 
				Select ProjectId, Max ( id ) as maxid
				From A_TaskManager_CardUserResultsProject
				Group by ProjectId
			)a on t1.ProjectId = a.ProjectId
		Group By t1.Id, t1.ProjectId, a.maxid
		Having Count(*) > 1	
	
	--   if any doublicate found 
	if (@@rowcount > 0) begin
		
		Declare @y table (idx int identity(1,1), id int, name nvarchar(200), isoutput bit, success bit, isdefault bit, projectid uniqueidentifier)
		Insert into @y (id, name, isoutput, success, isdefault, projectid)
			Select id, name, isoutput, success, isdefault, projectid
			From A_TaskManager_CardUserResultsProject t
			Where exists ( Select *
							From @x x
							Where (x.id = t.id)
								and (x.projectid = t.projectid))
			Order by projectid, id
		
		Update x
		Set x.minidx = a.minidx
		From @x x, (Select min(idx) as minidx, id, projectid
					From @y
					Group by id, projectid) a
		Where (x.id = a.id)
			and (x.projectid = a.projectid)
		
		Delete 
		From A_TaskManager_CardUserResultsProject 
		Where exists ( Select * 
						From @x x 
						Where (x.id = A_TaskManager_CardUserResultsProject.id)
							and (x.projectid = A_TaskManager_CardUserResultsProject.projectid))
		
		-- inserting back with different id
		Insert into A_TaskManager_CardUserResultsProject ( id, name, isoutput, success, isdefault, projectid )
			Select case when (y.idx = x.minidx) then y.id else x.maxid + y.idx - x.minidx end as id,
				y.name, y.isoutput, y.success, y.isdefault, y.projectid
			From @y y
				Inner join @x x on x.id = y.id and x.projectid = y.projectid		
	end		
end
GO
If Not exists (Select 1 From information_schema.key_column_usage sub_k
                Where objectproperty(object_id(sub_k.constraint_name), 'IsPrimaryKey') = 1 and sub_k.Table_name = 'A_TaskManager_CardUserResultsProject')
	Alter table dbo.A_TaskManager_CardUserResultsProject Alter column [ProjectId] uniqueidentifier not null
GO                
If Not exists (Select 1 From information_schema.key_column_usage sub_k
                Where objectproperty(object_id(sub_k.constraint_name), 'IsPrimaryKey') = 1 and sub_k.Table_name = 'A_TaskManager_CardUserResultsProject')
    Alter table dbo.A_TaskManager_CardUserResultsProject Add Constraint A_TaskManager_CardUserResultsProject_pk Primary Key (Id, ProjectId)
GO


If Not exists (Select 1 From information_schema.key_column_usage sub_k
                Where objectproperty(object_id(sub_k.constraint_name), 'IsPrimaryKey') = 1 and sub_k.Table_name = 'A_TaskManager_Operators')
    Alter table dbo.A_TaskManager_Operators Alter column [OperatorId] uniqueidentifier not null
GO
If Not exists (Select 1 From information_schema.key_column_usage sub_k
                Where objectproperty(object_id(sub_k.constraint_name), 'IsPrimaryKey') = 1 and sub_k.Table_name = 'A_TaskManager_Operators')
    Alter table dbo.A_TaskManager_Operators Add Constraint A_TaskManager_Operators_pk Primary Key (TaskId, OperatorId)
GO


If Not exists (Select 1 From information_schema.key_column_usage sub_k
                Where objectproperty(object_id(sub_k.constraint_name), 'IsPrimaryKey') = 1 and sub_k.Table_name = 'A_TaskManager_ProjectUsers')
Begin
    Alter table dbo.A_TaskManager_ProjectUsers Alter column [IdUser] uniqueidentifier not null
    Alter table dbo.A_TaskManager_ProjectUsers Alter column [IdProject] uniqueidentifier not null
End
GO
If Not exists (Select 1 From information_schema.key_column_usage sub_k
                Where objectproperty(object_id(sub_k.constraint_name), 'IsPrimaryKey') = 1 and sub_k.Table_name = 'A_TaskManager_ProjectUsers')
    Alter table dbo.A_TaskManager_ProjectUsers Add Constraint A_TaskManager_ProjectUsers_pk Primary Key (IdProject, IdUser)
GO


------------------------------------------------------------
---- A_TaskManager_RunPeriods ------------------------------
------------------------------------------------------------

--If Not exists (Select 1 From information_schema.key_column_usage sub_k
--                Where objectproperty(object_id(sub_k.constraint_name), 'IsPrimaryKey') = 1 and sub_k.Table_name = 'A_TaskManager_RunPeriods')
--    Alter table dbo.A_TaskManager_RunPeriods Add Id int identity(1,1) Not Null Constraint A_TaskManager_RunPeriods_pk Primary Key
--GO


Use oktell_settings
GO 

if (not object_id ( 'dbo.A_TaskManager_RunPeriods_tmp' ) is null)
	Drop table dbo.A_TaskManager_RunPeriods_tmp
GO

CREATE TABLE [dbo].[A_TaskManager_RunPeriods_tmp]
(
	[TaskId] uniqueidentifier not null,
	[DayOfWeek] int not null,
	[StartTime] datetime not null,
	[FinishTime] datetime not null
)
GO

if (not object_id ( 'tempdb..#tmp' ) is null)
	Drop table #tmp
GO

CREATE TABLE #tmp
(
	[idx] int identity (1,1),
	[TaskId] uniqueidentifier not null,
	[DayOfWeek] int not null,
	[StartTime] datetime not null,
	[FinishTime] datetime  not null
)

Insert into #tmp ([TaskId], [DayOfWeek], [StartTime], [FinishTime])
	Select [TaskId], [DayOfWeek], 
		DateAdd ( yyyy, 2000-DatePart(yyyy, [StartTime]), [StartTime]), 
		DateAdd ( yyyy, 2000-DatePart(yyyy, [FinishTime]), [FinishTime])
	From A_TaskManager_RunPeriods
				 
Insert into [dbo].[A_TaskManager_RunPeriods_tmp] ([TaskId], [DayOfWeek], [StartTime], [FinishTime])
	Select x.[TaskId], x.[DayOfWeek], x.[StartTime], x.[FinishTime]
	From #tmp x
		Inner join ( Select [TaskId], [DayOfWeek], [StartTime], [FinishTime], Min([idx]) as idx
					 From #tmp
					 Group by [TaskId], [DayOfWeek], [StartTime], [FinishTime] ) a 
			on (a.idx = x.idx)
				and (a.[TaskId] = x.[TaskId]) 
				and (a.[DayOfWeek] = x.[DayOfWeek]) 
				and (a.[StartTime] = x.[StartTime]) 
				and (a.[FinishTime] = x.[FinishTime]) 
GO

if (exists ( Select 1 From A_TaskManager_RunPeriods_tmp )
	or not exists( Select 1 From A_TaskManager_RunPeriods))
begin
	Exec sp_rename A_TaskManager_RunPeriods, A_TaskManager_RunPeriods2
	Exec sp_rename A_TaskManager_RunPeriods_tmp, A_TaskManager_RunPeriods
	Drop table A_TaskManager_RunPeriods2
end
GO

Alter 
Table dbo.A_TaskManager_RunPeriods
Add Constraint A_TaskManager_RunPeriods_pk Primary Key ([TaskId], [DayOfWeek], [StartTime], [FinishTime])
GO

if (not object_id ( 'dbo.H_createTableTrigger' ) is null)
	Exec [dbo].H_createTableTrigger 'A_TaskManager_RunPeriods'
GO

use oktell
GO

if (not object_id ( 'dbo.A_TaskManager_RunPeriods' ) is null)
	Drop View dbo.A_TaskManager_RunPeriods
GO

Create View dbo.A_TaskManager_RunPeriods
as 
	Select *
	From oktell_settings.dbo.A_TaskManager_RunPeriods
GO

Use oktell_settings
GO

------------------------------------------------------------
------------------------------------------------------------

If Not exists (Select 1 From information_schema.key_column_usage sub_k
                Where objectproperty(object_id(sub_k.constraint_name), 'IsPrimaryKey') = 1 and sub_k.Table_name = 'A_TaskManager_TaskExtLines')
    Alter table dbo.A_TaskManager_TaskExtLines Alter column [ExtLineId] uniqueidentifier not null
GO
If Not exists (Select 1 From information_schema.key_column_usage sub_k
                Where objectproperty(object_id(sub_k.constraint_name), 'IsPrimaryKey') = 1 and sub_k.Table_name = 'A_TaskManager_TaskExtLines')
    Alter table dbo.A_TaskManager_TaskExtLines Add Constraint A_TaskManager_TaskExtLines_pk Primary Key (TaskId, ExtLineId)
GO


If Not exists (Select 1 From information_schema.key_column_usage sub_k
                Where objectproperty(object_id(sub_k.constraint_name), 'IsPrimaryKey') = 1 and sub_k.Table_name = 'A_TaskManager_TaskSupervisors')
Begin
    Alter table dbo.A_TaskManager_TaskSupervisors Alter column [TaskId] uniqueidentifier not null
    Alter table dbo.A_TaskManager_TaskSupervisors Alter column [SupervisorId] uniqueidentifier not null
End
GO
If Not exists (Select 1 From information_schema.key_column_usage sub_k
                Where objectproperty(object_id(sub_k.constraint_name), 'IsPrimaryKey') = 1 and sub_k.Table_name = 'A_TaskManager_TaskSupervisors')
    Alter table dbo.A_TaskManager_TaskSupervisors Add Constraint A_TaskManager_TaskSupervisors_pk Primary Key (TaskId, SupervisorId)
GO

-----------------------------------------------------------------------------------
---- A_UserRoles_RightsOfRoles ----------------------------------------------------
-----------------------------------------------------------------------------------
If Not exists (Select 1 From information_schema.key_column_usage sub_k
                Where objectproperty(object_id(sub_k.constraint_name), 'IsPrimaryKey') = 1 and sub_k.Table_name = 'A_UserRoles_RightsOfRoles') begin
	-- Delete doublicates
	--   first searching for doublicates
	Declare @x table ( idrole uniqueidentifier, idright uniqueidentifier)
	Insert into @x ( idrole, idright )
		Select IdRole, IdRight
		From A_UserRoles_RightsOfRoles
		Group by idrole, idright
		Having Count(*) > 1

	--   if any doublicate found 
	if (@@rowcount > 0) begin
		-- cutting everyone copy from table
		Declare @y table ( idrole uniqueidentifier, idright uniqueidentifier, value int)
		Insert into @y (idrole, idright, value)
			Select idrole, idright, value
			From A_UserRoles_RightsOfRoles rr
			Where exists ( Select *
							From @x x
							Where (x.idrole = rr.idrole)
								and (x.idright = rr.idright))
		Delete 
		From A_UserRoles_RightsOfRoles 
		Where exists ( Select * 
						From @x x 
						Where (x.idrole = A_UserRoles_RightsOfRoles.idrole)
							and (x.idright = A_UserRoles_RightsOfRoles.idright))
		
		-- inserting back only once					
		Insert into A_UserRoles_RightsOfRoles ( idrole, idright, value )
			Select idrole, idright, max (value) as value
			From @y
			Group by idrole, idright
	end	
end
GO

If Not exists (Select 1 From information_schema.key_column_usage sub_k
                Where objectproperty(object_id(sub_k.constraint_name), 'IsPrimaryKey') = 1 and sub_k.Table_name = 'A_UserRoles_RightsOfRoles')
    Alter table dbo.A_UserRoles_RightsOfRoles Add Constraint A_UserRoles_RightsOfRoles_pk Primary Key (IdRole, IdRight)
GO


-----------------------------------------------------------------------------------
---- A_UserRoles_RolesOfUsers -----------------------------------------------------
-----------------------------------------------------------------------------------
If Not exists (Select 1 From information_schema.key_column_usage sub_k
                Where objectproperty(object_id(sub_k.constraint_name), 'IsPrimaryKey') = 1 and sub_k.Table_name = 'A_UserRoles_RolesOfUsers') begin

	-- Delete doublicates
	--   first searching for doublicates
	Declare @x table ( iduser uniqueidentifier, idrole uniqueidentifier)
	Insert into @x ( iduser, idrole )
		Select IdUser, IdRole
		From A_UserRoles_RolesOfUsers
		Group by iduser, idrole
		Having Count(*) > 1
		
	--   if any doublicate found 
	if (@@rowcount > 0) begin
		-- cutting everyone copy from table
		Declare @y table ( iduser uniqueidentifier, idrole uniqueidentifier)
		Insert into @y (iduser, idrole)
			Select iduser, idrole
			From A_UserRoles_RolesOfUsers rr
			Where exists ( Select *
							From @x x
							Where (x.iduser = rr.iduser)
								and (x.idrole = rr.idrole))
		Delete 
		From A_UserRoles_RolesOfUsers 
		Where exists ( Select * 
						From @x x 
						Where (x.iduser = A_UserRoles_RolesOfUsers.iduser)
							and (x.idrole = A_UserRoles_RolesOfUsers.idrole))
		
		-- inserting back only once					
		Insert into A_UserRoles_RolesOfUsers ( iduser, idrole )
			Select iduser, idrole
			From @y
			Group by iduser, idrole
	end		
end
GO
                
If Not exists (Select 1 From information_schema.key_column_usage sub_k
                Where objectproperty(object_id(sub_k.constraint_name), 'IsPrimaryKey') = 1 and sub_k.Table_name = 'A_UserRoles_RolesOfUsers')
    Alter table dbo.A_UserRoles_RolesOfUsers Add Constraint A_UserRoles_RolesOfUsers_pk Primary Key (IdUser, IdRole)
GO

------------------------------------------------------------
-------------- A_PlugIns -----------------------------------
------------------------------------------------------------
use oktell_settings
GO

use oktell_settings
if exists ( select * from sysobjects where id = object_id ( 'dbo.A_PlugIns_tmp' ))
	Drop table dbo.A_PlugIns_tmp
GO

use oktell_settings
Create table [dbo].[A_PlugIns_tmp]
(
	[Id] [uniqueidentifier] NOT NULL PRIMARY KEY,
	[Type] [int] NOT NULL,
	[ObjectName] [nvarchar](500) collate database_default,
	[Name] [nvarchar](500) collate database_default,
	[Description] [nvarchar](4000) collate database_default,
	[Path] [nvarchar](1000) collate database_default,
	[LoadType] [int] ,
	[LoadMoment] [int],
	[Destination] [int],
	[LogMode] [int],	
) ON [PRIMARY] 
GO

use oktell_settings
Insert into A_PlugIns_tmp ( id, type, objectname, name, description, path, loadtype, loadmoment, destination, logmode)
	Select id, type, objectname, name, cast(description as nvarchar(4000)), path, loadtype, loadmoment, destination, logmode
	From A_PlugIns
GO

use oktell_settings
Drop table A_PlugIns
GO

use oktell_settings
exec sp_rename [A_PlugIns_tmp], [A_PlugIns]
GO

use [oktell]
GO

if exists ( select * from sysobjects where id = object_id ( 'dbo.A_PlugIns' ))
	Drop view dbo.A_PlugIns
GO

Create view dbo.A_PlugIns
as
	Select * 
	From oktell_settings.dbo.A_PlugIns
GO

use oktell_settings
GO

------------------------------------------------------------
-------------- A_PluginMenu --------------------------------
------------------------------------------------------------
use oktell_settings
GO

if exists ( select * from sysobjects where id = object_id ( 'dbo.A_PluginMenu_tmp' ))
	Drop table dbo.[A_PluginMenu_tmp]
GO

CREATE TABLE [dbo].[A_PluginMenu_tmp]
(
	[Id] [uniqueidentifier] NOT NULL PRIMARY KEY,
	[OrderIndex] [int] NULL,
	[IdModule] [uniqueidentifier],
	[IdForm] [uniqueidentifier],
	[HeaderText] [nvarchar](300) collate database_default NULL,
	[MenuText] [nvarchar](300) collate database_default NULL,
	[VisibleAllDefault] [bit],
	[Description] [nvarchar](4000) collate database_default NULL,
	[Type] [int],
	[AddressString] [nvarchar](3000) collate database_default NULL,
	[Enabled] [bit],
	[HelpLink] [nvarchar](500) collate database_default NULL 
) ON [PRIMARY]

GO

Insert into dbo.[A_PluginMenu_tmp] ( id, orderindex, idmodule, idform, headertext, menutext, visiblealldefault, description, type, addressstring, enabled, helplink)
	Select id, orderindex, idmodule, idform, headertext, menutext, visiblealldefault,  cast(description as nvarchar(4000)), type, addressstring, enabled, helplink
	From A_PluginMenu
GO

Drop table A_PluginMenu
GO

exec sp_rename [A_PluginMenu_tmp], [A_PluginMenu]
GO

use [oktell]
GO

if exists ( select * from sysobjects where id = object_id ( 'dbo.A_PluginMenu' ))
	Drop view dbo.A_PluginMenu
GO

Create view dbo.A_PluginMenu
as
	Select * 
	From oktell_settings.dbo.A_PluginMenu
GO

use oktell_settings
GO

------------------------------------------------------------
------------------------------------------------------------

use oktell_settings
GO

if exists ( Select * From sysobjects where id = object_id ( 'dbo.A_Websock_Config' ))
	exec sp_rename [A_Websock_Config], [A_WebsockConfig_Procedures]
GO

If Not exists (Select 1 From information_schema.key_column_usage sub_k
                Where objectproperty(object_id(sub_k.constraint_name), 'IsPrimaryKey') = 1 and sub_k.Table_name = 'A_WebsockConfig_Procedures')
    Alter table dbo.A_WebsockConfig_Procedures Alter column [value] nvarchar(250) collate database_default not null 
GO

use [oktell]
GO

if exists ( select * from sysobjects where id = object_id ( 'dbo.A_Websock_Config' ))
	Drop view dbo.A_Websock_Config
GO

if exists ( select * from sysobjects where id = object_id ( 'dbo.A_WebsockConfig_Procedures' ))
	Drop view dbo.A_WebsockConfig_Procedures
GO

Create view dbo.A_WebsockConfig_Procedures
as
	Select * 
	From oktell_settings.dbo.A_WebsockConfig_Procedures
GO

if exists ( Select * from sysobjects where id = object_id ( 'dbo.A_Websock_Config_GetAll' ))
	Drop procedure dbo.A_Websock_Config_GetAll
GO

if exists ( Select * from sysobjects where id = object_id ( 'dbo.A_WebsockConfig_Procedures_GetAll' ))
	Drop procedure dbo.A_WebsockConfig_Procedures_GetAll
GO

Create procedure dbo.A_WebsockConfig_Procedures_GetAll
as
begin
	
	Select * 
    From [dbo].A_WebsockConfig_Procedures
    
end
GO

use oktell
GO

