﻿if exists ( Select * FROM Sysobjects where id = object_id ( 'dbo.A_UserOutcomingLines_Save' ))
	Drop procedure dbo.A_UserOutcomingLines_Save
GO

Create procedure [dbo].[A_UserOutcomingLines_Save]
	@xml ntext, -- <items><a ida=""><b idb=""/><b idb=""/></a><a ida....>
	@authorizeduserid uniqueidentifier = NULL
as
begin

	If object_id('dbo.H_Authorizeduserid_SPID_Save') is not NULL
		EXEC dbo.H_Authorizeduserid_SPID_Save @authorizeduserid
		
	
	If object_id('tempdb..#tmp_xml') is not NULL
		Drop table #tmp_xml	
	Create table #tmp_xml ( 
		a uniqueidentifier, 
		b uniqueidentifier, 
		idx int 
	)
		
	Declare @idoc int
	Exec sp_xml_preparedocument @idoc OUTPUT, @xml
	
	Insert into #tmp_xml
		Select *
		From OpenXml (@idoc, '/items/a/b', 2)	
		With ( 
			ida varchar(50) '../@ida',
			idb varchar(50) '@idb',
			idx int '@idx'
		)	
		

	-- Удаляем те, которых не осталось
	Delete
	From dbo.A_UserOutcomingLines
	Where exists ( Select a From #tmp_xml x Where dbo.A_UserOutcomingLines.IdUser = x.a )			
		and not exists( Select a 
						From #tmp_xml x 
						Where (dbo.A_UserOutcomingLines.IdUser = x.a) 
							and (dbo.A_UserOutcomingLines.IdLine = x.b))
	
	-- Обновляем индексы у тех что были и остались 
	Update w
	Set w.LineIndex = x.idx
	From dbo.A_UserOutcomingLines w, #tmp_xml x
	Where (w.IdUser = x.IdUser)
		and (w.IdLine = x.IdLine)
		and (w.LineIndex != x.idx)
		
	-- Добавляем новые
	Insert into dbo.A_UserOutcomingLines (IdUser, IdLine, LineIndex)
		Select Distinct a, b, idx
		From #tmp_xml x
		Where not exists ( Select a 
							From dbo.A_UserOutcomingLines w
							Where (w.IdUser = x.a) 
								and (w.IdLine = x.b))
	
end
GO