﻿if exists (Select * From sysobjects where id=object_id ( 'dbo.A_Admin_Line_Ext_Set' ))
	Drop procedure dbo.A_Admin_Line_Ext_Set
GO

Create Procedure [dbo].[A_Admin_Line_Ext_Set]
	@id uniqueidentifier,
	@extnumber nvarchar ( 200 ),
	@canautodial bit,
	@canipout bit,
	@canmobile bit,
	@cansimpleout bit,
	@caption nvarchar ( 200 ),
	@dt int,
	@enabled bit,
	@prefix nvarchar ( 200 ),
	@connectedpbx bit,
	@type int = 1,
	@linecode nvarchar ( 200 ) = '',
	@authorizeduserid uniqueidentifier = NULL
as
begin

	If object_id('dbo.H_Authorizeduserid_SPID_Save') is not NULL
		EXEC dbo.H_Authorizeduserid_SPID_Save @authorizeduserid
		

	Update dbo.A_ServerExtLines 
	Set [ExtNumber] = @extnumber,
		[CanAutoDial] = @canautodial,
		[CanIp] = @canipout,
		[CanMobile] = @canmobile,
		[CanSimpleOut] = @cansimpleout,
		[Caption] = @caption,
		[DialType] = @dt,
		[Enabled] = @enabled,
		[Prefix] = @prefix,
		[ConnectedPBX] = @connectedpbx,
		[Type] = @type,
		[LineCode] = @linecode
	Where [Id] = @id
		and (([ExtNumber] != @extnumber)
			or ([CanAutoDial] != @canautodial)
			or ([CanIp] != @canipout)
			or ([CanMobile] != @canmobile)
			or ([CanSimpleOut] != @cansimpleout)
			or ([Caption] != @caption)
			or ([DialType] != @dt)
			or ([Enabled] != @enabled)
			or ([Prefix] != @prefix)
			or ([ConnectedPBX] != @connectedpbx)
			or ([Type] != @type)
			or ([LineCode] != @linecode))
		
end
GO


if exists (Select * From sysobjects where id=object_id ( 'dbo.A_Admin_Line_Int_Set' ))
	Drop procedure dbo.A_Admin_Line_Int_Set
GO


Create Procedure [dbo].[A_Admin_Line_Int_Set]
	@id uniqueidentifier,
	@citystraight bit,
	@caption nvarchar ( 200 ),
	@enabled bit,
	@parentgroupid uniqueidentifier,
	@linecode nvarchar ( 200 ) = '',
	@authorizeduserid uniqueidentifier = NULL
as
begin
-- Задает общие свойства внутренним линиям

	If object_id('dbo.H_Authorizeduserid_SPID_Save') is not NULL
		EXEC dbo.H_Authorizeduserid_SPID_Save @authorizeduserid		
	

	Update dbo.A_ServerIntLines 
	Set [CityStraight] = @citystraight,
		[Caption] = @caption,
		[Enabled] = @enabled,
		[ParentGroupId] = @parentgroupid,
		[LineCode] = @linecode
	Where ([Id] = @id)
		and (([CityStraight] != @citystraight)
			or ([Caption] != @caption)
			or ([Enabled] != @enabled)
			or ([ParentGroupId] != @parentgroupid)
			or ([LineCode] != @linecode))
	

	Update dbo.A_ServerUsbLines 
	Set [CityStraight] = @citystraight,
		[Caption] = @caption,
		[Enabled] = @enabled,
		[ParentGroupId]	= @parentgroupid,
		[LineCode] = @linecode
	Where ([Id] = @id)
		and (([CityStraight] != @citystraight)
			or ([Caption] != @caption)
			or ([Enabled] != @enabled)
			or ([ParentGroupId] != @parentgroupid)
			or ([LineCode] != @linecode))
		
		
	Update dbo.A_ServerSipLines 
	Set [CityStraight] = @citystraight,
		[Caption] = @caption,
		[Enabled] = @enabled,
		[ParentGroupId]	= @parentgroupid,
		[LineCode] = @linecode
	Where ([Id] = @id)
		and (([CityStraight] != @citystraight)
			or ([Caption] != @caption)
			or ([Enabled] != @enabled)
			or ([ParentGroupId] != @parentgroupid)
			or ([LineCode] != @linecode))


	Update dbo.A_ServerVirtualLines 
	Set [CityStraight] = @citystraight,
		[Caption] = @caption,
		[Enabled] = @enabled,
		[ParentGroupId]	= @parentgroupid,
		[LineCode] = @linecode
	Where ([Id] = @id)
		and (([CityStraight] != @citystraight)
			or ([Caption] != @caption)
			or ([Enabled] != @enabled)
			or ([ParentGroupId] != @parentgroupid)
			or ([LineCode] != @linecode))
end
GO