
--Drop table [dbo].[A_SmsTaskManager_Task_IncomingResults]
--GO
--Drop table oktell_cc_temp.[dbo].A_Cube_CC_TextResults
--GO


if (object_id ('dbo.A_SmsTaskManager_Task_IncomingResults') is null)
	CREATE TABLE [dbo].[A_SmsTaskManager_Task_IncomingResults]
	(
		[IdEffort] [uniqueidentifier] NOT NULL PRIMARY KEY NONCLUSTERED,
		[IdSession] [uniqueidentifier] NOT NULL,
		[IdTask] [uniqueidentifier] NOT NULL,
		[IdInList] int NOT NULL,
		[AbonentKey] [nvarchar](500) NULL,
		[TimeStart] [datetime] NULL,
		[TimeStop] [datetime] NULL,
		[IdOperator] [uniqueidentifier],
		[Result] [int] NULL,
		[Info] [nvarchar](500) NULL		
	)
GO

IF  EXISTS (SELECT * FROM sys.indexes WHERE object_id = OBJECT_ID(N'[dbo].[A_SmsTaskManager_Task_IncomingResults]') AND name = N'idx_SmsTaskResults_Task_Session_Operator')
	DROP INDEX [idx_SmsTaskResults_Task_Session_Operator] ON [dbo].A_SmsTaskManager_Task_IncomingResults
GO

CREATE CLUSTERED INDEX [idx_SmsTaskResults_Task_Session_Operator] ON [dbo].A_SmsTaskManager_Task_IncomingResults 
(
	[IdTask] ASC,
	[IdSession] ASC,
	[IdOperator] ASC
)
GO

----------------------------

if not (object_id ( 'dbo.A_SmsTaskManager_Task_AddIncomingResult' ) is null )
	Drop procedure dbo.A_SmsTaskManager_Task_AddIncomingResult
GO

Create procedure dbo.A_SmsTaskManager_Task_AddIncomingResult
	@ideffort uniqueidentifier,
	@idsession uniqueidentifier,
	@idtask uniqueidentifier,
	@idinlist int,
	@contactkey nvarchar(500),
	@timestart datetime,
	@timestop datetime,
	@idoperator uniqueidentifier,
	@effresult int,
	@effresultinfo nvarchar(500)	
as
begin
	
	if Exists ( select Id from A_SmsTaskManager_Tasks where id = @idtask ) begin
		
		Insert Into A_SmsTaskManager_Task_IncomingResults
			( IdEffort, IdSession, IdTask, IdInList, AbonentKey, IdOperator, TimeStart, TimeStop, Result, Info )
		Values 
			( @ideffort, @idsession, @idtask, @idinlist, @contactkey, @idoperator, @timestart, @timestop, @effresult, @effresultinfo )
		
	end
	
end
GO

-------------------------------------------------------------------
Use oktell_cc_temp
GO

--if not (object_id ( 'dbo.A_Cube_CC_TextResults' ) is null )
--	Drop table dbo.A_Cube_CC_TextResults
--GO

if (object_id ( 'dbo.A_Cube_CC_TextResults' ) is null )
	Create table A_Cube_CC_TextResults
	(
		IdSession uniqueidentifier,
		IdEffort uniqueidentifier NOT NULL, 
		IdProject uniqueidentifier NOT NULL, 
		IdTask uniqueidentifier NOT NULL, 		
		IdOperator uniqueidentifier, 
		IdInList int, 
		AbonentKey nvarchar(500), 
		Result int NOT NULL, 
		ResultInfo nvarchar(500), 
		DateTimeStart datetime NOT NULL, 
		DateStart datetime NOT NULL, 
		TimeStart datetime NOT NULL, 
		DateTimeStartHandle datetime NULL, 
		DateTimeStop datetime NOT NULL,		
		LenHandleTime float NOT NULL, 
		LenQueue float NOT NULL, 
		IsHandled bit NOT NULL, 
		IsSuccess bit NOT NULL,
		UserResult int
	)
GO

if not (object_id ( 'dbo.A_Cube_CC_TextResults' ) is null )
	IF not EXISTS (SELECT * FROM sys.indexes WHERE object_id = OBJECT_ID(N'[dbo].[A_Cube_CC_TextResults]') AND name = N'idx_TextResults_Multi')
		Create CLUSTERED index idx_TextResults_Multi on dbo.A_Cube_CC_TextResults 
		(
			DateTimeStart, IdTask, IdEffort, IdOperator, IsHandled, Result
		)
GO

Use oktell
GO

if not (object_id ( 'dbo.A_CallCenter_Temp_UpdateAfterTextResult' ) is null )
	Drop procedure dbo.A_CallCenter_Temp_UpdateAfterTextResult
GO

Create procedure dbo.A_CallCenter_Temp_UpdateAfterTextResult
	@idsession uniqueidentifier,
	@ideffort uniqueidentifier,
	@idtask uniqueidentifier,
	@idinlist int,
	@contactkey nvarchar(200),
	@effresult int,
	@effresultinfo nvarchar(200),
	@lenhandletime float,
	@lenqueue float,
	@timestart datetime,
	@timestarthandle datetime = NULL,
	@timeexit datetime,
	@userresult int,
	@idoperator uniqueidentifier,
	@dtnow datetime = NULL		
as
begin

	--if (@dtnow is null)
	--	Set @dtnow = GetDate()	
	
	Declare @idproject uniqueidentifier
	Select @idproject = IdProject
	From A_SmsTaskManager_Tasks
	Where Id = @idtask
	
	--   Tmp_A_Cube_CC_EffortConnections ----------------------------
	Insert Into [oktell_cc_temp].[dbo].[A_Cube_CC_TextResults]
		(
			IdSession, IdEffort, IdProject, IdTask, IdOperator, IdInList, AbonentKey, Result, ResultInfo, 
			DateTimeStart, DateStart, TimeStart, DateTimeStartHandle, DateTimeStop,			
			LenHandleTime, LenQueue, 
			IsHandled, IsSuccess,
			UserResult
		)
        Select @idsession, @ideffort, @idproject, @idtask, @idoperator, @idinlist, @contactkey, @effresult, @effresultinfo,
			@timestart, 
			cast(Floor(cast (@timestart as float)) as datetime), 
			cast(cast (@timestart as float) - Floor(cast (@timestart as float)) as datetime), 
			@timestarthandle, @timeexit,			
			@lenhandletime, @lenqueue,
			case when (@effresult in (5, 18)) then 1 else 0 end,
			case when (@effresult = 5) then 1 else 0 end,
			@userresult
        --From A_SmsTaskManager_Task_IncomingResults r
		--	Inner join A_SmsTaskManager_Tasks t on r.TaskId = t.Id
		
	--      A_Cube_CC_Cat_Task
	if not exists ( Select Id From [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_Task] Where Id = @idtask )
		Insert Into [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_Task]
		Select Id, Name, Type, Isoutputtask From A_SmsTaskManager_Tasks Where Id = @idtask		

	--      A_Cube_CC_Cat_Project
	if not exists ( Select Id From [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_Project] Where Id = @idproject )
		Insert Into [oktell_cc_temp].[dbo].[A_Cube_CC_Cat_Project]
		Select Id, Name From A_TaskManager_Projects Where Id = @idproject
	
end
GO
