﻿if not (object_id ('dbo.A_UserRoles_SetupUserRoles') is null)
	Drop procedure dbo.A_UserRoles_SetupUserRoles
GO

Create procedure [dbo].[A_UserRoles_SetupUserRoles]
	@iduser uniqueidentifier,	
 	@xmlroles ntext = NULL,
	@authorizeduserid uniqueidentifier = NULL
As
begin

	If object_id('dbo.H_Authorizeduserid_SPID_Save') is not NULL
		EXEC dbo.H_Authorizeduserid_SPID_Save @authorizeduserid	
					
				
	If object_id('tempdb..#tmp_xml') is not NULL
		Drop table #tmp_xml
	Create table #tmp_xml ( idrole uniqueidentifier )
			
	Declare @idoc1 int
	Exec sp_xml_preparedocument @idoc1 OUTPUT, @xmlroles
	
	Insert into #tmp_xml (idrole)
		Select idrole
		From OpenXml (@idoc1, '/items/r', 2)	
		With ( idrole varchar(50) '@id' )
	
	
	Declare @modified bit
	Set @modified = 0
	
	--------------------------------------------
	-- Удаляем те, что отсутствуют в параметре
	Delete 
	From dbo.A_UserRoles_RolesOfUsers
	Where (IdUser = @iduser)
		and not exists( Select 1
						From #tmp_xml x
						Where (dbo.A_UserRoles_RolesOfUsers.IdRole = x.idrole))
						
	if (@@rowcount != 0)
		Set @modified = 1
		
	--------------------------------------------	
	-- Добавляем те, что есть в параметре, но нет в таблице
	Insert Into dbo.A_UserRoles_RolesOfUsers ( IdUser, IdRole )
		Select @iduser, x.idrole
		From #tmp_xml x
		Where not exists( Select 1
							From dbo.A_UserRoles_RolesOfUsers w
							Where (w.IdUser = @iduser)
								and (w.IdRole = x.idrole))
								
	if (@@rowcount != 0)
		Set @modified = 1
		
	--------------------------------------------
	
	if (@modified = 1)
		exec dbo.A_Policy_SubjectGroupCache_SetUpdate
		
		
end
GO


if not (object_id ('dbo.A_UserRoles_SetupRoleUsers') is null)
	Drop procedure dbo.A_UserRoles_SetupRoleUsers
GO


Create procedure [dbo].[A_UserRoles_SetupRoleUsers]
	@idrole uniqueidentifier,	
 	@xmlusers ntext = NULL,
	@authorizeduserid uniqueidentifier = NULL
As
begin

	If object_id('dbo.H_Authorizeduserid_SPID_Save') is not NULL
		EXEC dbo.H_Authorizeduserid_SPID_Save @authorizeduserid
					
				
	If object_id('tempdb..#tmp_xml') is not NULL
		Drop table #tmp_xml
	Create table #tmp_xml
	( 
		iduser uniqueidentifier,
		value int
	)
			
	Declare @idoc1 int
	Exec sp_xml_preparedocument @idoc1 OUTPUT, @xmlusers
	
	Insert into #tmp_xml (iduser, value)
		Select iduser, value
		From OpenXml (@idoc1, '/items/u', 2)	
		With ( 
			iduser varchar(50) '@id',
			value int '@val'			
		)
	
	
	Declare @modified bit
	Set @modified = 0
	
	--------------------------------------------
	-- Удаляем те, что присутствуют в параметре с признаком "удалено", других не трогаем, остаются как были
	Delete 
	From dbo.A_UserRoles_RolesOfUsers
	Where (IdRole = @idrole)
		and exists( Select 1
					From #tmp_xml x
					Where (dbo.A_UserRoles_RolesOfUsers.IdUser = x.iduser)
						and (x.value = 0))
	
	if (@@rowcount != 0)
		Set @modified = 1
		
	--------------------------------------------
	-- Добавляем те, что есть в параметре с признаком "добавлено", но нет в таблице
	Insert Into dbo.A_UserRoles_RolesOfUsers ( IdUser, IdRole )
		Select x.iduser, @idrole
		From #tmp_xml x
		Where (x.value = 1)
			and not exists( Select 1
							From dbo.A_UserRoles_RolesOfUsers w
							Where (w.IdRole = @idrole)
								and (w.IdUser = x.iduser))
								
	if (@@rowcount != 0)
		Set @modified = 1
	--------------------------------------------
	
	if (@modified = 1)
		exec dbo.A_Policy_SubjectGroupCache_SetUpdate
		
end
GO